--/////////////////////////////////////////////////////////////////////////////
--// Name:        wxDir.e
--// Purpose:     Class include for wxEuphoria
--// Author:      Matt Lewis
--// Modified by:
--// Created:     2004-11-29
--// Copyright:   (c) Matt Lewis
--// Licence:     wxWindows license
--/////////////////////////////////////////////////////////////////////////////

include dll.e
include cplusplus.e as cpp
include wxEuphoria.e as wxeu

-- begin autogenerated
------------------------------
include wxClassInfo.e as CI

-- begin class wxDir (13 members)
------------------------------

global constant 

-- wxDir::Exists(const wxString&)
wxDir_Exists = define_c_var( wxWin, "@wxDir@Exists$qrx8wxString" ),

-- wxDir::GetAllFiles(const wxString&, wxArrayString *, const wxString&, int)
wxDir_GetAllFiles = define_c_var( wxWin, "@wxDir@GetAllFiles$qrx8wxStringp13wxArrayStringt1i" ),

-- wxDir::GetFirst(wxString *, const wxString&, int) const
wxDir_GetFirst = define_c_var( wxWin, "@wxDir@GetFirst$xqp8wxStringrx8wxStringi" ),

-- wxDir::GetName() const
wxDir_GetName = define_c_var( wxWin, "@wxDir@GetName$xqv" ),

-- wxDir::GetNext(wxString *) const
wxDir_GetNext = define_c_var( wxWin, "@wxDir@GetNext$xqp8wxString" ),

-- wxDir::HasFiles(const wxString&)
wxDir_HasFiles = define_c_var( wxWin, "@wxDir@HasFiles$qrx8wxString" ),

-- wxDir::HasSubDirs(const wxString&)
wxDir_HasSubDirs = define_c_var( wxWin, "@wxDir@HasSubDirs$qrx8wxString" ),

-- wxDir::IsOpened() const
wxDir_IsOpened = define_c_var( wxWin, "@wxDir@IsOpened$xqv" ),

-- wxDir::Open(const wxString&)
wxDir_Open = define_c_var( wxWin, "@wxDir@Open$qrx8wxString" ),

-- wxDir::Traverse(wxDirTraverser&, const wxString&, int) const
wxDir_Traverse = define_c_var( wxWin, "@wxDir@Traverse$xqr14wxDirTraverserrx8wxStringi" ),

-- wxDir::wxDir(const wxString&)
wxDir_op_ctr = define_c_var( wxWin, "@wxDir@$bctr$qrx8wxString" ),

-- wxDir::wxDir()
wxDir_op_ctr_1 = define_c_var( wxWin, "@wxDir@$bctr$qv" ),

-- wxDir::~wxDir()
wxDir_op_dtr = define_c_var( wxWin, "@wxDir@$bdtr$qv" ),

sizeof_wxDir = 1,
wxDir = define_class( "wxDir", wxWin, wxDir_op_ctr, sizeof_wxDir, wxDir_op_dtr )

-- end class wxDir
------------------------------

-- end autogenerated
------------------------------

global constant
    wxDIR_FILES     = 0001,       --// include files
    wxDIR_DIRS      = 0002,       --// include directories
    wxDIR_HIDDEN    = 0004,       --// include hidden files
    wxDIR_DOTDOT    = 0008,       --// include '.' and '..'

    --// by default, enumerate everything except '.' and '..'
    wxDIR_DEFAULT   = wx_or_all( wxDIR_FILES & wxDIR_DIRS & wxDIR_HIDDEN )

--wxDir
---------------------------------


--/topic wxDir
--/parent Classes
--/parent Files
--/info
--
--Params:
--<ul>
--/li Directory [=""]
--</ul>

function new_wxDir( sequence params )
	atom str, this
	str = create( wxString, params )
	this = new_instance( wxDir, 0, {str} )
	delete_string( str )
	return this
end function
create_func( wxDir, routine_id("new_wxDir"))

--/topic wxDir
--/func is_opened( atom dir )
--
global function is_opened( atom dir )
	return cpp:call_member( wxDir_IsOpened, dir, "")
end function

--wxDirTraverser
-----------------------

--/topic wxDirTraverser
--/parent Classes
--/parent wxDir
--/parent Files
--/info
--Creation parameters:
--<ul>
--/li /wxArrayString
--/li function OnFile( /wxDirTraverser this, /wxString fname) [= default callback]
--/li function OnDir( /wxDirTraverser this, /wxString dirname) [= default callback]
--</ul>
--The first parameter is required, and is a /wxArrayString.  The list of files
--will be put into this array.  OnFile and OnDir are optional, and are cdecl callbacks
--used by the traverser:
--<ul>
--/li /b OnFile:  This function is called for each file. It may return /b wxDIR_STOP 
--to abort traversing (for example, if the file being searched is found) or /b wxDIR_CONTINUE to proceed.
--/li /b OnDir: This function is called for each directory. It may return /b wxDIR_STOP to abort 
--traversing completely, /b wxDIR_IGNORE to skip this directory but continue with others or 
--/b wxDIR_CONTINUE to enumerate all files and subdirectories in this directory.
--</ul>
--The defaults are files that always return wxDIR_CONTINUE.  OnFile adds each file name
--to the /wxArrayString.
global constant
    wxDIR_IGNORE = -1,      --// ignore this directory but continue with others
    wxDIR_STOP = 0,         --// stop traversing
    wxDIR_CONTINUE = 1      --// continue into this directory

function OnFile( atom this, atom fname )
	atom files, size
	files = peek4u( this + 4 )
	size = cpp:call_member( wxArrayString_Add, files, { fname, 1})
	return wxDIR_CONTINUE
end function

function OnDir( atom this, atom dirname )
	return wxDIR_CONTINUE
end function

constant default_traverser = { 0, call_back( '+' & routine_id("OnFile") ), call_back('+' & routine_id("OnDir")) }
function new_wxDirTraverser( sequence params )
	atom this, vtable
	this = wx_alloc( 8 )
	vtable = wx_alloc( 8 )
	poke4( this, vtable )
	if length(params) then
		poke4( this + 4, params[1] )
	end if
	
	if length(params) > 1 then
		poke4( vtable, params[2] )
		if length(params) > 2 then
			poke4( vtable + 4, params[3] )
		end if
	else
		poke4( vtable, default_traverser[2..3])
	end if
	
	return this
end function


procedure destroy_traverser( atom this )
	free( peek4u( this ) )
	free( this )
end procedure
global constant
wxDirTraverser = define_class( "wxDirTraverser", wxWin, 0, 8, - routine_id("destroy_traverser") )
create_func( wxDirTraverser, routine_id("new_wxDirTraverser"))

--/topic wxDir
--/func get_all_files( object dirname, sequence filespec, integer flags, atom traverser )
--
--Walks the specified directory, returning all the files and/or directories as specified by
--/b flags.
--<ul>
--/li /b dirname
--<ul>
--/li sequence: directory name (a /wxDir will be created and destroyed)
--/li atom: instance of /wxDir to be used
--</ul>
--/li /b filespec: wildcard pattern to be matched against files
--/li /b flags: mixture of wxDIR_FILES, wxDIR_HIDDEN, wxDIR_DIRS, wxDIR_DOTDOT
--/li /b traverser
--<ul>
--/li 0: Use the default /wxDirTraverser which always returns wxDIR_CONTINUE
--/li /wxDirTraverser: Use the supplied /wxDirTraverser
--</ul>
--</ul>

global function get_all_files( object dirname, sequence filespec, integer flags, atom traverser )
	atom fspec, dname, farray, size, dir, dt
	sequence files
	
	if sequence( dirname ) then
		dname = create( wxString, dirname )
		dir = create( wxDir, dirname )
	else
		dir = dirname
	end if
	
	fspec = create( wxString, filespec )
	
	if is_opened( dir ) then
		if not traverser then
			farray = create( wxArrayString, {})
			dt = create( wxDirTraverser, farray )
		end if
		size = cpp:call_member( wxDir_Traverse, dir, {dt, fspec, flags})
	else
		return {}
	end if

	files = get_arraystring( farray )
	if not traverser then
		delete_instance( dt & farray )
	end if
	if sequence( dirname ) then
		delete_string( dname )
		delete_instance( dir )
	end if
	
	delete_string( fspec )
	
	return files
end function

--/topic wxDir
--/func has_files( atom dir, sequence spec )
--
global function has_files( atom dir, sequence spec )
	atom s, b
	s = create( wxString, spec )
	b = cpp:call_member( wxDir_HasFiles, dir, {s})
	delete_string( s )
	return b
end function

--/topic wxDir
--/func has_subdirs( atom dir, sequence spec )
--
global function has_subdirs( atom dir, sequence spec )
	atom s, b
	s = create( wxString, spec )
	b = cpp:call_member( wxDir_HasSubDirs, dir, {s})
	delete_string( s )
	return b
end function

--/topic wxDir
--/func open_dir( atom dir, sequence dname )
--
global function open_dir( atom dir, sequence dname )
	atom s, b
	s = create( wxString, dname )
	b = cpp:call_member( wxDir_Open, dir, {s})
	delete_string( s )
	return b
end function












