--/////////////////////////////////////////////////////////////////////////////
--// Name:        wxStatusBar.e
--// Purpose:     Class include file for wxEuphoria
--// Author:      Matt Lewis
--// Modified by:
--// Created:     2004-01-23
--// Copyright:   (c) Matt Lewis
--// Licence:     wxWindows license
--/////////////////////////////////////////////////////////////////////////////
include dll.e
include cplusplus.e as cpp
include wxEuphoria.e as wxeu

-- begin autogenerated
------------------------------
include wxClassInfo.e as CI

-- begin class wxStatusBar (16 members)
------------------------------

global constant 

-- wxStatusBar::Create(wxWindow *, int, long, const wxString&)
wxStatusBar_Create = define_c_var( wxWin, "@wxStatusBar@Create$qp8wxWindowilrx8wxString" ),

-- wxStatusBar::DoMoveWindow(int, int, int, int)
wxStatusBar_DoMoveWindow = define_c_var( wxWin, "@wxStatusBar@DoMoveWindow$qiiii" ),

-- wxStatusBar::GetBorderX() const
wxStatusBar_GetBorderX = define_c_var( wxWin, "@wxStatusBar@GetBorderX$xqv" ),

-- wxStatusBar::GetBorderY() const
wxStatusBar_GetBorderY = define_c_var( wxWin, "@wxStatusBar@GetBorderY$xqv" ),

-- wxStatusBar::GetClassInfo() const
wxStatusBar_GetClassInfo = define_c_var( wxWin, "@wxStatusBar@GetClassInfo$xqv" ),

-- wxStatusBar::GetFieldRect(int, wxRect&) const
wxStatusBar_GetFieldRect = define_c_var( wxWin, "@wxStatusBar@GetFieldRect$xqir6wxRect" ),

-- wxStatusBar::GetStatusText(int) const
wxStatusBar_GetStatusText = define_c_var( wxWin, "@wxStatusBar@GetStatusText$xqi" ),

-- wxStatusBar::SetFieldsCount(int, const int *)
wxStatusBar_SetFieldsCount = define_c_var( wxWin, "@wxStatusBar@SetFieldsCount$qipxi" ),

-- wxStatusBar::SetFieldsWidth()
wxStatusBar_SetFieldsWidth = define_c_var( wxWin, "@wxStatusBar@SetFieldsWidth$qv" ),

-- wxStatusBar::SetMinHeight(int)
wxStatusBar_SetMinHeight = define_c_var( wxWin, "@wxStatusBar@SetMinHeight$qi" ),

-- wxStatusBar::SetStatusText(const wxString&, int)
wxStatusBar_SetStatusText = define_c_var( wxWin, "@wxStatusBar@SetStatusText$qrx8wxStringi" ),

-- wxStatusBar::SetStatusWidths(int, const int * const)
wxStatusBar_SetStatusWidths = define_c_var( wxWin, "@wxStatusBar@SetStatusWidths$qixpxi" ),

-- wxStatusBar::wxStatusBar(wxWindow *, int, long, const wxString&)
wxStatusBar_op_ctr = define_c_var( wxWin, "@wxStatusBar@$bctr$qp8wxWindowilrx8wxString" ),

-- wxStatusBar::wxStatusBar()
wxStatusBar_op_ctr_1 = define_c_var( wxWin, "@wxStatusBar@$bctr$qv" ),

-- wxStatusBar::~wxStatusBar()
wxStatusBar_op_dtr = define_c_var( wxWin, "@wxStatusBar@$bdtr$qv" ),

-- wxStatusBar::sm_classwxStatusBar
wxStatusBar_sm_classwxStatusBar = define_c_var( wxWin, "@wxStatusBar@sm_classwxStatusBar" ),

sizeof_wxStatusBar = CI:sizeof_class( wxStatusBar_sm_classwxStatusBar ),
wxStatusBar = define_class( "wxStatusBar", wxWin, wxStatusBar_op_ctr, sizeof_wxStatusBar, wxStatusBar_op_dtr )

-- end class wxStatusBar
------------------------------


-- begin class wxStatusBarBase (15 members)
------------------------------

global constant 

-- wxStatusBarBase::AcceptsFocus() const
wxStatusBarBase_AcceptsFocus = define_c_var( wxWin, "@wxStatusBarBase@AcceptsFocus$xqv" ),

-- wxStatusBarBase::CalculateAbsWidths(int) const
wxStatusBarBase_CalculateAbsWidths = define_c_var( wxWin, "@wxStatusBarBase@CalculateAbsWidths$xqi" ),

-- wxStatusBarBase::FreeStacks()
wxStatusBarBase_FreeStacks = define_c_var( wxWin, "@wxStatusBarBase@FreeStacks$qv" ),

-- wxStatusBarBase::FreeWidths()
wxStatusBarBase_FreeWidths = define_c_var( wxWin, "@wxStatusBarBase@FreeWidths$qv" ),

-- wxStatusBarBase::GetOrCreateStatusStack(int)
wxStatusBarBase_GetOrCreateStatusStack = define_c_var( wxWin, "@wxStatusBarBase@GetOrCreateStatusStack$qi" ),

-- wxStatusBarBase::GetStatusStack(int) const
wxStatusBarBase_GetStatusStack = define_c_var( wxWin, "@wxStatusBarBase@GetStatusStack$xqi" ),

-- wxStatusBarBase::InitStacks()
wxStatusBarBase_InitStacks = define_c_var( wxWin, "@wxStatusBarBase@InitStacks$qv" ),

-- wxStatusBarBase::InitWidths()
wxStatusBarBase_InitWidths = define_c_var( wxWin, "@wxStatusBarBase@InitWidths$qv" ),

-- wxStatusBarBase::PopStatusText(int)
wxStatusBarBase_PopStatusText = define_c_var( wxWin, "@wxStatusBarBase@PopStatusText$qi" ),

-- wxStatusBarBase::PushStatusText(const wxString&, int)
wxStatusBarBase_PushStatusText = define_c_var( wxWin, "@wxStatusBarBase@PushStatusText$qrx8wxStringi" ),

-- wxStatusBarBase::ReinitWidths()
wxStatusBarBase_ReinitWidths = define_c_var( wxWin, "@wxStatusBarBase@ReinitWidths$qv" ),

-- wxStatusBarBase::SetFieldsCount(int, const int *)
wxStatusBarBase_SetFieldsCount = define_c_var( wxWin, "@wxStatusBarBase@SetFieldsCount$qipxi" ),

-- wxStatusBarBase::SetStatusWidths(int, const int * const)
wxStatusBarBase_SetStatusWidths = define_c_var( wxWin, "@wxStatusBarBase@SetStatusWidths$qixpxi" ),

-- wxStatusBarBase::wxStatusBarBase()
wxStatusBarBase_op_ctr = define_c_var( wxWin, "@wxStatusBarBase@$bctr$qv" ),

-- wxStatusBarBase::~wxStatusBarBase()
wxStatusBarBase_op_dtr = define_c_var( wxWin, "@wxStatusBarBase@$bdtr$qv" ),

sizeof_wxStatusBarBase = 10,
wxStatusBarBase = define_class( "wxStatusBarBase", wxWin, wxStatusBarBase_op_ctr, sizeof_wxStatusBarBase, wxStatusBarBase_op_dtr )

-- end class wxStatusBarBase
------------------------------

-- end autogenerated
------------------------------

global constant
wxST_SIZEGRIP			  = #10

object void

--/topic wxStatusBar
--/proc set_status_fields( atom bar, sequence widths )
--/i widths:  An array of n integers, each of which is a status field width in pixels. 
--A value of -1 indicates that the field is variable width; at least one field must be -1.

global procedure set_status_fields( atom bar, sequence widths )
	atom ptr, fields
	fields = length( widths )
	ptr = wxeu:wx_alloc( 4 * fields )
	poke4( ptr, widths )
	void = cpp:call_member( wxStatusBar_SetFieldsCount, bar, {fields, ptr})
	wxeu:wx_free( ptr )
end procedure

--wxStatusBar(
--1 wxWindow* parent, 
--2 wxWindowID id, 
--3 long style = wxST_SIZEGRIP, 
--4 const wxString& name = "statusBar")

--virtual wxStatusBar* CreateStatusBar(
--int number = 1, 
--long style = 0, 
--wxWindowID id = -1, 
--const wxString& name = "statusBar"

constant default_bar = {1,0,-1,wxeu:create(wxeu:wxString,{"statusBar"})}
function new__wxStatusBar( sequence params )
	sequence bar
	bar = default_bar
	bar[1..length(params)] = params
	return new_instance( wxStatusBar, 0, bar )
end function

function new_wxStatusBar( sequence params )
	sequence bar
	atom this
	bar = default_bar

	bar[1..length(params)-1] = params[2..length(params)]

	this = call_member( wxFrameBase_CreateStatusBar, params[1], bar )

	return this
end function
wxeu:create_func( wxStatusBar, routine_id("new_wxStatusBar"))

--wxStatusBar
-------------------

--/topic wxStatusBar
--/parent Classes
--/parent wxFrame
--/parent Controls
--/info
--include file: wxStatusBar
--The status bar should be a child of a /wxFrame.  Creation parameters:
--<ul>
--/li atom parent
--/li atom fields
--/li atom style [= 0]
--</ul>

--/topic wxStatusBar
--/proc set_status_text( atom bar, sequence text, integer field )
--Set the status text of field /i field (zero based).  This routine does
--nothing if /i field refers to a non-existant status field.
with trace
global procedure set_status_text( atom bar, sequence text, integer field )
	atom str
	
	-- bounds check the number of status fields:
--#WIN32
	if field >= peek4u( bar + sizeof_wxStatusBar - 12 ) then
--#ENDWIN32
--#LINUX
--	if field >= cpp:call_member( wxStatusBarBase_GetFieldsCount, bar, {}) then
--#ENDLINUX
		return
	end if
	str = wxeu:create( wxeu:wxString, {text})
	void = cpp:call_member( wxStatusBar_SetStatusText, bar, {str, field})
end procedure



















