--/////////////////////////////////////////////////////////////////////////////
--// Name:        wxTimer.e
--// Purpose:     Class include file for wxEuphoria
--// Author:      Matt Lewis
--// Modified by:
--// Created:     2004-01-23
--// Copyright:   (c) Matt Lewis
--// Licence:     wxWindows license
--/////////////////////////////////////////////////////////////////////////////
include dll.e
include cplusplus.e as cpp
include wxEuphoria.e as wxeu

-- begin autogenerated
------------------------------
include wxClassInfo.e as CI

-- begin class wxTimer (8 members)
------------------------------

global constant 

-- wxTimer::GetClassInfo() const
wxTimer_GetClassInfo = define_c_var( wxWin, "@wxTimer@GetClassInfo$xqv" ),

-- wxTimer::Init()
wxTimer_Init = define_c_var( wxWin, "@wxTimer@Init$qv" ),

-- wxTimer::IsRunning() const
wxTimer_IsRunning = define_c_var( wxWin, "@wxTimer@IsRunning$xqv" ),

-- wxTimer::Start(int, bool)
wxTimer_Start = define_c_var( wxWin, "@wxTimer@Start$qio" ),

-- wxTimer::Stop()
wxTimer_Stop = define_c_var( wxWin, "@wxTimer@Stop$qv" ),

-- wxTimer::wxTimer()
wxTimer_op_ctr = define_c_var( wxWin, "@wxTimer@$bctr$qv" ),

-- wxTimer::~wxTimer()
wxTimer_op_dtr = define_c_var( wxWin, "@wxTimer@$bdtr$qv" ),

-- wxTimer::sm_classwxTimer
wxTimer_sm_classwxTimer = define_c_var( wxWin, "@wxTimer@sm_classwxTimer" ),

sizeof_wxTimer = CI:sizeof_class( wxTimer_sm_classwxTimer ),
wxTimer = define_class( "wxTimer", wxWin, wxTimer_op_ctr, sizeof_wxTimer, wxTimer_op_dtr )

-- end class wxTimer
------------------------------


-- begin class wxTimerBase (7 members)
------------------------------

global constant 

-- wxTimerBase::Init()
wxTimerBase_Init = define_c_var( wxWin, "@wxTimerBase@Init$qv" ),

-- wxTimerBase::IsOneShot() const
wxTimerBase_IsOneShot = define_c_var( wxWin, "@wxTimerBase@IsOneShot$xqv" ),

-- wxTimerBase::Notify()
wxTimerBase_Notify = define_c_var( wxWin, "@wxTimerBase@Notify$qv" ),

-- wxTimerBase::SetOwner(wxEvtHandler *, int)
wxTimerBase_SetOwner = define_c_var( wxWin, "@wxTimerBase@SetOwner$qp12wxEvtHandleri" ),

-- wxTimerBase::Start(int, bool)
wxTimerBase_Start = define_c_var( wxWin, "@wxTimerBase@Start$qio" ),

-- wxTimerBase::wxTimerBase()
wxTimerBase_op_ctr = define_c_var( wxWin, "@wxTimerBase@$bctr$qv" ),

-- wxTimerBase::~wxTimerBase()
wxTimerBase_op_dtr = define_c_var( wxWin, "@wxTimerBase@$bdtr$qv" ),

sizeof_wxTimerBase = 10,
wxTimerBase = define_class( "wxTimerBase", wxWin, wxTimerBase_op_ctr, sizeof_wxTimerBase, wxTimerBase_op_dtr )

-- end class wxTimerBase
------------------------------

-- end autogenerated
------------------------------

object void

--Timers
--------------------------------

--/topic Timers
--/info
--Setting and using timers
---

--wxTimer
-----------------------------

--/topic wxTimer
--/parent Timers
--/parent Classes
--/parent Events
--/info
--include file: wxTimer
--Creation parameters:
--<ul>
--/li parent
--/li id [=-1]
--</ul>
--The /i parent is important, as this is the only way to receive wxTimer events.
--To set a timer event handler, use wxEVT_TIMER:
--/code
--ex:
--
--constant
--main = create( wxFrame, {0,-1,"Timer"}),
--timer = create( wxTimer, {main})
--
--procedure on_timer( atom this, atom event )
--    puts(1,"Timer\n")
--end procedure
--
---- NOTE: using the parent to identify the timer.
--set_event_handler( main, -1, wxEVT_TIMER, routine_id("on_timer"))
--
---- set the timer to fire every 1 second, repeatedly
--start_timer( timer, 1000, 0 )
--
--wxMain( main )
--/endcode

--/topic wxTimer
--/proc start_timer( atom timer, atom msec, integer oneshot )
--
--Set the timer to fire every /i msec millisecond ( 1000msec = 1sec ).  /i oneshot
--indicates whether the timer should stop firing after the first time, or fire
--repeatedly until /stop_timer() is called.
global procedure start_timer( atom timer, atom msec, integer oneshot )
	void = cpp:call_member( wxTimer_Start, timer, {msec, oneshot})
end procedure

--/topic wxTimer
--/proc stop_timer( atom timer )
--
--Stops a timer from firing until reset using /start_timer().
global procedure stop_timer( atom timer )
	void = cpp:call_member( wxTimer_Stop, timer, {})
end procedure

function new_wxTimer( sequence params )
	atom this
	this = new_instance( wxTimer, 0, {})
	if length(params) = 1 then
		params &= -1
	end if

	void = call_member( wxTimerBase_SetOwner, this, params )
	return this
end function
create_func( wxTimer, routine_id("new_wxTimer"))





















