--/////////////////////////////////////////////////////////////////////////////
--// Name:        wxEuphoria.e
--// Purpose:     Main include for wxEuphoria, including many basic classes
--// Author:      Matt Lewis
--// Modified by:
--// Created:     2003-07-03
--// Copyright:   (c) Matt Lewis
--// Licence:     wxWidgets license
--/////////////////////////////////////////////////////////////////////////////
with trace
without warning


integer events_ok
events_ok = 1
--/topic Events
--/proc enable_events()
--
--Resumes calls to event handlers after /disable_events() has
--been called.

global procedure enable_events()
	events_ok = 1
end procedure

--/topic Events
--/proc disable_events()
--
--Suspends event handling calls to your event handlers until
--/enable_events() is called.
global procedure disable_events()
	events_ok = 0
end procedure



include dll.e as dll
include get.e
include misc.e

global sequence PATH
integer slash
PATH = command_line()
if length(PATH) then
	PATH = reverse(PATH[2])
else
	PATH = ""
end if

if platform() = LINUX then
	slash = '/'
else
	slash = '\\'
end if

if find(slash, PATH) then
	PATH = reverse( PATH[find(slash, PATH)..$] )
else
	PATH = ""
end if

--function define_c_var( object d, object v )
--	atom p
--	
--	p = dll:define_c_var( d, v )
--	if p = 23733224 then -- wxDefaultValidator
--	if p = 23733304 then
--
--		? 1/0
--		
--	end if
--	return p
--end function

--/topic Miscellaneous Routines
--/func wxEu_Lib()
--
--This is a global function that you can declare /i before you include wxEuphoria.e.
--If it is present, the return value of the function will be used as the name
--of the wxEuphoria library when calling open_dll().  The default names are:
--/code
--   Win32: wxeu.dll
--  Linux: $EUDIR/bin/wxeu.so
--/endcode

sequence wxWin_name

global constant
wxEuphoria_Version = {0,9,0},
--#WIN32
wxEuphoria_Platform = WIN32,
wxNEED_BUILD = 9
wxWin_name = "wxeu.dll"
--#ENDWIN32

--#LINUX
--wxEuphoria_Platform = LINUX,
--wxNEED_BUILD = 9
--wxWin_name = "wxeu.so"
--#ENDLINUX
if routine_id("wxEu_Lib") != -1 then
	wxWin_name = call_func( routine_id("wxEu_Lib"), {})
end if
global constant
wxWin = open_dll( wxWin_name )

if wxWin <= 0 then
	printf(2, "The wxEuphoria library \"%s\" could not be opened.\nPress any key to exit.\n",
		{wxWin_name})
	abort( wait_key() )
end if

global constant
--#LINUX
--WX_DLL_BUILD = peek4u(define_c_var(wxWin, "WX_DLL_BUILD"))
--
--global constant
--euret  = define_c_var( wxWin, "_ZN8wxEuCall5euretE" ),
--eucall = define_c_proc( wxWin, "_ZN8wxEuCall6eucallEv", {} ),
--eucall_str = define_c_proc( wxWin, "_ZN8wxEuCall6eucallER8wxString", {C_POINTER} ),
--eufunc = define_c_var( wxWin, "_ZN8wxEuCall6eufuncE" ),
--euparam_count = define_c_var( wxWin, "_ZN8wxEuCall7euparamE" ),
--eulog = define_c_func( wxWin, "_ZN8wxEuCall5eulogEPKc", {C_POINTER}, C_POINTER),
--euparam = euparam_count + 4
--#ENDLINUX

--#WIN32
WX_DLL_BUILD = peek4u(define_c_var(wxWin, "_WX_DLL_BUILD"))
global constant
eucall = define_c_proc( wxWin, "+@wxEuCall@eucall$qv", {} ),
eucall_str = define_c_proc( wxWin, "+@wxEuCall@eucall$qr8wxString", {C_POINTER}),
eufunc = define_c_var( wxWin, "@wxEuCall@eufunc" ),
euret  = define_c_var( wxWin, "@wxEuCall@euret" ),
euparam_count = define_c_var( wxWin, "@wxEuCall@euparam" ),
euparam = euparam_count + 4,
eulog = define_c_func( wxWin, "+@wxEuCall@eulog$qpxc", {C_POINTER}, C_POINTER)
--#ENDWIN32


include cplusplus.e as cpp
include wxLowLevel.e

object void

-- begin autogenerated
------------------------------
include wxClassInfo.e as CI

-- begin class functions (252 members)
------------------------------

global constant 

-- DoubleToString(double, const char *)
DoubleToString = define_c_var( wxWin, "@DoubleToString$qdpxc" ),

-- FloatToString(float, const char *)
FloatToString = define_c_var( wxWin, "@FloatToString$qfpxc" ),

-- GetLine(wxSocketBase *, wxString&)
GetLine = define_c_var( wxWin, "@GetLine$qp12wxSocketBaser8wxString" ),

-- IntToString(int)
IntToString = define_c_var( wxWin, "@IntToString$qi" ),

-- LongToString(long)
LongToString = define_c_var( wxWin, "@LongToString$ql" ),

-- StringToDouble(const char *, double *)
StringToDouble = define_c_var( wxWin, "@StringToDouble$qpxcpd" ),

-- StringToFloat(const char *, float *)
StringToFloat = define_c_var( wxWin, "@StringToFloat$qpxcpf" ),

-- StringToInt(const char *, int *)
StringToInt = define_c_var( wxWin, "@StringToInt$qpxcpi" ),

-- StringToLong(const char *, long *)
StringToLong = define_c_var( wxWin, "@StringToLong$qpxcpl" ),

-- copystring(const char *)
copystring = define_c_var( wxWin, "@copystring$qpxc" ),

-- endl(wxTextOutputStream&)
endl = define_c_var( wxWin, "@endl$qr18wxTextOutputStream" ),

-- wxAssert(int, const char *, int, const char *, const char *)
wxAssert = define_c_var( wxWin, "@wxAssert$qipxcit2t2" ),

-- wxAssertIsEqual(int, int)
wxAssertIsEqual = define_c_var( wxWin, "@wxAssertIsEqual$qii" ),

-- wxAtof(const char *)
wxAtof = define_c_var( wxWin, "@wxAtof$qpxc" ),

-- wxBeginBusyCursor(wxCursor *)
wxBeginBusyCursor = define_c_var( wxWin, "@wxBeginBusyCursor$qp8wxCursor" ),

-- wxBell()
wxBell = define_c_var( wxWin, "@wxBell$qv" ),

-- wxCanUseInitThemeEngine()
wxCanUseInitThemeEngine = define_c_var( wxWin, "@wxCanUseInitThemeEngine$qv" ),

-- wxCharCodeMSWToWX(int)
wxCharCodeMSWToWX = define_c_var( wxWin, "@wxCharCodeMSWToWX$qi" ),

-- wxCharCodeWXToMSW(int, bool *)
wxCharCodeWXToMSW = define_c_var( wxWin, "@wxCharCodeWXToMSW$qipo" ),

-- wxCheckForInterrupt(wxWindow *)
wxCheckForInterrupt = define_c_var( wxWin, "@wxCheckForInterrupt$qp8wxWindow" ),

-- wxCheckWindowWndProc(unsigned long, int __stdcall (*)())
wxCheckWindowWndProc = define_c_var( wxWin, "@wxCheckWindowWndProc$qulpqqsv$i" ),

-- wxClientDisplayRect(int *, int *, int *, int *)
wxClientDisplayRect = define_c_var( wxWin, "@wxClientDisplayRect$qpit1t1t1" ),

-- wxCloseClipboard()
wxCloseClipboard = define_c_var( wxWin, "@wxCloseClipboard$qv" ),

-- wxColourDisplay()
wxColourDisplay = define_c_var( wxWin, "@wxColourDisplay$qv" ),

-- wxConcatFiles(const wxString&, const wxString&, const wxString&)
wxConcatFiles = define_c_var( wxWin, "@wxConcatFiles$qrx8wxStringt1t1" ),

-- wxContextId(int)
wxContextId = define_c_var( wxWin, "@wxContextId$qi" ),

-- wxContractPath(const wxString&, const wxString&, const wxString&)
wxContractPath = define_c_var( wxWin, "@wxContractPath$qrx8wxStringt1t1" ),

-- wxConvertBitmapToDIB(tagBITMAPINFO *, const wxBitmap&)
wxConvertBitmapToDIB = define_c_var( wxWin, "@wxConvertBitmapToDIB$qp13tagBITMAPINFOrx8wxBitmap" ),

-- wxConvertDIBToBitmap(tagBITMAPINFO * const)
wxConvertDIBToBitmap = define_c_var( wxWin, "@wxConvertDIBToBitmap$qxp13tagBITMAPINFO" ),

-- wxCopyAbsolutePath(const wxString&)
wxCopyAbsolutePath = define_c_var( wxWin, "@wxCopyAbsolutePath$qrx8wxString" ),

-- wxCopyFile(const wxString&, const wxString&, bool)
wxCopyFile = define_c_var( wxWin, "@wxCopyFile$qrx8wxStringt1o" ),

-- wxCreateDynamicObject(const char *)
wxCreateDynamicObject = define_c_var( wxWin, "@wxCreateDynamicObject$qpxc" ),

-- wxCreateFileTipProvider(const wxString&, unsigned int)
wxCreateFileTipProvider = define_c_var( wxWin, "@wxCreateFileTipProvider$qrx8wxStringui" ),

-- wxCreateFontFromLogFont(const tagLOGFONTA *)
wxCreateFontFromLogFont = define_c_var( wxWin, "@wxCreateFontFromLogFont$qpx11tagLOGFONTA" ),

-- wxDDECleanUp()
wxDDECleanUp = define_c_var( wxWin, "@wxDDECleanUp$qv" ),

-- wxDDEInitialize()
wxDDEInitialize = define_c_var( wxWin, "@wxDDEInitialize$qv" ),

-- wxDecToHex(int)
wxDecToHex = define_c_var( wxWin, "@wxDecToHex$qi" ),

-- wxDecToHex(int, char *)
wxDecToHex_1 = define_c_var( wxWin, "@wxDecToHex$qipc" ),

-- wxDeleteStockLists()
wxDeleteStockLists = define_c_var( wxWin, "@wxDeleteStockLists$qv" ),

-- wxDeleteStockObjects()
wxDeleteStockObjects = define_c_var( wxWin, "@wxDeleteStockObjects$qv" ),

-- wxDirSelector(const wxString&, const wxString&, long, const wxPoint&, wxWindow *)
wxDirSelector = define_c_var( wxWin, "@wxDirSelector$qrx8wxStringt1lrx7wxPointp8wxWindow" ),

-- wxDisplayDepth()
wxDisplayDepth = define_c_var( wxWin, "@wxDisplayDepth$qv" ),

-- wxDisplaySize(int *, int *)
wxDisplaySize = define_c_var( wxWin, "@wxDisplaySize$qpit1" ),

-- wxDisplaySizeMM(int *, int *)
wxDisplaySizeMM = define_c_var( wxWin, "@wxDisplaySizeMM$qpit1" ),

-- wxDos2UnixFilename(char *)
wxDos2UnixFilename = define_c_var( wxWin, "@wxDos2UnixFilename$qpc" ),

-- wxEmptyClipboard()
wxEmptyClipboard = define_c_var( wxWin, "@wxEmptyClipboard$qv" ),

-- wxEnableTopLevelWindows(bool)
wxEnableTopLevelWindows = define_c_var( wxWin, "@wxEnableTopLevelWindows$qo" ),

-- wxEndBusyCursor()
wxEndBusyCursor = define_c_var( wxWin, "@wxEndBusyCursor$qv" ),

-- wxEndL(wxOutputStream&)
wxEndL = define_c_var( wxWin, "@wxEndL$qr14wxOutputStream" ),

-- wxEndsWithPathSeparator(const char *)
wxEndsWithPathSeparator = define_c_var( wxWin, "@wxEndsWithPathSeparator$qpxc" ),

-- wxEntry(void *, void *, char *, int, bool)
wxEntry = define_c_var( wxWin, "@wxEntry$qpvt1pcio" ),

-- wxEntryCleanup()
wxEntryCleanup = define_c_var( wxWin, "@wxEntryCleanup$qv" ),

-- wxEntryInitGui()
wxEntryInitGui = define_c_var( wxWin, "@wxEntryInitGui$qv" ),

-- wxEntryStart(int, char * *)
wxEntryStart = define_c_var( wxWin, "@wxEntryStart$qippc" ),

-- wxEnumClipboardFormats(wxDataFormat)
wxEnumClipboardFormats = define_c_var( wxWin, "@wxEnumClipboardFormats$q12wxDataFormat" ),

-- wxExecute(char * *, int, wxProcess *)
wxExecute = define_c_var( wxWin, "@wxExecute$qppcip9wxProcess" ),

-- wxExecute(const wxString&, int, wxProcess *)
wxExecute_1 = define_c_var( wxWin, "@wxExecute$qrx8wxStringip9wxProcess" ),

-- wxExecute(const wxString&, wxArrayString&)
wxExecute_2 = define_c_var( wxWin, "@wxExecute$qrx8wxStringr13wxArrayString" ),

-- wxExecute(const wxString&, wxArrayString&, wxArrayString&)
wxExecute_3 = define_c_var( wxWin, "@wxExecute$qrx8wxStringr13wxArrayStringt2" ),

-- wxExit()
wxExit = define_c_var( wxWin, "@wxExit$qv" ),

-- wxExpandEnvVars(const wxString&)
wxExpandEnvVars = define_c_var( wxWin, "@wxExpandEnvVars$qrx8wxString" ),

-- wxExpandPath(char *, const char *)
wxExpandPath = define_c_var( wxWin, "@wxExpandPath$qpcpxc" ),

-- wxFileExists(const wxString&)
wxFileExists = define_c_var( wxWin, "@wxFileExists$qrx8wxString" ),

-- wxFileModificationTime(const wxString&)
wxFileModificationTime = define_c_var( wxWin, "@wxFileModificationTime$qrx8wxString" ),

-- wxFileNameFromPath(char *)
wxFileNameFromPath = define_c_var( wxWin, "@wxFileNameFromPath$qpc" ),

-- wxFileNameFromPath(const wxString&)
wxFileNameFromPath_1 = define_c_var( wxWin, "@wxFileNameFromPath$qrx8wxString" ),

-- wxFileSelector(const char *, const char *, const char *, const char *, const char *, int, wxWindow *, int, int)
wxFileSelector = define_c_var( wxWin, "@wxFileSelector$qpxct1t1t1t1ip8wxWindowii" ),

-- wxFileSelector(wxString&,const char*,const char*,const char*,const char*,const char*,int,wxWindow*,int,int)
wxFileSelector2 = define_c_var( wxWin, "@wxFileSelector$qr8wxStringpxct2t2t2t2ip8wxWindowii" ),

-- wxFileSelectorEx(const char *, const char *, const char *, int *, const char *, int, wxWindow *, int, int)
wxFileSelectorEx = define_c_var( wxWin, "@wxFileSelectorEx$qpxct1t1pit1ip8wxWindowii" ),

-- wxFillLogFont(tagLOGFONTA *, const wxFont *)
wxFillLogFont = define_c_var( wxWin, "@wxFillLogFont$qp11tagLOGFONTApx6wxFont" ),

-- wxFindFileInPath(wxString *, const char *, const char *)
wxFindFileInPath = define_c_var( wxWin, "@wxFindFileInPath$qp8wxStringpxct2" ),

-- wxFindFirstFile(const char *, int)
wxFindFirstFile = define_c_var( wxWin, "@wxFindFirstFile$qpxci" ),

-- wxFindMaxSize(unsigned long, tagRECT *)
wxFindMaxSize = define_c_var( wxWin, "@wxFindMaxSize$qulp7tagRECT" ),

-- wxFindMenuItemId(wxFrame *, const wxString&, const wxString&)
wxFindMenuItemId = define_c_var( wxWin, "@wxFindMenuItemId$qp7wxFramerx8wxStringt2" ),

-- wxFindNextFile()
wxFindNextFile = define_c_var( wxWin, "@wxFindNextFile$qv" ),

-- wxFindWinFromHandle(unsigned long)
wxFindWinFromHandle = define_c_var( wxWin, "@wxFindWinFromHandle$qul" ),

-- wxFindWindowAtPoint(const wxPoint&)
wxFindWindowAtPoint = define_c_var( wxWin, "@wxFindWindowAtPoint$qrx7wxPoint" ),

-- wxFindWindowAtPointer(wxPoint&)
wxFindWindowAtPointer = define_c_var( wxWin, "@wxFindWindowAtPointer$qr7wxPoint" ),

-- wxFindWindowByLabel(const wxString&, wxWindow *)
wxFindWindowByLabel = define_c_var( wxWin, "@wxFindWindowByLabel$qrx8wxStringp8wxWindow" ),

-- wxFindWindowByName(const wxString&, wxWindow *)
wxFindWindowByName = define_c_var( wxWin, "@wxFindWindowByName$qrx8wxStringp8wxWindow" ),

-- wxFlushEvents()
wxFlushEvents = define_c_var( wxWin, "@wxFlushEvents$qv" ),

-- wxGenericFindWindowAtPoint(const wxPoint&)
wxGenericFindWindowAtPoint = define_c_var( wxWin, "@wxGenericFindWindowAtPoint$qrx7wxPoint" ),

-- wxGetAccelFromString(const wxString&)
wxGetAccelFromString = define_c_var( wxWin, "@wxGetAccelFromString$qrx8wxString" ),

-- wxGetActiveWindow()
wxGetActiveWindow = define_c_var( wxWin, "@wxGetActiveWindow$qv" ),

-- wxGetCharSize(unsigned long, int *, int *, const wxFont *)
wxGetCharSize = define_c_var( wxWin, "@wxGetCharSize$qulpit2px6wxFont" ),

-- wxGetClientDisplayRect()
wxGetClientDisplayRect = define_c_var( wxWin, "@wxGetClientDisplayRect$qv" ),

-- wxGetClipboardData(wxDataFormat, long *)
wxGetClipboardData = define_c_var( wxWin, "@wxGetClipboardData$q12wxDataFormatpl" ),

-- wxGetClipboardFormatName(wxDataFormat, char *, int)
wxGetClipboardFormatName = define_c_var( wxWin, "@wxGetClipboardFormatName$q12wxDataFormatpci" ),

-- wxGetColourFromUser(wxWindow *, const wxColour&)
wxGetColourFromUser = define_c_var( wxWin, "@wxGetColourFromUser$qp8wxWindowrx8wxColour" ),

-- wxGetCurrentId()
wxGetCurrentId = define_c_var( wxWin, "@wxGetCurrentId$qv" ),

-- wxGetCwd()
wxGetCwd = define_c_var( wxWin, "@wxGetCwd$qv" ),

-- wxGetDataDir()
wxGetDataDir = define_c_var( wxWin, "@wxGetDataDir$qv" ),

-- wxGetDiskSpace(const wxString&, wxLongLongNative *, wxLongLongNative *)
wxGetDiskSpace = define_c_var( wxWin, "@wxGetDiskSpace$qrx8wxStringp16wxLongLongNativet2" ),

-- wxGetDisplaySize()
wxGetDisplaySize = define_c_var( wxWin, "@wxGetDisplaySize$qv" ),

-- wxGetDisplaySizeMM()
wxGetDisplaySizeMM = define_c_var( wxWin, "@wxGetDisplaySizeMM$qv" ),

-- wxGetElapsedTime(bool)
wxGetElapsedTime = define_c_var( wxWin, "@wxGetElapsedTime$qo" ),

-- wxGetEmailAddress(char *, int)
wxGetEmailAddress = define_c_var( wxWin, "@wxGetEmailAddress$qpci" ),

-- wxGetEmailAddress()
wxGetEmailAddress_1 = define_c_var( wxWin, "@wxGetEmailAddress$qv" ),

-- wxGetEnv(const wxString&, wxString *)
wxGetEnv = define_c_var( wxWin, "@wxGetEnv$qrx8wxStringp8wxString" ),

-- wxGetFontEncFromCharSet(int)
wxGetFontEncFromCharSet = define_c_var( wxWin, "@wxGetFontEncFromCharSet$qi" ),

-- wxGetFontFromUser(wxWindow *, const wxFont&)
wxGetFontFromUser = define_c_var( wxWin, "@wxGetFontFromUser$qp8wxWindowrx6wxFont" ),

-- wxGetFreeMemory()
wxGetFreeMemory = define_c_var( wxWin, "@wxGetFreeMemory$qv" ),

-- wxGetFullHostName(char *, int)
wxGetFullHostName = define_c_var( wxWin, "@wxGetFullHostName$qpci" ),

-- wxGetFullHostName()
wxGetFullHostName_1 = define_c_var( wxWin, "@wxGetFullHostName$qv" ),

-- wxGetHiconSize(HICON__ *)
wxGetHiconSize = define_c_var( wxWin, "@wxGetHiconSize$qp7HICON__" ),

-- wxGetHomeDir(wxString *)
wxGetHomeDir = define_c_var( wxWin, "@wxGetHomeDir$qp8wxString" ),

-- wxGetHomeDir()
wxGetHomeDir_1 = define_c_var( wxWin, "@wxGetHomeDir$qv" ),

-- wxGetHostName(char *, int)
wxGetHostName = define_c_var( wxWin, "@wxGetHostName$qpci" ),

-- wxGetHostName()
wxGetHostName_1 = define_c_var( wxWin, "@wxGetHostName$qv" ),

-- wxGetInstallPrefix()
wxGetInstallPrefix = define_c_var( wxWin, "@wxGetInstallPrefix$qv" ),

-- wxGetKeyState(wxKeyCode)
wxGetKeyState = define_c_var( wxWin, "@wxGetKeyState$q9wxKeyCode" ),

-- wxGetLocalTime()
wxGetLocalTime = define_c_var( wxWin, "@wxGetLocalTime$qv" ),

-- wxGetLocalTimeMillis()
wxGetLocalTimeMillis = define_c_var( wxWin, "@wxGetLocalTimeMillis$qv" ),

-- wxGetLocale()
wxGetLocale = define_c_var( wxWin, "@wxGetLocale$qv" ),

-- wxGetMousePosition(int *, int *)
wxGetMousePosition = define_c_var( wxWin, "@wxGetMousePosition$qpit1" ),

-- wxGetMousePosition()
wxGetMousePosition_1 = define_c_var( wxWin, "@wxGetMousePosition$qv" ),

-- wxGetMultipleChoices(wxArrayInt&, const wxString&, const wxString&, int, const wxString *, wxWindow *, int, int, bool, int, int)
wxGetMultipleChoices = define_c_var( wxWin, "@wxGetMultipleChoices$qr10wxArrayIntrx8wxStringt2ipx8wxStringp8wxWindowiioii" ),

-- wxGetMultipleChoices(wxArrayInt&, const wxString&, const wxString&, const wxArrayString&, wxWindow *, int, int, bool, int, int)
wxGetMultipleChoices_1 = define_c_var( wxWin, "@wxGetMultipleChoices$qr10wxArrayIntrx8wxStringt2rx13wxArrayStringp8wxWindowiioii" ),

-- wxGetNumberFromUser(const wxString&, const wxString&, const wxString&, long, long, long, wxWindow *, const wxPoint&)
wxGetNumberFromUser = define_c_var( wxWin, "@wxGetNumberFromUser$qrx8wxStringt1t1lllp8wxWindowrx7wxPoint" ),

-- wxGetOSDirectory()
wxGetOSDirectory = define_c_var( wxWin, "@wxGetOSDirectory$qv" ),

-- wxGetOsDescription()
wxGetOsDescription = define_c_var( wxWin, "@wxGetOsDescription$qv" ),

-- wxGetOsVersion(int *, int *)
wxGetOsVersion = define_c_var( wxWin, "@wxGetOsVersion$qpit1" ),

-- wxGetPasswordFromUser(const wxString&, const wxString&, const wxString&, wxWindow *)
wxGetPasswordFromUser = define_c_var( wxWin, "@wxGetPasswordFromUser$qrx8wxStringt1t1p8wxWindow" ),

-- wxGetPrinterDC(const wxPrintData&)
wxGetPrinterDC = define_c_var( wxWin, "@wxGetPrinterDC$qrx11wxPrintData" ),

-- wxGetProcessId()
wxGetProcessId = define_c_var( wxWin, "@wxGetProcessId$qv" ),

-- wxGetResource(const wxString&, const wxString&, float *, const wxString&)
wxGetResource = define_c_var( wxWin, "@wxGetResource$qrx8wxStringt1pft1" ),

-- wxGetResource(const wxString&, const wxString&, int *, const wxString&)
wxGetResource_1 = define_c_var( wxWin, "@wxGetResource$qrx8wxStringt1pit1" ),

-- wxGetResource(const wxString&, const wxString&, long *, const wxString&)
wxGetResource_2 = define_c_var( wxWin, "@wxGetResource$qrx8wxStringt1plt1" ),

-- wxGetResource(const wxString&, const wxString&, char * *, const wxString&)
wxGetResource_3 = define_c_var( wxWin, "@wxGetResource$qrx8wxStringt1ppct1" ),

-- wxGetSingleChoice(const wxString&, const wxString&, int, const wxString *, wxWindow *, int, int, bool, int, int)
wxGetSingleChoice = define_c_var( wxWin, "@wxGetSingleChoice$qrx8wxStringt1ipx8wxStringp8wxWindowiioii" ),

-- wxGetSingleChoiceData(const wxString&, const wxString&, int, const wxString *, void * *, wxWindow *, int, int, bool, int, int)
wxGetSingleChoiceData = define_c_var( wxWin, "@wxGetSingleChoiceData$qrx8wxStringt1ipx8wxStringppvp8wxWindowiioii" ),

-- wxGetSingleChoiceData(const wxString&, const wxString&, const wxArrayString&, void * *, wxWindow *, int, int, bool, int, int)
wxGetSingleChoiceData_1 = define_c_var( wxWin, "@wxGetSingleChoiceData$qrx8wxStringt1rx13wxArrayStringppvp8wxWindowiioii" ),

-- wxGetSingleChoiceIndex(const wxString&, const wxString&, int, const wxString *, wxWindow *, int, int, bool, int, int)
wxGetSingleChoiceIndex = define_c_var( wxWin, "@wxGetSingleChoiceIndex$qrx8wxStringt1ipx8wxStringp8wxWindowiioii" ),

-- wxGetSingleChoiceIndex(const wxString&, const wxString&, const wxArrayString&, wxWindow *, int, int, bool, int, int)
wxGetSingleChoiceIndex_1 = define_c_var( wxWin, "@wxGetSingleChoiceIndex$qrx8wxStringt1rx13wxArrayStringp8wxWindowiioii" ),

-- wxGetSingleChoice(const wxString&, const wxString&, const wxArrayString&, wxWindow *, int, int, bool, int, int)
wxGetSingleChoice_1 = define_c_var( wxWin, "@wxGetSingleChoice$qrx8wxStringt1rx13wxArrayStringp8wxWindowiioii" ),

-- wxGetTempFileName(const wxString&, char *)
wxGetTempFileName = define_c_var( wxWin, "@wxGetTempFileName$qrx8wxStringpc" ),

-- wxGetTempFileName(const wxString&, wxString&)
wxGetTempFileName_1 = define_c_var( wxWin, "@wxGetTempFileName$qrx8wxStringr8wxString" ),

-- wxGetTextFromUser(const wxString&, const wxString&, const wxString&, wxWindow *, int, int, bool)
wxGetTextFromUser = define_c_var( wxWin, "@wxGetTextFromUser$qrx8wxStringt1t1p8wxWindowiio" ),

-- wxGetTopLevelParent(wxWindow *)
wxGetTopLevelParent = define_c_var( wxWin, "@wxGetTopLevelParent$qp8wxWindow" ),

-- wxGetUTCTime()
wxGetUTCTime = define_c_var( wxWin, "@wxGetUTCTime$qv" ),

-- wxGetUserHome(const wxString&)
wxGetUserHome = define_c_var( wxWin, "@wxGetUserHome$qrx8wxString" ),

-- wxGetUserId(char *, int)
wxGetUserId = define_c_var( wxWin, "@wxGetUserId$qpci" ),

-- wxGetUserId()
wxGetUserId_1 = define_c_var( wxWin, "@wxGetUserId$qv" ),

-- wxGetUserName(char *, int)
wxGetUserName = define_c_var( wxWin, "@wxGetUserName$qpci" ),

-- wxGetUserName()
wxGetUserName_1 = define_c_var( wxWin, "@wxGetUserName$qv" ),

-- wxGetWindowClass(unsigned long)
wxGetWindowClass = define_c_var( wxWin, "@wxGetWindowClass$qul" ),

-- wxGetWindowFromHWND(unsigned long)
wxGetWindowFromHWND = define_c_var( wxWin, "@wxGetWindowFromHWND$qul" ),

-- wxGetWindowId(unsigned long)
wxGetWindowId = define_c_var( wxWin, "@wxGetWindowId$qul" ),

-- wxGetWindowText(unsigned long)
wxGetWindowText = define_c_var( wxWin, "@wxGetWindowText$qul" ),

-- wxGetWorkingDirectory(char *, int)
wxGetWorkingDirectory = define_c_var( wxWin, "@wxGetWorkingDirectory$qpci" ),

-- wxHandleFatalExceptions(bool)
wxHandleFatalExceptions = define_c_var( wxWin, "@wxHandleFatalExceptions$qo" ),

-- wxHexToDec(const wxString&)
wxHexToDec = define_c_var( wxWin, "@wxHexToDec$qrx8wxString" ),

-- wxInitAllImageHandlers()
wxInitAllImageHandlers = define_c_var( wxWin, "@wxInitAllImageHandlers$qv" ),

-- wxInitializeStockLists()
wxInitializeStockLists = define_c_var( wxWin, "@wxInitializeStockLists$qv" ),

-- wxInitializeStockObjects()
wxInitializeStockObjects = define_c_var( wxWin, "@wxInitializeStockObjects$qv" ),

-- wxIsAbsolutePath(const wxString&)
wxIsAbsolutePath = define_c_var( wxWin, "@wxIsAbsolutePath$qrx8wxString" ),

-- wxIsBusy()
wxIsBusy = define_c_var( wxWin, "@wxIsBusy$qv" ),

-- wxIsClipboardFormatAvailable(wxDataFormat)
wxIsClipboardFormatAvailable = define_c_var( wxWin, "@wxIsClipboardFormatAvailable$q12wxDataFormat" ),

-- wxIsClipboardOpened()
wxIsClipboardOpened = define_c_var( wxWin, "@wxIsClipboardOpened$qv" ),

-- wxIsDragResultOk(wxDragResult)
wxIsDragResultOk = define_c_var( wxWin, "@wxIsDragResultOk$q12wxDragResult" ),

-- wxIsWild(const wxString&)
wxIsWild = define_c_var( wxWin, "@wxIsWild$qrx8wxString" ),

-- wxKill(long, wxSignal, wxKillError *)
wxKill = define_c_var( wxWin, "@wxKill$ql8wxSignalp11wxKillError" ),

-- wxLoadFileSelector(const char *, const char *, const char *, wxWindow *)
wxLoadFileSelector = define_c_var( wxWin, "@wxLoadFileSelector$qpxct1t1p8wxWindow" ),

-- wxLoadUserResource(const wxString&, const wxString&)
wxLoadUserResource = define_c_var( wxWin, "@wxLoadUserResource$qrx8wxStringt1" ),

-- wxLogDebug(const char *, ...)
wxLogDebug = define_c_var( wxWin, "@wxLogDebug$qpxce" ),

-- wxLogError(const char *, ...)
wxLogError = define_c_var( wxWin, "@wxLogError$qpxce" ),

-- wxLogFatalError(const char *, ...)
wxLogFatalError = define_c_var( wxWin, "@wxLogFatalError$qpxce" ),

-- wxLogGeneric(unsigned long, const char *, ...)
wxLogGeneric = define_c_var( wxWin, "@wxLogGeneric$qulpxce" ),

-- wxLogInfo(const char *, ...)
wxLogInfo = define_c_var( wxWin, "@wxLogInfo$qpxce" ),

-- wxLogMessage(const char *, ...)
wxLogMessage = define_c_var( wxWin, "@wxLogMessage$qpxce" ),

-- wxLogStatus(wxFrame *, const char *, ...)
wxLogStatus = define_c_var( wxWin, "@wxLogStatus$qp7wxFramepxce" ),

-- wxLogStatus(const char *, ...)
wxLogStatus_1 = define_c_var( wxWin, "@wxLogStatus$qpxce" ),

-- wxLogSysError(long, const char *, ...)
wxLogSysError = define_c_var( wxWin, "@wxLogSysError$qlpxce" ),

-- wxLogSysError(const char *, ...)
wxLogSysError_1 = define_c_var( wxWin, "@wxLogSysError$qpxce" ),

-- wxLogTrace(const char *, ...)
wxLogTrace = define_c_var( wxWin, "@wxLogTrace$qpxce" ),

-- wxLogTrace(const char *, const char *, ...)
wxLogTrace_1 = define_c_var( wxWin, "@wxLogTrace$qpxct1e" ),

-- wxLogTrace(unsigned long, const char *, ...)
wxLogTrace_2 = define_c_var( wxWin, "@wxLogTrace$qulpxce" ),

-- wxLogVerbose(const char *, ...)
wxLogVerbose = define_c_var( wxWin, "@wxLogVerbose$qpxce" ),

-- wxLogWarning(const char *, ...)
wxLogWarning = define_c_var( wxWin, "@wxLogWarning$qpxce" ),

-- wxMB2WC(wchar_t *, const char *, unsigned int)
wxMB2WC = define_c_var( wxWin, "@wxMB2WC$qpbpxcui" ),

-- wxMatchWild(const wxString&, const wxString&, bool)
wxMatchWild = define_c_var( wxWin, "@wxMatchWild$qrx8wxStringt1o" ),

-- wxMessageBox(const wxString&, const wxString&, long, wxWindow *, int, int)
wxMessageBox = define_c_var( wxWin, "@wxMessageBox$qrx8wxStringt1lp8wxWindowii" ),

-- wxMkdir(const wxString&, int)
wxMkdir = define_c_var( wxWin, "@wxMkdir$qrx8wxStringi" ),

-- wxNewEventType()
wxNewEventType = define_c_var( wxWin, "@wxNewEventType$qv" ),

-- wxNewId()
wxNewId = define_c_var( wxWin, "@wxNewId$qv" ),

-- wxNotebookApplyThemeBackground(wxNotebook *, wxWindow *, const wxColour&)
wxNotebookApplyThemeBackground = define_c_var( wxWin, "@wxNotebookApplyThemeBackground$qp10wxNotebookp8wxWindowrx8wxColour" ),

-- wxNotebookGetThemeBackgroundColour(wxNotebook *)
wxNotebookGetThemeBackgroundColour = define_c_var( wxWin, "@wxNotebookGetThemeBackgroundColour$qp10wxNotebook" ),

-- wxNow()
wxNow = define_c_var( wxWin, "@wxNow$qv" ),

-- wxOKlibc()
wxOKlibc = define_c_var( wxWin, "@wxOKlibc$qv" ),

-- wxOnAssert(const char *, int, const char *, const char *)
wxOnAssert = define_c_var( wxWin, "@wxOnAssert$qpxcit1t1" ),

-- wxOpenClipboard()
wxOpenClipboard = define_c_var( wxWin, "@wxOpenClipboard$qv" ),

-- wxPathExists(const char *)
wxPathExists = define_c_var( wxWin, "@wxPathExists$qpxc" ),

-- wxPathOnly(const wxString&)
wxPathOnly = define_c_var( wxWin, "@wxPathOnly$qrx8wxString" ),

-- wxRealPath(char *)
wxRealPath = define_c_var( wxWin, "@wxRealPath$qpc" ),

-- wxRegisterClipboardFormat(char *)
wxRegisterClipboardFormat = define_c_var( wxWin, "@wxRegisterClipboardFormat$qpc" ),

-- wxRegisterId(long)
wxRegisterId = define_c_var( wxWin, "@wxRegisterId$ql" ),

-- wxRemoveFile(const wxString&)
wxRemoveFile = define_c_var( wxWin, "@wxRemoveFile$qrx8wxString" ),

-- wxRenameFile(const wxString&, const wxString&)
wxRenameFile = define_c_var( wxWin, "@wxRenameFile$qrx8wxStringt1" ),

-- wxRmdir(const wxString&, int)
wxRmdir = define_c_var( wxWin, "@wxRmdir$qrx8wxStringi" ),

-- wxSafeShowMessage(const wxString&, const wxString&)
wxSafeShowMessage = define_c_var( wxWin, "@wxSafeShowMessage$qrx8wxStringt1" ),

-- wxSafeYield(wxWindow *, bool)
wxSafeYield = define_c_var( wxWin, "@wxSafeYield$qp8wxWindowo" ),

-- wxSaveFileSelector(const char *, const char *, const char *, wxWindow *)
wxSaveFileSelector = define_c_var( wxWin, "@wxSaveFileSelector$qpxct1t1p8wxWindow" ),

-- wxSetClipboardData(wxDataFormat, const void *, int, int)
wxSetClipboardData = define_c_var( wxWin, "@wxSetClipboardData$q12wxDataFormatpxvii" ),

-- wxSetCursor(const wxCursor&)
wxSetCursor = define_c_var( wxWin, "@wxSetCursor$qrx8wxCursor" ),

-- wxSetDetectableAutoRepeat(bool)
wxSetDetectableAutoRepeat = define_c_var( wxWin, "@wxSetDetectableAutoRepeat$qo" ),

-- wxSetEnv(const wxString&, const char *)
wxSetEnv = define_c_var( wxWin, "@wxSetEnv$qrx8wxStringpxc" ),

-- wxSetInstance(HINSTANCE__ *)
wxSetInstance = define_c_var( wxWin, "@wxSetInstance$qp11HINSTANCE__" ),

-- wxSetWorkingDirectory(const wxString&)
wxSetWorkingDirectory = define_c_var( wxWin, "@wxSetWorkingDirectory$qrx8wxString" ),

-- wxShell(const wxString&)
wxShell = define_c_var( wxWin, "@wxShell$qrx8wxString" ),

-- wxShowTip(wxWindow *, wxTipProvider *, bool)
wxShowTip = define_c_var( wxWin, "@wxShowTip$qp8wxWindowp13wxTipProvidero" ),

-- wxShutdown(wxShutdownFlags)
wxShutdown = define_c_var( wxWin, "@wxShutdown$q15wxShutdownFlags" ),

-- wxSleep(int)
wxSleep = define_c_var( wxWin, "@wxSleep$qi" ),

-- wxSplitPath(const char *, wxString *, wxString *, wxString *)
wxSplitPath = define_c_var( wxWin, "@wxSplitPath$qpxcp8wxStringt2t2" ),

-- wxSplitPath(wxArrayString&, const char *)
wxSplitPath_1 = define_c_var( wxWin, "@wxSplitPath$qr13wxArrayStringpxc" ),

-- wxStartTimer()
wxStartTimer = define_c_var( wxWin, "@wxStartTimer$qv" ),

-- wxStringTokenize(const wxString&, const wxString&, wxStringTokenizerMode)
wxStringTokenize = define_c_var( wxWin, "@wxStringTokenize$qrx8wxStringt121wxStringTokenizerMode" ),

-- wxStripExtension(char *)
wxStripExtension = define_c_var( wxWin, "@wxStripExtension$qpc" ),

-- wxStripExtension(wxString&)
wxStripExtension_1 = define_c_var( wxWin, "@wxStripExtension$qr8wxString" ),

-- wxStripMenuCodes(const char *, char *)
wxStripMenuCodes = define_c_var( wxWin, "@wxStripMenuCodes$qpxcpc" ),

-- wxStripMenuCodes(const wxString&)
wxStripMenuCodes_1 = define_c_var( wxWin, "@wxStripMenuCodes$qrx8wxString" ),

-- wxStrtok(char *, const char *, char * *)
wxStrtok = define_c_var( wxWin, "@wxStrtok$qpcpxcppc" ),

-- wxSysErrorCode()
wxSysErrorCode = define_c_var( wxWin, "@wxSysErrorCode$qv" ),

-- wxSysErrorMsg(unsigned long)
wxSysErrorMsg = define_c_var( wxWin, "@wxSysErrorMsg$qul" ),

-- wxTransferFileToStream(const wxString&, wxOutputStream&)
wxTransferFileToStream = define_c_var( wxWin, "@wxTransferFileToStream$qrx8wxStringr14wxOutputStream" ),

-- wxTransferStreamToFile(wxInputStream&, const wxString&)
wxTransferStreamToFile = define_c_var( wxWin, "@wxTransferStreamToFile$qr13wxInputStreamrx8wxString" ),

-- wxTrap()
wxTrap = define_c_var( wxWin, "@wxTrap$qv" ),

-- wxUnix2DosFilename(char *)
wxUnix2DosFilename = define_c_var( wxWin, "@wxUnix2DosFilename$qpc" ),

-- wxUsleep(unsigned long)
wxUsleep = define_c_var( wxWin, "@wxUsleep$qul" ),

-- wxVLogDebug(const char *, void *)
wxVLogDebug = define_c_var( wxWin, "@wxVLogDebug$qpxcpv" ),

-- wxVLogError(const char *, void *)
wxVLogError = define_c_var( wxWin, "@wxVLogError$qpxcpv" ),

-- wxVLogFatalError(const char *, void *)
wxVLogFatalError = define_c_var( wxWin, "@wxVLogFatalError$qpxcpv" ),

-- wxVLogGeneric(unsigned long, const char *, void *)
wxVLogGeneric = define_c_var( wxWin, "@wxVLogGeneric$qulpxcpv" ),

-- wxVLogInfo(const char *, void *)
wxVLogInfo = define_c_var( wxWin, "@wxVLogInfo$qpxcpv" ),

-- wxVLogMessage(const char *, void *)
wxVLogMessage = define_c_var( wxWin, "@wxVLogMessage$qpxcpv" ),

-- wxVLogStatus(wxFrame *, const char *, void *)
wxVLogStatus = define_c_var( wxWin, "@wxVLogStatus$qp7wxFramepxcpv" ),

-- wxVLogStatus(const char *, void *)
wxVLogStatus_1 = define_c_var( wxWin, "@wxVLogStatus$qpxcpv" ),

-- wxVLogSysError(long, const char *, void *)
wxVLogSysError = define_c_var( wxWin, "@wxVLogSysError$qlpxcpv" ),

-- wxVLogSysError(const char *, void *)
wxVLogSysError_1 = define_c_var( wxWin, "@wxVLogSysError$qpxcpv" ),

-- wxVLogTrace(const char *, void *)
wxVLogTrace = define_c_var( wxWin, "@wxVLogTrace$qpxcpv" ),

-- wxVLogTrace(const char *, const char *, void *)
wxVLogTrace_1 = define_c_var( wxWin, "@wxVLogTrace$qpxct1pv" ),

-- wxVLogTrace(unsigned long, const char *, void *)
wxVLogTrace_2 = define_c_var( wxWin, "@wxVLogTrace$qulpxcpv" ),

-- wxVLogVerbose(const char *, void *)
wxVLogVerbose = define_c_var( wxWin, "@wxVLogVerbose$qpxcpv" ),

-- wxVLogWarning(const char *, void *)
wxVLogWarning = define_c_var( wxWin, "@wxVLogWarning$qpxcpv" ),

-- wxWC2MB(char *, const wchar_t *, unsigned int)
wxWC2MB = define_c_var( wxWin, "@wxWC2MB$qpcpxbui" ),

-- wxWakeUpIdle()
wxWakeUpIdle = define_c_var( wxWin, "@wxWakeUpIdle$qv" ),

-- __stdcall wxWndProc(HWND__ *, unsigned int, unsigned int, long)
wxWndProc = define_c_var( wxWin, "@wxWndProc$qqsp6HWND__uiuil" ),

-- wxWriteResource(const wxString&, const wxString&, float, const wxString&)
wxWriteResource = define_c_var( wxWin, "@wxWriteResource$qrx8wxStringt1ft1" ),

-- wxWriteResource(const wxString&, const wxString&, int, const wxString&)
wxWriteResource_1 = define_c_var( wxWin, "@wxWriteResource$qrx8wxStringt1it1" ),

-- wxWriteResource(const wxString&, const wxString&, long, const wxString&)
wxWriteResource_2 = define_c_var( wxWin, "@wxWriteResource$qrx8wxStringt1lt1" ),

-- wxWriteResource(const wxString&, const wxString&, const wxString&, const wxString&)
wxWriteResource_3 = define_c_var( wxWin, "@wxWriteResource$qrx8wxStringt1t1t1" ),

-- wxYield()
wxYield = define_c_var( wxWin, "@wxYield$qv" ),

-- wxYieldIfNeeded()
wxYieldIfNeeded = define_c_var( wxWin, "@wxYieldIfNeeded$qv" ),LAST_functions = 0

-- end class functions
------------------------------


-- begin class wxApp (32 members)
------------------------------

global constant 

-- wxApp::CleanUp()
wxApp_CleanUp = define_c_var( wxWin, "@wxApp@CleanUp$qv" ),

-- wxApp::ConvertToStandardCommandArgs(const char *)
wxApp_ConvertToStandardCommandArgs = define_c_var( wxWin, "@wxApp@ConvertToStandardCommandArgs$qpxc" ),

-- wxApp::DeletePendingObjects()
wxApp_DeletePendingObjects = define_c_var( wxWin, "@wxApp@DeletePendingObjects$qv" ),

-- wxApp::Dispatch()
wxApp_Dispatch = define_c_var( wxWin, "@wxApp@Dispatch$qv" ),

-- wxApp::DoMessage(void * *)
wxApp_DoMessage = define_c_var( wxWin, "@wxApp@DoMessage$qppv" ),

-- wxApp::DoMessage()
wxApp_DoMessage_1 = define_c_var( wxWin, "@wxApp@DoMessage$qv" ),

-- wxApp::ExitMainLoop()
wxApp_ExitMainLoop = define_c_var( wxWin, "@wxApp@ExitMainLoop$qv" ),

-- wxApp::GetAuto3D() const
wxApp_GetAuto3D = define_c_var( wxWin, "@wxApp@GetAuto3D$xqv" ),

-- wxApp::GetClassInfo() const
wxApp_GetClassInfo = define_c_var( wxWin, "@wxApp@GetClassInfo$xqv" ),

-- wxApp::GetComCtl32Version()
wxApp_GetComCtl32Version = define_c_var( wxWin, "@wxApp@GetComCtl32Version$qv" ),

-- wxApp::GetEventTable() const
wxApp_GetEventTable = define_c_var( wxWin, "@wxApp@GetEventTable$xqv" ),

-- wxApp::GetPrintMode() const
wxApp_GetPrintMode = define_c_var( wxWin, "@wxApp@GetPrintMode$xqv" ),

-- wxApp::Initialize()
wxApp_Initialize = define_c_var( wxWin, "@wxApp@Initialize$qv" ),

-- wxApp::Initialized()
wxApp_Initialized = define_c_var( wxWin, "@wxApp@Initialized$qv" ),

-- wxApp::MainLoop()
wxApp_MainLoop = define_c_var( wxWin, "@wxApp@MainLoop$qv" ),

-- wxApp::OnEndSession(wxCloseEvent&)
wxApp_OnEndSession = define_c_var( wxWin, "@wxApp@OnEndSession$qr12wxCloseEvent" ),

-- wxApp::OnIdle(wxIdleEvent&)
wxApp_OnIdle = define_c_var( wxWin, "@wxApp@OnIdle$qr11wxIdleEvent" ),

-- wxApp::OnQueryEndSession(wxCloseEvent&)
wxApp_OnQueryEndSession = define_c_var( wxWin, "@wxApp@OnQueryEndSession$qr12wxCloseEvent" ),

-- wxApp::Pending()
wxApp_Pending = define_c_var( wxWin, "@wxApp@Pending$qv" ),

-- wxApp::ProcessIdle()
wxApp_ProcessIdle = define_c_var( wxWin, "@wxApp@ProcessIdle$qv" ),

-- wxApp::ProcessMessage(void * *)
wxApp_ProcessMessage = define_c_var( wxWin, "@wxApp@ProcessMessage$qppv" ),

-- wxApp::RegisterWindowClasses()
wxApp_RegisterWindowClasses = define_c_var( wxWin, "@wxApp@RegisterWindowClasses$qv" ),

-- wxApp::SendIdleEvents(wxWindow *)
wxApp_SendIdleEvents = define_c_var( wxWin, "@wxApp@SendIdleEvents$qp8wxWindow" ),

-- wxApp::SendIdleEvents()
wxApp_SendIdleEvents_1 = define_c_var( wxWin, "@wxApp@SendIdleEvents$qv" ),

-- wxApp::SetPrintMode(int)
wxApp_SetPrintMode = define_c_var( wxWin, "@wxApp@SetPrintMode$qi" ),

-- wxApp::UnregisterWindowClasses()
wxApp_UnregisterWindowClasses = define_c_var( wxWin, "@wxApp@UnregisterWindowClasses$qv" ),

-- wxApp::Yield(bool)
wxApp_Yield = define_c_var( wxWin, "@wxApp@Yield$qo" ),

-- wxApp::wxApp()
wxApp_op_ctr = define_c_var( wxWin, "@wxApp@$bctr$qv" ),

-- wxApp::~wxApp()
wxApp_op_dtr = define_c_var( wxWin, "@wxApp@$bdtr$qv" ),

-- wxApp::sm_classwxApp
wxApp_sm_classwxApp = define_c_var( wxWin, "@wxApp@sm_classwxApp" ),

-- wxApp::sm_eventTable
wxApp_sm_eventTable = define_c_var( wxWin, "@wxApp@sm_eventTable" ),

-- wxApp::sm_eventTableEntries
wxApp_sm_eventTableEntries = define_c_var( wxWin, "@wxApp@sm_eventTableEntries" ),

sizeof_wxApp = CI:sizeof_class( wxApp_sm_classwxApp ),
wxApp = define_class( "wxApp", wxWin, wxApp_op_ctr, sizeof_wxApp, wxApp_op_dtr )

-- end class wxApp
------------------------------


-- begin class wxAppBase (30 members)
------------------------------

global constant 

-- wxAppBase::CheckBuildOptions(const wxBuildOptions&)
wxAppBase_CheckBuildOptions = define_c_var( wxWin, "@wxAppBase@CheckBuildOptions$qrx14wxBuildOptions" ),

-- wxAppBase::CreateLogTarget()
wxAppBase_CreateLogTarget = define_c_var( wxWin, "@wxAppBase@CreateLogTarget$qv" ),

-- wxAppBase::CreateMessageOutput()
wxAppBase_CreateMessageOutput = define_c_var( wxWin, "@wxAppBase@CreateMessageOutput$qv" ),

-- wxAppBase::FilterEvent(wxEvent&)
wxAppBase_FilterEvent = define_c_var( wxWin, "@wxAppBase@FilterEvent$qr7wxEvent" ),

-- wxAppBase::GetAppName() const
wxAppBase_GetAppName = define_c_var( wxWin, "@wxAppBase@GetAppName$xqv" ),

-- wxAppBase::GetDisplayMode() const
wxAppBase_GetDisplayMode = define_c_var( wxWin, "@wxAppBase@GetDisplayMode$xqv" ),

-- wxAppBase::GetExitOnFrameDelete() const
wxAppBase_GetExitOnFrameDelete = define_c_var( wxWin, "@wxAppBase@GetExitOnFrameDelete$xqv" ),

-- wxAppBase::GetInitializerFunction()
wxAppBase_GetInitializerFunction = define_c_var( wxWin, "@wxAppBase@GetInitializerFunction$qv" ),

-- wxAppBase::GetTopWindow() const
wxAppBase_GetTopWindow = define_c_var( wxWin, "@wxAppBase@GetTopWindow$xqv" ),

-- wxAppBase::GetVendorName() const
wxAppBase_GetVendorName = define_c_var( wxWin, "@wxAppBase@GetVendorName$xqv" ),

-- wxAppBase::IsActive() const
wxAppBase_IsActive = define_c_var( wxWin, "@wxAppBase@IsActive$xqv" ),

-- wxAppBase::OnAssert(const char *, int, const char *, const char *)
wxAppBase_OnAssert = define_c_var( wxWin, "@wxAppBase@OnAssert$qpxcit1t1" ),

-- wxAppBase::OnCmdLineError(wxCmdLineParser&)
wxAppBase_OnCmdLineError = define_c_var( wxWin, "@wxAppBase@OnCmdLineError$qr15wxCmdLineParser" ),

-- wxAppBase::OnCmdLineHelp(wxCmdLineParser&)
wxAppBase_OnCmdLineHelp = define_c_var( wxWin, "@wxAppBase@OnCmdLineHelp$qr15wxCmdLineParser" ),

-- wxAppBase::OnCmdLineParsed(wxCmdLineParser&)
wxAppBase_OnCmdLineParsed = define_c_var( wxWin, "@wxAppBase@OnCmdLineParsed$qr15wxCmdLineParser" ),

-- wxAppBase::OnExit()
wxAppBase_OnExit = define_c_var( wxWin, "@wxAppBase@OnExit$qv" ),

-- wxAppBase::OnFatalException()
wxAppBase_OnFatalException = define_c_var( wxWin, "@wxAppBase@OnFatalException$qv" ),

-- wxAppBase::OnInit()
wxAppBase_OnInit = define_c_var( wxWin, "@wxAppBase@OnInit$qv" ),

-- wxAppBase::OnInitCmdLine(wxCmdLineParser&)
wxAppBase_OnInitCmdLine = define_c_var( wxWin, "@wxAppBase@OnInitCmdLine$qr15wxCmdLineParser" ),

-- wxAppBase::OnInitGui()
wxAppBase_OnInitGui = define_c_var( wxWin, "@wxAppBase@OnInitGui$qv" ),

-- wxAppBase::OnRun()
wxAppBase_OnRun = define_c_var( wxWin, "@wxAppBase@OnRun$qv" ),

-- wxAppBase::ProcessPendingEvents()
wxAppBase_ProcessPendingEvents = define_c_var( wxWin, "@wxAppBase@ProcessPendingEvents$qv" ),

-- wxAppBase::SetActive(bool, wxWindow *)
wxAppBase_SetActive = define_c_var( wxWin, "@wxAppBase@SetActive$qop8wxWindow" ),

-- wxAppBase::SetAppName(const wxString&)
wxAppBase_SetAppName = define_c_var( wxWin, "@wxAppBase@SetAppName$qrx8wxString" ),

-- wxAppBase::SetDisplayMode(const wxDisplayModeInfo&)
wxAppBase_SetDisplayMode = define_c_var( wxWin, "@wxAppBase@SetDisplayMode$qrx17wxDisplayModeInfo" ),

-- wxAppBase::SetPrintMode(int)
wxAppBase_SetPrintMode = define_c_var( wxWin, "@wxAppBase@SetPrintMode$qi" ),

-- wxAppBase::SetTopWindow(wxWindow *)
wxAppBase_SetTopWindow = define_c_var( wxWin, "@wxAppBase@SetTopWindow$qp8wxWindow" ),

-- wxAppBase::m_appInitFn
wxAppBase_m_appInitFn = define_c_var( wxWin, "@wxAppBase@m_appInitFn" ),

-- wxAppBase::wxAppBase()
wxAppBase_op_ctr = define_c_var( wxWin, "@wxAppBase@$bctr$qv" ),

-- wxAppBase::~wxAppBase()
wxAppBase_op_dtr = define_c_var( wxWin, "@wxAppBase@$bdtr$qv" ),

sizeof_wxAppBase = 10,
wxAppBase = define_class( "wxAppBase", wxWin, wxAppBase_op_ctr, sizeof_wxAppBase, wxAppBase_op_dtr )

-- end class wxAppBase
------------------------------


-- begin class wxArrayString (31 members)
------------------------------

global constant 

-- wxArrayString::Add(const wxString&, unsigned int)
wxArrayString_Add = define_c_var( wxWin, "@wxArrayString@Add$qrx8wxStringui" ),

-- wxArrayString::Alloc(unsigned int)
wxArrayString_Alloc = define_c_var( wxWin, "@wxArrayString@Alloc$qui" ),

-- wxArrayString::Clear()
wxArrayString_Clear = define_c_var( wxWin, "@wxArrayString@Clear$qv" ),

-- wxArrayString::Copy(const wxArrayString&)
wxArrayString_Copy = define_c_var( wxWin, "@wxArrayString@Copy$qrx13wxArrayString" ),

-- wxArrayString::Count() const
wxArrayString_Count = define_c_var( wxWin, "@wxArrayString@Count$xqv" ),

-- wxArrayString::DoSort()
wxArrayString_DoSort = define_c_var( wxWin, "@wxArrayString@DoSort$qv" ),

-- wxArrayString::Empty()
wxArrayString_Empty = define_c_var( wxWin, "@wxArrayString@Empty$qv" ),

-- wxArrayString::Free()
wxArrayString_Free = define_c_var( wxWin, "@wxArrayString@Free$qv" ),

-- wxArrayString::GetCount() const
wxArrayString_GetCount = define_c_var( wxWin, "@wxArrayString@GetCount$xqv" ),

-- wxArrayString::GetStringArray() const
wxArrayString_GetStringArray = define_c_var( wxWin, "@wxArrayString@GetStringArray$xqv" ),

-- wxArrayString::Grow(unsigned int)
wxArrayString_Grow = define_c_var( wxWin, "@wxArrayString@Grow$qui" ),

-- wxArrayString::Index(const char *, bool, bool) const
wxArrayString_Index = define_c_var( wxWin, "@wxArrayString@Index$xqpxcoo" ),

-- wxArrayString::Init(bool)
wxArrayString_Init = define_c_var( wxWin, "@wxArrayString@Init$qo" ),

-- wxArrayString::Insert(const wxString&, unsigned int, unsigned int)
wxArrayString_Insert = define_c_var( wxWin, "@wxArrayString@Insert$qrx8wxStringuiui" ),

-- wxArrayString::IsEmpty() const
wxArrayString_IsEmpty = define_c_var( wxWin, "@wxArrayString@IsEmpty$xqv" ),

-- wxArrayString::Item(unsigned int) const
wxArrayString_Item = define_c_var( wxWin, "@wxArrayString@Item$xqui" ),

-- wxArrayString::Last() const
wxArrayString_Last = define_c_var( wxWin, "@wxArrayString@Last$xqv" ),

-- wxArrayString::Remove(const char *)
wxArrayString_Remove = define_c_var( wxWin, "@wxArrayString@Remove$qpxc" ),

-- wxArrayString::RemoveAt(unsigned int, unsigned int)
wxArrayString_RemoveAt = define_c_var( wxWin, "@wxArrayString@RemoveAt$quiui" ),

-- wxArrayString::Remove(unsigned int, unsigned int)
wxArrayString_Remove_1 = define_c_var( wxWin, "@wxArrayString@Remove$quiui" ),

-- wxArrayString::SetCount(unsigned int)
wxArrayString_SetCount = define_c_var( wxWin, "@wxArrayString@SetCount$qui" ),

-- wxArrayString::Shrink()
wxArrayString_Shrink = define_c_var( wxWin, "@wxArrayString@Shrink$qv" ),

-- wxArrayString::Sort(bool)
wxArrayString_Sort = define_c_var( wxWin, "@wxArrayString@Sort$qo" ),

-- wxArrayString::Sort(int (*)(const wxString&, const wxString&))
wxArrayString_Sort_1 = define_c_var( wxWin, "@wxArrayString@Sort$qpqrx8wxStringt1$i" ),

-- wxArrayString::operator =(const wxArrayString&)
wxArrayString_op_asg = define_c_var( wxWin, "@wxArrayString@$basg$qrx13wxArrayString" ),

-- wxArrayString::wxArrayString(int)
wxArrayString_op_ctr = define_c_var( wxWin, "@wxArrayString@$bctr$qi" ),

-- wxArrayString::wxArrayString(const wxArrayString&)
wxArrayString_op_ctr_1 = define_c_var( wxWin, "@wxArrayString@$bctr$qrx13wxArrayString" ),

-- wxArrayString::wxArrayString()
wxArrayString_op_ctr_2 = define_c_var( wxWin, "@wxArrayString@$bctr$qv" ),

-- wxArrayString::~wxArrayString()
wxArrayString_op_dtr = define_c_var( wxWin, "@wxArrayString@$bdtr$qv" ),

-- wxArrayString::operator ==(const wxArrayString&) const
wxArrayString_op_eql = define_c_var( wxWin, "@wxArrayString@$beql$xqrx13wxArrayString" ),

-- wxArrayString::operator [](unsigned int) const
wxArrayString_op_subs = define_c_var( wxWin, "@wxArrayString@$bsubs$xqui" ),

sizeof_wxArrayString = 16,
wxArrayString = define_class( "wxArrayString", wxWin, wxArrayString_op_ctr, sizeof_wxArrayString, wxArrayString_op_dtr )

-- end class wxArrayString
------------------------------


-- begin class wxCursor (13 members)
------------------------------

global constant 

-- wxCursor::CreateData() const
wxCursor_CreateData = define_c_var( wxWin, "@wxCursor@CreateData$xqv" ),

-- wxCursor::GetClassInfo() const
wxCursor_GetClassInfo = define_c_var( wxWin, "@wxCursor@GetClassInfo$xqv" ),

-- wxCursor::GetHCURSOR() const
wxCursor_GetHCURSOR = define_c_var( wxWin, "@wxCursor@GetHCURSOR$xqv" ),

-- wxCursor::operator =(const wxCursor&)
wxCursor_op_asg = define_c_var( wxWin, "@wxCursor@$basg$qrx8wxCursor" ),

-- wxCursor::wxCursor(int)
wxCursor_op_ctr = define_c_var( wxWin, "@wxCursor@$bctr$qi" ),

-- wxCursor::wxCursor(const wxImage&)
wxCursor_op_ctr_1 = define_c_var( wxWin, "@wxCursor@$bctr$qrx7wxImage" ),

-- wxCursor::wxCursor(const wxCursor&)
wxCursor_op_ctr_2 = define_c_var( wxWin, "@wxCursor@$bctr$qrx8wxCursor" ),

-- wxCursor::wxCursor(const wxString&, long, int, int)
wxCursor_op_ctr_3 = define_c_var( wxWin, "@wxCursor@$bctr$qrx8wxStringlii" ),

-- wxCursor::wxCursor()
wxCursor_op_ctr_4 = define_c_var( wxWin, "@wxCursor@$bctr$qv" ),

-- wxCursor::wxCursor(const char * const, int, int, int, int, const char * const)
wxCursor_op_ctr_5 = define_c_var( wxWin, "@wxCursor@$bctr$qxpxciiiit1" ),

-- wxCursor::~wxCursor()
wxCursor_op_dtr = define_c_var( wxWin, "@wxCursor@$bdtr$qv" ),

-- wxCursor::operator ==(const wxCursor&) const
wxCursor_op_eql = define_c_var( wxWin, "@wxCursor@$beql$xqrx8wxCursor" ),

-- wxCursor::sm_classwxCursor
wxCursor_sm_classwxCursor = define_c_var( wxWin, "@wxCursor@sm_classwxCursor" ),

sizeof_wxCursor = CI:sizeof_class( wxCursor_sm_classwxCursor ),
wxCursor = define_class( "wxCursor", wxWin, wxCursor_op_ctr, sizeof_wxCursor, 0 )

-- end class wxCursor
------------------------------


-- begin class wxEvent (14 members)
------------------------------

global constant 

-- wxEvent::GetClassInfo() const
wxEvent_GetClassInfo = define_c_var( wxWin, "@wxEvent@GetClassInfo$xqv" ),

-- wxEvent::GetEventObject() const
wxEvent_GetEventObject = define_c_var( wxWin, "@wxEvent@GetEventObject$xqv" ),

-- wxEvent::GetEventType() const
wxEvent_GetEventType = define_c_var( wxWin, "@wxEvent@GetEventType$xqv" ),

-- wxEvent::GetId() const
wxEvent_GetId = define_c_var( wxWin, "@wxEvent@GetId$xqv" ),

-- wxEvent::GetSkipped() const
wxEvent_GetSkipped = define_c_var( wxWin, "@wxEvent@GetSkipped$xqv" ),

-- wxEvent::IsCommandEvent() const
wxEvent_IsCommandEvent = define_c_var( wxWin, "@wxEvent@IsCommandEvent$xqv" ),

-- wxEvent::SetEventObject(wxObject *)
wxEvent_SetEventObject = define_c_var( wxWin, "@wxEvent@SetEventObject$qp8wxObject" ),

-- wxEvent::SetEventType(int)
wxEvent_SetEventType = define_c_var( wxWin, "@wxEvent@SetEventType$qi" ),

-- wxEvent::SetId(int)
wxEvent_SetId = define_c_var( wxWin, "@wxEvent@SetId$qi" ),

-- wxEvent::SetTimestamp(long)
wxEvent_SetTimestamp = define_c_var( wxWin, "@wxEvent@SetTimestamp$ql" ),

-- wxEvent::Skip(bool)
wxEvent_Skip = define_c_var( wxWin, "@wxEvent@Skip$qo" ),

-- wxEvent::wxEvent(int, int)
wxEvent_op_ctr = define_c_var( wxWin, "@wxEvent@$bctr$qii" ),

-- wxEvent::wxEvent(const wxEvent&)
wxEvent_op_ctr_1 = define_c_var( wxWin, "@wxEvent@$bctr$qrx7wxEvent" ),

-- wxEvent::sm_classwxEvent
wxEvent_sm_classwxEvent = define_c_var( wxWin, "@wxEvent@sm_classwxEvent" ),

sizeof_wxEvent = CI:sizeof_class( wxEvent_sm_classwxEvent ),
wxEvent = define_class( "wxEvent", wxWin, wxEvent_op_ctr, sizeof_wxEvent, 0 )

-- end class wxEvent
------------------------------


-- begin class wxEvtHandler (25 members)
------------------------------

global constant 

-- wxEvtHandler::AddPendingEvent(wxEvent&)
wxEvtHandler_AddPendingEvent = define_c_var( wxWin, "@wxEvtHandler@AddPendingEvent$qr7wxEvent" ),

-- void wxEvtHandler::Connect(int, int, int, wxEvent& wxObject::*)
wxEvtHandler_Connect = define_c_var( wxWin, "@wxEvtHandler@Connect$qiiiM8wxObjectqr7wxEvent$vp8wxObject" ),

-- void wxEvtHandler::Disconnect(int, int, int, wxEvent& wxObject::*)
wxEvtHandler_Disconnect = define_c_var( wxWin, "@wxEvtHandler@Disconnect$qiiiM8wxObjectqr7wxEvent$vp8wxObject" ),

-- wxEvtHandler::DoGetClientData() const
wxEvtHandler_DoGetClientData = define_c_var( wxWin, "@wxEvtHandler@DoGetClientData$xqv" ),

-- wxEvtHandler::DoGetClientObject() const
wxEvtHandler_DoGetClientObject = define_c_var( wxWin, "@wxEvtHandler@DoGetClientObject$xqv" ),

-- wxEvtHandler::DoSetClientData(void *)
wxEvtHandler_DoSetClientData = define_c_var( wxWin, "@wxEvtHandler@DoSetClientData$qpv" ),

-- wxEvtHandler::DoSetClientObject(wxClientData *)
wxEvtHandler_DoSetClientObject = define_c_var( wxWin, "@wxEvtHandler@DoSetClientObject$qp12wxClientData" ),

-- wxEvtHandler::GetClassInfo() const
wxEvtHandler_GetClassInfo = define_c_var( wxWin, "@wxEvtHandler@GetClassInfo$xqv" ),

-- wxEvtHandler::GetClientData() const
wxEvtHandler_GetClientData = define_c_var( wxWin, "@wxEvtHandler@GetClientData$xqv" ),

-- wxEvtHandler::GetClientObject() const
wxEvtHandler_GetClientObject = define_c_var( wxWin, "@wxEvtHandler@GetClientObject$xqv" ),

-- wxEvtHandler::GetEventTable() const
wxEvtHandler_GetEventTable = define_c_var( wxWin, "@wxEvtHandler@GetEventTable$xqv" ),

-- wxEvtHandler::GetEvtHandlerEnabled() const
wxEvtHandler_GetEvtHandlerEnabled = define_c_var( wxWin, "@wxEvtHandler@GetEvtHandlerEnabled$xqv" ),

-- wxEvtHandler::GetNextHandler() const
wxEvtHandler_GetNextHandler = define_c_var( wxWin, "@wxEvtHandler@GetNextHandler$xqv" ),

-- wxEvtHandler::ProcessEvent(wxEvent&)
wxEvtHandler_ProcessEvent = define_c_var( wxWin, "@wxEvtHandler@ProcessEvent$qr7wxEvent" ),

-- wxEvtHandler::ProcessPendingEvents()
wxEvtHandler_ProcessPendingEvents = define_c_var( wxWin, "@wxEvtHandler@ProcessPendingEvents$qv" ),

-- wxEvtHandler::SearchDynamicEventTable(wxEvent&)
wxEvtHandler_SearchDynamicEventTable = define_c_var( wxWin, "@wxEvtHandler@SearchDynamicEventTable$qr7wxEvent" ),

-- wxEvtHandler::SearchEventTable(wxEventTable&, wxEvent&)
wxEvtHandler_SearchEventTable = define_c_var( wxWin, "@wxEvtHandler@SearchEventTable$qr12wxEventTabler7wxEvent" ),

-- wxEvtHandler::SetClientData(void *)
wxEvtHandler_SetClientData = define_c_var( wxWin, "@wxEvtHandler@SetClientData$qpv" ),

-- wxEvtHandler::SetNextHandler(wxEvtHandler *)
wxEvtHandler_SetNextHandler = define_c_var( wxWin, "@wxEvtHandler@SetNextHandler$qp12wxEvtHandler" ),

-- wxEvtHandler::SetPreviousHandler(wxEvtHandler *)
wxEvtHandler_SetPreviousHandler = define_c_var( wxWin, "@wxEvtHandler@SetPreviousHandler$qp12wxEvtHandler" ),

-- wxEvtHandler::wxEvtHandler()
wxEvtHandler_op_ctr = define_c_var( wxWin, "@wxEvtHandler@$bctr$qv" ),

-- wxEvtHandler::~wxEvtHandler()
wxEvtHandler_op_dtr = define_c_var( wxWin, "@wxEvtHandler@$bdtr$qv" ),

-- wxEvtHandler::sm_classwxEvtHandler
wxEvtHandler_sm_classwxEvtHandler = define_c_var( wxWin, "@wxEvtHandler@sm_classwxEvtHandler" ),

-- wxEvtHandler::sm_eventTable
wxEvtHandler_sm_eventTable = define_c_var( wxWin, "@wxEvtHandler@sm_eventTable" ),

-- wxEvtHandler::sm_eventTableEntries
wxEvtHandler_sm_eventTableEntries = define_c_var( wxWin, "@wxEvtHandler@sm_eventTableEntries" ),

sizeof_wxEvtHandler = CI:sizeof_class( wxEvtHandler_sm_classwxEvtHandler ),
wxEvtHandler = define_class( "wxEvtHandler", wxWin, wxEvtHandler_op_ctr, sizeof_wxEvtHandler, wxEvtHandler_op_dtr )

-- end class wxEvtHandler
------------------------------


-- begin class wxFrame (35 members)
------------------------------

global constant 

-- wxFrame::AttachMenuBar(wxMenuBar *)
wxFrame_AttachMenuBar = define_c_var( wxWin, "@wxFrame@AttachMenuBar$qp9wxMenuBar" ),

-- wxFrame::Create(wxWindow *, int, const wxString&, const wxPoint&, const wxSize&, long, const wxString&)
wxFrame_Create = define_c_var( wxWin, "@wxFrame@Create$qp8wxWindowirx8wxStringrx7wxPointrx6wxSizelt3" ),

-- wxFrame::CreateToolBar(long, int, const wxString&)
wxFrame_CreateToolBar = define_c_var( wxWin, "@wxFrame@CreateToolBar$qlirx8wxString" ),

-- wxFrame::DoGetClientSize(int *, int *) const
wxFrame_DoGetClientSize = define_c_var( wxWin, "@wxFrame@DoGetClientSize$xqpit1" ),

-- wxFrame::DoSetClientSize(int, int)
wxFrame_DoSetClientSize = define_c_var( wxWin, "@wxFrame@DoSetClientSize$qii" ),

-- wxFrame::GetClassInfo() const
wxFrame_GetClassInfo = define_c_var( wxWin, "@wxFrame@GetClassInfo$xqv" ),

-- wxFrame::GetDefaultIcon() const
wxFrame_GetDefaultIcon = define_c_var( wxWin, "@wxFrame@GetDefaultIcon$xqv" ),

-- wxFrame::GetEventTable() const
wxFrame_GetEventTable = define_c_var( wxWin, "@wxFrame@GetEventTable$xqv" ),

-- wxFrame::GetWinMenu() const
wxFrame_GetWinMenu = define_c_var( wxWin, "@wxFrame@GetWinMenu$xqv" ),

-- wxFrame::HandleCommand(unsigned short, unsigned short, unsigned long)
wxFrame_HandleCommand = define_c_var( wxWin, "@wxFrame@HandleCommand$qususul" ),

-- wxFrame::HandleMenuLoop(const int&, unsigned short)
wxFrame_HandleMenuLoop = define_c_var( wxWin, "@wxFrame@HandleMenuLoop$qrxius" ),

-- wxFrame::HandleMenuSelect(unsigned short, unsigned short, unsigned long)
wxFrame_HandleMenuSelect = define_c_var( wxWin, "@wxFrame@HandleMenuSelect$qususul" ),

-- wxFrame::HandlePaint()
wxFrame_HandlePaint = define_c_var( wxWin, "@wxFrame@HandlePaint$qv" ),

-- wxFrame::HandleSize(int, int, unsigned int)
wxFrame_HandleSize = define_c_var( wxWin, "@wxFrame@HandleSize$qiiui" ),

-- wxFrame::IconizeChildFrames(bool)
wxFrame_IconizeChildFrames = define_c_var( wxWin, "@wxFrame@IconizeChildFrames$qo" ),

-- wxFrame::Init()
wxFrame_Init = define_c_var( wxWin, "@wxFrame@Init$qv" ),

-- wxFrame::InternalSetMenuBar()
wxFrame_InternalSetMenuBar = define_c_var( wxWin, "@wxFrame@InternalSetMenuBar$qv" ),

-- wxFrame::IsMDIChild() const
wxFrame_IsMDIChild = define_c_var( wxWin, "@wxFrame@IsMDIChild$xqv" ),

-- wxFrame::MSWTranslateMessage(void * *)
wxFrame_MSWTranslateMessage = define_c_var( wxWin, "@wxFrame@MSWTranslateMessage$qppv" ),

-- wxFrame::MSWWindowProc(unsigned int, unsigned int, long)
wxFrame_MSWWindowProc = define_c_var( wxWin, "@wxFrame@MSWWindowProc$quiuil" ),

-- wxFrame::OnCreateStatusBar(int, long, int, const wxString&)
wxFrame_OnCreateStatusBar = define_c_var( wxWin, "@wxFrame@OnCreateStatusBar$qilirx8wxString" ),

-- wxFrame::OnSysColourChanged(wxSysColourChangedEvent&)
wxFrame_OnSysColourChanged = define_c_var( wxWin, "@wxFrame@OnSysColourChanged$qr23wxSysColourChangedEvent" ),

-- wxFrame::PositionStatusBar()
wxFrame_PositionStatusBar = define_c_var( wxWin, "@wxFrame@PositionStatusBar$qv" ),

-- wxFrame::PositionToolBar()
wxFrame_PositionToolBar = define_c_var( wxWin, "@wxFrame@PositionToolBar$qv" ),

-- wxFrame::Raise()
wxFrame_Raise = define_c_var( wxWin, "@wxFrame@Raise$qv" ),

-- wxFrame::SendSizeEvent()
wxFrame_SendSizeEvent = define_c_var( wxWin, "@wxFrame@SendSizeEvent$qv" ),

-- wxFrame::ShowFullScreen(bool, long)
wxFrame_ShowFullScreen = define_c_var( wxWin, "@wxFrame@ShowFullScreen$qol" ),

-- wxFrame::UsesNativeStatusBar()
wxFrame_UsesNativeStatusBar = define_c_var( wxWin, "@wxFrame@UsesNativeStatusBar$qv" ),

-- wxFrame::m_useNativeStatusBar
wxFrame_m_useNativeStatusBar = define_c_var( wxWin, "@wxFrame@m_useNativeStatusBar" ),

-- wxFrame::wxFrame(wxWindow *, int, const wxString&, const wxPoint&, const wxSize&, long, const wxString&)
wxFrame_op_ctr = define_c_var( wxWin, "@wxFrame@$bctr$qp8wxWindowirx8wxStringrx7wxPointrx6wxSizelt3" ),

-- wxFrame::wxFrame()
wxFrame_op_ctr_1 = define_c_var( wxWin, "@wxFrame@$bctr$qv" ),

-- wxFrame::~wxFrame()
wxFrame_op_dtr = define_c_var( wxWin, "@wxFrame@$bdtr$qv" ),

-- wxFrame::sm_classwxFrame
wxFrame_sm_classwxFrame = define_c_var( wxWin, "@wxFrame@sm_classwxFrame" ),

-- wxFrame::sm_eventTable
wxFrame_sm_eventTable = define_c_var( wxWin, "@wxFrame@sm_eventTable" ),

-- wxFrame::sm_eventTableEntries
wxFrame_sm_eventTableEntries = define_c_var( wxWin, "@wxFrame@sm_eventTableEntries" ),

sizeof_wxFrame = CI:sizeof_class( wxFrame_sm_classwxFrame ),
wxFrame = define_class( "wxFrame", wxWin, wxFrame_op_ctr, sizeof_wxFrame, wxFrame_op_dtr )

-- end class wxFrame
------------------------------


-- begin class wxFrameBase (35 members)
------------------------------

global constant 

-- wxFrameBase::AttachMenuBar(wxMenuBar *)
wxFrameBase_AttachMenuBar = define_c_var( wxWin, "@wxFrameBase@AttachMenuBar$qp9wxMenuBar" ),

-- wxFrameBase::CreateStatusBar(int, long, int, const wxString&)
wxFrameBase_CreateStatusBar = define_c_var( wxWin, "@wxFrameBase@CreateStatusBar$qilirx8wxString" ),

-- wxFrameBase::CreateToolBar(long, int, const wxString&)
wxFrameBase_CreateToolBar = define_c_var( wxWin, "@wxFrameBase@CreateToolBar$qlirx8wxString" ),

-- wxFrameBase::DeleteAllBars()
wxFrameBase_DeleteAllBars = define_c_var( wxWin, "@wxFrameBase@DeleteAllBars$qv" ),

-- wxFrameBase::DetachMenuBar()
wxFrameBase_DetachMenuBar = define_c_var( wxWin, "@wxFrameBase@DetachMenuBar$qv" ),

-- wxFrameBase::DoGiveHelp(const wxString&, bool)
wxFrameBase_DoGiveHelp = define_c_var( wxWin, "@wxFrameBase@DoGiveHelp$qrx8wxStringo" ),

-- wxFrameBase::DoMenuUpdates(wxMenu *, wxWindow *)
wxFrameBase_DoMenuUpdates = define_c_var( wxWin, "@wxFrameBase@DoMenuUpdates$qp6wxMenup8wxWindow" ),

-- wxFrameBase::DoMenuUpdates()
wxFrameBase_DoMenuUpdates_1 = define_c_var( wxWin, "@wxFrameBase@DoMenuUpdates$qv" ),

-- wxFrameBase::GetClientAreaOrigin() const
wxFrameBase_GetClientAreaOrigin = define_c_var( wxWin, "@wxFrameBase@GetClientAreaOrigin$xqv" ),

-- wxFrameBase::GetEventTable() const
wxFrameBase_GetEventTable = define_c_var( wxWin, "@wxFrameBase@GetEventTable$xqv" ),

-- wxFrameBase::GetMenuBar() const
wxFrameBase_GetMenuBar = define_c_var( wxWin, "@wxFrameBase@GetMenuBar$xqv" ),

-- wxFrameBase::GetStatusBar() const
wxFrameBase_GetStatusBar = define_c_var( wxWin, "@wxFrameBase@GetStatusBar$xqv" ),

-- wxFrameBase::GetToolBar() const
wxFrameBase_GetToolBar = define_c_var( wxWin, "@wxFrameBase@GetToolBar$xqv" ),

-- wxFrameBase::IsOneOfBars(const wxWindow *) const
wxFrameBase_IsOneOfBars = define_c_var( wxWin, "@wxFrameBase@IsOneOfBars$xqpx8wxWindow" ),

-- wxFrameBase::New(wxWindow *, int, const wxString&, const wxPoint&, const wxSize&, long, const wxString&)
wxFrameBase_New = define_c_var( wxWin, "@wxFrameBase@New$qp8wxWindowirx8wxStringrx7wxPointrx6wxSizelt3" ),

-- wxFrameBase::OnCreateStatusBar(int, long, int, const wxString&)
wxFrameBase_OnCreateStatusBar = define_c_var( wxWin, "@wxFrameBase@OnCreateStatusBar$qilirx8wxString" ),

-- wxFrameBase::OnCreateToolBar(long, int, const wxString&)
wxFrameBase_OnCreateToolBar = define_c_var( wxWin, "@wxFrameBase@OnCreateToolBar$qlirx8wxString" ),

-- wxFrameBase::OnIdle(wxIdleEvent&)
wxFrameBase_OnIdle = define_c_var( wxWin, "@wxFrameBase@OnIdle$qr11wxIdleEvent" ),

-- wxFrameBase::OnMenuHighlight(wxMenuEvent&)
wxFrameBase_OnMenuHighlight = define_c_var( wxWin, "@wxFrameBase@OnMenuHighlight$qr11wxMenuEvent" ),

-- wxFrameBase::PopStatusText(int)
wxFrameBase_PopStatusText = define_c_var( wxWin, "@wxFrameBase@PopStatusText$qi" ),

-- wxFrameBase::PositionMenuBar()
wxFrameBase_PositionMenuBar = define_c_var( wxWin, "@wxFrameBase@PositionMenuBar$qv" ),

-- wxFrameBase::PositionStatusBar()
wxFrameBase_PositionStatusBar = define_c_var( wxWin, "@wxFrameBase@PositionStatusBar$qv" ),

-- wxFrameBase::PositionToolBar()
wxFrameBase_PositionToolBar = define_c_var( wxWin, "@wxFrameBase@PositionToolBar$qv" ),

-- wxFrameBase::ProcessCommand(int)
wxFrameBase_ProcessCommand = define_c_var( wxWin, "@wxFrameBase@ProcessCommand$qi" ),

-- wxFrameBase::PushStatusText(const wxString&, int)
wxFrameBase_PushStatusText = define_c_var( wxWin, "@wxFrameBase@PushStatusText$qrx8wxStringi" ),

-- wxFrameBase::SendSizeEvent()
wxFrameBase_SendSizeEvent = define_c_var( wxWin, "@wxFrameBase@SendSizeEvent$qv" ),

-- wxFrameBase::SetMenuBar(wxMenuBar *)
wxFrameBase_SetMenuBar = define_c_var( wxWin, "@wxFrameBase@SetMenuBar$qp9wxMenuBar" ),

-- wxFrameBase::SetStatusText(const wxString&, int)
wxFrameBase_SetStatusText = define_c_var( wxWin, "@wxFrameBase@SetStatusText$qrx8wxStringi" ),

-- wxFrameBase::SetStatusWidths(int, const int * const)
wxFrameBase_SetStatusWidths = define_c_var( wxWin, "@wxFrameBase@SetStatusWidths$qixpxi" ),

-- wxFrameBase::SetToolBar(wxToolBar *)
wxFrameBase_SetToolBar = define_c_var( wxWin, "@wxFrameBase@SetToolBar$qp9wxToolBar" ),

-- wxFrameBase::ShowMenuHelp(wxStatusBar *, int)
wxFrameBase_ShowMenuHelp = define_c_var( wxWin, "@wxFrameBase@ShowMenuHelp$qp11wxStatusBari" ),

-- wxFrameBase::wxFrameBase()
wxFrameBase_op_ctr = define_c_var( wxWin, "@wxFrameBase@$bctr$qv" ),

-- wxFrameBase::~wxFrameBase()
wxFrameBase_op_dtr = define_c_var( wxWin, "@wxFrameBase@$bdtr$qv" ),

-- wxFrameBase::sm_eventTable
wxFrameBase_sm_eventTable = define_c_var( wxWin, "@wxFrameBase@sm_eventTable" ),

-- wxFrameBase::sm_eventTableEntries
wxFrameBase_sm_eventTableEntries = define_c_var( wxWin, "@wxFrameBase@sm_eventTableEntries" ),

sizeof_wxFrameBase = 30,
wxFrameBase = define_class( "wxFrameBase", wxWin, wxFrameBase_op_ctr, sizeof_wxFrameBase, wxFrameBase_op_dtr )

-- end class wxFrameBase
------------------------------


-- begin class wxKeyEvent (14 members)
------------------------------

global constant 

-- wxKeyEvent::AltDown() const
wxKeyEvent_AltDown = define_c_var( wxWin, "@wxKeyEvent@AltDown$xqv" ),

-- wxKeyEvent::Clone() const
wxKeyEvent_Clone = define_c_var( wxWin, "@wxKeyEvent@Clone$xqv" ),

-- wxKeyEvent::ControlDown() const
wxKeyEvent_ControlDown = define_c_var( wxWin, "@wxKeyEvent@ControlDown$xqv" ),

-- wxKeyEvent::GetClassInfo() const
wxKeyEvent_GetClassInfo = define_c_var( wxWin, "@wxKeyEvent@GetClassInfo$xqv" ),

-- wxKeyEvent::GetKeyCode() const
wxKeyEvent_GetKeyCode = define_c_var( wxWin, "@wxKeyEvent@GetKeyCode$xqv" ),

-- wxKeyEvent::GetRawKeyCode() const
wxKeyEvent_GetRawKeyCode = define_c_var( wxWin, "@wxKeyEvent@GetRawKeyCode$xqv" ),

-- wxKeyEvent::HasModifiers() const
wxKeyEvent_HasModifiers = define_c_var( wxWin, "@wxKeyEvent@HasModifiers$xqv" ),

-- wxKeyEvent::KeyCode() const
wxKeyEvent_KeyCode = define_c_var( wxWin, "@wxKeyEvent@KeyCode$xqv" ),

-- wxKeyEvent::MetaDown() const
wxKeyEvent_MetaDown = define_c_var( wxWin, "@wxKeyEvent@MetaDown$xqv" ),

-- wxKeyEvent::ShiftDown() const
wxKeyEvent_ShiftDown = define_c_var( wxWin, "@wxKeyEvent@ShiftDown$xqv" ),

-- wxKeyEvent::operator =(const wxKeyEvent&)
wxKeyEvent_op_asg = define_c_var( wxWin, "@wxKeyEvent@$basg$qrx10wxKeyEvent" ),

-- wxKeyEvent::wxKeyEvent(int)
wxKeyEvent_op_ctr = define_c_var( wxWin, "@wxKeyEvent@$bctr$qi" ),

-- wxKeyEvent::wxKeyEvent(const wxKeyEvent&)
wxKeyEvent_op_ctr_1 = define_c_var( wxWin, "@wxKeyEvent@$bctr$qrx10wxKeyEvent" ),

-- wxKeyEvent::sm_classwxKeyEvent
wxKeyEvent_sm_classwxKeyEvent = define_c_var( wxWin, "@wxKeyEvent@sm_classwxKeyEvent" ),

sizeof_wxKeyEvent = CI:sizeof_class( wxKeyEvent_sm_classwxKeyEvent ),
wxKeyEvent = define_class( "wxKeyEvent", wxWin, wxKeyEvent_op_ctr, sizeof_wxKeyEvent, 0 )

-- end class wxKeyEvent
------------------------------


-- begin class wxList (6 members)
------------------------------

global constant 

-- wxList::GetClassInfo() const
wxList_GetClassInfo = define_c_var( wxWin, "@wxList@GetClassInfo$xqv" ),

-- wxList::Member(wxObject *) const
wxList_Member = define_c_var( wxWin, "@wxList@Member$xqp8wxObject" ),

-- wxList::operator =(const wxList&)
wxList_op_asg = define_c_var( wxWin, "@wxList@$basg$qrx6wxList" ),

-- wxList::wxList(int)
wxList_op_ctr = define_c_var( wxWin, "@wxList@$bctr$qi" ),

-- wxList::~wxList()
wxList_op_dtr = define_c_var( wxWin, "@wxList@$bdtr$qv" ),

-- wxList::sm_classwxList
wxList_sm_classwxList = define_c_var( wxWin, "@wxList@sm_classwxList" ),

sizeof_wxList = CI:sizeof_class( wxList_sm_classwxList ),
wxList = define_class( "wxList", wxWin, 0, sizeof_wxList, 0 )

-- end class wxList
------------------------------


-- begin class wxListBase (33 members)
------------------------------

global constant 

-- wxListBase::Append(long, void *)
wxListBase_Append = define_c_var( wxWin, "@wxListBase@Append$qlpv" ),

-- wxListBase::AppendCommon(wxNodeBase *)
wxListBase_AppendCommon = define_c_var( wxWin, "@wxListBase@AppendCommon$qp10wxNodeBase" ),

-- wxListBase::Append(void *)
wxListBase_Append_1 = define_c_var( wxWin, "@wxListBase@Append$qpv" ),

-- wxListBase::Append(const char *, void *)
wxListBase_Append_2 = define_c_var( wxWin, "@wxListBase@Append$qpxcpv" ),

-- wxListBase::Clear()
wxListBase_Clear = define_c_var( wxWin, "@wxListBase@Clear$qv" ),

-- wxListBase::DeleteContents(bool)
wxListBase_DeleteContents = define_c_var( wxWin, "@wxListBase@DeleteContents$qo" ),

-- wxListBase::DeleteNode(wxNodeBase *)
wxListBase_DeleteNode = define_c_var( wxWin, "@wxListBase@DeleteNode$qp10wxNodeBase" ),

-- wxListBase::DeleteObject(void *)
wxListBase_DeleteObject = define_c_var( wxWin, "@wxListBase@DeleteObject$qpv" ),

-- wxListBase::DetachNode(wxNodeBase *)
wxListBase_DetachNode = define_c_var( wxWin, "@wxListBase@DetachNode$qp10wxNodeBase" ),

-- wxListBase::DoCopy(const wxListBase&)
wxListBase_DoCopy = define_c_var( wxWin, "@wxListBase@DoCopy$qrx10wxListBase" ),

-- wxListBase::DoDeleteNode(wxNodeBase *)
wxListBase_DoDeleteNode = define_c_var( wxWin, "@wxListBase@DoDeleteNode$qp10wxNodeBase" ),

-- wxListBase::Find(void *) const
wxListBase_Find = define_c_var( wxWin, "@wxListBase@Find$xqpv" ),

-- wxListBase::Find(const wxListKey&) const
wxListBase_Find_1 = define_c_var( wxWin, "@wxListBase@Find$xqrx9wxListKey" ),

-- wxListBase::First() const
wxListBase_First = define_c_var( wxWin, "@wxListBase@First$xqv" ),

-- wxListBase::FirstThat(int (*)(void *))
wxListBase_FirstThat = define_c_var( wxWin, "@wxListBase@FirstThat$qpqpv$i" ),

-- wxListBase::ForEach(int (*)(void *))
wxListBase_ForEach = define_c_var( wxWin, "@wxListBase@ForEach$qpqpv$i" ),

-- wxListBase::GetCount() const
wxListBase_GetCount = define_c_var( wxWin, "@wxListBase@GetCount$xqv" ),

-- wxListBase::GetFirst() const
wxListBase_GetFirst = define_c_var( wxWin, "@wxListBase@GetFirst$xqv" ),

-- wxListBase::GetLast() const
wxListBase_GetLast = define_c_var( wxWin, "@wxListBase@GetLast$xqv" ),

-- wxListBase::IndexOf(void *) const
wxListBase_IndexOf = define_c_var( wxWin, "@wxListBase@IndexOf$xqpv" ),

-- wxListBase::Init(wxKeyType)
wxListBase_Init = define_c_var( wxWin, "@wxListBase@Init$q9wxKeyType" ),

-- wxListBase::Insert(wxNodeBase *, void *)
wxListBase_Insert = define_c_var( wxWin, "@wxListBase@Insert$qp10wxNodeBasepv" ),

-- wxListBase::Insert(unsigned int, void *)
wxListBase_Insert_1 = define_c_var( wxWin, "@wxListBase@Insert$quipv" ),

-- wxListBase::Item(unsigned int) const
wxListBase_Item = define_c_var( wxWin, "@wxListBase@Item$xqui" ),

-- wxListBase::Last() const
wxListBase_Last = define_c_var( wxWin, "@wxListBase@Last$xqv" ),

-- wxListBase::LastThat(int (*)(void *))
wxListBase_LastThat = define_c_var( wxWin, "@wxListBase@LastThat$qpqpv$i" ),

-- wxListBase::Nth(unsigned int) const
wxListBase_Nth = define_c_var( wxWin, "@wxListBase@Nth$xqui" ),

-- wxListBase::Number() const
wxListBase_Number = define_c_var( wxWin, "@wxListBase@Number$xqv" ),

-- wxListBase::Sort(int (*)(const void *, const void *) const)
wxListBase_Sort = define_c_var( wxWin, "@wxListBase@Sort$qxpqpxvt1$i" ),

-- wxListBase::operator =(const wxListBase&)
wxListBase_op_asg = define_c_var( wxWin, "@wxListBase@$basg$qrx10wxListBase" ),

-- wxListBase::wxListBase(wxKeyType)
wxListBase_op_ctr = define_c_var( wxWin, "@wxListBase@$bctr$q9wxKeyType" ),

-- wxListBase::wxListBase(unsigned int, void * *)
wxListBase_op_ctr_1 = define_c_var( wxWin, "@wxListBase@$bctr$quippv" ),

-- wxListBase::~wxListBase()
wxListBase_op_dtr = define_c_var( wxWin, "@wxListBase@$bdtr$qv" ),

sizeof_wxListBase = 1,
wxListBase = define_class( "wxListBase", wxWin, 0, sizeof_wxListBase, 0 )

-- end class wxListBase
------------------------------


-- begin class wxLog (34 members)
------------------------------

global constant 

-- wxLog::AddTraceMask(const wxString&)
wxLog_AddTraceMask = define_c_var( wxWin, "@wxLog@AddTraceMask$qrx8wxString" ),

-- wxLog::ClearTraceMasks()
wxLog_ClearTraceMasks = define_c_var( wxWin, "@wxLog@ClearTraceMasks$qv" ),

-- wxLog::DoLog(unsigned long, const char *, long)
wxLog_DoLog = define_c_var( wxWin, "@wxLog@DoLog$qulpxcl" ),

-- wxLog::DoLogString(const char *, long)
wxLog_DoLogString = define_c_var( wxWin, "@wxLog@DoLogString$qpxcl" ),

-- wxLog::DontCreateOnDemand()
wxLog_DontCreateOnDemand = define_c_var( wxWin, "@wxLog@DontCreateOnDemand$qv" ),

-- wxLog::EnableLogging(bool)
wxLog_EnableLogging = define_c_var( wxWin, "@wxLog@EnableLogging$qo" ),

-- wxLog::Flush()
wxLog_Flush = define_c_var( wxWin, "@wxLog@Flush$qv" ),

-- wxLog::FlushActive()
wxLog_FlushActive = define_c_var( wxWin, "@wxLog@FlushActive$qv" ),

-- wxLog::GetActiveTarget()
wxLog_GetActiveTarget = define_c_var( wxWin, "@wxLog@GetActiveTarget$qv" ),

-- wxLog::GetTimestamp()
wxLog_GetTimestamp = define_c_var( wxWin, "@wxLog@GetTimestamp$qv" ),

-- wxLog::GetTraceMask()
wxLog_GetTraceMask = define_c_var( wxWin, "@wxLog@GetTraceMask$qv" ),

-- wxLog::GetVerbose()
wxLog_GetVerbose = define_c_var( wxWin, "@wxLog@GetVerbose$qv" ),

-- wxLog::HasPendingMessages() const
wxLog_HasPendingMessages = define_c_var( wxWin, "@wxLog@HasPendingMessages$xqv" ),

-- wxLog::IsAllowedTraceMask(const char *)
wxLog_IsAllowedTraceMask = define_c_var( wxWin, "@wxLog@IsAllowedTraceMask$qpxc" ),

-- wxLog::IsEnabled()
wxLog_IsEnabled = define_c_var( wxWin, "@wxLog@IsEnabled$qv" ),

-- wxLog::OnLog(unsigned long, const char *, long)
wxLog_OnLog = define_c_var( wxWin, "@wxLog@OnLog$qulpxcl" ),

-- wxLog::RemoveTraceMask(const wxString&)
wxLog_RemoveTraceMask = define_c_var( wxWin, "@wxLog@RemoveTraceMask$qrx8wxString" ),

-- wxLog::Resume()
wxLog_Resume = define_c_var( wxWin, "@wxLog@Resume$qv" ),

-- wxLog::SetActiveTarget(wxLog *)
wxLog_SetActiveTarget = define_c_var( wxWin, "@wxLog@SetActiveTarget$qp5wxLog" ),

-- wxLog::SetLogBuffer(char *, unsigned int)
wxLog_SetLogBuffer = define_c_var( wxWin, "@wxLog@SetLogBuffer$qpcui" ),

-- wxLog::SetVerbose(bool)
wxLog_SetVerbose = define_c_var( wxWin, "@wxLog@SetVerbose$qo" ),

-- wxLog::Suspend()
wxLog_Suspend = define_c_var( wxWin, "@wxLog@Suspend$qv" ),

-- wxLog::TimeStamp(wxString *)
wxLog_TimeStamp = define_c_var( wxWin, "@wxLog@TimeStamp$qp8wxString" ),

-- wxLog::ms_aTraceMasks
wxLog_ms_aTraceMasks = define_c_var( wxWin, "@wxLog@ms_aTraceMasks" ),

-- wxLog::ms_bAutoCreate
wxLog_ms_bAutoCreate = define_c_var( wxWin, "@wxLog@ms_bAutoCreate" ),

-- wxLog::ms_bVerbose
wxLog_ms_bVerbose = define_c_var( wxWin, "@wxLog@ms_bVerbose" ),

-- wxLog::ms_doLog
wxLog_ms_doLog = define_c_var( wxWin, "@wxLog@ms_doLog" ),

-- wxLog::ms_logLevel
wxLog_ms_logLevel = define_c_var( wxWin, "@wxLog@ms_logLevel" ),

-- wxLog::ms_pLogger
wxLog_ms_pLogger = define_c_var( wxWin, "@wxLog@ms_pLogger" ),

-- wxLog::ms_suspendCount
wxLog_ms_suspendCount = define_c_var( wxWin, "@wxLog@ms_suspendCount" ),

-- wxLog::ms_timestamp
wxLog_ms_timestamp = define_c_var( wxWin, "@wxLog@ms_timestamp" ),

-- wxLog::ms_ulTraceMask
wxLog_ms_ulTraceMask = define_c_var( wxWin, "@wxLog@ms_ulTraceMask" ),

-- wxLog::wxLog()
wxLog_op_ctr = define_c_var( wxWin, "@wxLog@$bctr$qv" ),

-- wxLog::~wxLog()
wxLog_op_dtr = define_c_var( wxWin, "@wxLog@$bdtr$qv" ),

sizeof_wxLog = 100,
wxLog = define_class( "wxLog", wxWin, wxLog_op_ctr, sizeof_wxLog, wxLog_op_dtr )

-- end class wxLog
------------------------------


-- begin class wxLogStderr (2 members)
------------------------------

global constant 

-- wxLogStderr::DoLogString(const char *, long)
wxLogStderr_DoLogString = define_c_var( wxWin, "@wxLogStderr@DoLogString$qpxcl" ),

-- wxLogStderr::wxLogStderr(std::FILE *)
wxLogStderr_op_ctr = define_c_var( wxWin, "@wxLogStderr@$bctr$qp8std@FILE" ),

sizeof_wxLogStderr = 100,
wxLogStderr = define_class( "wxLogStderr", wxWin, wxLogStderr_op_ctr, sizeof_wxLogStderr, 0 )

-- end class wxLogStderr
------------------------------


-- begin class wxMessageDialog (4 members)
------------------------------

global constant 

-- wxMessageDialog::GetClassInfo() const
wxMessageDialog_GetClassInfo = define_c_var( wxWin, "@wxMessageDialog@GetClassInfo$xqv" ),

-- wxMessageDialog::ShowModal()
wxMessageDialog_ShowModal = define_c_var( wxWin, "@wxMessageDialog@ShowModal$qv" ),

-- wxMessageDialog::wxMessageDialog(wxWindow *, const wxString&, const wxString&, long, const wxPoint&)
wxMessageDialog_op_ctr = define_c_var( wxWin, "@wxMessageDialog@$bctr$qp8wxWindowrx8wxStringt2lrx7wxPoint" ),

-- wxMessageDialog::sm_classwxMessageDialog
wxMessageDialog_sm_classwxMessageDialog = define_c_var( wxWin, "@wxMessageDialog@sm_classwxMessageDialog" ),

sizeof_wxMessageDialog = CI:sizeof_class( wxMessageDialog_sm_classwxMessageDialog ),
wxMessageDialog = define_class( "wxMessageDialog", wxWin, wxMessageDialog_op_ctr, sizeof_wxMessageDialog, 0 )

-- end class wxMessageDialog
------------------------------


-- begin class wxMouseEvent (42 members)
------------------------------

global constant 

-- wxMouseEvent::AltDown() const
wxMouseEvent_AltDown = define_c_var( wxWin, "@wxMouseEvent@AltDown$xqv" ),

-- wxMouseEvent::Assign(const wxMouseEvent&)
wxMouseEvent_Assign = define_c_var( wxWin, "@wxMouseEvent@Assign$qrx12wxMouseEvent" ),

-- wxMouseEvent::Button(int) const
wxMouseEvent_Button = define_c_var( wxWin, "@wxMouseEvent@Button$xqi" ),

-- wxMouseEvent::ButtonDClick(int) const
wxMouseEvent_ButtonDClick = define_c_var( wxWin, "@wxMouseEvent@ButtonDClick$xqi" ),

-- wxMouseEvent::ButtonDown(int) const
wxMouseEvent_ButtonDown = define_c_var( wxWin, "@wxMouseEvent@ButtonDown$xqi" ),

-- wxMouseEvent::ButtonIsDown(int) const
wxMouseEvent_ButtonIsDown = define_c_var( wxWin, "@wxMouseEvent@ButtonIsDown$xqi" ),

-- wxMouseEvent::ButtonUp(int) const
wxMouseEvent_ButtonUp = define_c_var( wxWin, "@wxMouseEvent@ButtonUp$xqi" ),

-- wxMouseEvent::Clone() const
wxMouseEvent_Clone = define_c_var( wxWin, "@wxMouseEvent@Clone$xqv" ),

-- wxMouseEvent::ControlDown() const
wxMouseEvent_ControlDown = define_c_var( wxWin, "@wxMouseEvent@ControlDown$xqv" ),

-- wxMouseEvent::Dragging() const
wxMouseEvent_Dragging = define_c_var( wxWin, "@wxMouseEvent@Dragging$xqv" ),

-- wxMouseEvent::Entering() const
wxMouseEvent_Entering = define_c_var( wxWin, "@wxMouseEvent@Entering$xqv" ),

-- wxMouseEvent::GetButton() const
wxMouseEvent_GetButton = define_c_var( wxWin, "@wxMouseEvent@GetButton$xqv" ),

-- wxMouseEvent::GetClassInfo() const
wxMouseEvent_GetClassInfo = define_c_var( wxWin, "@wxMouseEvent@GetClassInfo$xqv" ),

-- wxMouseEvent::GetLinesPerAction() const
wxMouseEvent_GetLinesPerAction = define_c_var( wxWin, "@wxMouseEvent@GetLinesPerAction$xqv" ),

-- wxMouseEvent::GetLogicalPosition(const wxDC&) const
wxMouseEvent_GetLogicalPosition = define_c_var( wxWin, "@wxMouseEvent@GetLogicalPosition$xqrx4wxDC" ),

-- wxMouseEvent::GetPosition(int *, int *) const
wxMouseEvent_GetPosition = define_c_var( wxWin, "@wxMouseEvent@GetPosition$xqpit1" ),

-- wxMouseEvent::GetPosition() const
wxMouseEvent_GetPosition_1 = define_c_var( wxWin, "@wxMouseEvent@GetPosition$xqv" ),

-- wxMouseEvent::GetWheelDelta() const
wxMouseEvent_GetWheelDelta = define_c_var( wxWin, "@wxMouseEvent@GetWheelDelta$xqv" ),

-- wxMouseEvent::GetWheelRotation() const
wxMouseEvent_GetWheelRotation = define_c_var( wxWin, "@wxMouseEvent@GetWheelRotation$xqv" ),

-- wxMouseEvent::GetX() const
wxMouseEvent_GetX = define_c_var( wxWin, "@wxMouseEvent@GetX$xqv" ),

-- wxMouseEvent::GetY() const
wxMouseEvent_GetY = define_c_var( wxWin, "@wxMouseEvent@GetY$xqv" ),

-- wxMouseEvent::IsButton() const
wxMouseEvent_IsButton = define_c_var( wxWin, "@wxMouseEvent@IsButton$xqv" ),

-- wxMouseEvent::IsPageScroll() const
wxMouseEvent_IsPageScroll = define_c_var( wxWin, "@wxMouseEvent@IsPageScroll$xqv" ),

-- wxMouseEvent::Leaving() const
wxMouseEvent_Leaving = define_c_var( wxWin, "@wxMouseEvent@Leaving$xqv" ),

-- wxMouseEvent::LeftDClick() const
wxMouseEvent_LeftDClick = define_c_var( wxWin, "@wxMouseEvent@LeftDClick$xqv" ),

-- wxMouseEvent::LeftDown() const
wxMouseEvent_LeftDown = define_c_var( wxWin, "@wxMouseEvent@LeftDown$xqv" ),

-- wxMouseEvent::LeftIsDown() const
wxMouseEvent_LeftIsDown = define_c_var( wxWin, "@wxMouseEvent@LeftIsDown$xqv" ),

-- wxMouseEvent::LeftUp() const
wxMouseEvent_LeftUp = define_c_var( wxWin, "@wxMouseEvent@LeftUp$xqv" ),

-- wxMouseEvent::MetaDown() const
wxMouseEvent_MetaDown = define_c_var( wxWin, "@wxMouseEvent@MetaDown$xqv" ),

-- wxMouseEvent::MiddleDClick() const
wxMouseEvent_MiddleDClick = define_c_var( wxWin, "@wxMouseEvent@MiddleDClick$xqv" ),

-- wxMouseEvent::MiddleDown() const
wxMouseEvent_MiddleDown = define_c_var( wxWin, "@wxMouseEvent@MiddleDown$xqv" ),

-- wxMouseEvent::MiddleIsDown() const
wxMouseEvent_MiddleIsDown = define_c_var( wxWin, "@wxMouseEvent@MiddleIsDown$xqv" ),

-- wxMouseEvent::MiddleUp() const
wxMouseEvent_MiddleUp = define_c_var( wxWin, "@wxMouseEvent@MiddleUp$xqv" ),

-- wxMouseEvent::Moving() const
wxMouseEvent_Moving = define_c_var( wxWin, "@wxMouseEvent@Moving$xqv" ),

-- wxMouseEvent::RightDClick() const
wxMouseEvent_RightDClick = define_c_var( wxWin, "@wxMouseEvent@RightDClick$xqv" ),

-- wxMouseEvent::RightDown() const
wxMouseEvent_RightDown = define_c_var( wxWin, "@wxMouseEvent@RightDown$xqv" ),

-- wxMouseEvent::RightIsDown() const
wxMouseEvent_RightIsDown = define_c_var( wxWin, "@wxMouseEvent@RightIsDown$xqv" ),

-- wxMouseEvent::RightUp() const
wxMouseEvent_RightUp = define_c_var( wxWin, "@wxMouseEvent@RightUp$xqv" ),

-- wxMouseEvent::ShiftDown() const
wxMouseEvent_ShiftDown = define_c_var( wxWin, "@wxMouseEvent@ShiftDown$xqv" ),

-- wxMouseEvent::wxMouseEvent(int)
wxMouseEvent_op_ctr = define_c_var( wxWin, "@wxMouseEvent@$bctr$qi" ),

-- wxMouseEvent::wxMouseEvent(const wxMouseEvent&)
wxMouseEvent_op_ctr_1 = define_c_var( wxWin, "@wxMouseEvent@$bctr$qrx12wxMouseEvent" ),

-- wxMouseEvent::sm_classwxMouseEvent
wxMouseEvent_sm_classwxMouseEvent = define_c_var( wxWin, "@wxMouseEvent@sm_classwxMouseEvent" ),

sizeof_wxMouseEvent = CI:sizeof_class( wxMouseEvent_sm_classwxMouseEvent ),
wxMouseEvent = define_class( "wxMouseEvent", wxWin, wxMouseEvent_op_ctr, sizeof_wxMouseEvent, 0 )

-- end class wxMouseEvent
------------------------------


-- begin class wxObject (12 members)
------------------------------

global constant 

-- wxObject::AllocExclusive()
wxObject_AllocExclusive = define_c_var( wxWin, "@wxObject@AllocExclusive$qv" ),

-- wxObject::CloneRefData(const wxObjectRefData *) const
wxObject_CloneRefData = define_c_var( wxWin, "@wxObject@CloneRefData$xqpx15wxObjectRefData" ),

-- wxObject::CreateRefData() const
wxObject_CreateRefData = define_c_var( wxWin, "@wxObject@CreateRefData$xqv" ),

-- wxObject::GetClassInfo() const
wxObject_GetClassInfo = define_c_var( wxWin, "@wxObject@GetClassInfo$xqv" ),

-- wxObject::InitFrom(const wxObject&)
wxObject_InitFrom = define_c_var( wxWin, "@wxObject@InitFrom$qrx8wxObject" ),

-- wxObject::IsKindOf(wxClassInfo *) const
wxObject_IsKindOf = define_c_var( wxWin, "@wxObject@IsKindOf$xqp11wxClassInfo" ),

-- wxObject::Ref(const wxObject&)
wxObject_Ref = define_c_var( wxWin, "@wxObject@Ref$qrx8wxObject" ),

-- wxObject::UnRef()
wxObject_UnRef = define_c_var( wxWin, "@wxObject@UnRef$qv" ),

-- wxObject::operator =(const wxObject&)
wxObject_op_asg = define_c_var( wxWin, "@wxObject@$basg$qrx8wxObject" ),

-- wxObject::wxObject()
wxObject_op_ctr = define_c_var( wxWin, "@wxObject@$bctr$qv" ),

-- wxObject::~wxObject()
wxObject_op_dtr = define_c_var( wxWin, "@wxObject@$bdtr$qv" ),

-- wxObject::sm_classwxObject
wxObject_sm_classwxObject = define_c_var( wxWin, "@wxObject@sm_classwxObject" ),

sizeof_wxObject = CI:sizeof_class( wxObject_sm_classwxObject ),
wxObject = define_class( "wxObject", wxWin, wxObject_op_ctr, sizeof_wxObject, wxObject_op_dtr )

-- end class wxObject
------------------------------


-- begin class wxPanel (21 members)
------------------------------

global constant 

-- wxPanel::Create(wxWindow *, int, const wxPoint&, const wxSize&, long, const wxString&)
wxPanel_Create = define_c_var( wxWin, "@wxPanel@Create$qp8wxWindowirx7wxPointrx6wxSizelrx8wxString" ),

-- wxPanel::GetClassInfo() const
wxPanel_GetClassInfo = define_c_var( wxWin, "@wxPanel@GetClassInfo$xqv" ),

-- wxPanel::GetDefaultItem() const
wxPanel_GetDefaultItem = define_c_var( wxWin, "@wxPanel@GetDefaultItem$xqv" ),

-- wxPanel::GetEventTable() const
wxPanel_GetEventTable = define_c_var( wxWin, "@wxPanel@GetEventTable$xqv" ),

-- wxPanel::Init()
wxPanel_Init = define_c_var( wxWin, "@wxPanel@Init$qv" ),

-- wxPanel::InitDialog()
wxPanel_InitDialog = define_c_var( wxWin, "@wxPanel@InitDialog$qv" ),

-- wxPanel::OnChildFocus(wxChildFocusEvent&)
wxPanel_OnChildFocus = define_c_var( wxWin, "@wxPanel@OnChildFocus$qr17wxChildFocusEvent" ),

-- wxPanel::OnFocus(wxFocusEvent&)
wxPanel_OnFocus = define_c_var( wxWin, "@wxPanel@OnFocus$qr12wxFocusEvent" ),

-- wxPanel::OnNavigationKey(wxNavigationKeyEvent&)
wxPanel_OnNavigationKey = define_c_var( wxWin, "@wxPanel@OnNavigationKey$qr20wxNavigationKeyEvent" ),

-- wxPanel::OnSize(wxSizeEvent&)
wxPanel_OnSize = define_c_var( wxWin, "@wxPanel@OnSize$qr11wxSizeEvent" ),

-- wxPanel::OnSysColourChanged(wxSysColourChangedEvent&)
wxPanel_OnSysColourChanged = define_c_var( wxWin, "@wxPanel@OnSysColourChanged$qr23wxSysColourChangedEvent" ),

-- wxPanel::RemoveChild(wxWindowBase *)
wxPanel_RemoveChild = define_c_var( wxWin, "@wxPanel@RemoveChild$qp12wxWindowBase" ),

-- wxPanel::SetDefaultItem(wxWindow *)
wxPanel_SetDefaultItem = define_c_var( wxWin, "@wxPanel@SetDefaultItem$qp8wxWindow" ),

-- wxPanel::SetFocus()
wxPanel_SetFocus = define_c_var( wxWin, "@wxPanel@SetFocus$qv" ),

-- wxPanel::SetTmpDefaultItem(wxWindow *)
wxPanel_SetTmpDefaultItem = define_c_var( wxWin, "@wxPanel@SetTmpDefaultItem$qp8wxWindow" ),

-- wxPanel::wxPanel(wxWindow *, int, const wxPoint&, const wxSize&, long, const wxString&)
wxPanel_op_ctr = define_c_var( wxWin, "@wxPanel@$bctr$qp8wxWindowirx7wxPointrx6wxSizelrx8wxString" ),

-- wxPanel::wxPanel()
wxPanel_op_ctr_1 = define_c_var( wxWin, "@wxPanel@$bctr$qv" ),

-- wxPanel::~wxPanel()
wxPanel_op_dtr = define_c_var( wxWin, "@wxPanel@$bdtr$qv" ),

-- wxPanel::sm_classwxPanel
wxPanel_sm_classwxPanel = define_c_var( wxWin, "@wxPanel@sm_classwxPanel" ),

-- wxPanel::sm_eventTable
wxPanel_sm_eventTable = define_c_var( wxWin, "@wxPanel@sm_eventTable" ),

-- wxPanel::sm_eventTableEntries
wxPanel_sm_eventTableEntries = define_c_var( wxWin, "@wxPanel@sm_eventTableEntries" ),

sizeof_wxPanel = CI:sizeof_class( wxPanel_sm_classwxPanel ),
wxPanel = define_class( "wxPanel", wxWin, wxPanel_op_ctr, sizeof_wxPanel, wxPanel_op_dtr )

-- end class wxPanel
------------------------------


-- begin class wxPoint (5 members)
------------------------------

global constant 

-- wxPoint::wxPoint(int, int)
wxPoint_op_ctr = define_c_var( wxWin, "@wxPoint@$bctr$qii" ),

-- wxPoint::wxPoint()
wxPoint_op_ctr_1 = define_c_var( wxWin, "@wxPoint@$bctr$qv" ),

-- wxPoint::operator ==(const wxPoint&) const
wxPoint_op_eql = define_c_var( wxWin, "@wxPoint@$beql$xqrx7wxPoint" ),

-- wxPoint::operator !=(const wxPoint&) const
wxPoint_op_neq = define_c_var( wxWin, "@wxPoint@$bneq$xqrx7wxPoint" ),

-- wxPoint::operator -(const wxPoint&) const
wxPoint_op_sub = define_c_var( wxWin, "@wxPoint@$bsub$xqrx7wxPoint" ),

sizeof_wxPoint = 8,
wxPoint = define_class( "wxPoint", wxWin, wxPoint_op_ctr, sizeof_wxPoint, 0 )

-- end class wxPoint
------------------------------


-- begin class wxRect (32 members)
------------------------------

global constant 

-- wxRect::GetBottom() const
wxRect_GetBottom = define_c_var( wxWin, "@wxRect@GetBottom$xqv" ),

-- wxRect::GetHeight() const
wxRect_GetHeight = define_c_var( wxWin, "@wxRect@GetHeight$xqv" ),

-- wxRect::GetLeft() const
wxRect_GetLeft = define_c_var( wxWin, "@wxRect@GetLeft$xqv" ),

-- wxRect::GetRight() const
wxRect_GetRight = define_c_var( wxWin, "@wxRect@GetRight$xqv" ),

-- wxRect::GetSize() const
wxRect_GetSize = define_c_var( wxWin, "@wxRect@GetSize$xqv" ),

-- wxRect::GetTop() const
wxRect_GetTop = define_c_var( wxWin, "@wxRect@GetTop$xqv" ),

-- wxRect::GetWidth() const
wxRect_GetWidth = define_c_var( wxWin, "@wxRect@GetWidth$xqv" ),

-- wxRect::GetX() const
wxRect_GetX = define_c_var( wxWin, "@wxRect@GetX$xqv" ),

-- wxRect::GetY() const
wxRect_GetY = define_c_var( wxWin, "@wxRect@GetY$xqv" ),

-- wxRect::Inflate(int)
wxRect_Inflate = define_c_var( wxWin, "@wxRect@Inflate$qi" ),

-- wxRect::Inflate(int, int)
wxRect_Inflate_1 = define_c_var( wxWin, "@wxRect@Inflate$qii" ),

-- wxRect::Inside(int, int) const
wxRect_Inside = define_c_var( wxWin, "@wxRect@Inside$xqii" ),

-- wxRect::Inside(const wxPoint&) const
wxRect_Inside_1 = define_c_var( wxWin, "@wxRect@Inside$xqrx7wxPoint" ),

-- wxRect::Intersect(const wxRect&)
wxRect_Intersect = define_c_var( wxWin, "@wxRect@Intersect$qrx6wxRect" ),

-- wxRect::Intersect(const wxRect&) const
wxRect_Intersect_1 = define_c_var( wxWin, "@wxRect@Intersect$xqrx6wxRect" ),

-- wxRect::Intersects(const wxRect&) const
wxRect_Intersects = define_c_var( wxWin, "@wxRect@Intersects$xqrx6wxRect" ),

-- wxRect::SetBottom(int)
wxRect_SetBottom = define_c_var( wxWin, "@wxRect@SetBottom$qi" ),

-- wxRect::SetHeight(int)
wxRect_SetHeight = define_c_var( wxWin, "@wxRect@SetHeight$qi" ),

-- wxRect::SetLeft(int)
wxRect_SetLeft = define_c_var( wxWin, "@wxRect@SetLeft$qi" ),

-- wxRect::SetRight(int)
wxRect_SetRight = define_c_var( wxWin, "@wxRect@SetRight$qi" ),

-- wxRect::SetTop(int)
wxRect_SetTop = define_c_var( wxWin, "@wxRect@SetTop$qi" ),

-- wxRect::SetWidth(int)
wxRect_SetWidth = define_c_var( wxWin, "@wxRect@SetWidth$qi" ),

-- wxRect::SetX(int)
wxRect_SetX = define_c_var( wxWin, "@wxRect@SetX$qi" ),

-- wxRect::SetY(int)
wxRect_SetY = define_c_var( wxWin, "@wxRect@SetY$qi" ),

-- wxRect::operator +(const wxRect&) const
wxRect_op_add = define_c_var( wxWin, "@wxRect@$badd$xqrx6wxRect" ),

-- wxRect::wxRect(int, int, int, int)
wxRect_op_ctr = define_c_var( wxWin, "@wxRect@$bctr$qiiii" ),

-- wxRect::wxRect(const wxPoint&, const wxSize&)
wxRect_op_ctr_1 = define_c_var( wxWin, "@wxRect@$bctr$qrx7wxPointrx6wxSize" ),

-- wxRect::wxRect(const wxPoint&, const wxPoint&)
wxRect_op_ctr_2 = define_c_var( wxWin, "@wxRect@$bctr$qrx7wxPointt1" ),

-- wxRect::wxRect()
wxRect_op_ctr_3 = define_c_var( wxWin, "@wxRect@$bctr$qv" ),

-- wxRect::operator ==(const wxRect&) const
wxRect_op_eql = define_c_var( wxWin, "@wxRect@$beql$xqrx6wxRect" ),

-- wxRect::operator !=(const wxRect&) const
wxRect_op_neq = define_c_var( wxWin, "@wxRect@$bneq$xqrx6wxRect" ),

-- wxRect::operator +=(const wxRect&)
wxRect_op_rplu = define_c_var( wxWin, "@wxRect@$brplu$qrx6wxRect" ),

sizeof_wxRect = 16,
wxRect = define_class( "wxRect", wxWin, wxRect_op_ctr, sizeof_wxRect, 0 )

-- end class wxRect
------------------------------


-- begin class wxScrolledWindow (4 members)
------------------------------

global constant 

-- wxScrolledWindow::GetClassInfo() const
wxScrolledWindow_GetClassInfo = define_c_var( wxWin, "@wxScrolledWindow@GetClassInfo$xqv" ),

-- wxScrolledWindow::wxScrolledWindow(wxWindow *, int, const wxPoint&, const wxSize&, long, const wxString&)
wxScrolledWindow_op_ctr = define_c_var( wxWin, "@wxScrolledWindow@$bctr$qp8wxWindowirx7wxPointrx6wxSizelrx8wxString" ),

-- wxScrolledWindow::wxScrolledWindow()
wxScrolledWindow_op_ctr_1 = define_c_var( wxWin, "@wxScrolledWindow@$bctr$qv" ),

-- wxScrolledWindow::sm_classwxScrolledWindow
wxScrolledWindow_sm_classwxScrolledWindow = define_c_var( wxWin, "@wxScrolledWindow@sm_classwxScrolledWindow" ),

sizeof_wxScrolledWindow = CI:sizeof_class( wxScrolledWindow_sm_classwxScrolledWindow ),
wxScrolledWindow = define_class( "wxScrolledWindow", wxWin, wxScrolledWindow_op_ctr, sizeof_wxScrolledWindow, 0 )

-- end class wxScrolledWindow
------------------------------


-- begin class wxSize (9 members)
------------------------------

global constant 

-- wxSize::GetHeight() const
wxSize_GetHeight = define_c_var( wxWin, "@wxSize@GetHeight$xqv" ),

-- wxSize::GetWidth() const
wxSize_GetWidth = define_c_var( wxWin, "@wxSize@GetWidth$xqv" ),

-- wxSize::SetHeight(int)
wxSize_SetHeight = define_c_var( wxWin, "@wxSize@SetHeight$qi" ),

-- wxSize::SetWidth(int)
wxSize_SetWidth = define_c_var( wxWin, "@wxSize@SetWidth$qi" ),

-- wxSize::operator +(const wxSize&)
wxSize_op_add = define_c_var( wxWin, "@wxSize@$badd$qrx6wxSize" ),

-- wxSize::wxSize(int, int)
wxSize_op_ctr = define_c_var( wxWin, "@wxSize@$bctr$qii" ),

-- wxSize::wxSize()
wxSize_op_ctr_1 = define_c_var( wxWin, "@wxSize@$bctr$qv" ),

-- wxSize::operator ==(const wxSize&) const
wxSize_op_eql = define_c_var( wxWin, "@wxSize@$beql$xqrx6wxSize" ),

-- wxSize::operator !=(const wxSize&) const
wxSize_op_neq = define_c_var( wxWin, "@wxSize@$bneq$xqrx6wxSize" ),

sizeof_wxSize = 8,
wxSize = define_class( "wxSize", wxWin, wxSize_op_ctr, sizeof_wxSize, 0 )

-- end class wxSize
------------------------------


-- begin class wxString (141 members)
------------------------------

global constant 

-- wxString::After(char) const
wxString_After = define_c_var( wxWin, "@wxString@After$xqc" ),

-- wxString::AfterFirst(char) const
wxString_AfterFirst = define_c_var( wxWin, "@wxString@AfterFirst$xqc" ),

-- wxString::AfterLast(char) const
wxString_AfterLast = define_c_var( wxWin, "@wxString@AfterLast$xqc" ),

-- wxString::Alloc(unsigned int)
wxString_Alloc = define_c_var( wxWin, "@wxString@Alloc$qui" ),

-- wxString::AllocBeforeWrite(unsigned int)
wxString_AllocBeforeWrite = define_c_var( wxWin, "@wxString@AllocBeforeWrite$qui" ),

-- wxString::AllocBuffer(unsigned int)
wxString_AllocBuffer = define_c_var( wxWin, "@wxString@AllocBuffer$qui" ),

-- wxString::AllocCopy(wxString&, int, int) const
wxString_AllocCopy = define_c_var( wxWin, "@wxString@AllocCopy$xqr8wxStringii" ),

-- wxString::Append(char, unsigned int)
wxString_Append = define_c_var( wxWin, "@wxString@Append$qcui" ),

-- wxString::Append(const wxString&)
wxString_Append_1 = define_c_var( wxWin, "@wxString@Append$qrx8wxString" ),

-- wxString::AssignCopy(unsigned int, const char *)
wxString_AssignCopy = define_c_var( wxWin, "@wxString@AssignCopy$quipxc" ),

-- wxString::BeforeFirst(char) const
wxString_BeforeFirst = define_c_var( wxWin, "@wxString@BeforeFirst$xqc" ),

-- wxString::BeforeLast(char) const
wxString_BeforeLast = define_c_var( wxWin, "@wxString@BeforeLast$xqc" ),

-- wxString::Clear()
wxString_Clear = define_c_var( wxWin, "@wxString@Clear$qv" ),

-- wxString::Cmp(const char *) const
wxString_Cmp = define_c_var( wxWin, "@wxString@Cmp$xqpxc" ),

-- wxString::CmpNoCase(const char *) const
wxString_CmpNoCase = define_c_var( wxWin, "@wxString@CmpNoCase$xqpxc" ),

-- wxString::CompareTo(const char *, wxString::caseCompare) const
wxString_CompareTo = define_c_var( wxWin, "@wxString@CompareTo$xqpxc20wxString@caseCompare" ),

-- wxString::ConcatSelf(int, const char *)
wxString_ConcatSelf = define_c_var( wxWin, "@wxString@ConcatSelf$qipxc" ),

-- wxString::Contains(const wxString&) const
wxString_Contains = define_c_var( wxWin, "@wxString@Contains$xqrx8wxString" ),

-- wxString::CopyBeforeWrite()
wxString_CopyBeforeWrite = define_c_var( wxWin, "@wxString@CopyBeforeWrite$qv" ),

-- wxString::Empty()
wxString_Empty = define_c_var( wxWin, "@wxString@Empty$qv" ),

-- wxString::Find(char, bool) const
wxString_Find = define_c_var( wxWin, "@wxString@Find$xqco" ),

-- wxString::Find(const char *) const
wxString_Find_1 = define_c_var( wxWin, "@wxString@Find$xqpxc" ),

-- wxString::First(const char *) const
wxString_First = define_c_var( wxWin, "@wxString@First$xqpxc" ),

-- wxString::Format(const char *, ...)
wxString_Format = define_c_var( wxWin, "@wxString@Format$qpxce" ),

-- wxString::FormatV(const char *, void *)
wxString_FormatV = define_c_var( wxWin, "@wxString@FormatV$qpxcpv" ),

-- wxString::Freq(char) const
wxString_Freq = define_c_var( wxWin, "@wxString@Freq$xqc" ),

-- wxString::FromAscii(const char *)
wxString_FromAscii = define_c_var( wxWin, "@wxString@FromAscii$qpxc" ),

-- wxString::FromAscii(const char)
wxString_FromAscii_1 = define_c_var( wxWin, "@wxString@FromAscii$qxc" ),

-- wxString::GetChar(unsigned int) const
wxString_GetChar = define_c_var( wxWin, "@wxString@GetChar$xqui" ),

-- wxString::GetData() const
wxString_GetData = define_c_var( wxWin, "@wxString@GetData$xqv" ),

-- wxString::GetStringData() const
wxString_GetStringData = define_c_var( wxWin, "@wxString@GetStringData$xqv" ),

-- wxString::GetWritableChar(unsigned int)
wxString_GetWritableChar = define_c_var( wxWin, "@wxString@GetWritableChar$qui" ),

-- wxString::GetWriteBuf(unsigned int)
wxString_GetWriteBuf = define_c_var( wxWin, "@wxString@GetWriteBuf$qui" ),

-- wxString::Index(char) const
wxString_Index = define_c_var( wxWin, "@wxString@Index$xqc" ),

-- wxString::Init()
wxString_Init = define_c_var( wxWin, "@wxString@Init$qv" ),

-- wxString::InitWith(const char *, unsigned int, unsigned int)
wxString_InitWith = define_c_var( wxWin, "@wxString@InitWith$qpxcuiui" ),

-- wxString::IsAscii() const
wxString_IsAscii = define_c_var( wxWin, "@wxString@IsAscii$xqv" ),

-- wxString::IsEmpty() const
wxString_IsEmpty = define_c_var( wxWin, "@wxString@IsEmpty$xqv" ),

-- wxString::IsNull() const
wxString_IsNull = define_c_var( wxWin, "@wxString@IsNull$xqv" ),

-- wxString::IsNumber() const
wxString_IsNumber = define_c_var( wxWin, "@wxString@IsNumber$xqv" ),

-- wxString::IsSameAs(char, bool) const
wxString_IsSameAs = define_c_var( wxWin, "@wxString@IsSameAs$xqco" ),

-- wxString::IsSameAs(const char *, bool) const
wxString_IsSameAs_1 = define_c_var( wxWin, "@wxString@IsSameAs$xqpxco" ),

-- wxString::IsWord() const
wxString_IsWord = define_c_var( wxWin, "@wxString@IsWord$xqv" ),

-- wxString::Last()
wxString_Last = define_c_var( wxWin, "@wxString@Last$qv" ),

-- wxString::Last() const
wxString_Last_1 = define_c_var( wxWin, "@wxString@Last$xqv" ),

-- wxString::Left(unsigned int) const
wxString_Left = define_c_var( wxWin, "@wxString@Left$xqui" ),

-- wxString::Len() const
wxString_Len = define_c_var( wxWin, "@wxString@Len$xqv" ),

-- wxString::Length() const
wxString_Length = define_c_var( wxWin, "@wxString@Length$xqv" ),

-- wxString::Lower() const
wxString_Lower = define_c_var( wxWin, "@wxString@Lower$xqv" ),

-- wxString::MakeLower()
wxString_MakeLower = define_c_var( wxWin, "@wxString@MakeLower$qv" ),

-- wxString::MakeUpper()
wxString_MakeUpper = define_c_var( wxWin, "@wxString@MakeUpper$qv" ),

-- wxString::Matches(const char *) const
wxString_Matches = define_c_var( wxWin, "@wxString@Matches$xqpxc" ),

-- wxString::Mid(unsigned int, unsigned int) const
wxString_Mid = define_c_var( wxWin, "@wxString@Mid$xquiui" ),

-- wxString::Pad(unsigned int, char, bool)
wxString_Pad = define_c_var( wxWin, "@wxString@Pad$quico" ),

-- wxString::Prepend(const wxString&)
wxString_Prepend = define_c_var( wxWin, "@wxString@Prepend$qrx8wxString" ),

-- wxString::Printf(const char *, ...)
wxString_Printf = define_c_var( wxWin, "@wxString@Printf$qpxce" ),

-- wxString::PrintfV(const char *, void *)
wxString_PrintfV = define_c_var( wxWin, "@wxString@PrintfV$qpxcpv" ),

-- wxString::Reinit()
wxString_Reinit = define_c_var( wxWin, "@wxString@Reinit$qv" ),

-- wxString::Remove(unsigned int)
wxString_Remove = define_c_var( wxWin, "@wxString@Remove$qui" ),

-- wxString::RemoveLast(unsigned int)
wxString_RemoveLast = define_c_var( wxWin, "@wxString@RemoveLast$qui" ),

-- wxString::Remove(unsigned int, unsigned int)
wxString_Remove_1 = define_c_var( wxWin, "@wxString@Remove$quiui" ),

-- wxString::Replace(const char *, const char *, bool)
wxString_Replace = define_c_var( wxWin, "@wxString@Replace$qpxct1o" ),

-- wxString::Right(unsigned int) const
wxString_Right = define_c_var( wxWin, "@wxString@Right$xqui" ),

-- wxString::Shrink()
wxString_Shrink = define_c_var( wxWin, "@wxString@Shrink$qv" ),

-- wxString::StartsWith(const char *, wxString *) const
wxString_StartsWith = define_c_var( wxWin, "@wxString@StartsWith$xqpxcp8wxString" ),

-- wxString::Strip(wxString::stripType) const
wxString_Strip = define_c_var( wxWin, "@wxString@Strip$xq18wxString@stripType" ),

-- wxString::ToAscii() const
wxString_ToAscii = define_c_var( wxWin, "@wxString@ToAscii$xqv" ),

-- wxString::ToDouble(double *) const
wxString_ToDouble = define_c_var( wxWin, "@wxString@ToDouble$xqpd" ),

-- wxString::ToLong(long *, int) const
wxString_ToLong = define_c_var( wxWin, "@wxString@ToLong$xqpli" ),

-- wxString::ToULong(unsigned long *, int) const
wxString_ToULong = define_c_var( wxWin, "@wxString@ToULong$xqpuli" ),

-- wxString::Trim(bool)
wxString_Trim = define_c_var( wxWin, "@wxString@Trim$qo" ),

-- wxString::Truncate(unsigned int)
wxString_Truncate = define_c_var( wxWin, "@wxString@Truncate$qui" ),

-- wxString::UngetWriteBuf(unsigned int)
wxString_UngetWriteBuf = define_c_var( wxWin, "@wxString@UngetWriteBuf$qui" ),

-- wxString::UngetWriteBuf()
wxString_UngetWriteBuf_1 = define_c_var( wxWin, "@wxString@UngetWriteBuf$qv" ),

-- wxString::Upper() const
wxString_Upper = define_c_var( wxWin, "@wxString@Upper$xqv" ),

-- wxString::UpperCase()
wxString_UpperCase = define_c_var( wxWin, "@wxString@UpperCase$qv" ),

-- wxString::append(const char *, unsigned int)
wxString_append = define_c_var( wxWin, "@wxString@append$qpxcui" ),

-- wxString::c_str() const
wxString_c_str = define_c_var( wxWin, "@wxString@c_str$xqv" ),

-- wxString::clear()
wxString_clear = define_c_var( wxWin, "@wxString@clear$qv" ),

-- wxString::empty() const
wxString_empty = define_c_var( wxWin, "@wxString@empty$xqv" ),

-- wxString::end() const
wxString_end = define_c_var( wxWin, "@wxString@end$xqv" ),

-- wxString::erase(unsigned int, unsigned int)
wxString_erase = define_c_var( wxWin, "@wxString@erase$quiui" ),

-- wxString::find(const char *, unsigned int, unsigned int) const
wxString_find = define_c_var( wxWin, "@wxString@find$xqpxcuiui" ),

-- wxString::find(const wxString&, unsigned int) const
wxString_find_1 = define_c_var( wxWin, "@wxString@find$xqrx8wxStringui" ),

-- wxString::find_first_not_of(char, unsigned int) const
wxString_find_first_not_of = define_c_var( wxWin, "@wxString@find_first_not_of$xqcui" ),

-- wxString::find_first_not_of(const char *, unsigned int) const
wxString_find_first_not_of_1 = define_c_var( wxWin, "@wxString@find_first_not_of$xqpxcui" ),

-- wxString::find_first_not_of(const wxString&, unsigned int) const
wxString_find_first_not_of_2 = define_c_var( wxWin, "@wxString@find_first_not_of$xqrx8wxStringui" ),

-- wxString::find_first_of(const char *, unsigned int) const
wxString_find_first_of = define_c_var( wxWin, "@wxString@find_first_of$xqpxcui" ),

-- wxString::find_first_of(const wxString&, unsigned int) const
wxString_find_first_of_1 = define_c_var( wxWin, "@wxString@find_first_of$xqrx8wxStringui" ),

-- wxString::find_last_not_of(char, unsigned int) const
wxString_find_last_not_of = define_c_var( wxWin, "@wxString@find_last_not_of$xqcui" ),

-- wxString::find_last_not_of(const char *, unsigned int) const
wxString_find_last_not_of_1 = define_c_var( wxWin, "@wxString@find_last_not_of$xqpxcui" ),

-- wxString::find_last_of(char, unsigned int) const
wxString_find_last_of = define_c_var( wxWin, "@wxString@find_last_of$xqcui" ),

-- wxString::find_last_of(const char *, unsigned int) const
wxString_find_last_of_1 = define_c_var( wxWin, "@wxString@find_last_of$xqpxcui" ),

-- wxString::find_last_of(const wxString&, unsigned int) const
wxString_find_last_of_2 = define_c_var( wxWin, "@wxString@find_last_of$xqrx8wxStringui" ),

-- wxString::fn_str() const
wxString_fn_str = define_c_var( wxWin, "@wxString@fn_str$xqv" ),

-- wxString::insert(unsigned int, const wxString&)
wxString_insert = define_c_var( wxWin, "@wxString@insert$quirx8wxString" ),

-- wxString::length() const
wxString_length = define_c_var( wxWin, "@wxString@length$xqv" ),

-- wxString::mb_str(wxMBConv&) const
wxString_mb_str = define_c_var( wxWin, "@wxString@mb_str$xqr8wxMBConv" ),

-- wxString::mb_str() const
wxString_mb_str_1 = define_c_var( wxWin, "@wxString@mb_str$xqv" ),

-- wxString::mbc_str() const
wxString_mbc_str = define_c_var( wxWin, "@wxString@mbc_str$xqv" ),

-- wxString::npos
wxString_npos = define_c_var( wxWin, "@wxString@npos" ),

-- wxString::operator =(char)
wxString_op_asg = define_c_var( wxWin, "@wxString@$basg$qc" ),

-- wxString::operator =(const wchar_t *)
wxString_op_asg_1 = define_c_var( wxWin, "@wxString@$basg$qpxb" ),

-- wxString::operator =(const char *)
wxString_op_asg_2 = define_c_var( wxWin, "@wxString@$basg$qpxc" ),

-- wxString::operator =(const unsigned char *)
wxString_op_asg_3 = define_c_var( wxWin, "@wxString@$basg$qpxuc" ),

-- wxString::operator =(const wxString&)
wxString_op_asg_4 = define_c_var( wxWin, "@wxString@$basg$qrx8wxString" ),

-- wxString::operator ()(unsigned int, unsigned int) const
wxString_op_call = define_c_var( wxWin, "@wxString@$bcall$xquiui" ),

-- wxString::wxString(char, unsigned int)
wxString_op_ctr = define_c_var( wxWin, "@wxString@$bctr$qcui" ),

-- wxString::wxString(const wchar_t *, wxMBConv&, unsigned int)
wxString_op_ctr_1 = define_c_var( wxWin, "@wxString@$bctr$qpxbr8wxMBConvui" ),

-- wxString::wxString(const char *, wxMBConv&, unsigned int)
wxString_op_ctr_2 = define_c_var( wxWin, "@wxString@$bctr$qpxcr8wxMBConvui" ),

-- wxString::wxString(const char *, unsigned int)
wxString_op_ctr_3 = define_c_var( wxWin, "@wxString@$bctr$qpxcui" ),

-- wxString::wxString(const void *, const void *)
wxString_op_ctr_4 = define_c_var( wxWin, "@wxString@$bctr$qpxvt1" ),

-- wxString::wxString(const wxString&)
wxString_op_ctr_5 = define_c_var( wxWin, "@wxString@$bctr$qrx8wxString" ),

-- wxString::wxString()
wxString_op_ctr_6 = define_c_var( wxWin, "@wxString@$bctr$qv" ),

-- wxString::~wxString()
wxString_op_dtr = define_c_var( wxWin, "@wxString@$bdtr$qv" ),

-- wxString::operator <<(char)
wxString_op_lsh = define_c_var( wxWin, "@wxString@$blsh$qc" ),

-- wxString::operator <<(int)
wxString_op_lsh_1 = define_c_var( wxWin, "@wxString@$blsh$qi" ),

-- wxString::operator <<(long)
wxString_op_lsh_2 = define_c_var( wxWin, "@wxString@$blsh$ql" ),

-- wxString::operator <<(const char *)
wxString_op_lsh_3 = define_c_var( wxWin, "@wxString@$blsh$qpxc" ),

-- wxString::operator <<(const wxString&)
wxString_op_lsh_4 = define_c_var( wxWin, "@wxString@$blsh$qrx8wxString" ),

-- wxString::operator !() const
wxString_op_not = define_c_var( wxWin, "@wxString@$bnot$xqv" ),

-- wxString::operator +=(char)
wxString_op_rplu = define_c_var( wxWin, "@wxString@$brplu$qc" ),

-- wxString::operator +=(const char *)
wxString_op_rplu_1 = define_c_var( wxWin, "@wxString@$brplu$qpxc" ),

-- wxString::operator +=(const wxString&)
wxString_op_rplu_2 = define_c_var( wxWin, "@wxString@$brplu$qrx8wxString" ),

-- wxString::operator [](unsigned int)
wxString_op_subs = define_c_var( wxWin, "@wxString@$bsubs$qui" ),

-- wxString::operator [](int) const
wxString_op_subs_1 = define_c_var( wxWin, "@wxString@$bsubs$xqi" ),

-- wxString::operator [](unsigned int) const
wxString_op_subs_2 = define_c_var( wxWin, "@wxString@$bsubs$xqui" ),

-- wxString::operator const char *() const
wxString_opxc = define_c_var( wxWin, "@wxString@$opxc$xqv" ),

-- wxString::replace(unsigned int, unsigned int, const char *)
wxString_replace = define_c_var( wxWin, "@wxString@replace$quiuipxc" ),

-- wxString::replace(unsigned int, unsigned int, const char *, unsigned int)
wxString_replace_1 = define_c_var( wxWin, "@wxString@replace$quiuipxcui" ),

-- wxString::replace(unsigned int, unsigned int, const wxString&, unsigned int, unsigned int)
wxString_replace_2 = define_c_var( wxWin, "@wxString@replace$quiuirx8wxStringuiui" ),

-- wxString::replace(unsigned int, unsigned int, unsigned int, char)
wxString_replace_3 = define_c_var( wxWin, "@wxString@replace$quiuiuic" ),

-- wxString::reserve(unsigned int)
wxString_reserve = define_c_var( wxWin, "@wxString@reserve$qui" ),

-- wxString::resize(unsigned int, char)
wxString_resize = define_c_var( wxWin, "@wxString@resize$quic" ),

-- wxString::rfind(char, unsigned int) const
wxString_rfind = define_c_var( wxWin, "@wxString@rfind$xqcui" ),

-- wxString::rfind(const char *, unsigned int, unsigned int) const
wxString_rfind_1 = define_c_var( wxWin, "@wxString@rfind$xqpxcuiui" ),

-- wxString::rfind(const wxString&, unsigned int) const
wxString_rfind_2 = define_c_var( wxWin, "@wxString@rfind$xqrx8wxStringui" ),

-- wxString::sprintf(const char *, ...)
wxString_sprintf = define_c_var( wxWin, "@wxString@sprintf$qpxce" ),

-- wxString::substr(unsigned int, unsigned int) const
wxString_substr = define_c_var( wxWin, "@wxString@substr$xquiui" ),

-- wxString::swap(wxString&)
wxString_swap = define_c_var( wxWin, "@wxString@swap$qr8wxString" ),

-- wxString::wx_str() const
wxString_wx_str = define_c_var( wxWin, "@wxString@wx_str$xqv" ),

sizeof_wxString = 4,
wxString = define_class( "wxString", wxWin, wxString_op_ctr_3, sizeof_wxString, wxString_op_dtr )

-- end class wxString
------------------------------


-- begin class wxSystemSettings (4 members)
------------------------------

global constant 

-- wxSystemSettings::GetScreenType()
wxSystemSettings_GetScreenType = define_c_var( wxWin, "@wxSystemSettings@GetScreenType$qv" ),

-- wxSystemSettings::GetSystemColour(int)
wxSystemSettings_GetSystemColour = define_c_var( wxWin, "@wxSystemSettings@GetSystemColour$qi" ),

-- wxSystemSettings::SetScreenType(wxSystemScreenType)
wxSystemSettings_SetScreenType = define_c_var( wxWin, "@wxSystemSettings@SetScreenType$q18wxSystemScreenType" ),

-- wxSystemSettings::ms_screen
wxSystemSettings_ms_screen = define_c_var( wxWin, "@wxSystemSettings@ms_screen" ),

sizeof_wxSystemSettings = 1,
wxSystemSettings = define_class( "wxSystemSettings", wxWin, 0, sizeof_wxSystemSettings, 0 )

-- end class wxSystemSettings
------------------------------


-- begin class wxSystemSettingsNative (5 members)
------------------------------

global constant 

-- wxSystemSettingsNative::GetColour(wxSystemColour)
wxSystemSettingsNative_GetColour = define_c_var( wxWin, "@wxSystemSettingsNative@GetColour$q14wxSystemColour" ),

-- wxSystemSettingsNative::GetColour(wxSystemColour,wxColour)
wxSystemSettingsNative_GetColour2 = define_c_var( wxWin, "@wxSystemSettingsNative@GetColour$qir8wxColour" ),

-- wxSystemSettingsNative::GetFont(wxSystemFont)
wxSystemSettingsNative_GetFont = define_c_var( wxWin, "@wxSystemSettingsNative@GetFont$q12wxSystemFont" ),

-- wxSystemSettingsNative::GetMetric(wxSystemMetric)
wxSystemSettingsNative_GetMetric = define_c_var( wxWin, "@wxSystemSettingsNative@GetMetric$q14wxSystemMetric" ),

-- wxSystemSettingsNative::HasFeature(wxSystemFeature)
wxSystemSettingsNative_HasFeature = define_c_var( wxWin, "@wxSystemSettingsNative@HasFeature$q15wxSystemFeature" ),

sizeof_wxSystemSettingsNative = 1,
wxSystemSettingsNative = define_class( "wxSystemSettingsNative", wxWin, 0, sizeof_wxSystemSettingsNative, 0 )

-- end class wxSystemSettingsNative
------------------------------


-- begin class wxTopLevelWindow (3 members)
------------------------------

global constant 

-- wxTopLevelWindow::GetClassInfo() const
wxTopLevelWindow_GetClassInfo = define_c_var( wxWin, "@wxTopLevelWindow@GetClassInfo$xqv" ),

-- wxTopLevelWindow::wxTopLevelWindow()
wxTopLevelWindow_op_ctr = define_c_var( wxWin, "@wxTopLevelWindow@$bctr$qv" ),

-- wxTopLevelWindow::sm_classwxTopLevelWindow
wxTopLevelWindow_sm_classwxTopLevelWindow = define_c_var( wxWin, "@wxTopLevelWindow@sm_classwxTopLevelWindow" ),

sizeof_wxTopLevelWindow = CI:sizeof_class( wxTopLevelWindow_sm_classwxTopLevelWindow ),
wxTopLevelWindow = define_class( "wxTopLevelWindow", wxWin, 0, sizeof_wxTopLevelWindow, 0 )

-- end class wxTopLevelWindow
------------------------------


-- begin class wxTopLevelWindowBase (18 members)
------------------------------

global constant 

-- wxTopLevelWindowBase::Destroy()
wxTopLevelWindowBase_Destroy = define_c_var( wxWin, "@wxTopLevelWindowBase@Destroy$qv" ),

-- wxTopLevelWindowBase::DoClientToScreen(int *, int *) const
wxTopLevelWindowBase_DoClientToScreen = define_c_var( wxWin, "@wxTopLevelWindowBase@DoClientToScreen$xqpit1" ),

-- wxTopLevelWindowBase::DoScreenToClient(int *, int *) const
wxTopLevelWindowBase_DoScreenToClient = define_c_var( wxWin, "@wxTopLevelWindowBase@DoScreenToClient$xqpit1" ),

-- wxTopLevelWindowBase::GetEventTable() const
wxTopLevelWindowBase_GetEventTable = define_c_var( wxWin, "@wxTopLevelWindowBase@GetEventTable$xqv" ),

-- wxTopLevelWindowBase::GetIcon() const
wxTopLevelWindowBase_GetIcon = define_c_var( wxWin, "@wxTopLevelWindowBase@GetIcon$xqv" ),

-- wxTopLevelWindowBase::GetMaxSize() const
wxTopLevelWindowBase_GetMaxSize = define_c_var( wxWin, "@wxTopLevelWindowBase@GetMaxSize$xqv" ),

-- wxTopLevelWindowBase::IsLastBeforeExit() const
wxTopLevelWindowBase_IsLastBeforeExit = define_c_var( wxWin, "@wxTopLevelWindowBase@IsLastBeforeExit$xqv" ),

-- wxTopLevelWindowBase::IsOneOfBars(const wxWindow *) const
wxTopLevelWindowBase_IsOneOfBars = define_c_var( wxWin, "@wxTopLevelWindowBase@IsOneOfBars$xqpx8wxWindow" ),

-- wxTopLevelWindowBase::IsTopLevel() const
wxTopLevelWindowBase_IsTopLevel = define_c_var( wxWin, "@wxTopLevelWindowBase@IsTopLevel$xqv" ),

-- wxTopLevelWindowBase::OnCloseWindow(wxCloseEvent&)
wxTopLevelWindowBase_OnCloseWindow = define_c_var( wxWin, "@wxTopLevelWindowBase@OnCloseWindow$qr12wxCloseEvent" ),

-- wxTopLevelWindowBase::OnSize(wxSizeEvent&)
wxTopLevelWindowBase_OnSize = define_c_var( wxWin, "@wxTopLevelWindowBase@OnSize$qr11wxSizeEvent" ),

-- wxTopLevelWindowBase::SendIconizeEvent(bool)
wxTopLevelWindowBase_SendIconizeEvent = define_c_var( wxWin, "@wxTopLevelWindowBase@SendIconizeEvent$qo" ),

-- wxTopLevelWindowBase::SetIcon(const wxIcon&)
wxTopLevelWindowBase_SetIcon = define_c_var( wxWin, "@wxTopLevelWindowBase@SetIcon$qrx6wxIcon" ),

-- wxTopLevelWindowBase::SetIcons(const wxIconBundle&)
wxTopLevelWindowBase_SetIcons = define_c_var( wxWin, "@wxTopLevelWindowBase@SetIcons$qrx12wxIconBundle" ),

-- wxTopLevelWindowBase::wxTopLevelWindowBase()
wxTopLevelWindowBase_op_ctr = define_c_var( wxWin, "@wxTopLevelWindowBase@$bctr$qv" ),

-- wxTopLevelWindowBase::~wxTopLevelWindowBase()
wxTopLevelWindowBase_op_dtr = define_c_var( wxWin, "@wxTopLevelWindowBase@$bdtr$qv" ),

-- wxTopLevelWindowBase::sm_eventTable
wxTopLevelWindowBase_sm_eventTable = define_c_var( wxWin, "@wxTopLevelWindowBase@sm_eventTable" ),

-- wxTopLevelWindowBase::sm_eventTableEntries
wxTopLevelWindowBase_sm_eventTableEntries = define_c_var( wxWin, "@wxTopLevelWindowBase@sm_eventTableEntries" ),

sizeof_wxTopLevelWindowBase = 1,
wxTopLevelWindowBase = define_class( "wxTopLevelWindowBase", wxWin, wxTopLevelWindowBase_op_ctr, sizeof_wxTopLevelWindowBase, wxTopLevelWindowBase_op_dtr )

-- end class wxTopLevelWindowBase
------------------------------


-- begin class wxTopLevelWindowMSW (27 members)
------------------------------

global constant 

-- wxTopLevelWindowMSW::Create(wxWindow *, int, const wxString&, const wxPoint&, const wxSize&, long, const wxString&)
wxTopLevelWindowMSW_Create = define_c_var( wxWin, "@wxTopLevelWindowMSW@Create$qp8wxWindowirx8wxStringrx7wxPointrx6wxSizelt3" ),

-- wxTopLevelWindowMSW::CreateDialog(const void *, const wxString&, const wxPoint&, const wxSize&)
wxTopLevelWindowMSW_CreateDialog = define_c_var( wxWin, "@wxTopLevelWindowMSW@CreateDialog$qpxvrx8wxStringrx7wxPointrx6wxSize" ),

-- wxTopLevelWindowMSW::CreateFrame(const wxString&, const wxPoint&, const wxSize&)
wxTopLevelWindowMSW_CreateFrame = define_c_var( wxWin, "@wxTopLevelWindowMSW@CreateFrame$qrx8wxStringrx7wxPointrx6wxSize" ),

-- wxTopLevelWindowMSW::DoShowWindow(int)
wxTopLevelWindowMSW_DoShowWindow = define_c_var( wxWin, "@wxTopLevelWindowMSW@DoShowWindow$qi" ),

-- wxTopLevelWindowMSW::EnableCloseButton(bool)
wxTopLevelWindowMSW_EnableCloseButton = define_c_var( wxWin, "@wxTopLevelWindowMSW@EnableCloseButton$qo" ),

-- wxTopLevelWindowMSW::GetEventTable() const
wxTopLevelWindowMSW_GetEventTable = define_c_var( wxWin, "@wxTopLevelWindowMSW@GetEventTable$xqv" ),

-- wxTopLevelWindowMSW::GetLastFocus() const
wxTopLevelWindowMSW_GetLastFocus = define_c_var( wxWin, "@wxTopLevelWindowMSW@GetLastFocus$xqv" ),

-- wxTopLevelWindowMSW::Iconize(bool)
wxTopLevelWindowMSW_Iconize = define_c_var( wxWin, "@wxTopLevelWindowMSW@Iconize$qo" ),

-- wxTopLevelWindowMSW::Init()
wxTopLevelWindowMSW_Init = define_c_var( wxWin, "@wxTopLevelWindowMSW@Init$qv" ),

-- wxTopLevelWindowMSW::IsFullScreen() const
wxTopLevelWindowMSW_IsFullScreen = define_c_var( wxWin, "@wxTopLevelWindowMSW@IsFullScreen$xqv" ),

-- wxTopLevelWindowMSW::IsIconized() const
wxTopLevelWindowMSW_IsIconized = define_c_var( wxWin, "@wxTopLevelWindowMSW@IsIconized$xqv" ),

-- wxTopLevelWindowMSW::IsMaximized() const
wxTopLevelWindowMSW_IsMaximized = define_c_var( wxWin, "@wxTopLevelWindowMSW@IsMaximized$xqv" ),

-- wxTopLevelWindowMSW::MSWGetParent() const
wxTopLevelWindowMSW_MSWGetParent = define_c_var( wxWin, "@wxTopLevelWindowMSW@MSWGetParent$xqv" ),

-- wxTopLevelWindowMSW::MSWGetStyle(long, unsigned long *) const
wxTopLevelWindowMSW_MSWGetStyle = define_c_var( wxWin, "@wxTopLevelWindowMSW@MSWGetStyle$xqlpul" ),

-- wxTopLevelWindowMSW::Maximize(bool)
wxTopLevelWindowMSW_Maximize = define_c_var( wxWin, "@wxTopLevelWindowMSW@Maximize$qo" ),

-- wxTopLevelWindowMSW::OnActivate(wxActivateEvent&)
wxTopLevelWindowMSW_OnActivate = define_c_var( wxWin, "@wxTopLevelWindowMSW@OnActivate$qr15wxActivateEvent" ),

-- wxTopLevelWindowMSW::Restore()
wxTopLevelWindowMSW_Restore = define_c_var( wxWin, "@wxTopLevelWindowMSW@Restore$qv" ),

-- wxTopLevelWindowMSW::SetIcon(const wxIcon&)
wxTopLevelWindowMSW_SetIcon = define_c_var( wxWin, "@wxTopLevelWindowMSW@SetIcon$qrx6wxIcon" ),

-- wxTopLevelWindowMSW::SetIcons(const wxIconBundle&)
wxTopLevelWindowMSW_SetIcons = define_c_var( wxWin, "@wxTopLevelWindowMSW@SetIcons$qrx12wxIconBundle" ),

-- wxTopLevelWindowMSW::SetLastFocus(wxWindow *)
wxTopLevelWindowMSW_SetLastFocus = define_c_var( wxWin, "@wxTopLevelWindowMSW@SetLastFocus$qp8wxWindow" ),

-- wxTopLevelWindowMSW::SetShape(const wxRegion&)
wxTopLevelWindowMSW_SetShape = define_c_var( wxWin, "@wxTopLevelWindowMSW@SetShape$qrx8wxRegion" ),

-- wxTopLevelWindowMSW::Show(bool)
wxTopLevelWindowMSW_Show = define_c_var( wxWin, "@wxTopLevelWindowMSW@Show$qo" ),

-- wxTopLevelWindowMSW::ShowFullScreen(bool, long)
wxTopLevelWindowMSW_ShowFullScreen = define_c_var( wxWin, "@wxTopLevelWindowMSW@ShowFullScreen$qol" ),

-- wxTopLevelWindowMSW::wxTopLevelWindowMSW()
wxTopLevelWindowMSW_op_ctr = define_c_var( wxWin, "@wxTopLevelWindowMSW@$bctr$qv" ),

-- wxTopLevelWindowMSW::~wxTopLevelWindowMSW()
wxTopLevelWindowMSW_op_dtr = define_c_var( wxWin, "@wxTopLevelWindowMSW@$bdtr$qv" ),

-- wxTopLevelWindowMSW::sm_eventTable
wxTopLevelWindowMSW_sm_eventTable = define_c_var( wxWin, "@wxTopLevelWindowMSW@sm_eventTable" ),

-- wxTopLevelWindowMSW::sm_eventTableEntries
wxTopLevelWindowMSW_sm_eventTableEntries = define_c_var( wxWin, "@wxTopLevelWindowMSW@sm_eventTableEntries" ),

sizeof_wxTopLevelWindowMSW = 1,
wxTopLevelWindowMSW = define_class( "wxTopLevelWindowMSW", wxWin, wxTopLevelWindowMSW_op_ctr, sizeof_wxTopLevelWindowMSW, wxTopLevelWindowMSW_op_dtr )

-- end class wxTopLevelWindowMSW
------------------------------


-- begin class wxValidator (12 members)
------------------------------

global constant 

-- wxValidator::Clone() const
wxValidator_Clone = define_c_var( wxWin, "@wxValidator@Clone$xqv" ),

-- wxValidator::Copy(const wxValidator&)
wxValidator_Copy = define_c_var( wxWin, "@wxValidator@Copy$qrx11wxValidator" ),

-- wxValidator::GetClassInfo() const
wxValidator_GetClassInfo = define_c_var( wxWin, "@wxValidator@GetClassInfo$xqv" ),

-- wxValidator::IsSilent()
wxValidator_IsSilent = define_c_var( wxWin, "@wxValidator@IsSilent$qv" ),

-- wxValidator::SetWindow(wxWindowBase *)
wxValidator_SetWindow = define_c_var( wxWin, "@wxValidator@SetWindow$qp12wxWindowBase" ),

-- wxValidator::TransferFromWindow()
wxValidator_TransferFromWindow = define_c_var( wxWin, "@wxValidator@TransferFromWindow$qv" ),

-- wxValidator::TransferToWindow()
wxValidator_TransferToWindow = define_c_var( wxWin, "@wxValidator@TransferToWindow$qv" ),

-- wxValidator::Validate(wxWindow *)
wxValidator_Validate = define_c_var( wxWin, "@wxValidator@Validate$qp8wxWindow" ),

-- wxValidator::ms_isSilent
wxValidator_ms_isSilent = define_c_var( wxWin, "@wxValidator@ms_isSilent" ),

-- wxValidator::wxValidator()
wxValidator_op_ctr = define_c_var( wxWin, "@wxValidator@$bctr$qv" ),

-- wxValidator::~wxValidator()
wxValidator_op_dtr = define_c_var( wxWin, "@wxValidator@$bdtr$qv" ),

-- wxValidator::sm_classwxValidator
wxValidator_sm_classwxValidator = define_c_var( wxWin, "@wxValidator@sm_classwxValidator" ),

sizeof_wxValidator = CI:sizeof_class( wxValidator_sm_classwxValidator ),
wxValidator = define_class( "wxValidator", wxWin, wxValidator_op_ctr, sizeof_wxValidator, 0 )

-- end class wxValidator
------------------------------


-- begin class wxWindow (139 members)
------------------------------

global constant 

-- wxWindow::AdoptAttributesFromHWND()
wxWindow_AdoptAttributesFromHWND = define_c_var( wxWin, "@wxWindow@AdoptAttributesFromHWND$qv" ),

-- wxWindow::Clear()
wxWindow_Clear = define_c_var( wxWin, "@wxWindow@Clear$qv" ),

-- wxWindow::ContainsHWND(unsigned long) const
wxWindow_ContainsHWND = define_c_var( wxWin, "@wxWindow@ContainsHWND$xqul" ),

-- wxWindow::Create(wxWindow *, int, const wxPoint&, const wxSize&, long, const wxString&)
wxWindow_Create = define_c_var( wxWin, "@wxWindow@Create$qp8wxWindowirx7wxPointrx6wxSizelrx8wxString" ),

-- wxWindow::CreateKeyEvent(int, int, long, unsigned int) const
wxWindow_CreateKeyEvent = define_c_var( wxWin, "@wxWindow@CreateKeyEvent$xqiilui" ),

-- wxWindow::CreateWindowFromHWND(wxWindow *, unsigned long)
wxWindow_CreateWindowFromHWND = define_c_var( wxWin, "@wxWindow@CreateWindowFromHWND$qp8wxWindowul" ),

-- wxWindow::Determine3DEffects(unsigned long, bool *) const
wxWindow_Determine3DEffects = define_c_var( wxWin, "@wxWindow@Determine3DEffects$xqulpo" ),

-- wxWindow::DoCaptureMouse()
wxWindow_DoCaptureMouse = define_c_var( wxWin, "@wxWindow@DoCaptureMouse$qv" ),

-- wxWindow::DoClientToScreen(int *, int *) const
wxWindow_DoClientToScreen = define_c_var( wxWin, "@wxWindow@DoClientToScreen$xqpit1" ),

-- wxWindow::DoGetClientSize(int *, int *) const
wxWindow_DoGetClientSize = define_c_var( wxWin, "@wxWindow@DoGetClientSize$xqpit1" ),

-- wxWindow::DoGetPosition(int *, int *) const
wxWindow_DoGetPosition = define_c_var( wxWin, "@wxWindow@DoGetPosition$xqpit1" ),

-- wxWindow::DoGetSize(int *, int *) const
wxWindow_DoGetSize = define_c_var( wxWin, "@wxWindow@DoGetSize$xqpit1" ),

-- wxWindow::DoMoveWindow(int, int, int, int)
wxWindow_DoMoveWindow = define_c_var( wxWin, "@wxWindow@DoMoveWindow$qiiii" ),

-- wxWindow::DoPopupMenu(wxMenu *, int, int)
wxWindow_DoPopupMenu = define_c_var( wxWin, "@wxWindow@DoPopupMenu$qp6wxMenuii" ),

-- wxWindow::DoReleaseMouse()
wxWindow_DoReleaseMouse = define_c_var( wxWin, "@wxWindow@DoReleaseMouse$qv" ),

-- wxWindow::DoScreenToClient(int *, int *) const
wxWindow_DoScreenToClient = define_c_var( wxWin, "@wxWindow@DoScreenToClient$xqpit1" ),

-- wxWindow::DoSetClientSize(int, int)
wxWindow_DoSetClientSize = define_c_var( wxWin, "@wxWindow@DoSetClientSize$qii" ),

-- wxWindow::DoSetSize(int, int, int, int, int)
wxWindow_DoSetSize = define_c_var( wxWin, "@wxWindow@DoSetSize$qiiiii" ),

-- wxWindow::DoSetToolTip(wxToolTip *)
wxWindow_DoSetToolTip = define_c_var( wxWin, "@wxWindow@DoSetToolTip$qp9wxToolTip" ),

-- wxWindow::DragAcceptFiles(bool)
wxWindow_DragAcceptFiles = define_c_var( wxWin, "@wxWindow@DragAcceptFiles$qo" ),

-- wxWindow::Enable(bool)
wxWindow_Enable = define_c_var( wxWin, "@wxWindow@Enable$qo" ),

-- wxWindow::FindItem(long) const
wxWindow_FindItem = define_c_var( wxWin, "@wxWindow@FindItem$xql" ),

-- wxWindow::FindItemByHWND(unsigned long, bool) const
wxWindow_FindItemByHWND = define_c_var( wxWin, "@wxWindow@FindItemByHWND$xqulo" ),

-- wxWindow::Freeze()
wxWindow_Freeze = define_c_var( wxWin, "@wxWindow@Freeze$qv" ),

-- wxWindow::GetCharHeight() const
wxWindow_GetCharHeight = define_c_var( wxWin, "@wxWindow@GetCharHeight$xqv" ),

-- wxWindow::GetCharWidth() const
wxWindow_GetCharWidth = define_c_var( wxWin, "@wxWindow@GetCharWidth$xqv" ),

-- wxWindow::GetClassInfo() const
wxWindow_GetClassInfo = define_c_var( wxWin, "@wxWindow@GetClassInfo$xqv" ),

-- wxWindow::GetClientAreaOrigin() const
wxWindow_GetClientAreaOrigin = define_c_var( wxWin, "@wxWindow@GetClientAreaOrigin$xqv" ),

-- wxWindow::GetEventTable() const
wxWindow_GetEventTable = define_c_var( wxWin, "@wxWindow@GetEventTable$xqv" ),

-- wxWindow::GetHWND() const
wxWindow_GetHWND = define_c_var( wxWin, "@wxWindow@GetHWND$xqv" ),

-- wxWindow::GetHandle() const
wxWindow_GetHandle = define_c_var( wxWin, "@wxWindow@GetHandle$xqv" ),

-- wxWindow::GetScrollPos(int) const
wxWindow_GetScrollPos = define_c_var( wxWin, "@wxWindow@GetScrollPos$xqi" ),

-- wxWindow::GetScrollRange(int) const
wxWindow_GetScrollRange = define_c_var( wxWin, "@wxWindow@GetScrollRange$xqi" ),

-- wxWindow::GetScrollThumb(int) const
wxWindow_GetScrollThumb = define_c_var( wxWin, "@wxWindow@GetScrollThumb$xqi" ),

-- wxWindow::GetTextExtent(const wxString&, int *, int *, int *, int *, const wxFont *) const
wxWindow_GetTextExtent = define_c_var( wxWin, "@wxWindow@GetTextExtent$xqrx8wxStringpit2t2t2px6wxFont" ),

-- wxWindow::GetTitle() const
wxWindow_GetTitle = define_c_var( wxWin, "@wxWindow@GetTitle$xqv" ),

-- wxWindow::GetTransparentBackground() const
wxWindow_GetTransparentBackground = define_c_var( wxWin, "@wxWindow@GetTransparentBackground$xqv" ),

-- wxWindow::GetWindowChild(int)
wxWindow_GetWindowChild = define_c_var( wxWin, "@wxWindow@GetWindowChild$qi" ),

-- wxWindow::GetWindowChild1(int)
wxWindow_GetWindowChild1 = define_c_var( wxWin, "@wxWindow@GetWindowChild1$qi" ),

-- wxWindow::HandleActivate(int, bool, unsigned long)
wxWindow_HandleActivate = define_c_var( wxWin, "@wxWindow@HandleActivate$qioul" ),

-- wxWindow::HandleCaptureChanged(unsigned long)
wxWindow_HandleCaptureChanged = define_c_var( wxWin, "@wxWindow@HandleCaptureChanged$qul" ),

-- wxWindow::HandleChar(unsigned int, long, bool)
wxWindow_HandleChar = define_c_var( wxWin, "@wxWindow@HandleChar$quilo" ),

-- wxWindow::HandleCommand(unsigned short, unsigned short, unsigned long)
wxWindow_HandleCommand = define_c_var( wxWin, "@wxWindow@HandleCommand$qususul" ),

-- wxWindow::HandleCreate(void *, bool *)
wxWindow_HandleCreate = define_c_var( wxWin, "@wxWindow@HandleCreate$qpvpo" ),

-- wxWindow::HandleCtlColor(unsigned long *, unsigned long, unsigned long, unsigned int, unsigned int, unsigned int, long)
wxWindow_HandleCtlColor = define_c_var( wxWin, "@wxWindow@HandleCtlColor$qpulululuiuiuil" ),

-- wxWindow::HandleDestroy()
wxWindow_HandleDestroy = define_c_var( wxWin, "@wxWindow@HandleDestroy$qv" ),

-- wxWindow::HandleDisplayChange()
wxWindow_HandleDisplayChange = define_c_var( wxWin, "@wxWindow@HandleDisplayChange$qv" ),

-- wxWindow::HandleDropFiles(unsigned int)
wxWindow_HandleDropFiles = define_c_var( wxWin, "@wxWindow@HandleDropFiles$qui" ),

-- wxWindow::HandleEndSession(bool, long)
wxWindow_HandleEndSession = define_c_var( wxWin, "@wxWindow@HandleEndSession$qol" ),

-- wxWindow::HandleEraseBkgnd(unsigned long)
wxWindow_HandleEraseBkgnd = define_c_var( wxWin, "@wxWindow@HandleEraseBkgnd$qul" ),

-- wxWindow::HandleGetMinMaxInfo(void *)
wxWindow_HandleGetMinMaxInfo = define_c_var( wxWin, "@wxWindow@HandleGetMinMaxInfo$qpv" ),

-- wxWindow::HandleInitDialog(unsigned long)
wxWindow_HandleInitDialog = define_c_var( wxWin, "@wxWindow@HandleInitDialog$qul" ),

-- wxWindow::HandleJoystickEvent(unsigned int, int, int, unsigned int)
wxWindow_HandleJoystickEvent = define_c_var( wxWin, "@wxWindow@HandleJoystickEvent$quiiiui" ),

-- wxWindow::HandleKeyDown(unsigned int, long)
wxWindow_HandleKeyDown = define_c_var( wxWin, "@wxWindow@HandleKeyDown$quil" ),

-- wxWindow::HandleKeyUp(unsigned int, long)
wxWindow_HandleKeyUp = define_c_var( wxWin, "@wxWindow@HandleKeyUp$quil" ),

-- wxWindow::HandleKillFocus(unsigned long)
wxWindow_HandleKillFocus = define_c_var( wxWin, "@wxWindow@HandleKillFocus$qul" ),

-- wxWindow::HandleMaximize()
wxWindow_HandleMaximize = define_c_var( wxWin, "@wxWindow@HandleMaximize$qv" ),

-- wxWindow::HandleMinimize()
wxWindow_HandleMinimize = define_c_var( wxWin, "@wxWindow@HandleMinimize$qv" ),

-- wxWindow::HandleMouseEvent(unsigned int, int, int, unsigned int)
wxWindow_HandleMouseEvent = define_c_var( wxWin, "@wxWindow@HandleMouseEvent$quiiiui" ),

-- wxWindow::HandleMouseMove(int, int, unsigned int)
wxWindow_HandleMouseMove = define_c_var( wxWin, "@wxWindow@HandleMouseMove$qiiui" ),

-- wxWindow::HandleMouseWheel(unsigned int, long)
wxWindow_HandleMouseWheel = define_c_var( wxWin, "@wxWindow@HandleMouseWheel$quil" ),

-- wxWindow::HandleMove(int, int)
wxWindow_HandleMove = define_c_var( wxWin, "@wxWindow@HandleMove$qii" ),

-- wxWindow::HandleNotify(int, long, long *)
wxWindow_HandleNotify = define_c_var( wxWin, "@wxWindow@HandleNotify$qilpl" ),

-- wxWindow::HandlePaint()
wxWindow_HandlePaint = define_c_var( wxWin, "@wxWindow@HandlePaint$qv" ),

-- wxWindow::HandlePaletteChanged(unsigned long)
wxWindow_HandlePaletteChanged = define_c_var( wxWin, "@wxWindow@HandlePaletteChanged$qul" ),

-- wxWindow::HandleQueryEndSession(long, bool *)
wxWindow_HandleQueryEndSession = define_c_var( wxWin, "@wxWindow@HandleQueryEndSession$qlpo" ),

-- wxWindow::HandleQueryNewPalette()
wxWindow_HandleQueryNewPalette = define_c_var( wxWin, "@wxWindow@HandleQueryNewPalette$qv" ),

-- wxWindow::HandleSetCursor(unsigned long, short, int)
wxWindow_HandleSetCursor = define_c_var( wxWin, "@wxWindow@HandleSetCursor$qulsi" ),

-- wxWindow::HandleSetFocus(unsigned long)
wxWindow_HandleSetFocus = define_c_var( wxWin, "@wxWindow@HandleSetFocus$qul" ),

-- wxWindow::HandleShow(bool, int)
wxWindow_HandleShow = define_c_var( wxWin, "@wxWindow@HandleShow$qoi" ),

-- wxWindow::HandleSize(int, int, unsigned int)
wxWindow_HandleSize = define_c_var( wxWin, "@wxWindow@HandleSize$qiiui" ),

-- wxWindow::HandleSysColorChange()
wxWindow_HandleSysColorChange = define_c_var( wxWin, "@wxWindow@HandleSysColorChange$qv" ),

-- wxWindow::HandleSysCommand(unsigned int, long)
wxWindow_HandleSysCommand = define_c_var( wxWin, "@wxWindow@HandleSysCommand$quil" ),

-- wxWindow::HandleTooltipNotify(unsigned int, long, const wxString&)
wxWindow_HandleTooltipNotify = define_c_var( wxWin, "@wxWindow@HandleTooltipNotify$quilrx8wxString" ),

-- wxWindow::Init()
wxWindow_Init = define_c_var( wxWin, "@wxWindow@Init$qv" ),

-- wxWindow::InitMouseEvent(wxMouseEvent&, int, int, unsigned int)
wxWindow_InitMouseEvent = define_c_var( wxWin, "@wxWindow@InitMouseEvent$qr12wxMouseEventiiui" ),

-- wxWindow::IsMouseInWindow() const
wxWindow_IsMouseInWindow = define_c_var( wxWin, "@wxWindow@IsMouseInWindow$xqv" ),

-- wxWindow::IsOfStandardClass() const
wxWindow_IsOfStandardClass = define_c_var( wxWin, "@wxWindow@IsOfStandardClass$xqv" ),

-- wxWindow::LoadNativeDialog(wxWindow *, int&)
wxWindow_LoadNativeDialog = define_c_var( wxWin, "@wxWindow@LoadNativeDialog$qp8wxWindowri" ),

-- wxWindow::LoadNativeDialog(wxWindow *, const wxString&)
wxWindow_LoadNativeDialog_1 = define_c_var( wxWin, "@wxWindow@LoadNativeDialog$qp8wxWindowrx8wxString" ),

-- wxWindow::Lower()
wxWindow_Lower = define_c_var( wxWin, "@wxWindow@Lower$qv" ),

-- wxWindow::MSWCommand(unsigned int, unsigned short)
wxWindow_MSWCommand = define_c_var( wxWin, "@wxWindow@MSWCommand$quius" ),

-- wxWindow::MSWCreate(const char *, const char *, const wxPoint&, const wxSize&, unsigned long, unsigned long)
wxWindow_MSWCreate = define_c_var( wxWin, "@wxWindow@MSWCreate$qpxct1rx7wxPointrx6wxSizeulul" ),

-- wxWindow::MSWDefWindowProc(unsigned int, unsigned int, long)
wxWindow_MSWDefWindowProc = define_c_var( wxWin, "@wxWindow@MSWDefWindowProc$quiuil" ),

-- wxWindow::MSWDestroyWindow()
wxWindow_MSWDestroyWindow = define_c_var( wxWin, "@wxWindow@MSWDestroyWindow$qv" ),

-- wxWindow::MSWGetCreateWindowCoords(const wxPoint&, const wxSize&, int&, int&, int&, int&) const
wxWindow_MSWGetCreateWindowCoords = define_c_var( wxWin, "@wxWindow@MSWGetCreateWindowCoords$xqrx7wxPointrx6wxSizerit3t3t3" ),

-- wxWindow::MSWGetCreateWindowFlags(unsigned long *) const
wxWindow_MSWGetCreateWindowFlags = define_c_var( wxWin, "@wxWindow@MSWGetCreateWindowFlags$xqpul" ),

-- wxWindow::MSWGetOldWndProc() const
wxWindow_MSWGetOldWndProc = define_c_var( wxWin, "@wxWindow@MSWGetOldWndProc$xqv" ),

-- wxWindow::MSWGetParent() const
wxWindow_MSWGetParent = define_c_var( wxWin, "@wxWindow@MSWGetParent$xqv" ),

-- wxWindow::MSWGetStyle(long, unsigned long *) const
wxWindow_MSWGetStyle = define_c_var( wxWin, "@wxWindow@MSWGetStyle$xqlpul" ),

-- wxWindow::MSWOnDrawItem(int, void * *)
wxWindow_MSWOnDrawItem = define_c_var( wxWin, "@wxWindow@MSWOnDrawItem$qippv" ),

-- wxWindow::MSWOnMeasureItem(int, void * *)
wxWindow_MSWOnMeasureItem = define_c_var( wxWin, "@wxWindow@MSWOnMeasureItem$qippv" ),

-- wxWindow::MSWOnNotify(int, long, long *)
wxWindow_MSWOnNotify = define_c_var( wxWin, "@wxWindow@MSWOnNotify$qilpl" ),

-- wxWindow::MSWOnScroll(int, unsigned short, unsigned short, unsigned long)
wxWindow_MSWOnScroll = define_c_var( wxWin, "@wxWindow@MSWOnScroll$qiususul" ),

-- wxWindow::MSWProcessMessage(void * *)
wxWindow_MSWProcessMessage = define_c_var( wxWin, "@wxWindow@MSWProcessMessage$qppv" ),

-- wxWindow::MSWShouldPreProcessMessage(void * *)
wxWindow_MSWShouldPreProcessMessage = define_c_var( wxWin, "@wxWindow@MSWShouldPreProcessMessage$qppv" ),

-- wxWindow::MSWTranslateMessage(void * *)
wxWindow_MSWTranslateMessage = define_c_var( wxWin, "@wxWindow@MSWTranslateMessage$qppv" ),

-- wxWindow::MSWWindowProc(unsigned int, unsigned int, long)
wxWindow_MSWWindowProc = define_c_var( wxWin, "@wxWindow@MSWWindowProc$quiuil" ),

-- wxWindow::MakeExtendedStyle(long, bool)
wxWindow_MakeExtendedStyle = define_c_var( wxWin, "@wxWindow@MakeExtendedStyle$qlo" ),

-- wxWindow::OnCtlColor(unsigned long, unsigned long, unsigned int, unsigned int, unsigned int, long)
wxWindow_OnCtlColor = define_c_var( wxWin, "@wxWindow@OnCtlColor$qululuiuiuil" ),

-- wxWindow::OnEraseBackground(wxEraseEvent&)
wxWindow_OnEraseBackground = define_c_var( wxWin, "@wxWindow@OnEraseBackground$qr12wxEraseEvent" ),

-- wxWindow::OnIdle(wxIdleEvent&)
wxWindow_OnIdle = define_c_var( wxWin, "@wxWindow@OnIdle$qr11wxIdleEvent" ),

-- wxWindow::OnPaint(wxPaintEvent&)
wxWindow_OnPaint = define_c_var( wxWin, "@wxWindow@OnPaint$qr12wxPaintEvent" ),

-- wxWindow::OnSysColourChanged(wxSysColourChangedEvent&)
wxWindow_OnSysColourChanged = define_c_var( wxWin, "@wxWindow@OnSysColourChanged$qr23wxSysColourChangedEvent" ),

-- wxWindow::Raise()
wxWindow_Raise = define_c_var( wxWin, "@wxWindow@Raise$qv" ),

-- wxWindow::Refresh(bool, const wxRect *)
wxWindow_Refresh = define_c_var( wxWin, "@wxWindow@Refresh$qopx6wxRect" ),

-- wxWindow::Reparent(wxWindowBase *)
wxWindow_Reparent = define_c_var( wxWin, "@wxWindow@Reparent$qp12wxWindowBase" ),

-- wxWindow::ScrollLines(int)
wxWindow_ScrollLines = define_c_var( wxWin, "@wxWindow@ScrollLines$qi" ),

-- wxWindow::ScrollPages(int)
wxWindow_ScrollPages = define_c_var( wxWin, "@wxWindow@ScrollPages$qi" ),

-- wxWindow::ScrollWindow(int, int, const wxRect *)
wxWindow_ScrollWindow = define_c_var( wxWin, "@wxWindow@ScrollWindow$qiipx6wxRect" ),

-- wxWindow::SetCursor(const wxCursor&)
wxWindow_SetCursor = define_c_var( wxWin, "@wxWindow@SetCursor$qrx8wxCursor" ),

-- wxWindow::SetDropTarget(wxDropTarget *)
wxWindow_SetDropTarget = define_c_var( wxWin, "@wxWindow@SetDropTarget$qp12wxDropTarget" ),

-- wxWindow::SetFocus()
wxWindow_SetFocus = define_c_var( wxWin, "@wxWindow@SetFocus$qv" ),

-- wxWindow::SetFocusFromKbd()
wxWindow_SetFocusFromKbd = define_c_var( wxWin, "@wxWindow@SetFocusFromKbd$qv" ),

-- wxWindow::SetFont(const wxFont&)
wxWindow_SetFont = define_c_var( wxWin, "@wxWindow@SetFont$qrx6wxFont" ),

-- wxWindow::SetHWND(unsigned long)
wxWindow_SetHWND = define_c_var( wxWin, "@wxWindow@SetHWND$qul" ),

-- wxWindow::SetScrollPos(int, int, bool)
wxWindow_SetScrollPos = define_c_var( wxWin, "@wxWindow@SetScrollPos$qiio" ),

-- wxWindow::SetScrollbar(int, int, int, int, bool)
wxWindow_SetScrollbar = define_c_var( wxWin, "@wxWindow@SetScrollbar$qiiiio" ),

-- wxWindow::SetTitle(const wxString&)
wxWindow_SetTitle = define_c_var( wxWin, "@wxWindow@SetTitle$qrx8wxString" ),

-- wxWindow::SetTransparent(bool)
wxWindow_SetTransparent = define_c_var( wxWin, "@wxWindow@SetTransparent$qo" ),

-- wxWindow::SetWindowStyleFlag(long)
wxWindow_SetWindowStyleFlag = define_c_var( wxWin, "@wxWindow@SetWindowStyleFlag$ql" ),

-- wxWindow::SetupColours()
wxWindow_SetupColours = define_c_var( wxWin, "@wxWindow@SetupColours$qv" ),

-- wxWindow::Show(bool)
wxWindow_Show = define_c_var( wxWin, "@wxWindow@Show$qo" ),

-- wxWindow::SubclassWin(unsigned long)
wxWindow_SubclassWin = define_c_var( wxWin, "@wxWindow@SubclassWin$qul" ),

-- wxWindow::Thaw()
wxWindow_Thaw = define_c_var( wxWin, "@wxWindow@Thaw$qv" ),

-- wxWindow::UnpackActivate(unsigned int, long, unsigned short *, unsigned short *, unsigned long *)
wxWindow_UnpackActivate = define_c_var( wxWin, "@wxWindow@UnpackActivate$quilpust3pul" ),

-- wxWindow::UnpackCommand(unsigned int, long, unsigned short *, unsigned long *, unsigned short *)
wxWindow_UnpackCommand = define_c_var( wxWin, "@wxWindow@UnpackCommand$quilpuspult3" ),

-- wxWindow::UnpackCtlColor(unsigned int, long, unsigned short *, unsigned long *, unsigned long *)
wxWindow_UnpackCtlColor = define_c_var( wxWin, "@wxWindow@UnpackCtlColor$quilpuspult4" ),

-- wxWindow::UnpackMenuSelect(unsigned int, long, unsigned short *, unsigned short *, unsigned long *)
wxWindow_UnpackMenuSelect = define_c_var( wxWin, "@wxWindow@UnpackMenuSelect$quilpust3pul" ),

-- wxWindow::UnpackScroll(unsigned int, long, unsigned short *, unsigned short *, unsigned long *)
wxWindow_UnpackScroll = define_c_var( wxWin, "@wxWindow@UnpackScroll$quilpust3pul" ),

-- wxWindow::UnsubclassWin()
wxWindow_UnsubclassWin = define_c_var( wxWin, "@wxWindow@UnsubclassWin$qv" ),

-- wxWindow::Update()
wxWindow_Update = define_c_var( wxWin, "@wxWindow@Update$qv" ),

-- wxWindow::WarpPointer(int, int)
wxWindow_WarpPointer = define_c_var( wxWin, "@wxWindow@WarpPointer$qii" ),

-- wxWindow::wxWindow(wxWindow *, int, const wxPoint&, const wxSize&, long, const wxString&)
wxWindow_op_ctr = define_c_var( wxWin, "@wxWindow@$bctr$qp8wxWindowirx7wxPointrx6wxSizelrx8wxString" ),

-- wxWindow::wxWindow()
wxWindow_op_ctr_1 = define_c_var( wxWin, "@wxWindow@$bctr$qv" ),

-- wxWindow::~wxWindow()
wxWindow_op_dtr = define_c_var( wxWin, "@wxWindow@$bdtr$qv" ),

-- wxWindow::sm_classwxWindow
wxWindow_sm_classwxWindow = define_c_var( wxWin, "@wxWindow@sm_classwxWindow" ),

-- wxWindow::sm_eventTable
wxWindow_sm_eventTable = define_c_var( wxWin, "@wxWindow@sm_eventTable" ),

-- wxWindow::sm_eventTableEntries
wxWindow_sm_eventTableEntries = define_c_var( wxWin, "@wxWindow@sm_eventTableEntries" ),

sizeof_wxWindow = CI:sizeof_class( wxWindow_sm_classwxWindow ),
wxWindow = define_class( "wxWindow", wxWin, wxWindow_op_ctr, sizeof_wxWindow, wxWindow_op_dtr )

-- end class wxWindow
------------------------------


-- begin class wxWindowBase (194 members)
------------------------------

global constant 

-- wxWindowBase::AcceptsFocus() const
wxWindowBase_AcceptsFocus = define_c_var( wxWin, "@wxWindowBase@AcceptsFocus$xqv" ),

-- wxWindowBase::AcceptsFocusFromKeyboard() const
wxWindowBase_AcceptsFocusFromKeyboard = define_c_var( wxWin, "@wxWindowBase@AcceptsFocusFromKeyboard$xqv" ),

-- wxWindowBase::AddChild(wxWindowBase *)
wxWindowBase_AddChild = define_c_var( wxWin, "@wxWindowBase@AddChild$qp12wxWindowBase" ),

-- wxWindowBase::AddConstraintReference(wxWindowBase *)
wxWindowBase_AddConstraintReference = define_c_var( wxWin, "@wxWindowBase@AddConstraintReference$qp12wxWindowBase" ),

-- wxWindowBase::AdjustForParentClientOrigin(int&, int&, int) const
wxWindowBase_AdjustForParentClientOrigin = define_c_var( wxWin, "@wxWindowBase@AdjustForParentClientOrigin$xqrit1i" ),

-- wxWindowBase::CaptureMouse()
wxWindowBase_CaptureMouse = define_c_var( wxWin, "@wxWindowBase@CaptureMouse$qv" ),

-- wxWindowBase::Centre(int)
wxWindowBase_Centre = define_c_var( wxWin, "@wxWindowBase@Centre$qi" ),

-- wxWindowBase::CentreOnParent(int)
wxWindowBase_CentreOnParent = define_c_var( wxWin, "@wxWindowBase@CentreOnParent$qi" ),

-- wxWindowBase::CentreOnScreen(int)
wxWindowBase_CentreOnScreen = define_c_var( wxWin, "@wxWindowBase@CentreOnScreen$qi" ),

-- wxWindowBase::ClientToScreen(int *, int *) const
wxWindowBase_ClientToScreen = define_c_var( wxWin, "@wxWindowBase@ClientToScreen$xqpit1" ),

-- wxWindowBase::ClientToScreen(const wxPoint&) const
wxWindowBase_ClientToScreen_1 = define_c_var( wxWin, "@wxWindowBase@ClientToScreen$xqrx7wxPoint" ),

-- wxWindowBase::Close(bool)
wxWindowBase_Close = define_c_var( wxWin, "@wxWindowBase@Close$qo" ),

-- wxWindowBase::ConvertDialogToPixels(const wxPoint&)
wxWindowBase_ConvertDialogToPixels = define_c_var( wxWin, "@wxWindowBase@ConvertDialogToPixels$qrx7wxPoint" ),

-- wxWindowBase::ConvertPixelsToDialog(const wxPoint&)
wxWindowBase_ConvertPixelsToDialog = define_c_var( wxWin, "@wxWindowBase@ConvertPixelsToDialog$qrx7wxPoint" ),

-- wxWindowBase::CreateBase(wxWindowBase *, int, const wxPoint&, const wxSize&, long, const wxValidator&, const wxString&)
wxWindowBase_CreateBase = define_c_var( wxWin, "@wxWindowBase@CreateBase$qp12wxWindowBaseirx7wxPointrx6wxSizelrx11wxValidatorrx8wxString" ),

-- wxWindowBase::DeleteRelatedConstraints()
wxWindowBase_DeleteRelatedConstraints = define_c_var( wxWin, "@wxWindowBase@DeleteRelatedConstraints$qv" ),

-- wxWindowBase::Destroy()
wxWindowBase_Destroy = define_c_var( wxWin, "@wxWindowBase@Destroy$qv" ),

-- wxWindowBase::DestroyChildren()
wxWindowBase_DestroyChildren = define_c_var( wxWin, "@wxWindowBase@DestroyChildren$qv" ),

-- wxWindowBase::Disable()
wxWindowBase_Disable = define_c_var( wxWin, "@wxWindowBase@Disable$qv" ),

-- wxWindowBase::DoGetBestSize() const
wxWindowBase_DoGetBestSize = define_c_var( wxWin, "@wxWindowBase@DoGetBestSize$xqv" ),

-- wxWindowBase::DoGetVirtualSize() const
wxWindowBase_DoGetVirtualSize = define_c_var( wxWin, "@wxWindowBase@DoGetVirtualSize$xqv" ),

-- wxWindowBase::DoHitTest(int, int) const
wxWindowBase_DoHitTest = define_c_var( wxWin, "@wxWindowBase@DoHitTest$xqii" ),

-- wxWindowBase::DoPhase(int)
wxWindowBase_DoPhase = define_c_var( wxWin, "@wxWindowBase@DoPhase$qi" ),

-- wxWindowBase::DoSetToolTip(wxToolTip *)
wxWindowBase_DoSetToolTip = define_c_var( wxWin, "@wxWindowBase@DoSetToolTip$qp9wxToolTip" ),

-- wxWindowBase::DoSetVirtualSize(int, int)
wxWindowBase_DoSetVirtualSize = define_c_var( wxWin, "@wxWindowBase@DoSetVirtualSize$qii" ),

-- wxWindowBase::Enable(bool)
wxWindowBase_Enable = define_c_var( wxWin, "@wxWindowBase@Enable$qo" ),

-- wxWindowBase::FindFocus()
wxWindowBase_FindFocus = define_c_var( wxWin, "@wxWindowBase@FindFocus$qv" ),

-- wxWindowBase::FindWindow(long)
wxWindowBase_FindWindow = define_c_var( wxWin, "@wxWindowBase@FindWindow$ql" ),

-- wxWindowBase::FindWindowById(long, const wxWindow *)
wxWindowBase_FindWindowById = define_c_var( wxWin, "@wxWindowBase@FindWindowById$qlpx8wxWindow" ),

-- wxWindowBase::FindWindowByLabel(const wxString&, const wxWindow *)
wxWindowBase_FindWindowByLabel = define_c_var( wxWin, "@wxWindowBase@FindWindowByLabel$qrx8wxStringpx8wxWindow" ),

-- wxWindowBase::FindWindowByName(const wxString&, const wxWindow *)
wxWindowBase_FindWindowByName = define_c_var( wxWin, "@wxWindowBase@FindWindowByName$qrx8wxStringpx8wxWindow" ),

-- wxWindowBase::FindWindow(const wxString&)
wxWindowBase_FindWindow_1 = define_c_var( wxWin, "@wxWindowBase@FindWindow$qrx8wxString" ),

-- wxWindowBase::Fit()
wxWindowBase_Fit = define_c_var( wxWin, "@wxWindowBase@Fit$qv" ),

-- wxWindowBase::FitInside()
wxWindowBase_FitInside = define_c_var( wxWin, "@wxWindowBase@FitInside$qv" ),

-- wxWindowBase::Freeze()
wxWindowBase_Freeze = define_c_var( wxWin, "@wxWindowBase@Freeze$qv" ),

-- wxWindowBase::GetAdjustedBestSize() const
wxWindowBase_GetAdjustedBestSize = define_c_var( wxWin, "@wxWindowBase@GetAdjustedBestSize$xqv" ),

-- wxWindowBase::GetAncestorWithCustomPalette() const
wxWindowBase_GetAncestorWithCustomPalette = define_c_var( wxWin, "@wxWindowBase@GetAncestorWithCustomPalette$xqv" ),

-- wxWindowBase::GetAutoLayout() const
wxWindowBase_GetAutoLayout = define_c_var( wxWin, "@wxWindowBase@GetAutoLayout$xqv" ),

-- wxWindowBase::GetBackgroundColour() const
wxWindowBase_GetBackgroundColour = define_c_var( wxWin, "@wxWindowBase@GetBackgroundColour$xqv" ),

-- wxWindowBase::GetBestSize() const
wxWindowBase_GetBestSize = define_c_var( wxWin, "@wxWindowBase@GetBestSize$xqv" ),

-- wxWindowBase::GetBestVirtualSize() const
wxWindowBase_GetBestVirtualSize = define_c_var( wxWin, "@wxWindowBase@GetBestVirtualSize$xqv" ),

-- wxWindowBase::GetBorder() const
wxWindowBase_GetBorder = define_c_var( wxWin, "@wxWindowBase@GetBorder$xqv" ),

-- wxWindowBase::GetCapture()
wxWindowBase_GetCapture = define_c_var( wxWin, "@wxWindowBase@GetCapture$qv" ),

-- wxWindowBase::GetChildren()
wxWindowBase_GetChildren = define_c_var( wxWin, "@wxWindowBase@GetChildren$qv" ),

-- wxWindowBase::GetChildren() const
wxWindowBase_GetChildren_1 = define_c_var( wxWin, "@wxWindowBase@GetChildren$xqv" ),

-- wxWindowBase::GetClassInfo() const
wxWindowBase_GetClassInfo = define_c_var( wxWin, "@wxWindowBase@GetClassInfo$xqv" ),

-- wxWindowBase::GetClientAreaOrigin() const
wxWindowBase_GetClientAreaOrigin = define_c_var( wxWin, "@wxWindowBase@GetClientAreaOrigin$xqv" ),

-- wxWindowBase::GetClientRect() const
wxWindowBase_GetClientRect = define_c_var( wxWin, "@wxWindowBase@GetClientRect$xqv" ),

-- wxWindowBase::GetClientSize(int *, int *) const
wxWindowBase_GetClientSize = define_c_var( wxWin, "@wxWindowBase@GetClientSize$xqpit1" ),

-- wxWindowBase::GetClientSizeConstraint(int *, int *) const
wxWindowBase_GetClientSizeConstraint = define_c_var( wxWin, "@wxWindowBase@GetClientSizeConstraint$xqpit1" ),

-- wxWindowBase::GetClientSize() const
wxWindowBase_GetClientSize_1 = define_c_var( wxWin, "@wxWindowBase@GetClientSize$xqv" ),

-- wxWindowBase::GetConstraints() const
wxWindowBase_GetConstraints = define_c_var( wxWin, "@wxWindowBase@GetConstraints$xqv" ),

-- wxWindowBase::GetCursor()
wxWindowBase_GetCursor = define_c_var( wxWin, "@wxWindowBase@GetCursor$qv" ),

-- wxWindowBase::GetDefaultBorder() const
wxWindowBase_GetDefaultBorder = define_c_var( wxWin, "@wxWindowBase@GetDefaultBorder$xqv" ),

-- wxWindowBase::GetDefaultItem() const
wxWindowBase_GetDefaultItem = define_c_var( wxWin, "@wxWindowBase@GetDefaultItem$xqv" ),

-- wxWindowBase::GetDefaultText(wxString&)
wxWindowBase_GetDefaultText = define_c_var( wxWin, "@wxWindowBase@GetDefaultText$qr8wxString" ),

-- wxWindowBase::GetDropTarget() const
wxWindowBase_GetDropTarget = define_c_var( wxWin, "@wxWindowBase@GetDropTarget$xqv" ),

-- wxWindowBase::GetEventHandler() const
wxWindowBase_GetEventHandler = define_c_var( wxWin, "@wxWindowBase@GetEventHandler$xqv" ),

-- wxWindowBase::GetEventTable() const
wxWindowBase_GetEventTable = define_c_var( wxWin, "@wxWindowBase@GetEventTable$xqv" ),

-- wxWindowBase::GetExtraStyle() const
wxWindowBase_GetExtraStyle = define_c_var( wxWin, "@wxWindowBase@GetExtraStyle$xqv" ),

-- wxWindowBase::GetFont()
wxWindowBase_GetFont = define_c_var( wxWin, "@wxWindowBase@GetFont$qv" ),

-- wxWindowBase::GetFont() const
wxWindowBase_GetFont_1 = define_c_var( wxWin, "@wxWindowBase@GetFont$xqv" ),

-- wxWindowBase::GetForegroundColour() const
wxWindowBase_GetForegroundColour = define_c_var( wxWin, "@wxWindowBase@GetForegroundColour$xqv" ),

-- wxWindowBase::GetHelpText() const
wxWindowBase_GetHelpText = define_c_var( wxWin, "@wxWindowBase@GetHelpText$xqv" ),

-- wxWindowBase::GetId() const
wxWindowBase_GetId = define_c_var( wxWin, "@wxWindowBase@GetId$xqv" ),

-- wxWindowBase::GetLabel() const
wxWindowBase_GetLabel = define_c_var( wxWin, "@wxWindowBase@GetLabel$xqv" ),

-- wxWindowBase::GetMaxHeight() const
wxWindowBase_GetMaxHeight = define_c_var( wxWin, "@wxWindowBase@GetMaxHeight$xqv" ),

-- wxWindowBase::GetMaxSize() const
wxWindowBase_GetMaxSize = define_c_var( wxWin, "@wxWindowBase@GetMaxSize$xqv" ),

-- wxWindowBase::GetMaxWidth() const
wxWindowBase_GetMaxWidth = define_c_var( wxWin, "@wxWindowBase@GetMaxWidth$xqv" ),

-- wxWindowBase::GetMinHeight() const
wxWindowBase_GetMinHeight = define_c_var( wxWin, "@wxWindowBase@GetMinHeight$xqv" ),

-- wxWindowBase::GetMinWidth() const
wxWindowBase_GetMinWidth = define_c_var( wxWin, "@wxWindowBase@GetMinWidth$xqv" ),

-- wxWindowBase::GetName() const
wxWindowBase_GetName = define_c_var( wxWin, "@wxWindowBase@GetName$xqv" ),

-- wxWindowBase::GetPalette() const
wxWindowBase_GetPalette = define_c_var( wxWin, "@wxWindowBase@GetPalette$xqv" ),

-- wxWindowBase::GetParent() const
wxWindowBase_GetParent = define_c_var( wxWin, "@wxWindowBase@GetParent$xqv" ),

-- wxWindowBase::GetPosition(int *, int *) const
wxWindowBase_GetPosition = define_c_var( wxWin, "@wxWindowBase@GetPosition$xqpit1" ),

-- wxWindowBase::GetPositionConstraint(int *, int *) const
wxWindowBase_GetPositionConstraint = define_c_var( wxWin, "@wxWindowBase@GetPositionConstraint$xqpit1" ),

-- wxWindowBase::GetPosition() const
wxWindowBase_GetPosition_1 = define_c_var( wxWin, "@wxWindowBase@GetPosition$xqv" ),

-- wxWindowBase::GetRect() const
wxWindowBase_GetRect = define_c_var( wxWin, "@wxWindowBase@GetRect$xqv" ),

-- wxWindowBase::GetSize(int *, int *) const
wxWindowBase_GetSize = define_c_var( wxWin, "@wxWindowBase@GetSize$xqpit1" ),

-- wxWindowBase::GetSizeConstraint(int *, int *) const
wxWindowBase_GetSizeConstraint = define_c_var( wxWin, "@wxWindowBase@GetSizeConstraint$xqpit1" ),

-- wxWindowBase::GetSize() const
wxWindowBase_GetSize_1 = define_c_var( wxWin, "@wxWindowBase@GetSize$xqv" ),

-- wxWindowBase::GetSizer() const
wxWindowBase_GetSizer = define_c_var( wxWin, "@wxWindowBase@GetSizer$xqv" ),

-- wxWindowBase::GetThemeEnabled() const
wxWindowBase_GetThemeEnabled = define_c_var( wxWin, "@wxWindowBase@GetThemeEnabled$xqv" ),

-- wxWindowBase::GetTitle() const
wxWindowBase_GetTitle = define_c_var( wxWin, "@wxWindowBase@GetTitle$xqv" ),

-- wxWindowBase::GetToolTip() const
wxWindowBase_GetToolTip = define_c_var( wxWin, "@wxWindowBase@GetToolTip$xqv" ),

-- wxWindowBase::GetUpdateClientRect() const
wxWindowBase_GetUpdateClientRect = define_c_var( wxWin, "@wxWindowBase@GetUpdateClientRect$xqv" ),

-- wxWindowBase::GetUpdateRegion()
wxWindowBase_GetUpdateRegion = define_c_var( wxWin, "@wxWindowBase@GetUpdateRegion$qv" ),

-- wxWindowBase::GetUpdateRegion() const
wxWindowBase_GetUpdateRegion_1 = define_c_var( wxWin, "@wxWindowBase@GetUpdateRegion$xqv" ),

-- wxWindowBase::GetValidator()
wxWindowBase_GetValidator = define_c_var( wxWin, "@wxWindowBase@GetValidator$qv" ),

-- wxWindowBase::GetVirtualSize(int *, int *) const
wxWindowBase_GetVirtualSize = define_c_var( wxWin, "@wxWindowBase@GetVirtualSize$xqpit1" ),

-- wxWindowBase::GetVirtualSize() const
wxWindowBase_GetVirtualSize_1 = define_c_var( wxWin, "@wxWindowBase@GetVirtualSize$xqv" ),

-- wxWindowBase::GetWindowStyle() const
wxWindowBase_GetWindowStyle = define_c_var( wxWin, "@wxWindowBase@GetWindowStyle$xqv" ),

-- wxWindowBase::GetWindowStyleFlag() const
wxWindowBase_GetWindowStyleFlag = define_c_var( wxWin, "@wxWindowBase@GetWindowStyleFlag$xqv" ),

-- wxWindowBase::HasCapture() const
wxWindowBase_HasCapture = define_c_var( wxWin, "@wxWindowBase@HasCapture$xqv" ),

-- wxWindowBase::HasCustomPalette() const
wxWindowBase_HasCustomPalette = define_c_var( wxWin, "@wxWindowBase@HasCustomPalette$xqv" ),

-- wxWindowBase::HasFlag(int) const
wxWindowBase_HasFlag = define_c_var( wxWin, "@wxWindowBase@HasFlag$xqi" ),

-- wxWindowBase::HasScrollbar(int) const
wxWindowBase_HasScrollbar = define_c_var( wxWin, "@wxWindowBase@HasScrollbar$xqi" ),

-- wxWindowBase::Hide()
wxWindowBase_Hide = define_c_var( wxWin, "@wxWindowBase@Hide$qv" ),

-- wxWindowBase::HitTest(int, int) const
wxWindowBase_HitTest = define_c_var( wxWin, "@wxWindowBase@HitTest$xqii" ),

-- wxWindowBase::InitBase()
wxWindowBase_InitBase = define_c_var( wxWin, "@wxWindowBase@InitBase$qv" ),

-- wxWindowBase::InitDialog()
wxWindowBase_InitDialog = define_c_var( wxWin, "@wxWindowBase@InitDialog$qv" ),

-- wxWindowBase::IsBeingDeleted() const
wxWindowBase_IsBeingDeleted = define_c_var( wxWin, "@wxWindowBase@IsBeingDeleted$xqv" ),

-- wxWindowBase::IsEnabled() const
wxWindowBase_IsEnabled = define_c_var( wxWin, "@wxWindowBase@IsEnabled$xqv" ),

-- wxWindowBase::IsExposed(int, int) const
wxWindowBase_IsExposed = define_c_var( wxWin, "@wxWindowBase@IsExposed$xqii" ),

-- wxWindowBase::IsExposed(int, int, int, int) const
wxWindowBase_IsExposed_1 = define_c_var( wxWin, "@wxWindowBase@IsExposed$xqiiii" ),

-- wxWindowBase::IsRetained() const
wxWindowBase_IsRetained = define_c_var( wxWin, "@wxWindowBase@IsRetained$xqv" ),

-- wxWindowBase::IsShown() const
wxWindowBase_IsShown = define_c_var( wxWin, "@wxWindowBase@IsShown$xqv" ),

-- wxWindowBase::IsTopLevel() const
wxWindowBase_IsTopLevel = define_c_var( wxWin, "@wxWindowBase@IsTopLevel$xqv" ),

-- wxWindowBase::Layout()
wxWindowBase_Layout = define_c_var( wxWin, "@wxWindowBase@Layout$qv" ),

-- wxWindowBase::LayoutPhase1(int *)
wxWindowBase_LayoutPhase1 = define_c_var( wxWin, "@wxWindowBase@LayoutPhase1$qpi" ),

-- wxWindowBase::LayoutPhase2(int *)
wxWindowBase_LayoutPhase2 = define_c_var( wxWin, "@wxWindowBase@LayoutPhase2$qpi" ),

-- wxWindowBase::MakeModal(bool)
wxWindowBase_MakeModal = define_c_var( wxWin, "@wxWindowBase@MakeModal$qo" ),

-- wxWindowBase::Move(int, int, int)
wxWindowBase_Move = define_c_var( wxWin, "@wxWindowBase@Move$qiii" ),

-- wxWindowBase::MoveConstraint(int, int)
wxWindowBase_MoveConstraint = define_c_var( wxWin, "@wxWindowBase@MoveConstraint$qii" ),

-- wxWindowBase::NewControlId()
wxWindowBase_NewControlId = define_c_var( wxWin, "@wxWindowBase@NewControlId$qv" ),

-- wxWindowBase::OnHelp(wxHelpEvent&)
wxWindowBase_OnHelp = define_c_var( wxWin, "@wxWindowBase@OnHelp$qr11wxHelpEvent" ),

-- wxWindowBase::OnInitDialog(wxInitDialogEvent&)
wxWindowBase_OnInitDialog = define_c_var( wxWin, "@wxWindowBase@OnInitDialog$qr17wxInitDialogEvent" ),

-- wxWindowBase::OnMiddleClick(wxMouseEvent&)
wxWindowBase_OnMiddleClick = define_c_var( wxWin, "@wxWindowBase@OnMiddleClick$qr12wxMouseEvent" ),

-- wxWindowBase::OnSysColourChanged(wxSysColourChangedEvent&)
wxWindowBase_OnSysColourChanged = define_c_var( wxWin, "@wxWindowBase@OnSysColourChanged$qr23wxSysColourChangedEvent" ),

-- wxWindowBase::PopEventHandler(bool)
wxWindowBase_PopEventHandler = define_c_var( wxWin, "@wxWindowBase@PopEventHandler$qo" ),

-- wxWindowBase::PopupMenu(wxMenu *, int, int)
wxWindowBase_PopupMenu = define_c_var( wxWin, "@wxWindowBase@PopupMenu$qp6wxMenuii" ),

-- wxWindowBase::PopupMenu(wxMenu *, const wxPoint&)
wxWindowBase_PopupMenu_1 = define_c_var( wxWin, "@wxWindowBase@PopupMenu$qp6wxMenurx7wxPoint" ),

-- wxWindowBase::PrepareDC(wxDC&)
wxWindowBase_PrepareDC = define_c_var( wxWin, "@wxWindowBase@PrepareDC$qr4wxDC" ),

-- wxWindowBase::PushEventHandler(wxEvtHandler *)
wxWindowBase_PushEventHandler = define_c_var( wxWin, "@wxWindowBase@PushEventHandler$qp12wxEvtHandler" ),

-- wxWindowBase::RefreshRect(const wxRect&)
wxWindowBase_RefreshRect = define_c_var( wxWin, "@wxWindowBase@RefreshRect$qrx6wxRect" ),

-- wxWindowBase::ReleaseMouse()
wxWindowBase_ReleaseMouse = define_c_var( wxWin, "@wxWindowBase@ReleaseMouse$qv" ),

-- wxWindowBase::RemoveChild(wxWindowBase *)
wxWindowBase_RemoveChild = define_c_var( wxWin, "@wxWindowBase@RemoveChild$qp12wxWindowBase" ),

-- wxWindowBase::RemoveConstraintReference(wxWindowBase *)
wxWindowBase_RemoveConstraintReference = define_c_var( wxWin, "@wxWindowBase@RemoveConstraintReference$qp12wxWindowBase" ),

-- wxWindowBase::RemoveEventHandler(wxEvtHandler *)
wxWindowBase_RemoveEventHandler = define_c_var( wxWin, "@wxWindowBase@RemoveEventHandler$qp12wxEvtHandler" ),

-- wxWindowBase::Reparent(wxWindowBase *)
wxWindowBase_Reparent = define_c_var( wxWin, "@wxWindowBase@Reparent$qp12wxWindowBase" ),

-- wxWindowBase::ResetConstraints()
wxWindowBase_ResetConstraints = define_c_var( wxWin, "@wxWindowBase@ResetConstraints$qv" ),

-- wxWindowBase::SatisfyConstraints()
wxWindowBase_SatisfyConstraints = define_c_var( wxWin, "@wxWindowBase@SatisfyConstraints$qv" ),

-- wxWindowBase::ScreenToClient(int *, int *) const
wxWindowBase_ScreenToClient = define_c_var( wxWin, "@wxWindowBase@ScreenToClient$xqpit1" ),

-- wxWindowBase::ScreenToClient(const wxPoint&) const
wxWindowBase_ScreenToClient_1 = define_c_var( wxWin, "@wxWindowBase@ScreenToClient$xqrx7wxPoint" ),

-- wxWindowBase::ScrollLines(int)
wxWindowBase_ScrollLines = define_c_var( wxWin, "@wxWindowBase@ScrollLines$qi" ),

-- wxWindowBase::ScrollPages(int)
wxWindowBase_ScrollPages = define_c_var( wxWin, "@wxWindowBase@ScrollPages$qi" ),

-- wxWindowBase::SetAcceleratorTable(const wxAcceleratorTable&)
wxWindowBase_SetAcceleratorTable = define_c_var( wxWin, "@wxWindowBase@SetAcceleratorTable$qrx18wxAcceleratorTable" ),

-- wxWindowBase::SetAutoLayout(bool)
wxWindowBase_SetAutoLayout = define_c_var( wxWin, "@wxWindowBase@SetAutoLayout$qo" ),

-- wxWindowBase::SetBackgroundColour(const wxColour&)
wxWindowBase_SetBackgroundColour = define_c_var( wxWin, "@wxWindowBase@SetBackgroundColour$qrx8wxColour" ),

-- wxWindowBase::SetBestSize(const wxSize&)
wxWindowBase_SetBestSize = define_c_var( wxWin, "@wxWindowBase@SetBestSize$qrx6wxSize" ),

-- wxWindowBase::SetCaret(wxCaret *)
wxWindowBase_SetCaret = define_c_var( wxWin, "@wxWindowBase@SetCaret$qp7wxCaret" ),

-- wxWindowBase::SetClientSize(int, int)
wxWindowBase_SetClientSize = define_c_var( wxWin, "@wxWindowBase@SetClientSize$qii" ),

-- wxWindowBase::SetClientSize(const wxSize&)
wxWindowBase_SetClientSize_1 = define_c_var( wxWin, "@wxWindowBase@SetClientSize$qrx6wxSize" ),

-- wxWindowBase::SetConstraintSizes(bool)
wxWindowBase_SetConstraintSizes = define_c_var( wxWin, "@wxWindowBase@SetConstraintSizes$qo" ),

-- wxWindowBase::SetConstraints(wxLayoutConstraints *)
wxWindowBase_SetConstraints = define_c_var( wxWin, "@wxWindowBase@SetConstraints$qp19wxLayoutConstraints" ),

-- wxWindowBase::SetContainingSizer(wxSizer *)
wxWindowBase_SetContainingSizer = define_c_var( wxWin, "@wxWindowBase@SetContainingSizer$qp7wxSizer" ),

-- wxWindowBase::SetCursor(const wxCursor&)
wxWindowBase_SetCursor = define_c_var( wxWin, "@wxWindowBase@SetCursor$qrx8wxCursor" ),

-- wxWindowBase::SetDefaultItem(wxWindow *)
wxWindowBase_SetDefaultItem = define_c_var( wxWin, "@wxWindowBase@SetDefaultItem$qp8wxWindow" ),

-- wxWindowBase::SetEventHandler(wxEvtHandler *)
wxWindowBase_SetEventHandler = define_c_var( wxWin, "@wxWindowBase@SetEventHandler$qp12wxEvtHandler" ),

-- wxWindowBase::SetExtraStyle(long)
wxWindowBase_SetExtraStyle = define_c_var( wxWin, "@wxWindowBase@SetExtraStyle$ql" ),

-- wxWindowBase::SetFocusFromKbd()
wxWindowBase_SetFocusFromKbd = define_c_var( wxWin, "@wxWindowBase@SetFocusFromKbd$qv" ),

-- wxWindowBase::SetFont(const wxFont&)
wxWindowBase_SetFont = define_c_var( wxWin, "@wxWindowBase@SetFont$qrx6wxFont" ),

-- wxWindowBase::SetForegroundColour(const wxColour&)
wxWindowBase_SetForegroundColour = define_c_var( wxWin, "@wxWindowBase@SetForegroundColour$qrx8wxColour" ),

-- wxWindowBase::SetHelpText(const wxString&)
wxWindowBase_SetHelpText = define_c_var( wxWin, "@wxWindowBase@SetHelpText$qrx8wxString" ),

-- wxWindowBase::SetHelpTextForId(const wxString&)
wxWindowBase_SetHelpTextForId = define_c_var( wxWin, "@wxWindowBase@SetHelpTextForId$qrx8wxString" ),

-- wxWindowBase::SetId(int)
wxWindowBase_SetId = define_c_var( wxWin, "@wxWindowBase@SetId$qi" ),

-- wxWindowBase::SetLabel(const wxString&)
wxWindowBase_SetLabel = define_c_var( wxWin, "@wxWindowBase@SetLabel$qrx8wxString" ),

-- wxWindowBase::SetName(const wxString&)
wxWindowBase_SetName = define_c_var( wxWin, "@wxWindowBase@SetName$qrx8wxString" ),

-- wxWindowBase::SetPalette(const wxPalette&)
wxWindowBase_SetPalette = define_c_var( wxWin, "@wxWindowBase@SetPalette$qrx9wxPalette" ),

-- wxWindowBase::SetParent(wxWindowBase *)
wxWindowBase_SetParent = define_c_var( wxWin, "@wxWindowBase@SetParent$qp12wxWindowBase" ),

-- wxWindowBase::SetSize(int, int)
wxWindowBase_SetSize = define_c_var( wxWin, "@wxWindowBase@SetSize$qii" ),

-- wxWindowBase::SetSizeConstraint(int, int, int, int)
wxWindowBase_SetSizeConstraint = define_c_var( wxWin, "@wxWindowBase@SetSizeConstraint$qiiii" ),

-- wxWindowBase::SetSizeHints(int, int, int, int, int, int)
wxWindowBase_SetSizeHints = define_c_var( wxWin, "@wxWindowBase@SetSizeHints$qiiiiii" ),

-- wxWindowBase::SetSize(int, int, int, int, int)
wxWindowBase_SetSize_1 = define_c_var( wxWin, "@wxWindowBase@SetSize$qiiiii" ),

-- wxWindowBase::SetSize(const wxRect&, int)
wxWindowBase_SetSize_2 = define_c_var( wxWin, "@wxWindowBase@SetSize$qrx6wxRecti" ),

-- wxWindowBase::SetSize(const wxSize&)
wxWindowBase_SetSize_3 = define_c_var( wxWin, "@wxWindowBase@SetSize$qrx6wxSize" ),

-- wxWindowBase::SetSizer(wxSizer *, bool)
wxWindowBase_SetSizer = define_c_var( wxWin, "@wxWindowBase@SetSizer$qp7wxSizero" ),

-- wxWindowBase::SetSizerAndFit(wxSizer *, bool)
wxWindowBase_SetSizerAndFit = define_c_var( wxWin, "@wxWindowBase@SetSizerAndFit$qp7wxSizero" ),

-- wxWindowBase::SetThemeEnabled(bool)
wxWindowBase_SetThemeEnabled = define_c_var( wxWin, "@wxWindowBase@SetThemeEnabled$qo" ),

-- wxWindowBase::SetTitle(const wxString&)
wxWindowBase_SetTitle = define_c_var( wxWin, "@wxWindowBase@SetTitle$qrx8wxString" ),

-- wxWindowBase::SetTmpDefaultItem(wxWindow *)
wxWindowBase_SetTmpDefaultItem = define_c_var( wxWin, "@wxWindowBase@SetTmpDefaultItem$qp8wxWindow" ),

-- wxWindowBase::SetToolTip(wxToolTip *)
wxWindowBase_SetToolTip = define_c_var( wxWin, "@wxWindowBase@SetToolTip$qp9wxToolTip" ),

-- wxWindowBase::SetToolTip(const wxString&)
wxWindowBase_SetToolTip_1 = define_c_var( wxWin, "@wxWindowBase@SetToolTip$qrx8wxString" ),

-- wxWindowBase::SetValidator(const wxValidator&)
wxWindowBase_SetValidator = define_c_var( wxWin, "@wxWindowBase@SetValidator$qrx11wxValidator" ),

-- wxWindowBase::SetVirtualSize(int, int)
wxWindowBase_SetVirtualSize = define_c_var( wxWin, "@wxWindowBase@SetVirtualSize$qii" ),

-- wxWindowBase::SetVirtualSizeHints(int, int, int, int)
wxWindowBase_SetVirtualSizeHints = define_c_var( wxWin, "@wxWindowBase@SetVirtualSizeHints$qiiii" ),

-- wxWindowBase::SetVirtualSize(const wxSize&)
wxWindowBase_SetVirtualSize_1 = define_c_var( wxWin, "@wxWindowBase@SetVirtualSize$qrx6wxSize" ),

-- wxWindowBase::SetWindowStyle(long)
wxWindowBase_SetWindowStyle = define_c_var( wxWin, "@wxWindowBase@SetWindowStyle$ql" ),

-- wxWindowBase::SetWindowStyleFlag(long)
wxWindowBase_SetWindowStyleFlag = define_c_var( wxWin, "@wxWindowBase@SetWindowStyleFlag$ql" ),

-- wxWindowBase::Show(bool)
wxWindowBase_Show = define_c_var( wxWin, "@wxWindowBase@Show$qo" ),

-- wxWindowBase::Thaw()
wxWindowBase_Thaw = define_c_var( wxWin, "@wxWindowBase@Thaw$qv" ),

-- wxWindowBase::TransferDataFromWindow()
wxWindowBase_TransferDataFromWindow = define_c_var( wxWin, "@wxWindowBase@TransferDataFromWindow$qv" ),

-- wxWindowBase::TransferDataToWindow()
wxWindowBase_TransferDataToWindow = define_c_var( wxWin, "@wxWindowBase@TransferDataToWindow$qv" ),

-- wxWindowBase::UnsetConstraints(wxLayoutConstraints *)
wxWindowBase_UnsetConstraints = define_c_var( wxWin, "@wxWindowBase@UnsetConstraints$qp19wxLayoutConstraints" ),

-- wxWindowBase::Update()
wxWindowBase_Update = define_c_var( wxWin, "@wxWindowBase@Update$qv" ),

-- wxWindowBase::UpdateWindowUI()
wxWindowBase_UpdateWindowUI = define_c_var( wxWin, "@wxWindowBase@UpdateWindowUI$qv" ),

-- wxWindowBase::Validate()
wxWindowBase_Validate = define_c_var( wxWin, "@wxWindowBase@Validate$qv" ),

-- wxWindowBase::ms_lastControlId
wxWindowBase_ms_lastControlId = define_c_var( wxWin, "@wxWindowBase@ms_lastControlId" ),

-- wxWindowBase::ms_winCaptureNext
wxWindowBase_ms_winCaptureNext = define_c_var( wxWin, "@wxWindowBase@ms_winCaptureNext" ),

-- wxWindowBase::wxWindowBase()
wxWindowBase_op_ctr = define_c_var( wxWin, "@wxWindowBase@$bctr$qv" ),

-- wxWindowBase::~wxWindowBase()
wxWindowBase_op_dtr = define_c_var( wxWin, "@wxWindowBase@$bdtr$qv" ),

-- wxWindowBase::sm_classwxWindowBase
wxWindowBase_sm_classwxWindowBase = define_c_var( wxWin, "@wxWindowBase@sm_classwxWindowBase" ),

-- wxWindowBase::sm_eventTable
wxWindowBase_sm_eventTable = define_c_var( wxWin, "@wxWindowBase@sm_eventTable" ),

-- wxWindowBase::sm_eventTableEntries
wxWindowBase_sm_eventTableEntries = define_c_var( wxWin, "@wxWindowBase@sm_eventTableEntries" ),

sizeof_wxWindowBase = 1,
wxWindowBase = define_class( "wxWindowBase", wxWin, wxWindowBase_op_ctr, sizeof_wxWindowBase, wxWindowBase_op_dtr )

-- end class wxWindowBase
------------------------------


-- begin class constant (341 members)
------------------------------

global constant 

-- _GSocket_GetError
GSocket_GetError = define_c_var( wxWin, "_GSocket_GetError" ),

-- ___CPPdebugHook
wx__CPPdebugHook = define_c_var( wxWin, "___CPPdebugHook" ),

-- _g_isPainting
g_isPainting = define_c_var( wxWin, "_g_isPainting" ),

-- _g_pThemeEngine
g_pThemeEngine = define_c_var( wxWin, "_g_pThemeEngine" ),

-- _wxBLACK
wxBLACK = peek4s( define_c_var( wxWin, "_wxBLACK" )),

-- _wxBLACK_BRUSH
wxBLACK_BRUSH = peek4s( define_c_var( wxWin, "_wxBLACK_BRUSH" )),

-- _wxBLACK_DASHED_PEN
wxBLACK_DASHED_PEN = peek4s( define_c_var( wxWin, "_wxBLACK_DASHED_PEN" )),

-- _wxBLACK_PEN
wxBLACK_PEN = peek4s( define_c_var( wxWin, "_wxBLACK_PEN" )),

-- _wxBLUE
wxBLUE = peek4s( define_c_var( wxWin, "_wxBLUE" )),

-- _wxBLUE_BRUSH
wxBLUE_BRUSH = peek4s( define_c_var( wxWin, "_wxBLUE_BRUSH" )),

-- _wxBitmapRadioButtonNameStr
wxBitmapRadioButtonNameStr = define_c_var( wxWin, "_wxBitmapRadioButtonNameStr" ),

-- _wxBuffer
wxBuffer = define_c_var( wxWin, "_wxBuffer" ),

-- _wxButtonBarNameStr
wxButtonBarNameStr = define_c_var( wxWin, "_wxButtonBarNameStr" ),

-- _wxButtonNameStr
wxButtonNameStr = define_c_var( wxWin, "_wxButtonNameStr" ),

-- _wxCROSS_CURSOR
wxCROSS_CURSOR = peek4s( define_c_var( wxWin, "_wxCROSS_CURSOR" )),

-- _wxCYAN
wxCYAN = peek4s( define_c_var( wxWin, "_wxCYAN" )),

-- _wxCYAN_BRUSH
wxCYAN_BRUSH = peek4s( define_c_var( wxWin, "_wxCYAN_BRUSH" )),

-- _wxCYAN_PEN
wxCYAN_PEN = peek4s( define_c_var( wxWin, "_wxCYAN_PEN" )),

-- _wxCanvasNameStr
wxCanvasNameStr = define_c_var( wxWin, "_wxCanvasNameStr" ),

-- _wxCheckBoxNameStr
wxCheckBoxNameStr = define_c_var( wxWin, "_wxCheckBoxNameStr" ),

-- _wxChoiceNameStr
wxChoiceNameStr = define_c_var( wxWin, "_wxChoiceNameStr" ),

-- _wxComboBoxNameStr
wxComboBoxNameStr = define_c_var( wxWin, "_wxComboBoxNameStr" ),

-- _wxControlNameStr
wxControlNameStr = define_c_var( wxWin, "_wxControlNameStr" ),

-- _wxConvCurrent
wxConvCurrent = define_c_var( wxWin, "_wxConvCurrent" ),

-- _wxConvISO8859_1
wxConvISO8859_1 = peek4s( define_c_var( wxWin, "_wxConvISO8859_1" )),

-- _wxConvLibc
wxConvLibc = define_c_var( wxWin, "_wxConvLibc" ),

-- _wxConvLocal
wxConvLocal = define_c_var( wxWin, "_wxConvLocal" ),

-- _wxConvUTF7
wxConvUTF7 = peek4s( define_c_var( wxWin, "_wxConvUTF7" )),

-- _wxConvUTF8
wxConvUTF8 = peek4s( define_c_var( wxWin, "_wxConvUTF8" )),

-- _wxDEFAULT_FRAME_ICON
wxDEFAULT_FRAME_ICON = peek4s( define_c_var( wxWin, "_wxDEFAULT_FRAME_ICON" )),

-- _wxDEFAULT_MDICHILDFRAME_ICON
wxDEFAULT_MDICHILDFRAME_ICON = peek4s( define_c_var( wxWin, "_wxDEFAULT_MDICHILDFRAME_ICON" )),

-- _wxDEFAULT_MDIPARENTFRAME_ICON
wxDEFAULT_MDIPARENTFRAME_ICON = peek4s( define_c_var( wxWin, "_wxDEFAULT_MDIPARENTFRAME_ICON" )),

-- _wxDefaultDateTime
wxDefaultDateTime = define_c_var( wxWin, "_wxDefaultDateTime" ),

-- _wxDefaultListKey
wxDefaultListKey = define_c_var( wxWin, "_wxDefaultListKey" ),

-- _wxDefaultPosition
wxDefaultPosition = define_c_var( wxWin, "_wxDefaultPosition" ),

-- _wxDefaultSize
wxDefaultSize = define_c_var( wxWin, "_wxDefaultSize" ),

-- _wxDefaultValidator
wxDefaultValidator = define_c_var( wxWin, "_wxDefaultValidator" ),

-- _wxDialogNameStr
wxDialogNameStr = define_c_var( wxWin, "_wxDialogNameStr" ),

-- _wxDirDialogDefaultFolderStr
wxDirDialogDefaultFolderStr = define_c_var( wxWin, "_wxDirDialogDefaultFolderStr" ),

-- _wxDirDialogNameStr
wxDirDialogNameStr = define_c_var( wxWin, "_wxDirDialogNameStr" ),

-- _wxDirSelectorPromptStr
wxDirSelectorPromptStr = define_c_var( wxWin, "_wxDirSelectorPromptStr" ),

-- _wxDoubleToStringStr
wxDoubleToStringStr = define_c_var( wxWin, "_wxDoubleToStringStr" ),

-- _wxEVT_ACTIVATE
wxEVT_ACTIVATE = peek4s( define_c_var( wxWin, "_wxEVT_ACTIVATE" )),

-- _wxEVT_ACTIVATE_APP
wxEVT_ACTIVATE_APP = peek4s( define_c_var( wxWin, "_wxEVT_ACTIVATE_APP" )),

-- _wxEVT_CALCULATE_LAYOUT
wxEVT_CALCULATE_LAYOUT = peek4s( define_c_var( wxWin, "_wxEVT_CALCULATE_LAYOUT" )),

-- _wxEVT_CALENDAR_DAY_CHANGED
wxEVT_CALENDAR_DAY_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_CALENDAR_DAY_CHANGED" )),

-- _wxEVT_CALENDAR_DOUBLECLICKED
wxEVT_CALENDAR_DOUBLECLICKED = peek4s( define_c_var( wxWin, "_wxEVT_CALENDAR_DOUBLECLICKED" )),

-- _wxEVT_CALENDAR_MONTH_CHANGED
wxEVT_CALENDAR_MONTH_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_CALENDAR_MONTH_CHANGED" )),

-- _wxEVT_CALENDAR_SEL_CHANGED
wxEVT_CALENDAR_SEL_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_CALENDAR_SEL_CHANGED" )),

-- _wxEVT_CALENDAR_WEEKDAY_CLICKED
wxEVT_CALENDAR_WEEKDAY_CLICKED = peek4s( define_c_var( wxWin, "_wxEVT_CALENDAR_WEEKDAY_CLICKED" )),

-- _wxEVT_CALENDAR_YEAR_CHANGED
wxEVT_CALENDAR_YEAR_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_CALENDAR_YEAR_CHANGED" )),

-- _wxEVT_CHAR
wxEVT_CHAR = peek4s( define_c_var( wxWin, "_wxEVT_CHAR" )),

-- _wxEVT_CHAR_HOOK
wxEVT_CHAR_HOOK = peek4s( define_c_var( wxWin, "_wxEVT_CHAR_HOOK" )),

-- _wxEVT_CHILD_FOCUS
wxEVT_CHILD_FOCUS = peek4s( define_c_var( wxWin, "_wxEVT_CHILD_FOCUS" )),

-- _wxEVT_CLOSE_WINDOW
wxEVT_CLOSE_WINDOW = peek4s( define_c_var( wxWin, "_wxEVT_CLOSE_WINDOW" )),

-- _wxEVT_COMMAND_BUTTON_CLICKED
wxEVT_COMMAND_BUTTON_CLICKED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_BUTTON_CLICKED" )),

-- _wxEVT_COMMAND_CHECKBOX_CLICKED
wxEVT_COMMAND_CHECKBOX_CLICKED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_CHECKBOX_CLICKED" )),

-- _wxEVT_COMMAND_CHECKLISTBOX_TOGGLED
wxEVT_COMMAND_CHECKLISTBOX_TOGGLED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_CHECKLISTBOX_TOGGLED" )),

-- _wxEVT_COMMAND_CHOICE_SELECTED
wxEVT_COMMAND_CHOICE_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_CHOICE_SELECTED" )),

-- _wxEVT_COMMAND_COMBOBOX_SELECTED
wxEVT_COMMAND_COMBOBOX_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_COMBOBOX_SELECTED" )),

-- _wxEVT_COMMAND_ENTER
wxEVT_COMMAND_ENTER = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_ENTER" )),

-- _wxEVT_COMMAND_FIND
wxEVT_COMMAND_FIND = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_FIND" )),

-- _wxEVT_COMMAND_FIND_CLOSE
wxEVT_COMMAND_FIND_CLOSE = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_FIND_CLOSE" )),

-- _wxEVT_COMMAND_FIND_NEXT
wxEVT_COMMAND_FIND_NEXT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_FIND_NEXT" )),

-- _wxEVT_COMMAND_FIND_REPLACE
wxEVT_COMMAND_FIND_REPLACE = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_FIND_REPLACE" )),

-- _wxEVT_COMMAND_FIND_REPLACE_ALL
wxEVT_COMMAND_FIND_REPLACE_ALL = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_FIND_REPLACE_ALL" )),

-- _wxEVT_COMMAND_KILL_FOCUS
wxEVT_COMMAND_KILL_FOCUS = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_KILL_FOCUS" )),

-- _wxEVT_COMMAND_LEFT_CLICK
wxEVT_COMMAND_LEFT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LEFT_CLICK" )),

-- _wxEVT_COMMAND_LEFT_DCLICK
wxEVT_COMMAND_LEFT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LEFT_DCLICK" )),

-- _wxEVT_COMMAND_LISTBOX_DOUBLECLICKED
wxEVT_COMMAND_LISTBOX_DOUBLECLICKED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LISTBOX_DOUBLECLICKED" )),

-- _wxEVT_COMMAND_LISTBOX_SELECTED
wxEVT_COMMAND_LISTBOX_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LISTBOX_SELECTED" )),

-- _wxEVT_COMMAND_LIST_BEGIN_DRAG
wxEVT_COMMAND_LIST_BEGIN_DRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_BEGIN_DRAG" )),

-- _wxEVT_COMMAND_LIST_BEGIN_LABEL_EDIT
wxEVT_COMMAND_LIST_BEGIN_LABEL_EDIT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_BEGIN_LABEL_EDIT" )),

-- _wxEVT_COMMAND_LIST_BEGIN_RDRAG
wxEVT_COMMAND_LIST_BEGIN_RDRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_BEGIN_RDRAG" )),

-- _wxEVT_COMMAND_LIST_CACHE_HINT
wxEVT_COMMAND_LIST_CACHE_HINT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_CACHE_HINT" )),

-- _wxEVT_COMMAND_LIST_COL_BEGIN_DRAG
wxEVT_COMMAND_LIST_COL_BEGIN_DRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_COL_BEGIN_DRAG" )),

-- _wxEVT_COMMAND_LIST_COL_CLICK
wxEVT_COMMAND_LIST_COL_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_COL_CLICK" )),

-- _wxEVT_COMMAND_LIST_COL_DRAGGING
wxEVT_COMMAND_LIST_COL_DRAGGING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_COL_DRAGGING" )),

-- _wxEVT_COMMAND_LIST_COL_END_DRAG
wxEVT_COMMAND_LIST_COL_END_DRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_COL_END_DRAG" )),

-- _wxEVT_COMMAND_LIST_COL_RIGHT_CLICK
wxEVT_COMMAND_LIST_COL_RIGHT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_COL_RIGHT_CLICK" )),

-- _wxEVT_COMMAND_LIST_DELETE_ALL_ITEMS
wxEVT_COMMAND_LIST_DELETE_ALL_ITEMS = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_DELETE_ALL_ITEMS" )),

-- _wxEVT_COMMAND_LIST_DELETE_ITEM
wxEVT_COMMAND_LIST_DELETE_ITEM = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_DELETE_ITEM" )),

-- _wxEVT_COMMAND_LIST_END_LABEL_EDIT
wxEVT_COMMAND_LIST_END_LABEL_EDIT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_END_LABEL_EDIT" )),

-- _wxEVT_COMMAND_LIST_GET_INFO
wxEVT_COMMAND_LIST_GET_INFO = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_GET_INFO" )),

-- _wxEVT_COMMAND_LIST_INSERT_ITEM
wxEVT_COMMAND_LIST_INSERT_ITEM = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_INSERT_ITEM" )),

-- _wxEVT_COMMAND_LIST_ITEM_ACTIVATED
wxEVT_COMMAND_LIST_ITEM_ACTIVATED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_ITEM_ACTIVATED" )),

-- _wxEVT_COMMAND_LIST_ITEM_DESELECTED
wxEVT_COMMAND_LIST_ITEM_DESELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_ITEM_DESELECTED" )),

-- _wxEVT_COMMAND_LIST_ITEM_FOCUSED
wxEVT_COMMAND_LIST_ITEM_FOCUSED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_ITEM_FOCUSED" )),

-- _wxEVT_COMMAND_LIST_ITEM_MIDDLE_CLICK
wxEVT_COMMAND_LIST_ITEM_MIDDLE_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_ITEM_MIDDLE_CLICK" )),

-- _wxEVT_COMMAND_LIST_ITEM_RIGHT_CLICK
wxEVT_COMMAND_LIST_ITEM_RIGHT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_ITEM_RIGHT_CLICK" )),

-- _wxEVT_COMMAND_LIST_ITEM_SELECTED
wxEVT_COMMAND_LIST_ITEM_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_ITEM_SELECTED" )),

-- _wxEVT_COMMAND_LIST_KEY_DOWN
wxEVT_COMMAND_LIST_KEY_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_KEY_DOWN" )),

-- _wxEVT_COMMAND_LIST_SET_INFO
wxEVT_COMMAND_LIST_SET_INFO = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_LIST_SET_INFO" )),

-- _wxEVT_COMMAND_MENU_SELECTED
wxEVT_COMMAND_MENU_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_MENU_SELECTED" )),

-- _wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED
wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED" )),

-- _wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING
wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING" )),

-- _wxEVT_COMMAND_RADIOBOX_SELECTED
wxEVT_COMMAND_RADIOBOX_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_RADIOBOX_SELECTED" )),

-- _wxEVT_COMMAND_RADIOBUTTON_SELECTED
wxEVT_COMMAND_RADIOBUTTON_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_RADIOBUTTON_SELECTED" )),

-- _wxEVT_COMMAND_RIGHT_CLICK
wxEVT_COMMAND_RIGHT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_RIGHT_CLICK" )),

-- _wxEVT_COMMAND_RIGHT_DCLICK
wxEVT_COMMAND_RIGHT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_RIGHT_DCLICK" )),

-- _wxEVT_COMMAND_SCROLLBAR_UPDATED
wxEVT_COMMAND_SCROLLBAR_UPDATED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SCROLLBAR_UPDATED" )),

-- _wxEVT_COMMAND_SET_FOCUS
wxEVT_COMMAND_SET_FOCUS = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SET_FOCUS" )),

-- _wxEVT_COMMAND_SLIDER_UPDATED
wxEVT_COMMAND_SLIDER_UPDATED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SLIDER_UPDATED" )),

-- _wxEVT_COMMAND_SPINCTRL_UPDATED
wxEVT_COMMAND_SPINCTRL_UPDATED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SPINCTRL_UPDATED" )),

-- _wxEVT_COMMAND_SPLITTER_DOUBLECLICKED
wxEVT_COMMAND_SPLITTER_DOUBLECLICKED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SPLITTER_DOUBLECLICKED" )),

-- _wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED
wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED" )),

-- _wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING
wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING" )),

-- _wxEVT_COMMAND_SPLITTER_UNSPLIT
wxEVT_COMMAND_SPLITTER_UNSPLIT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_SPLITTER_UNSPLIT" )),

-- _wxEVT_COMMAND_TAB_SEL_CHANGED
wxEVT_COMMAND_TAB_SEL_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TAB_SEL_CHANGED" )),

-- _wxEVT_COMMAND_TAB_SEL_CHANGING
wxEVT_COMMAND_TAB_SEL_CHANGING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TAB_SEL_CHANGING" )),

-- _wxEVT_COMMAND_TEXT_ENTER
wxEVT_COMMAND_TEXT_ENTER = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TEXT_ENTER" )),

-- _wxEVT_COMMAND_TEXT_MAXLEN
wxEVT_COMMAND_TEXT_MAXLEN = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TEXT_MAXLEN" )),

-- _wxEVT_COMMAND_TEXT_UPDATED
wxEVT_COMMAND_TEXT_UPDATED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TEXT_UPDATED" )),

-- _wxEVT_COMMAND_TEXT_URL
wxEVT_COMMAND_TEXT_URL = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TEXT_URL" )),

-- _wxEVT_COMMAND_TOGGLEBUTTON_CLICKED
wxEVT_COMMAND_TOGGLEBUTTON_CLICKED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TOGGLEBUTTON_CLICKED" )),

-- _wxEVT_COMMAND_TOOL_ENTER
wxEVT_COMMAND_TOOL_ENTER = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TOOL_ENTER" )),

-- _wxEVT_COMMAND_TOOL_RCLICKED
wxEVT_COMMAND_TOOL_RCLICKED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TOOL_RCLICKED" )),

-- _wxEVT_COMMAND_TREE_BEGIN_DRAG
wxEVT_COMMAND_TREE_BEGIN_DRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_BEGIN_DRAG" )),

-- _wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT
wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT" )),

-- _wxEVT_COMMAND_TREE_BEGIN_RDRAG
wxEVT_COMMAND_TREE_BEGIN_RDRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_BEGIN_RDRAG" )),

-- _wxEVT_COMMAND_TREE_DELETE_ITEM
wxEVT_COMMAND_TREE_DELETE_ITEM = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_DELETE_ITEM" )),

-- _wxEVT_COMMAND_TREE_END_DRAG
wxEVT_COMMAND_TREE_END_DRAG = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_END_DRAG" )),

-- _wxEVT_COMMAND_TREE_END_LABEL_EDIT
wxEVT_COMMAND_TREE_END_LABEL_EDIT = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_END_LABEL_EDIT" )),

-- _wxEVT_COMMAND_TREE_GET_INFO
wxEVT_COMMAND_TREE_GET_INFO = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_GET_INFO" )),

-- _wxEVT_COMMAND_TREE_ITEM_ACTIVATED
wxEVT_COMMAND_TREE_ITEM_ACTIVATED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_ACTIVATED" )),

-- _wxEVT_COMMAND_TREE_ITEM_COLLAPSED
wxEVT_COMMAND_TREE_ITEM_COLLAPSED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_COLLAPSED" )),

-- _wxEVT_COMMAND_TREE_ITEM_COLLAPSING
wxEVT_COMMAND_TREE_ITEM_COLLAPSING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_COLLAPSING" )),

-- _wxEVT_COMMAND_TREE_ITEM_EXPANDED
wxEVT_COMMAND_TREE_ITEM_EXPANDED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_EXPANDED" )),

-- _wxEVT_COMMAND_TREE_ITEM_EXPANDING
wxEVT_COMMAND_TREE_ITEM_EXPANDING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_EXPANDING" )),

-- _wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK
wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK" )),

-- _wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK
wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK" )),

-- _wxEVT_COMMAND_TREE_KEY_DOWN
wxEVT_COMMAND_TREE_KEY_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_KEY_DOWN" )),

-- _wxEVT_COMMAND_TREE_SEL_CHANGED
wxEVT_COMMAND_TREE_SEL_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_SEL_CHANGED" )),

-- _wxEVT_COMMAND_TREE_SEL_CHANGING
wxEVT_COMMAND_TREE_SEL_CHANGING = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_SEL_CHANGING" )),

-- _wxEVT_COMMAND_TREE_SET_INFO
wxEVT_COMMAND_TREE_SET_INFO = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_TREE_SET_INFO" )),

-- _wxEVT_COMMAND_VLBOX_SELECTED
wxEVT_COMMAND_VLBOX_SELECTED = peek4s( define_c_var( wxWin, "_wxEVT_COMMAND_VLBOX_SELECTED" )),

-- _wxEVT_COMPARE_ITEM
wxEVT_COMPARE_ITEM = peek4s( define_c_var( wxWin, "_wxEVT_COMPARE_ITEM" )),

-- _wxEVT_CONTEXT_MENU
wxEVT_CONTEXT_MENU = peek4s( define_c_var( wxWin, "_wxEVT_CONTEXT_MENU" )),

-- _wxEVT_CREATE
wxEVT_CREATE = peek4s( define_c_var( wxWin, "_wxEVT_CREATE" )),

-- _wxEVT_DESTROY
wxEVT_DESTROY = peek4s( define_c_var( wxWin, "_wxEVT_DESTROY" )),

-- _wxEVT_DETAILED_HELP
wxEVT_DETAILED_HELP = peek4s( define_c_var( wxWin, "_wxEVT_DETAILED_HELP" )),

-- _wxEVT_DIALUP_CONNECTED
wxEVT_DIALUP_CONNECTED = peek4s( define_c_var( wxWin, "_wxEVT_DIALUP_CONNECTED" )),

-- _wxEVT_DIALUP_DISCONNECTED
wxEVT_DIALUP_DISCONNECTED = peek4s( define_c_var( wxWin, "_wxEVT_DIALUP_DISCONNECTED" )),

-- _wxEVT_DISPLAY_CHANGED
wxEVT_DISPLAY_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_DISPLAY_CHANGED" )),

-- _wxEVT_DRAW_ITEM
wxEVT_DRAW_ITEM = peek4s( define_c_var( wxWin, "_wxEVT_DRAW_ITEM" )),

-- _wxEVT_DROP_FILES
wxEVT_DROP_FILES = peek4s( define_c_var( wxWin, "_wxEVT_DROP_FILES" )),

-- _wxEVT_END_PROCESS
wxEVT_END_PROCESS = peek4s( define_c_var( wxWin, "_wxEVT_END_PROCESS" )),

-- _wxEVT_END_SESSION
wxEVT_END_SESSION = peek4s( define_c_var( wxWin, "_wxEVT_END_SESSION" )),

-- _wxEVT_ENTER_WINDOW
wxEVT_ENTER_WINDOW = peek4s( define_c_var( wxWin, "_wxEVT_ENTER_WINDOW" )),

-- _wxEVT_ERASE_BACKGROUND
wxEVT_ERASE_BACKGROUND = peek4s( define_c_var( wxWin, "_wxEVT_ERASE_BACKGROUND" )),

-- _wxEVT_GRID_CELL_CHANGE
wxEVT_GRID_CELL_CHANGE = peek4s( define_c_var( wxWin, "_wxEVT_GRID_CELL_CHANGE" )),

-- _wxEVT_GRID_CELL_LEFT_CLICK
wxEVT_GRID_CELL_LEFT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_CELL_LEFT_CLICK" )),

-- _wxEVT_GRID_CELL_LEFT_DCLICK
wxEVT_GRID_CELL_LEFT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_CELL_LEFT_DCLICK" )),

-- _wxEVT_GRID_CELL_RIGHT_CLICK
wxEVT_GRID_CELL_RIGHT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_CELL_RIGHT_CLICK" )),

-- _wxEVT_GRID_CELL_RIGHT_DCLICK
wxEVT_GRID_CELL_RIGHT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_CELL_RIGHT_DCLICK" )),

-- _wxEVT_GRID_COL_SIZE
wxEVT_GRID_COL_SIZE = peek4s( define_c_var( wxWin, "_wxEVT_GRID_COL_SIZE" )),

-- _wxEVT_GRID_EDITOR_CREATED
wxEVT_GRID_EDITOR_CREATED = peek4s( define_c_var( wxWin, "_wxEVT_GRID_EDITOR_CREATED" )),

-- _wxEVT_GRID_EDITOR_HIDDEN
wxEVT_GRID_EDITOR_HIDDEN = peek4s( define_c_var( wxWin, "_wxEVT_GRID_EDITOR_HIDDEN" )),

-- _wxEVT_GRID_EDITOR_SHOWN
wxEVT_GRID_EDITOR_SHOWN = peek4s( define_c_var( wxWin, "_wxEVT_GRID_EDITOR_SHOWN" )),

-- _wxEVT_GRID_LABEL_LEFT_CLICK
wxEVT_GRID_LABEL_LEFT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_LABEL_LEFT_CLICK" )),

-- _wxEVT_GRID_LABEL_LEFT_DCLICK
wxEVT_GRID_LABEL_LEFT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_LABEL_LEFT_DCLICK" )),

-- _wxEVT_GRID_LABEL_RIGHT_CLICK
wxEVT_GRID_LABEL_RIGHT_CLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_LABEL_RIGHT_CLICK" )),

-- _wxEVT_GRID_LABEL_RIGHT_DCLICK
wxEVT_GRID_LABEL_RIGHT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_GRID_LABEL_RIGHT_DCLICK" )),

-- _wxEVT_GRID_RANGE_SELECT
wxEVT_GRID_RANGE_SELECT = peek4s( define_c_var( wxWin, "_wxEVT_GRID_RANGE_SELECT" )),

-- _wxEVT_GRID_ROW_SIZE
wxEVT_GRID_ROW_SIZE = peek4s( define_c_var( wxWin, "_wxEVT_GRID_ROW_SIZE" )),

-- _wxEVT_GRID_SELECT_CELL
wxEVT_GRID_SELECT_CELL = peek4s( define_c_var( wxWin, "_wxEVT_GRID_SELECT_CELL" )),

-- _wxEVT_HELP
wxEVT_HELP = peek4s( define_c_var( wxWin, "_wxEVT_HELP" )),

-- _wxEVT_ICONIZE
wxEVT_ICONIZE = peek4s( define_c_var( wxWin, "_wxEVT_ICONIZE" )),

-- _wxEVT_IDLE
wxEVT_IDLE = peek4s( define_c_var( wxWin, "_wxEVT_IDLE" )),

-- _wxEVT_INIT_DIALOG
wxEVT_INIT_DIALOG = peek4s( define_c_var( wxWin, "_wxEVT_INIT_DIALOG" )),

-- _wxEVT_JOY_BUTTON_DOWN
wxEVT_JOY_BUTTON_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_JOY_BUTTON_DOWN" )),

-- _wxEVT_JOY_BUTTON_UP
wxEVT_JOY_BUTTON_UP = peek4s( define_c_var( wxWin, "_wxEVT_JOY_BUTTON_UP" )),

-- _wxEVT_JOY_MOVE
wxEVT_JOY_MOVE = peek4s( define_c_var( wxWin, "_wxEVT_JOY_MOVE" )),

-- _wxEVT_JOY_ZMOVE
wxEVT_JOY_ZMOVE = peek4s( define_c_var( wxWin, "_wxEVT_JOY_ZMOVE" )),

-- _wxEVT_KEY_DOWN
wxEVT_KEY_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_KEY_DOWN" )),

-- _wxEVT_KEY_UP
wxEVT_KEY_UP = peek4s( define_c_var( wxWin, "_wxEVT_KEY_UP" )),

-- _wxEVT_KILL_FOCUS
wxEVT_KILL_FOCUS = peek4s( define_c_var( wxWin, "_wxEVT_KILL_FOCUS" )),

-- _wxEVT_LEAVE_WINDOW
wxEVT_LEAVE_WINDOW = peek4s( define_c_var( wxWin, "_wxEVT_LEAVE_WINDOW" )),

-- _wxEVT_LEFT_DCLICK
wxEVT_LEFT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_LEFT_DCLICK" )),

-- _wxEVT_LEFT_DOWN
wxEVT_LEFT_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_LEFT_DOWN" )),

-- _wxEVT_LEFT_UP
wxEVT_LEFT_UP = peek4s( define_c_var( wxWin, "_wxEVT_LEFT_UP" )),

-- _wxEVT_MAXIMIZE
wxEVT_MAXIMIZE = peek4s( define_c_var( wxWin, "_wxEVT_MAXIMIZE" )),

-- _wxEVT_MEASURE_ITEM
wxEVT_MEASURE_ITEM = peek4s( define_c_var( wxWin, "_wxEVT_MEASURE_ITEM" )),

-- _wxEVT_MENU_CLOSE
wxEVT_MENU_CLOSE = peek4s( define_c_var( wxWin, "_wxEVT_MENU_CLOSE" )),

-- _wxEVT_MENU_HIGHLIGHT
wxEVT_MENU_HIGHLIGHT = peek4s( define_c_var( wxWin, "_wxEVT_MENU_HIGHLIGHT" )),

-- _wxEVT_MENU_OPEN
wxEVT_MENU_OPEN = peek4s( define_c_var( wxWin, "_wxEVT_MENU_OPEN" )),

-- _wxEVT_MIDDLE_DCLICK
wxEVT_MIDDLE_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_MIDDLE_DCLICK" )),

-- _wxEVT_MIDDLE_DOWN
wxEVT_MIDDLE_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_MIDDLE_DOWN" )),

-- _wxEVT_MIDDLE_UP
wxEVT_MIDDLE_UP = peek4s( define_c_var( wxWin, "_wxEVT_MIDDLE_UP" )),

-- _wxEVT_MOTION
wxEVT_MOTION = peek4s( define_c_var( wxWin, "_wxEVT_MOTION" )),

-- _wxEVT_MOUSEWHEEL
wxEVT_MOUSEWHEEL = peek4s( define_c_var( wxWin, "_wxEVT_MOUSEWHEEL" )),

-- _wxEVT_MOUSE_CAPTURE_CHANGED
wxEVT_MOUSE_CAPTURE_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_MOUSE_CAPTURE_CHANGED" )),

-- _wxEVT_MOVE
wxEVT_MOVE = peek4s( define_c_var( wxWin, "_wxEVT_MOVE" )),

-- _wxEVT_NAVIGATION_KEY
wxEVT_NAVIGATION_KEY = peek4s( define_c_var( wxWin, "_wxEVT_NAVIGATION_KEY" )),

-- _wxEVT_NC_ENTER_WINDOW
wxEVT_NC_ENTER_WINDOW = peek4s( define_c_var( wxWin, "_wxEVT_NC_ENTER_WINDOW" )),

-- _wxEVT_NC_LEAVE_WINDOW
wxEVT_NC_LEAVE_WINDOW = peek4s( define_c_var( wxWin, "_wxEVT_NC_LEAVE_WINDOW" )),

-- _wxEVT_NC_LEFT_DCLICK
wxEVT_NC_LEFT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_NC_LEFT_DCLICK" )),

-- _wxEVT_NC_LEFT_DOWN
wxEVT_NC_LEFT_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_NC_LEFT_DOWN" )),

-- _wxEVT_NC_LEFT_UP
wxEVT_NC_LEFT_UP = peek4s( define_c_var( wxWin, "_wxEVT_NC_LEFT_UP" )),

-- _wxEVT_NC_MIDDLE_DCLICK
wxEVT_NC_MIDDLE_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_NC_MIDDLE_DCLICK" )),

-- _wxEVT_NC_MIDDLE_DOWN
wxEVT_NC_MIDDLE_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_NC_MIDDLE_DOWN" )),

-- _wxEVT_NC_MIDDLE_UP
wxEVT_NC_MIDDLE_UP = peek4s( define_c_var( wxWin, "_wxEVT_NC_MIDDLE_UP" )),

-- _wxEVT_NC_MOTION
wxEVT_NC_MOTION = peek4s( define_c_var( wxWin, "_wxEVT_NC_MOTION" )),

-- _wxEVT_NC_PAINT
wxEVT_NC_PAINT = peek4s( define_c_var( wxWin, "_wxEVT_NC_PAINT" )),

-- _wxEVT_NC_RIGHT_DCLICK
wxEVT_NC_RIGHT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_NC_RIGHT_DCLICK" )),

-- _wxEVT_NC_RIGHT_DOWN
wxEVT_NC_RIGHT_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_NC_RIGHT_DOWN" )),

-- _wxEVT_NC_RIGHT_UP
wxEVT_NC_RIGHT_UP = peek4s( define_c_var( wxWin, "_wxEVT_NC_RIGHT_UP" )),

-- _wxEVT_NULL
wxEVT_NULL = peek4s( define_c_var( wxWin, "_wxEVT_NULL" )),

-- _wxEVT_PAINT
wxEVT_PAINT = peek4s( define_c_var( wxWin, "_wxEVT_PAINT" )),

-- _wxEVT_PAINT_ICON
wxEVT_PAINT_ICON = peek4s( define_c_var( wxWin, "_wxEVT_PAINT_ICON" )),

-- _wxEVT_PALETTE_CHANGED
wxEVT_PALETTE_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_PALETTE_CHANGED" )),

-- _wxEVT_POWER
wxEVT_POWER = peek4s( define_c_var( wxWin, "_wxEVT_POWER" )),

-- _wxEVT_QUERY_END_SESSION
wxEVT_QUERY_END_SESSION = peek4s( define_c_var( wxWin, "_wxEVT_QUERY_END_SESSION" )),

-- _wxEVT_QUERY_LAYOUT_INFO
wxEVT_QUERY_LAYOUT_INFO = peek4s( define_c_var( wxWin, "_wxEVT_QUERY_LAYOUT_INFO" )),

-- _wxEVT_QUERY_NEW_PALETTE
wxEVT_QUERY_NEW_PALETTE = peek4s( define_c_var( wxWin, "_wxEVT_QUERY_NEW_PALETTE" )),

-- _wxEVT_RIGHT_DCLICK
wxEVT_RIGHT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_RIGHT_DCLICK" )),

-- _wxEVT_RIGHT_DOWN
wxEVT_RIGHT_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_RIGHT_DOWN" )),

-- _wxEVT_RIGHT_UP
wxEVT_RIGHT_UP = peek4s( define_c_var( wxWin, "_wxEVT_RIGHT_UP" )),

-- _wxEVT_SASH_DRAGGED
wxEVT_SASH_DRAGGED = peek4s( define_c_var( wxWin, "_wxEVT_SASH_DRAGGED" )),

-- _wxEVT_SCROLLWIN_BOTTOM
wxEVT_SCROLLWIN_BOTTOM = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_BOTTOM" )),

-- _wxEVT_SCROLLWIN_LINEDOWN
wxEVT_SCROLLWIN_LINEDOWN = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_LINEDOWN" )),

-- _wxEVT_SCROLLWIN_LINEUP
wxEVT_SCROLLWIN_LINEUP = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_LINEUP" )),

-- _wxEVT_SCROLLWIN_PAGEDOWN
wxEVT_SCROLLWIN_PAGEDOWN = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_PAGEDOWN" )),

-- _wxEVT_SCROLLWIN_PAGEUP
wxEVT_SCROLLWIN_PAGEUP = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_PAGEUP" )),

-- _wxEVT_SCROLLWIN_THUMBRELEASE
wxEVT_SCROLLWIN_THUMBRELEASE = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_THUMBRELEASE" )),

-- _wxEVT_SCROLLWIN_THUMBTRACK
wxEVT_SCROLLWIN_THUMBTRACK = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_THUMBTRACK" )),

-- _wxEVT_SCROLLWIN_TOP
wxEVT_SCROLLWIN_TOP = peek4s( define_c_var( wxWin, "_wxEVT_SCROLLWIN_TOP" )),

-- _wxEVT_SCROLL_BOTTOM
wxEVT_SCROLL_BOTTOM = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_BOTTOM" )),

-- _wxEVT_SCROLL_ENDSCROLL
wxEVT_SCROLL_ENDSCROLL = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_ENDSCROLL" )),

-- _wxEVT_SCROLL_LINEDOWN
wxEVT_SCROLL_LINEDOWN = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_LINEDOWN" )),

-- _wxEVT_SCROLL_LINEUP
wxEVT_SCROLL_LINEUP = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_LINEUP" )),

-- _wxEVT_SCROLL_PAGEDOWN
wxEVT_SCROLL_PAGEDOWN = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_PAGEDOWN" )),

-- _wxEVT_SCROLL_PAGEUP
wxEVT_SCROLL_PAGEUP = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_PAGEUP" )),

-- _wxEVT_SCROLL_THUMBRELEASE
wxEVT_SCROLL_THUMBRELEASE = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_THUMBRELEASE" )),

-- _wxEVT_SCROLL_THUMBTRACK
wxEVT_SCROLL_THUMBTRACK = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_THUMBTRACK" )),

-- _wxEVT_SCROLL_TOP
wxEVT_SCROLL_TOP = peek4s( define_c_var( wxWin, "_wxEVT_SCROLL_TOP" )),

-- _wxEVT_SETTING_CHANGED
wxEVT_SETTING_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_SETTING_CHANGED" )),

-- _wxEVT_SET_CURSOR
wxEVT_SET_CURSOR = peek4s( define_c_var( wxWin, "_wxEVT_SET_CURSOR" )),

-- _wxEVT_SET_FOCUS
wxEVT_SET_FOCUS = peek4s( define_c_var( wxWin, "_wxEVT_SET_FOCUS" )),

-- _wxEVT_SHOW
wxEVT_SHOW = peek4s( define_c_var( wxWin, "_wxEVT_SHOW" )),

-- _wxEVT_SIZE
wxEVT_SIZE = peek4s( define_c_var( wxWin, "_wxEVT_SIZE" )),

-- _wxEVT_SOCKET
wxEVT_SOCKET = peek4s( define_c_var( wxWin, "_wxEVT_SOCKET" )),

-- _wxEVT_SYS_COLOUR_CHANGED
wxEVT_SYS_COLOUR_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_SYS_COLOUR_CHANGED" )),

-- _wxEVT_TASKBAR_LEFT_DCLICK
wxEVT_TASKBAR_LEFT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_LEFT_DCLICK" )),

-- _wxEVT_TASKBAR_LEFT_DOWN
wxEVT_TASKBAR_LEFT_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_LEFT_DOWN" )),

-- _wxEVT_TASKBAR_LEFT_UP
wxEVT_TASKBAR_LEFT_UP = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_LEFT_UP" )),

-- _wxEVT_TASKBAR_MOVE
wxEVT_TASKBAR_MOVE = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_MOVE" )),

-- _wxEVT_TASKBAR_RIGHT_DCLICK
wxEVT_TASKBAR_RIGHT_DCLICK = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_RIGHT_DCLICK" )),

-- _wxEVT_TASKBAR_RIGHT_DOWN
wxEVT_TASKBAR_RIGHT_DOWN = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_RIGHT_DOWN" )),

-- _wxEVT_TASKBAR_RIGHT_UP
wxEVT_TASKBAR_RIGHT_UP = peek4s( define_c_var( wxWin, "_wxEVT_TASKBAR_RIGHT_UP" )),

-- _wxEVT_TIMER
wxEVT_TIMER = peek4s( define_c_var( wxWin, "_wxEVT_TIMER" )),

-- _wxEVT_UPDATE_UI
wxEVT_UPDATE_UI = peek4s( define_c_var( wxWin, "_wxEVT_UPDATE_UI" )),

-- _wxEVT_WIZARD_CANCEL
wxEVT_WIZARD_CANCEL = peek4s( define_c_var( wxWin, "_wxEVT_WIZARD_CANCEL" )),

-- _wxEVT_WIZARD_FINISHED
wxEVT_WIZARD_FINISHED = peek4s( define_c_var( wxWin, "_wxEVT_WIZARD_FINISHED" )),

-- _wxEVT_WIZARD_HELP
wxEVT_WIZARD_HELP = peek4s( define_c_var( wxWin, "_wxEVT_WIZARD_HELP" )),

-- _wxEVT_WIZARD_PAGE_CHANGED
wxEVT_WIZARD_PAGE_CHANGED = peek4s( define_c_var( wxWin, "_wxEVT_WIZARD_PAGE_CHANGED" )),

-- _wxEVT_WIZARD_PAGE_CHANGING
wxEVT_WIZARD_PAGE_CHANGING = peek4s( define_c_var( wxWin, "_wxEVT_WIZARD_PAGE_CHANGING" )),

-- _wxEmptyString
wxEmptyString = define_c_var( wxWin, "_wxEmptyString" ),

-- _wxEnhDialogNameStr
wxEnhDialogNameStr = define_c_var( wxWin, "_wxEnhDialogNameStr" ),

-- _wxFalse
wxFalse = define_c_var( wxWin, "_wxFalse" ),

-- _wxFileSelectorDefaultWildcardStr
wxFileSelectorDefaultWildcardStr = define_c_var( wxWin, "_wxFileSelectorDefaultWildcardStr" ),

-- _wxFileSelectorPromptStr
wxFileSelectorPromptStr = define_c_var( wxWin, "_wxFileSelectorPromptStr" ),

-- _wxFloatToStringStr
wxFloatToStringStr = define_c_var( wxWin, "_wxFloatToStringStr" ),

-- _wxFormatInvalid
wxFormatInvalid = define_c_var( wxWin, "_wxFormatInvalid" ),

-- _wxFrameNameStr
wxFrameNameStr = define_c_var( wxWin, "_wxFrameNameStr" ),

-- _wxGREEN
wxGREEN = peek4s( define_c_var( wxWin, "_wxGREEN" )),

-- _wxGREEN_BRUSH
wxGREEN_BRUSH = peek4s( define_c_var( wxWin, "_wxGREEN_BRUSH" )),

-- _wxGREEN_PEN
wxGREEN_PEN = peek4s( define_c_var( wxWin, "_wxGREEN_PEN" )),

-- _wxGREY_BRUSH
wxGREY_BRUSH = peek4s( define_c_var( wxWin, "_wxGREY_BRUSH" )),

-- _wxGREY_PEN
wxGREY_PEN = peek4s( define_c_var( wxWin, "_wxGREY_PEN" )),

-- _wxGaugeNameStr
wxGaugeNameStr = define_c_var( wxWin, "_wxGaugeNameStr" ),

-- _wxGetInstance
wxGetInstance = define_c_var( wxWin, "_wxGetInstance" ),

-- _wxGetTextFromUserPromptStr
wxGetTextFromUserPromptStr = define_c_var( wxWin, "_wxGetTextFromUserPromptStr" ),

-- _wxGridNoCellCoords
wxGridNoCellCoords = define_c_var( wxWin, "_wxGridNoCellCoords" ),

-- _wxGridNoCellRect
wxGridNoCellRect = define_c_var( wxWin, "_wxGridNoCellRect" ),

-- _wxHOURGLASS_CURSOR
wxHOURGLASS_CURSOR = peek4s( define_c_var( wxWin, "_wxHOURGLASS_CURSOR" )),

-- _wxITALIC_FONT
wxITALIC_FONT = peek4s( define_c_var( wxWin, "_wxITALIC_FONT" )),

-- _wxLIGHT_GREY
wxLIGHT_GREY = peek4s( define_c_var( wxWin, "_wxLIGHT_GREY" )),

-- _wxLIGHT_GREY_BRUSH
wxLIGHT_GREY_BRUSH = peek4s( define_c_var( wxWin, "_wxLIGHT_GREY_BRUSH" )),

-- _wxLIGHT_GREY_PEN
wxLIGHT_GREY_PEN = peek4s( define_c_var( wxWin, "_wxLIGHT_GREY_PEN" )),

-- _wxListBoxNameStr
wxListBoxNameStr = define_c_var( wxWin, "_wxListBoxNameStr" ),

-- _wxMEDIUM_GREY_BRUSH
wxMEDIUM_GREY_BRUSH = peek4s( define_c_var( wxWin, "_wxMEDIUM_GREY_BRUSH" )),

-- _wxMEDIUM_GREY_PEN
wxMEDIUM_GREY_PEN = peek4s( define_c_var( wxWin, "_wxMEDIUM_GREY_PEN" )),

-- _wxMessageBoxCaptionStr
wxMessageBoxCaptionStr = define_c_var( wxWin, "_wxMessageBoxCaptionStr" ),

-- _wxModelessWindows
wxModelessWindows = define_c_var( wxWin, "_wxModelessWindows" ),

-- _wxMultiTextNameStr
wxMultiTextNameStr = define_c_var( wxWin, "_wxMultiTextNameStr" ),

-- _wxNORMAL_FONT
wxNORMAL_FONT = peek4s( define_c_var( wxWin, "_wxNORMAL_FONT" )),

-- _wxNullAcceleratorTable
wxNullAcceleratorTable = define_c_var( wxWin, "_wxNullAcceleratorTable" ),

-- _wxNullBitmap
wxNullBitmap = define_c_var( wxWin, "_wxNullBitmap" ),

-- _wxNullBrush
wxNullBrush = define_c_var( wxWin, "_wxNullBrush" ),

-- _wxNullColour
wxNullColour = define_c_var( wxWin, "_wxNullColour" ),

-- _wxNullCursor
wxNullCursor = define_c_var( wxWin, "_wxNullCursor" ),

-- _wxNullFont
wxNullFont = define_c_var( wxWin, "_wxNullFont" ),

-- _wxNullIcon
wxNullIcon = define_c_var( wxWin, "_wxNullIcon" ),

-- _wxNullImage
wxNullImage = define_c_var( wxWin, "_wxNullImage" ),

-- _wxNullPalette
wxNullPalette = define_c_var( wxWin, "_wxNullPalette" ),

-- _wxNullPen
wxNullPen = define_c_var( wxWin, "_wxNullPen" ),

-- _wxNullVariant
wxNullVariant = define_c_var( wxWin, "_wxNullVariant" ),

-- _wxPageNumber
wxPageNumber = define_c_var( wxWin, "_wxPageNumber" ),

-- _wxPanelNameStr
wxPanelNameStr = define_c_var( wxWin, "_wxPanelNameStr" ),

-- _wxPendingDelete
wxPendingDelete = define_c_var( wxWin, "_wxPendingDelete" ),

-- _wxRED
wxRED = peek4s( define_c_var( wxWin, "_wxRED" )),

-- _wxRED_BRUSH
wxRED_BRUSH = peek4s( define_c_var( wxWin, "_wxRED_BRUSH" )),

-- _wxRED_PEN
wxRED_PEN = peek4s( define_c_var( wxWin, "_wxRED_PEN" )),

-- _wxRadioBoxNameStr
wxRadioBoxNameStr = define_c_var( wxWin, "_wxRadioBoxNameStr" ),

-- _wxRadioButtonNameStr
wxRadioButtonNameStr = define_c_var( wxWin, "_wxRadioButtonNameStr" ),

-- _wxSMALL_FONT
wxSMALL_FONT = peek4s( define_c_var( wxWin, "_wxSMALL_FONT" )),

-- _wxSTANDARD_CURSOR
wxSTANDARD_CURSOR = peek4s( define_c_var( wxWin, "_wxSTANDARD_CURSOR" )),

-- _wxSTD_FRAME_ICON
wxSTD_FRAME_ICON = peek4s( define_c_var( wxWin, "_wxSTD_FRAME_ICON" )),

-- _wxSTD_MDICHILDFRAME_ICON
wxSTD_MDICHILDFRAME_ICON = peek4s( define_c_var( wxWin, "_wxSTD_MDICHILDFRAME_ICON" )),

-- _wxSTD_MDIPARENTFRAME_ICON
wxSTD_MDIPARENTFRAME_ICON = peek4s( define_c_var( wxWin, "_wxSTD_MDIPARENTFRAME_ICON" )),

-- _wxSWISS_FONT
wxSWISS_FONT = peek4s( define_c_var( wxWin, "_wxSWISS_FONT" )),

-- _wxScrollBarNameStr
wxScrollBarNameStr = define_c_var( wxWin, "_wxScrollBarNameStr" ),

-- _wxSliderNameStr
wxSliderNameStr = define_c_var( wxWin, "_wxSliderNameStr" ),

-- _wxStaticBitmapNameStr
wxStaticBitmapNameStr = define_c_var( wxWin, "_wxStaticBitmapNameStr" ),

-- _wxStaticBoxNameStr
wxStaticBoxNameStr = define_c_var( wxWin, "_wxStaticBoxNameStr" ),

-- _wxStaticNameStr
wxStaticNameStr = define_c_var( wxWin, "_wxStaticNameStr" ),

-- _wxStaticTextNameStr
wxStaticTextNameStr = define_c_var( wxWin, "_wxStaticTextNameStr" ),

-- _wxStatusLineNameStr
wxStatusLineNameStr = define_c_var( wxWin, "_wxStatusLineNameStr" ),

-- _wxTRANSPARENT_BRUSH
wxTRANSPARENT_BRUSH = peek4s( define_c_var( wxWin, "_wxTRANSPARENT_BRUSH" )),

-- _wxTRANSPARENT_PEN
wxTRANSPARENT_PEN = peek4s( define_c_var( wxWin, "_wxTRANSPARENT_PEN" )),

-- _wxTextCtrlNameStr
wxTextCtrlNameStr = define_c_var( wxWin, "_wxTextCtrlNameStr" ),

-- _wxTextCtrlWindowNameStr
wxTextCtrlWindowNameStr = define_c_var( wxWin, "_wxTextCtrlWindowNameStr" ),

-- _wxTheApp
wxTheApp = define_c_var( wxWin, "_wxTheApp" ),

-- _wxTheBitmapList
wxTheBitmapList = define_c_var( wxWin, "_wxTheBitmapList" ),

-- _wxTheBrushList
wxTheBrushList = define_c_var( wxWin, "_wxTheBrushList" ),

-- _wxTheClipboard
wxTheClipboard = define_c_var( wxWin, "_wxTheClipboard" ),

-- _wxTheColourDatabase
wxTheColourDatabase = define_c_var( wxWin, "_wxTheColourDatabase" ),

-- _wxTheFontList
wxTheFontList = define_c_var( wxWin, "_wxTheFontList" ),

-- _wxTheMimeTypesManager
wxTheMimeTypesManager = define_c_var( wxWin, "_wxTheMimeTypesManager" ),

-- _wxThePenList
wxThePenList = define_c_var( wxWin, "_wxThePenList" ),

-- _wxThePrintPaperDatabase
wxThePrintPaperDatabase = define_c_var( wxWin, "_wxThePrintPaperDatabase" ),

-- _wxToolBarNameStr
wxToolBarNameStr = define_c_var( wxWin, "_wxToolBarNameStr" ),

-- _wxTopLevelWindows
wxTopLevelWindows = define_c_var( wxWin, "_wxTopLevelWindows" ),

-- _wxTreeCtrlNameStr
wxTreeCtrlNameStr = define_c_var( wxWin, "_wxTreeCtrlNameStr" ),

-- _wxUserResourceStr
wxUserResourceStr = define_c_var( wxWin, "_wxUserResourceStr" ),

-- _wxVirtListBoxNameStr
wxVirtListBoxNameStr = define_c_var( wxWin, "_wxVirtListBoxNameStr" ),

-- _wxWHITE
wxWHITE = peek4s( define_c_var( wxWin, "_wxWHITE" )),

-- _wxWHITE_BRUSH
wxWHITE_BRUSH = peek4s( define_c_var( wxWin, "_wxWHITE_BRUSH" )),

-- _wxWHITE_PEN
wxWHITE_PEN = peek4s( define_c_var( wxWin, "_wxWHITE_PEN" )),

-- _wxhInstance
wxhInstance = define_c_var( wxWin, "_wxhInstance" ),LAST_constant = 0

-- end class constant
------------------------------

-- end autogenerated
------------------------------

global constant wxTrue = not wxFalse

--/topic Classes
--/func is_kind( atom this, atom kind )
--
--Check to see if an object belongs to a certain class. /b kind is the
--/b sm_class... constant for the class in question.

global function is_kind( atom this, atom kind )
	atom info, is
--      info = call_member( wxObject_GetClassInfo, this, {})
	info = call_member( peek4u( peek4u( this ) ), this, {})
	is = call_member( wxClassInfo_IsKindOf, kind, {info}) --info, {kind})
	return is
end function


--/topic Developer's Notes
--/proc log_message( sequence f, object a )
--
--Calls wxLogMessage.  The first call to log_message in an application will create a file
--named wlog.txt.  You may change this by changing the global sequence log_file.  
--
--The arguments to log_message are the same as you would use with sprintf().  It is not
--necessary to add a newline to the message, as wxLogMessage does this automatically.
--/code
-- ex:
--     log_message( "The value is %d", 5 )
--/endcode

integer msgnum
msgnum = 0
global sequence log_file
log_file = "wlog.txt"
global procedure log_message( sequence f, object a )
	atom ptr
	sequence p

	if not msgnum then
		ptr = allocate_string( log_file )

		void = c_func( eulog, {ptr})
		free(ptr)
	end if

	p = {}
	if atom(a) then
		a = {a}
	end if
	
	for i = 1 to length(a) do
		if sequence(a[i]) then
			ptr = allocate_string( a[i] )
			p &= ptr
			a[i] = ptr
		end if
	end for

	ptr = allocate_string( "(%d - %08x: %08x %d): " & f )
	void = call_cdecl( wxLogMessage, ptr & msgnum & wxLogMessage & ptr & length(a) & a )
	msgnum += 1
	free(ptr)
	for i = 1 to length(p) do
		free(p[i])
	end for
end procedure

--#WIN32

global constant

		wxEVT_COMMAND_TOOL_CLICKED = wxEVT_COMMAND_MENU_SELECTED,
		wxEVT_FIRST = 10000,
		wxEVT_USER_FIRST = wxEVT_FIRST + 2000
--#ENDWIN32

--/topic wxString
--/proc deref_string( atom string )
--
--Decrements the reference count on a /wxString.  This will free
--the data held by the /wxString, but will not free the /wxString
--pointer itself.  This is called automatically by /delete_string().

--#WIN32
constant wxDebugFree = define_c_proc( wxWin, "+@wxDebugFree$qpvo", {C_POINTER, C_INT})
--#ENDWIN32
global procedure deref_string( atom string )
	atom data, refs

	data = peek4u(string)-12
	refs = peek4s(data)
	
	if refs = 1 then
--#LINUX
--		free(data)
--#ENDLINUX
--#WIN32
		-- wxWidgets allocated this memory, and it will sometimes
		-- error out if it doesn't get to free it, too.
		c_proc( wxDebugFree, {data, 0})
--#ENDWIN32
	elsif refs > 1 then
		poke4( data, refs - 1 )
	end if
	
end procedure

--/topic wxString
--/proc delete_string( atom string )
--
--This is a faster way to delete a string.  It is the routine that 
--is called by /delete_instance(), but with a lot less overhead.
--If you need to delete many strings, it is better to use delete_string()
--rather than /delete_instance(), however, you are unlikely to see much
--difference for one or two deletions.

global procedure delete_string( atom string )
	deref_string( string )
	deref_instance( string )
	free(string)
end procedure
set_destructor( wxString, routine_id("delete_string"))

global constant
	wxITEM_SEPARATOR = -1,
	wxITEM_NORMAL = 0,
	wxITEM_CHECK = 1,
	wxITEM_RADIO = 2,
	wxITEM_MAX = 3,
wxCallback = derived_class( "wxCallback", wxObject, wxWin, {}, sizeof_wxObject + 4 )


sequence events
atom event_handler_cb

events = {{},{}}
global atom myApp_this
myApp_this = 0


integer paint_ok
paint_ok = 1
global procedure disable_paint()
	paint_ok = 0
end procedure

global procedure enable_paint()
	events_ok = 1
end procedure

-- events:
--        [1]  sequence of 'this' pointers (wxEvtHandler's)
--        [2]  corresponding event handler data
--           [ix] (this pointer index)
--               [1] event types
--               [2] corresponding event handler data
--                  [jx] (event type index)
--                      [1] ids...
--                      [2] rids...
constant user_data = 0 -- allocate( 4 ) poke4( user_data, 0 )

global procedure set_event_handler( object this, object id, object event, integer rid )
	integer ix, jx, kx
	atom event_object
	
	if rid = -1 then
		return
	end if
	
	if atom(event) then
		event = {event}
	end if
	
	if atom(this) then
		event_object = this
	else
		if platform() = LINUX then
		    event_object = this[2]
		else
		    event_object = this[1]
		end if
		this = this[1]
	end if
	
	if atom(id) then
		id = {id}
	end if
	
	ix = find(event_object, events[1] )
	if not ix  then
		events[1] = append(events[1], event_object )
		events[2] = append(events[2], { {}, {}})
		ix = length(events[1])
	end if
	
	for i = 1  to length(event)  do
	if event[i] = wxEVT_TIMER then
	    ix = find( -wxEVT_TIMER, events[1] )
	    if not ix then
			events[1] &= -wxEVT_TIMER
			events[2] = append(events[2], { {}, {}})
			ix = length(events[1])
	    end if
	else
	    ix = find( event_object, events[1] )
	end if
	jx = find( event[i], events[2][ix][1] )
	if not jx then
	    events[2][ix][1] &= event[i]
	    events[2][ix][2] = append( events[2][ix][2], {{},{}} )
	    jx = length(events[2][ix][1])
	end if      
	
	for j = 1 to length(id)  do
	    kx = find( id[j], events[2][ix][2][jx][1] )
	    if not kx then
			events[2][ix][2][jx][1] &= id
			events[2][ix][2][jx][2] &= repeat(rid, length(id))
	    else
			events[2][ix][2][jx][2][kx] = rid
	    end if
	    void = call_member( wxEvtHandler_Connect, this,{ id[j], id[j], event[i],
			event_handler_cb, this})
	end for
	end for
end procedure

atom third, event 
event = -2
third = -1

function event_handler( atom this , atom event )
	sequence ev
	integer ix, event_type
	atom id, event_object
	if not events_ok then 
		return -1
	end if

	event_type = call_member( wxEvent_GetEventType, event, {0})

	if event_type = wxEVT_TIMER then
		event_object = -wxEVT_TIMER
	else
--#LINUX
--		event_object = call_member( wxEvent_GetEventObject, event, {})
--#ENDLINUX
--#WIN32
		event_object = this
--#ENDWIN32
	end if
	
	if event_type = wxEVT_PAINT and not paint_ok then
		return -2
	end if
	
	if not event_object then
		-- wxTimer's don't have one, so it should just be:
		event_object = this
	end if
	id = call_member_s( wxEvent_GetId, event, {0})
	ev = events
	ix = find(event_object, ev[1] )
	if not ix then
		return -3
	end if

	-- event handler data for 'this'
	ev = ev[2][ix]

	ix = find(event_type, ev[1] )
	if not ix then
		return -4
	end if

	-- id's and rid's for event_type
	ev = ev[2][ix]

	-- find the id...
	ix = find(id, ev[1])
	if not ix then
	ix = find(-1, ev[1])
		if not ix then
		    return -5
		end if
	end if

	call_proc( ev[2][ix], {event_object, event_type, id, event })

	return 1
end function

event_handler_cb = call_back( '+' & routine_id("event_handler"))


-- Introduction
------------------

--/topic Introduction
--/info
--
--<a href="http://wxeuphoria.sourceforge.net">wxEuphoria v0.9.0</a><br>
--Wrapper for wxWidgets<br>
--by Matt Lewis<br>
--<a href="mailto:matthewwalkerlewis@gmail.com">matthewwalkerlewis@gmail.com</a><br>
--<a href="http://www14.brinkster.com/matthewlewis">http://www14.brinkster.com/matthewlewis</a><br>
--<br><br>
--wxEuphoria is an implementation of <a href="http://www.wxwidgets.org">wxWidgets</a> by Julian
--Smart, et. al. for Euphoria.  wxWidgets is a cross platform GUI library.
--The wxWidgets library is compiled into a DLL/SO, and is linked
--to by Euphoria code.
--
--/b "This version of wxEuphoria requires library build #9."
--
--wxEuphoria is licensed under the wxWidgets license (see the license folder).<br><br>
--/code
--DISCLAIMER:
--THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, 
--INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY 
--AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE 
--AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, 
--OR CONSEQUENTIAL DAMGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
--SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFIT; OR BUSINESS 
--INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
--CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
--ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
--POSSIBILITY OF SUCH DAMAGE. 
--/endcode
--<h3>Other licensing issues</h3>
--<ul>
--/li Please see /b "license\tiff-copyright.txt" for libtiff license details
--/li This software is based in part on the work of the Independent JPEG Group. See /b "license\jpeg-readme.txt"
--/li Regarding the implementation of /b wxRegEx:
--
--<ul>
--Copyright 1992, 1993, 1994, 1997 Henry Spencer.  All rights reserved.
--This software is not subject to any license of the American Telephone
--and Telegraph Company or of the Regents of the University of California.
--
--Permission is granted to anyone to use this software for any purpose on
--any computer system, and to alter it and redistribute it, subject
--to the following restrictions:
--
--<ol>
--/li The author is not responsible for the consequences of use of this
--   software, no matter how awful, even if they arise from flaws in it.
--/li The origin of this software must not be misrepresented, either by
--explicit claim or by omission.  Since few users ever read sources,
--credits must appear in the documentation.
--/li Altered versions must be plainly marked as such, and must not be
--misrepresented as being the original software.  Since few users
--ever read sources, credits must appear in the documentation.
--/li This notice may not be removed or altered.
--</ol></ul></ul>
--/code
--Files Included:
-- * Documentation
--   + wxEuphoria.htm
--   + install.txt
-- * Licenses
--   + gpl
--   + jpeg-readme.txt
--   + lgpl.txt
--   + licence.txt
--   + tiff-copyright.txt
-- * Library:
--   + cplusplus.e
--   + wxButton.e
--   + wxCalendar.e
--   + wxCheckBox.e
--   + wxClassInfo.e
--   + wxControl.e
--   + wxData.e
--   + wxDialog.e
--   + wxEuphoria.e
--   + wxFile.e
--   + wxGraphics.e
--   + wxGrid.e
--   + wxHtml.e
--   + wxList.e
--   + wxLowLevel.e
--   + wxMenu.e
--   + wxNet.e
--   + wxNotebook.e
--   + wxScrollbar.e
--   + wxSizer.e
--   + wxStatic.e
--   + wxStatusBar.e
--   + wxText.e
--   + wxTimer.e 
--   + wxToolBar.e
--   + wxTreeCtrl.e
-- * Demos: see the demo subdirectory
--
--Files not included (with library source)
-- * wxeu.dll
-- * wxeu.so
--* wxWidgets source code and documentation (go to <a href="http://www.wxwidgets.org">www.wxwidgets.org</a>)
-- * wxEuphoria modifications to wxWidgets source code (see the wxEuphoria developers package)
-- * Euphoria v2.5
--/endcode

include machine.e

--/topic Utilities
--/func wx_or_all( sequence a )
--
--Executes a bitwise /b or operation on a sequence of atoms.  Use this to convert
--from a C/C++ style:
--/code
--    THING1|THING2|THING3
--
--    wx_or_all( THING1 & THING2 & THING3 )
--/endcode
--
global function wx_or_all( sequence a )
	atom x
	x = a[1]
	for i = 2 to length( a ) do
		x = or_bits( x, a[i] )
	end for
	return x
end function

global constant
wxID_SEPARATOR	= (-1),

-- Standard menu IDs
wxID_LOWEST 					 = 4999,

wxID_OPEN						 = 5000,
wxID_CLOSE						 = 5001,
wxID_NEW						 = 5002,
wxID_SAVE						 = 5003,
wxID_SAVEAS 					 = 5004,
wxID_REVERT 					 = 5005,
wxID_EXIT						 = 5006,
wxID_UNDO						 = 5007,
wxID_REDO						 = 5008,
wxID_HELP						 = 5009,
wxID_PRINT						 = 5010,
wxID_PRINT_SETUP				 = 5011,
wxID_PREVIEW					 = 5012,
wxID_ABOUT						 = 5013,
wxID_HELP_CONTENTS				 = 5014,
wxID_HELP_COMMANDS				 = 5015,
wxID_HELP_PROCEDURES 			 = 5016,
wxID_HELP_CONTEXT				 = 5017,

wxID_CUT						 = 5030,
wxID_COPY						 = 5031,
wxID_PASTE						 = 5032,
wxID_CLEAR						 = 5033,
wxID_FIND						 = 5034,
wxID_DUPLICATE					 = 5035,
wxID_SELECTALL					 = 5036,

wxID_FILE1						 = 5050,
wxID_FILE2						 = 5051,
wxID_FILE3						 = 5052,
wxID_FILE4						 = 5053,
wxID_FILE5						 = 5054,
wxID_FILE6						 = 5055,
wxID_FILE7						 = 5056,
wxID_FILE8						 = 5057,
wxID_FILE9						 = 5058,

-- Standard button IDs
wxID_OK 						 = 5100,
wxID_CANCEL 					 = 5101,
wxID_APPLY						 = 5102,
wxID_YES						 = 5103,
wxID_NO 						 = 5104,
wxID_STATIC 					 = 5105,
wxID_FORWARD					 = 5106,
wxID_BACKWARD					 = 5107,
wxID_DEFAULT					 = 5108,
wxID_MORE						 = 5109,
wxID_SETUP						 = 5110,
wxID_RESET						 = 5111,

-- IDs used by generic file dialog (11 consecutive starting from this value)
wxID_FILEDLGG					 = 5900,
wxID_HIGHEST					 = 5999,

-- IDs
--------------------

--/topic IDs
--/parent Controls
--/info
--
--Most operations in wxEuphoria are done using /i this pointers to objects (the value returned
--by /create().  Some things, such as events, however, require that control IDs be used.  It is 
--recommended that you create your controls with the default ID of -1, and allow wxWidgets to 
--automatically generate a unique id for you.  IDs are generated starting at -201 and decrease
--from there.  You can use /get_id() or /get_menuitem_id() to determine IDs when necessary.<br><br>
--There are some IDs, however, that have been set aside for specific uses, and will often be 
--used for menu items or command buttons.  Here is a list:
--
--/b "Standard menu IDs"
--<ul>
--/li wxID_LOWEST
--/li wxID_OPEN
--/li wxID_CLOSE
--/li wxID_NEW
--/li wxID_SAVE
--/li wxID_SAVEAS
--/li wxID_REVERT
--/li wxID_EXIT  
--/li wxID_UNDO  
--/li wxID_REDO  
--/li wxID_HELP  
--/li wxID_PRINT 
--/li wxID_PRINT_SETUP
--/li wxID_PREVIEW    
--/li wxID_ABOUT      
--/li wxID_HELP_CONTENTS
--/li wxID_HELP_COMMANDS   
--/li wxID_HELP_PROCEDURES 
--/li wxID_HELP_CONTEXT    
--/li wxID_CUT             
--/li wxID_COPY            
--/li wxID_PASTE           
--/li wxID_CLEAR           
--/li wxID_FIND            
--/li wxID_DUPLICATE       
--/li wxID_SELECTALL       
--/li wxID_FILE1           
--/li wxID_FILE2           
--/li wxID_FILE3           
--/li wxID_FILE4           
--/li wxID_FILE5           
--/li wxID_FILE6           
--/li wxID_FILE7           
--/li wxID_FILE8           
--/li wxID_FILE9
--</ul>
--/b Standard /b button /b IDs
--<ul>
--/li wxID_OK              
--/li wxID_CANCEL          
--/li wxID_APPLY           
--/li wxID_YES             
--/li wxID_NO              
--/li wxID_STATIC          
--/li wxID_FORWARD         
--/li wxID_BACKWARD        
--/li wxID_DEFAULT         
--/li wxID_MORE            
--/li wxID_SETUP           
--/li wxID_RESET           
--</ul>
-- /b "IDs used by generic file dialog (11 consecutive starting from this value)"
--<ul>
--/li wxID_FILEDLGG        
--/li wxID_HIGHEST
--</ul>

wxVSCROLL						= #80000000,
wxHSCROLL						= #40000000,
wxCAPTION						= #20000000,

-- New styles
wxDOUBLE_BORDER 				= #10000000,
wxSUNKEN_BORDER 				= #08000000,
wxRAISED_BORDER 				= #04000000,
wxBORDER						= #02000000,
wxSIMPLE_BORDER 				= wxBORDER,
wxSTATIC_BORDER 				= #01000000,
wxTRANSPARENT_WINDOW			= #00100000,
wxNO_BORDER 					= #00200000,

-- Override CTL3D etc. control colour processing to allow own background
-- colour.
-- Override CTL3D or native 3D styles for children
wxNO_3D 						= #00800000,

-- Clip children when painting, which reduces flicker in e.g. frames and
-- splitter windows, but can't be used in a panel where a static box must be
-- 'transparent' (panel paints the background for it)
wxCLIP_CHILDREN 				= #00400000,

-- Add this style to a panel to get tab traversal working outside of dialogs
-- (on by default for wxPanel, wxDialog, wxScrolledWindow)
wxTAB_TRAVERSAL 				= #00080000,

-- Add this style if the control wants to get all keyboard messages (under
-- Windows, it won't normally get the dialog navigation key events)
wxWANTS_CHARS					= #00040000,

-- Make window retained (mostly Motif, I think)
wxRETAINED						= #00020000,
wxBACKINGSTORE					= wxRETAINED,

-- don't invalidate the whole window (resulting in a PAINT event) when the
-- window is resized (currently, makes sense for wxMSW only)
wxNO_FULL_REPAINT_ON_RESIZE 	= #00010000,

-- * Extra window style flags (use wxWS_EX prefix to make it clear that they
-- * should be passed to wxWindow::SetExtraStyle(), not SetWindowStyle())
-- by default, TransferDataTo/FromWindow() only work on direct children of the
-- window (compatible behaviour), set this flag to make them recursively
-- descend into all subwindows
wxWS_EX_VALIDATE_RECURSIVELY	= #00000001,

-- * wxFrame/wxDialog style flags
wxSTAY_ON_TOP					= #8000,
wxICONIZE						= #4000,
wxMINIMIZE						= wxICONIZE,
wxMAXIMIZE						= #2000,
-- free value: 0x1000
wxSYSTEM_MENU					= #0800,
wxMINIMIZE_BOX					= #0400,
wxMAXIMIZE_BOX					= #0200,
wxTINY_CAPTION_HORIZ			= #0100,
wxTINY_CAPTION_VERT				= #0080,
wxRESIZE_BORDER 				= #0040,

-- Add for normal Windows frame behaviour
wxFRAME_FLOAT_ON_PARENT 		= #0020,

-- * MDI parent frame style flags
-- * Can overlap with some of the above.
wxFRAME_NO_WINDOW_MENU			= #0100,

wxDEFAULT_FRAME_STYLE = wx_or_all({wxSYSTEM_MENU, wxRESIZE_BORDER, wxMINIMIZE_BOX, wxMAXIMIZE_BOX,
	wxCAPTION, wxCLIP_CHILDREN}),

wxDEFAULT_DIALOG_STYLE	= wx_or_all({wxSYSTEM_MENU, wxCAPTION}),
--  Under Unix, the dialogs don't have a system menu. Specifying wxSYSTEM_MENU
--  here will make a close button appear.
--#   define wxDEFAULT_DIALOG_STYLE  wxCAPTION

-- * wxExtDialog style flags
wxED_CLIENT_MARGIN				= #0004,
wxED_BUTTONS_BOTTOM				= #0000, --   has no effect
wxED_BUTTONS_RIGHT				= #0002,
wxED_STATIC_LINE				= #0001,

--#if defined(__WXMSW__) || defined(__WXMAC__)
wxEXT_DIALOG_STYLE = wx_or_all ({wxDEFAULT_DIALOG_STYLE,wxED_CLIENT_MARGIN}),
--#else
--#   define wxEXT_DIALOG_STYLE  (wxDEFAULT_DIALOG_STYLE|wxED_CLIENT_MARGIN|wxED_STATIC_LINE)


wxOK							= #00000004,
wxYES_NO						= #0000000A,
wxCANCEL						= #00000010,
wxYES							= #00000002,
wxNO							= #00000008,
wxNO_DEFAULT					= #00000080,
wxYES_DEFAULT					= #00000000,  -- has no effect
wxICON_EXCLAMATION				= #00000100,
wxICON_HAND 					= #00000200,
wxICON_WARNING					= wxICON_EXCLAMATION,
wxICON_ERROR					= wxICON_HAND,
wxICON_QUESTION 				= #00000400,
wxICON_INFORMATION				= #00000800,
wxICON_STOP 					= wxICON_HAND,
wxICON_ASTERISK 				= wxICON_INFORMATION,
wxICON_MASK 					= wx_or_all({#00000100,#00000200,#00000400,#00000800}),

wxLEFT							= #0010,
wxRIGHT 						= #0020,
wxUP							= #0040,
wxDOWN							= #0080,

wxTOP							= wxUP,
wxBOTTOM						= wxDOWN,

wxNORTH 						= wxUP,
wxSOUTH 						= wxDOWN,
wxWEST							= wxLEFT,
wxEAST							= wxRIGHT,

wxALL							= (wxUP + wxDOWN + wxRIGHT + wxLEFT),

wxALIGN_NOT 					= #0000,
wxALIGN_CENTER_HORIZONTAL 		= #0100,
wxALIGN_CENTRE_HORIZONTAL 		= wxALIGN_CENTER_HORIZONTAL,
wxALIGN_LEFT					= wxALIGN_NOT,
wxALIGN_TOP 					= wxALIGN_NOT,
wxALIGN_RIGHT					= #0200,
wxALIGN_BOTTOM					= #0400,
wxALIGN_CENTER_VERTICAL   		= #0800,
wxALIGN_CENTRE_VERTICAL   		= wxALIGN_CENTER_VERTICAL,
wxALIGN_CENTER					= wx_or_all( {wxALIGN_CENTER_HORIZONTAL, wxALIGN_CENTER_VERTICAL}),

wxHORIZONTAL					= #0004,
wxVERTICAL						= #0008,
wxBOTH							= wxVERTICAL + wxHORIZONTAL,

wxSTRETCH_NOT					= #0000,
wxSHRINK						= #1000,
wxGROW							= #2000,
wxEXPAND						= wxGROW,
wxSHAPED						= #4000,

wxSYS_WHITE_BRUSH				= 0,
wxSYS_LTGRAY_BRUSH				= 1,
wxSYS_GRAY_BRUSH				= 2,
wxSYS_DKGRAY_BRUSH				= 3,
wxSYS_BLACK_BRUSH				= 4,
wxSYS_NULL_BRUSH				= 5,
wxSYS_HOLLOW_BRUSH				= wxSYS_NULL_BRUSH,
wxSYS_WHITE_PEN 				= 6,
wxSYS_BLACK_PEN 				= 7,
wxSYS_NULL_PEN					= 8,
wxSYS_OEM_FIXED_FONT	 		= 10,
wxSYS_ANSI_FIXED_FONT	 		= 11,
wxSYS_ANSI_VAR_FONT 	 		= 12,
wxSYS_SYSTEM_FONT				= 13,
wxSYS_DEVICE_DEFAULT_FONT		= 14,
wxSYS_DEFAULT_PALETTE	 		= 15,
wxSYS_SYSTEM_FIXED_FONT  		= 16,
wxSYS_DEFAULT_GUI_FONT	 		= 17,

wxSYS_COLOUR_SCROLLBAR			= 0,
wxSYS_COLOUR_BACKGROUND 		= 1,
wxSYS_COLOUR_ACTIVECAPTION		= 2,
wxSYS_COLOUR_INACTIVECAPTION	= 3,
wxSYS_COLOUR_MENU				= 4,
wxSYS_COLOUR_WINDOW 			= 5,
wxSYS_COLOUR_WINDOWFRAME		= 6,
wxSYS_COLOUR_MENUTEXT			= 7,
wxSYS_COLOUR_WINDOWTEXT 		= 8,
wxSYS_COLOUR_CAPTIONTEXT		= 9,
wxSYS_COLOUR_ACTIVEBORDER		= 10,
wxSYS_COLOUR_INACTIVEBORDER  	= 11,
wxSYS_COLOUR_APPWORKSPACE		= 12,
wxSYS_COLOUR_HIGHLIGHT			= 13,
wxSYS_COLOUR_HIGHLIGHTTEXT		= 14,
wxSYS_COLOUR_BTNFACE			= 15,
wxSYS_COLOUR_BTNSHADOW			= 16,
wxSYS_COLOUR_GRAYTEXT			= 17,
wxSYS_COLOUR_BTNTEXT			= 18,
wxSYS_COLOUR_INACTIVECAPTIONTEXT= 19,
wxSYS_COLOUR_BTNHIGHLIGHT		= 20,

wxSYS_COLOUR_3DDKSHADOW 		= 21,
wxSYS_COLOUR_3DLIGHT			= 22,
wxSYS_COLOUR_INFOTEXT			= 23,
wxSYS_COLOUR_INFOBK 			= 24,

wxSYS_COLOUR_LISTBOX			= 25,

wxSYS_COLOUR_DESKTOP			= wxSYS_COLOUR_BACKGROUND,
wxSYS_COLOUR_3DFACE 			= wxSYS_COLOUR_BTNFACE,
wxSYS_COLOUR_3DSHADOW			= wxSYS_COLOUR_BTNSHADOW,
wxSYS_COLOUR_3DHIGHLIGHT		= wxSYS_COLOUR_BTNHIGHLIGHT,
wxSYS_COLOUR_3DHILIGHT			= wxSYS_COLOUR_BTNHIGHLIGHT,
wxSYS_COLOUR_BTNHILIGHT 		= wxSYS_COLOUR_BTNHIGHLIGHT,

-- Metrics
wxSYS_MOUSE_BUTTONS 			= 1,
wxSYS_BORDER_X					= 2,
wxSYS_BORDER_Y					= 3,
wxSYS_CURSOR_X					= 4,
wxSYS_CURSOR_Y					= 5,
wxSYS_DCLICK_X					= 6,
wxSYS_DCLICK_Y					= 7,
wxSYS_DRAG_X					= 8,
wxSYS_DRAG_Y					= 9,
wxSYS_EDGE_X					= 10,
wxSYS_EDGE_Y					= 11,
wxSYS_HSCROLL_ARROW_X			= 12,
wxSYS_HSCROLL_ARROW_Y			= 13,
wxSYS_HTHUMB_X					= 14,
wxSYS_ICON_X					= 15,
wxSYS_ICON_Y					= 16,
wxSYS_ICONSPACING_X 			= 17,
wxSYS_ICONSPACING_Y 			= 18,
wxSYS_WINDOWMIN_X				= 19,
wxSYS_WINDOWMIN_Y				= 20,
wxSYS_SCREEN_X					= 21,
wxSYS_SCREEN_Y					= 22,
wxSYS_FRAMESIZE_X				= 23,
wxSYS_FRAMESIZE_Y				= 24,
wxSYS_SMALLICON_X				= 25,
wxSYS_SMALLICON_Y				= 26,
wxSYS_HSCROLL_Y 				= 27,
wxSYS_VSCROLL_X 				= 28,
wxSYS_VSCROLL_ARROW_X			= 29,
wxSYS_VSCROLL_ARROW_Y			= 30,
wxSYS_VTHUMB_Y					= 31,
wxSYS_CAPTION_Y 				= 32,
wxSYS_MENU_Y					= 33,
wxSYS_NETWORK_PRESENT			= 34,
wxSYS_PENWINDOWS_PRESENT		= 35,
wxSYS_SHOW_SOUNDS				= 36,
wxSYS_SWAP_BUTTONS				= 37

--/topic Miscellaneous Routines
--/func get_sys_metric( integer metric )
--/ret atom
--Available metrics are:
--<ul>
--/li wxSYS_MOUSE_BUTTONS
--/li wxSYS_BORDER_X
--/li wxSYS_BORDER_Y
--/li wxSYS_CURSOR_X
--/li wxSYS_CURSOR_Y
--/li wxSYS_DCLICK_X
--/li wxSYS_DCLICK_Y
--/li wxSYS_DRAG_X
--/li wxSYS_DRAG_Y
--/li wxSYS_EDGE_X
--/li wxSYS_EDGE_Y
--/li wxSYS_HSCROLL_ARROW_X
--/li wxSYS_HSCROLL_ARROW_Y
--/li wxSYS_HTHUMB_X
--/li wxSYS_ICON_X
--/li wxSYS_ICON_Y
--/li wxSYS_ICONSPACING_X
--/li wxSYS_ICONSPACING_Y
--/li wxSYS_WINDOWMIN_X
--/li wxSYS_WINDOWMIN_Y
--/li wxSYS_SCREEN_X
--/li wxSYS_SCREEN_Y
--/li wxSYS_FRAMESIZE_X
--/li wxSYS_FRAMESIZE_Y
--/li wxSYS_SMALLICON_X
--/li wxSYS_SMALLICON_Y
--/li wxSYS_HSCROLL_Y
--/li wxSYS_VSCROLL_X
--/li wxSYS_VSCROLL_ARROW_X
--/li wxSYS_VSCROLL_ARROW_Y
--/li wxSYS_VTHUMB_Y
--/li wxSYS_CAPTION_Y
--/li wxSYS_MENU_Y
--/li wxSYS_NETWORK_PRESENT
--/li wxSYS_PENWINDOWS_PRESENT
--/li wxSYS_SHOW_SOUNDS
--/li wxSYS_SWAP_BUTTONS
--</ul>

global function get_sys_metric( integer metric )
	return call_cdecl( wxSystemSettingsNative_GetMetric, {metric})
end function

--/topic Utilities
--/func wx_alloc( integer bytes )
--
--Allocates a /i bytes long chunk of memory and sets it to all zeroes.
global function wx_alloc( integer bytes )
	atom ptr
	ptr = allocate(bytes)
	mem_set( ptr, 0, bytes )
	return ptr
end function

--/topic Utilities
--/func wx_alloc_string( sequence string )
--
--Allocates a sequence as a C-style string.  This function currently calls
--Euphoria's built-in allocate_string()
--To create a /wxString, you should use the /create() function.
global function wx_alloc_string( sequence string )

	return allocate_string( string & 0 )
end function

--/topic Utilities
--/func wx_free( atom ptr )
--
--Frees an allocated chunk of memory.
global procedure wx_free( atom ptr )
	free( ptr )
end procedure

--/topic Utilities
--/func wx_peek_string( atom string )
--
--Returns a sequence of the string stored in a /wxString object.  Do not pass the
--pointer to a string allocated by /wx_alloc_string().

-- based on peek_string in clib.e
global function wx_peek_string( atom string )
	atom offset
	string = peek4u( string ) --call_member( wxString_c_str, string, {})
	offset = string
	while peek(offset) do offset += 1 end while
	return peek( {string, offset-string})
end function


--/topic IDs
--/func new_id()
--
--Generates an integer identifier unique to this run of the program.  This can be used
--to generate ids for menuitems or other controls.

constant new_ptr = allocate(4)
global function new_id()
	return call_cdecl_s(wxNewId,{new_ptr})
end function

sequence ctors
ctors = repeat( {}, 2 )

--/topic wxEuphoria Developers
--/proc create_func( integer class, integer id )
--
--This registers a function as the create function for a class, so that a user
--can call /create() without having to know the specific function required to create
--an object of the class.  Your create function should take one sequence as a parameter.
--The sequence will contain any required parameters.  You should only use a create function
--if there is some manipulation required before creation, such as creating a /wxString,
--/wxSize or /wxPoint, otherwise, /create() can handle the creation of the object.

global procedure create_func( integer class_, integer id )
	integer ix
	ix = find( class_, ctors[1] )
	if ix then
		return 
	end if
	ctors[1] &= class_
	ctors[2] &= id
end procedure

--/topic Classes
--/func create( integer class, object params )
--
--This function is used to create all classes included in wxEuphoria.  You should check the
--documentation of the class to see what the required and optional parameters are.
global function create( integer class_, object params )
	integer rid
	if atom(params) then
		params = {params}
	end if
	rid = find( class_, ctors[1] )
	if not rid then
		return cpp:new_instance( class_, 0, params )
	end if
	return call_func( ctors[2][rid], {params} )
end function

procedure call_func_str( atom func, sequence params, atom str )
	poke4( eufunc, func )
	poke4( euparam_count, length(params) )
	poke4( euparam, params )
	c_proc( eucall_str, {str})
end procedure

--/topic wxEuphoria Developers
--/func call_member_str( atom fptr, atom this, object params )
--
--Calls a member function using the appropriate calling convention by platform, and returns
--a wxString.  If a function returns a wxString by value, you need to use this instead of
--/call_member(), or else your application will crash.  You are responsible for calling
--/delete_instance() or /delete_string() on the returned pointer.
global function call_member_str( atom func, atom this, object params )
	atom str
	str = create( wxString, "" )
	call_func_str( func, this & params, str )
	return str -- peek4u( euret )
end function

--/topic wxEuphoria Developers
--/func call_cdecl_str( atom func, object params )
--
--Calls a function using the appropriate calling convention by platform, and returns
--a wxString.  If a function returns a wxString by value, you need to use this instead of
--/call_member(), or else your application will crash.  You are responsible for calling
--/delete_instance() or /delete_string() on the returned pointer.
global function call_cdecl_str( atom func, object params )
	atom str
	str = create( wxString, "" )
	if atom(params) then
		params = {params}
	end if
	call_func_str( func, params, str )
	return str
end function


atom string_ptr, string_ptr_len
string_ptr = wx_alloc(256)
string_ptr_len = 255

function new_wxString( sequence string )
	atom this

	this = 0
	if length(string) > 1 and sequence(string[1]) then
		this = string[2]
		string = string[1]			
	else
		this = wx_alloc( 4 )
		if length(string) and sequence( string[1] ) then
			string = string[1]
		end if
	end if
  
	if length(string) >= string_ptr_len then
		free(string_ptr)
		string_ptr_len = length(string) * 2
		string_ptr = wx_alloc( string_ptr_len + 1 )
	end if
	
	poke( string_ptr, string & 0 )
	this  = cpp:new_instance( wxString, this, {string_ptr, length( string )} )
	
	return this
end function
create_func( wxString, routine_id("new_wxString") )


--/topic wxWindow
--/proc set_back_color( atom window, atom color )
--
--<ul>
--/li /b window: the window whose color is to be set
--/li /b color: a /wxColour object
--</ul>
global procedure set_back_color( atom window, atom color )
--	void = call_member( peek4u(peek4u(window)+176), window, {color})
	void = call_member( wxWindowBase_SetBackgroundColour, window, {color})
end procedure

-- wxArrayString
-------------------

--/topic wxArrayString
--/parent Classes
--/info
--include file: wxEuphoria
--An array of type /wxString.
--
--You should pass a sequence of strings:
--/code
--ex:
--constant 
--myArrayString = create( wxArrayString, { "One", "Two" })
--/endcode                                           
--wxArrayStrings are mainly used within the library itself, and you should
--rarely need to directly create one, unless you are dealing with a class
--that hasn't been fully wrapped.
function new_wxArrayString( sequence strings )
	atom this, n, ptr

	this = cpp:new_instance( wxArrayString, 0, {0})

	n = length( strings ) 
	if n then
	
		for i = 1 to n do
			ptr = create(wxString, {strings[i]})
			void = call_member( wxArrayString_Add, this, {ptr, 1})
		end for
	end if
	return this
end function
create_func( wxArrayString, routine_id("new_wxArrayString"))

procedure destroy_arraystring( atom array )
	void = cpp:call_member( wxArrayString_Clear, array, {})
	free( array )
end procedure
set_destructor( wxArrayString, routine_id("destroy_arraystring"))

--/topic wxArrayString
--/func arraystring_count( atom array )
--
global function arraystring_count( atom array )
	return call_member_s( wxArrayString_Count, array, {})
end function

--/topic wxArrayString
--/func arraystring_item( atom array, integer item )
--
global function arraystring_item( atom array, integer item )
	atom str

	str = call_member( wxArrayString_Item, array, {item-1})
	return wx_peek_string(str)
end function

--/topic wxArrayString
--/func get_arraystring( atom array )
--
--Returns all the strings in the array.
global function get_arraystring( atom array )
	sequence strings
	integer count

	count = arraystring_count( array )

	strings = repeat( {}, count)
	for i = 1 to count do
	strings[i] = arraystring_item( array, i )
	end for
	return strings
end function

function new_wxPoint( sequence params )
	atom this
	if length( params ) = 3 then
	poke4( params[1], params[2..3])
	return params[1]
	end if

	this = allocate( sizeof_wxPoint )
	poke4( this, params )
	return this
--      return cpp:new_instance( wxPoint, 0, params )
end function
create_func( wxPoint, routine_id("new_wxPoint"))

--/topic wxWindow
--/func get_id( atom this )
--
--Returns the id for objects that are derived from class wxWindow.  This includes
--frames, windows and most controls, but does not include menu items.  You should
--use /get_menuitem_id() for that.
global function get_id( atom this )
	return call_member_s( wxWindowBase_GetId, this, {} )
end function

--/topic Controls
--/proc enable( object control, integer bool )
--

global procedure enable( object control, integer bool )
	if atom(control) then
		control = {control}
	end if
	for i = 1 to length(control) do
		void = cpp:call_member( wxWindow_Enable, control[i], {bool})
	end for
	
end procedure

global constant
    wxFULLSCREEN_NOMENUBAR   = #0001,
    wxFULLSCREEN_NOTOOLBAR   = #0002,
    wxFULLSCREEN_NOSTATUSBAR = #0004,
    wxFULLSCREEN_NOBORDER    = #0008,
    wxFULLSCREEN_NOCAPTION   = #0010,

    wxFULLSCREEN_ALL         = wx_or_all( wxFULLSCREEN_NOMENUBAR & 
    	wxFULLSCREEN_NOTOOLBAR & wxFULLSCREEN_NOSTATUSBAR &
    	wxFULLSCREEN_NOBORDER & wxFULLSCREEN_NOCAPTION )

--/topic wxFrame
--/proc show_fullscreen( atom frame, integer show, integer flags )
--
--<ul>
--/li /b show 1 to make the frame full screen, 0 to restore to normal
--/li /b flags should be one or more of the following /wx_or_all()'d together:
--<ul>
--/li    wxFULLSCREEN_NOMENUBAR
--/li    wxFULLSCREEN_NOTOOLBAR
--/li    wxFULLSCREEN_NOSTATUSBAR
--/li    wxFULLSCREEN_NOBORDER   
--/li    wxFULLSCREEN_NOCAPTION
--/li    wxFULLSCREEN_ALL (all of the above)
--</ul>
--</ul>
--The wxWidgets documentation warns that this function hasn't been tested on
--/wxMDIParentFrame s, but it seems to work fine under Windows.
global procedure show_fullscreen( atom frame, integer show, integer flags )
--#WIN32
	void = cpp:call_member( wxFrame_ShowFullScreen, frame, {show, flags})
--#ENDWIN32
--#LINUX
--	void = cpp:call_member( wxTopLevelWindowGTK_ShowFullScreen, frame, {show, flags})
--#ENDLINUX
end procedure


--/topic wxFrame
--/proc show_window( atom window, integer show )
--

global procedure show_window( atom window, integer show )
	void = call_member( wxWindow_Show, window, {show})
end procedure

--/topic Controls
--/func is_visible( atom window )
--
global function is_visible( atom window )
	return and_bits( 1, cpp:call_member( wxWindowBase_IsShown, window, {}))
end function

--#WIN32
function eu_delete( atom this )
	-- wxWidgets calls this to see who should delete
	-- something.  Errors can occur upon destroy() if
	-- the wrong person frees the memory.
	if lookup_class( this ) then
		free_instance(this)
		return 1
	else
		return 0
	end if
end function
--#ENDWIN32

--/topic Controls
--/proc destroy( atom this )
--
--You should use this instead of /delete_instance() to destroy any object
--that handles events (generally, any control or window).
global procedure destroy( atom this )
--	void = call_member( wxWindowBase_Destroy, this, {})
-- Use the virtual function, so that we use the version (wxWindowBase 
-- or wxTopLevelWindowBase) that we should...

--#WIN32
	void = call_member( peek4u( peek4u(this) + 44), this, {})
--#ENDWIN32
--#LINUX
--	void = call_member( peek4u( peek4u(this) + 48), this, {})
--#ENDLINUX
end procedure


--/topic wxFrame
--/proc raise_window( atom window )
--
--Bring a window to the front of the screen.
global procedure raise_window( atom window )
--#WIN32
	void = call_member( wxFrame_Raise, window, {})
--#ENDWIN32
--#LINUX
--	void = call_member( wxWindow_Raise, window, {})
--#ENDLINUX
end procedure

-- wxApp
------------------

--/topic wxApp
--/parent Classes
--/info
--include file: wxEuphoria.e
--
--You probably won't need to do much with this class.  wxEuphoria creates
--a wxApp object automatically.

atom mainWindow
mainWindow = 0

--/topic wxApp
--/proc exit_main()
--
--This is the procedure that should be used to exit the program.  If you
--create an on close event for your main frame, this must be called from
--the event handler, or your application will not close.  wxEuphoria automatically
--does this for you if you do not define an on close event.
global procedure exit_main()
	void = call_member( wxApp_ExitMainLoop, myApp_this, {})
end procedure

procedure OnCloseWindow( atom this, atom event_type, atom id, atom event )

	if this = mainWindow then
		exit_main()
	else
		show_window( this, 0 )
	end if

end procedure

--/topic Miscellaneous Routines
--/func message_box( sequence text, sequence title, atom ok )
--
--Creates a message box dialog, with style /i ok.  Allowable styles are:
--<ul>
--/code
--wxOK
--wxYES_NO
--wxCANCEL
--wxYES
--wxNO
--wxNO_DEFAULT
--wxYES_DEFAULT
--wxICON_EXCLAMATION
--wxICON_HAND
--wxICON_WARNING
--wxICON_ERROR
--wxICON_QUESTION
--wxICON_INFORMATION
--wxICON_STOP
--wxICON_ASTERISK
--/endcode
--</ul>

global function message_box( object s1, object s2, atom ok )
	
	s1 = create(wxString, {s1})
	s2 = create(wxString, {s2})

	ok = call_cdecl( wxMessageBox, {s1, s2, ok, 0, -1, -1 })
	delete_string(s1)
	delete_string(s2)
	return ok       
end function


global constant
-- execute the process asynchronously
wxEXEC_ASYNC	= 0,

-- execute it synchronously, i.e. wait until it finishes
wxEXEC_SYNC 	= 1,

-- under Windows, don't hide the child even if it's IO is redirected (this
-- is done by default)
wxEXEC_NOHIDE	= 2,

-- under Unix, if the process is the group leader then killing -pid kills
-- all children as well as pid
wxEXEC_MAKE_GROUP_LEADER = 4

--/topic Miscellaneous Routines
--/proc wx_execute( sequence command, integer flag )
--
--/i flag can be a combination of:
--<ul>
--/li wxEXEC_ASYNC: execute the process asynchronously
--/li wxEXEC_SYNC: execute it synchronously, i.e. wait until it finishes
--/li wxEXEC_NOHIDE: under Windows, don't hide the child even if it's IO is redirected (this
-- is done by default)
--/li wxEXEC_MAKE_GROUP_LEADER: under Unix, if the process is the group leader then killing -pid kills
-- all children as well as pid
--</ul>
global function wx_execute( sequence command, integer flag )
	atom str
	str = create( wxString, {command})
	void = call_cdecl( wxExecute_1, {str, flag, 0})

	cpp:delete_instance(str)
	return void
end function

--/topic Miscellaneous Routines
--/proc wx_shell( sequence command )
--
global procedure wx_shell( sequence command )
	atom str
	str = create( wxString, {command})
	void = call_cdecl( wxShell, {str})

	cpp:delete_instance(str)
end procedure

-- Mouse Events
--------------------

--/topic Mouse Events
--/parent Events
--/info
--

--/topic Mouse Events
--/func mouse_event_shiftdown( atom event )
--
global function mouse_event_shiftdown( atom event )
--	return peek(event+45)
	return and_bits(1, call_member( wxMouseEvent_ShiftDown, event, {}))
end function

--/topic Mouse Events
--/func mouse_event_position( atom event )
--
--Returns the coordinates of the mouse.
global function mouse_event_position( atom event ) 
	sequence coords
	coords = repeat(0,2)
	coords[1] = call_member_s( wxMouseEvent_GetX, event, {})
	coords[2] = call_member_s( wxMouseEvent_GetY, event, {})

	return coords
end function

--/topic wxWindow
--/proc release_mouse( atom window )
--
global procedure release_mouse( atom window )
	void = call_member( wxWindow_DoReleaseMouse, window, {} )
end procedure

--/topic wxWindow
--/proc capture_mouse( atom window )
--
global procedure capture_mouse( atom window )
	void = call_member( wxWindow_DoCaptureMouse, window, {})
end procedure



--/topic Events
--/proc skip( atom event )
--Called by an event handler to tell the event system that the event 
--handler should be skipped, and the next valid handler used instead.

global procedure skip( atom event )
	void = call_member( wxEvent_Skip, event, {1})
end procedure

--/topic Events
--/proc set_event_handler( object this, object id, object event, integer rid )
--
--Set up an event handler.  
--<ul>
--/li /b this is the object that receives the event.  Often, it will be 
--the top level frame that receives the event, as in the case of a menu item.
--When setting an event for a /wxMenuItem under Linux, /b this must be
--a sequence where the first element is the /wxFrame to which the /wxMenuItem
--belongs, and the second element is the /wxMenu to which the /wxMenuItem
--belongs.  Under Windows, set_event_hander() will also accept /b this as
--a sequence.
--/li /b id is the id of the item generating the event, such a a menu item.  
--/li /b event is an event constant, and
--/li /b rid is the routine id of your event handler.
--</UL>
--/code
--ex:
--procedure onclose( atom win, atom event )
--    exit_main()
--end procedure
--set_event_handler( myWindow, wxID_EXIT, wxEVT_MENU_SELECTED, routine_id("onclose"))
--/endcode
--See class documentation for valid event constants.


global constant 
wxEVT_SCROLL = {wxEVT_SCROLL_TOP, wxEVT_SCROLL_BOTTOM, wxEVT_SCROLL_LINEUP, wxEVT_SCROLL_LINEDOWN,
	wxEVT_SCROLL_PAGEUP, wxEVT_SCROLL_PAGEDOWN, wxEVT_SCROLL_THUMBTRACK, wxEVT_SCROLL_THUMBRELEASE},

  WXK_BACK				  =    8,
  WXK_TAB				  =    9,
  WXK_RETURN  =    13,
  WXK_ESCAPE  =    27,
  WXK_SPACE   =    32,
  WXK_DELETE  =    127,

  WXK_START   = 300,
  WXK_LBUTTON = 301,
  WXK_RBUTTON = 302,
  WXK_CANCEL = 303,
  WXK_MBUTTON = 304,
  WXK_CLEAR = 305,
  WXK_SHIFT = 306 ,
  WXK_ALT =307,
  WXK_CONTROL =308,
  WXK_MENU = 309,
  WXK_PAUSE =310 ,
  WXK_CAPITAL= 311,
  WXK_PRIOR = 312,--  /* Page up */
  WXK_NEXT = 313,--   /* Page down */
  WXK_END = 314,
  WXK_HOME = 315,
  WXK_LEFT = 316,
  WXK_UP = 317,
  WXK_RIGHT = 318,
  WXK_DOWN = 319,
  WXK_SELECT = 320,
  WXK_PRINT = 321,
  WXK_EXECUTE = 322,
  WXK_SNAPSHOT = 323,
  WXK_INSERT = 324 ,
  WXK_HELP = 325,
  WXK_NUMPAD0 = 326,
  WXK_NUMPAD1 = 327 , 
  WXK_NUMPAD2 =328,
  WXK_NUMPAD3 = 329,
  WXK_NUMPAD4 = 330,
  WXK_NUMPAD5 = 331,
  WXK_NUMPAD6 = 332,
  WXK_NUMPAD7 = 333,
  WXK_NUMPAD8 =334,
  WXK_NUMPAD9=335,
  WXK_MULTIPLY=336,
  WXK_ADD=337,
  WXK_SEPARATOR=338,
  WXK_SUBTRACT=339,
  WXK_DECIMAL=340,
  WXK_DIVIDE=341,
  WXK_F1=342,
  WXK_F2=343,
  WXK_F3=344,
  WXK_F4=345,
  WXK_F5=346,
  WXK_F6=347,
  WXK_F7=348,
  WXK_F8=349,
  WXK_F9=350,
  WXK_F10=351,
  WXK_F11=352,
  WXK_F12=353,
  WXK_F13=354,
  WXK_F14=355,
  WXK_F15=356,
  WXK_F16=357,
  WXK_F17=358,
  WXK_F18=359,
  WXK_F19=360,
  WXK_F20=361,
  WXK_F21=362,
  WXK_F22=363,
  WXK_F23=364,
  WXK_F24=365,
  WXK_NUMLOCK=366,
  WXK_SCROLL=367,
  WXK_PAGEUP=368,
  WXK_PAGEDOWN=369,

  WXK_NUMPAD_SPACE=370,
  WXK_NUMPAD_TAB=371,
  WXK_NUMPAD_ENTER=372,
  WXK_NUMPAD_F1=373,
  WXK_NUMPAD_F2=374,
  WXK_NUMPAD_F3=375,
  WXK_NUMPAD_F4=376,
  WXK_NUMPAD_HOME=377,
  WXK_NUMPAD_LEFT=378,
  WXK_NUMPAD_UP=379,
  WXK_NUMPAD_RIGHT=380,
  WXK_NUMPAD_DOWN=381,
  WXK_NUMPAD_PRIOR=382,
  WXK_NUMPAD_PAGEUP=383,
  WXK_NUMPAD_NEXT=384,
  WXK_NUMPAD_PAGEDOWN=385,
  WXK_NUMPAD_END=386,
  WXK_NUMPAD_BEGIN=387,
  WXK_NUMPAD_INSERT=388,
  WXK_NUMPAD_DELETE=389,
  WXK_NUMPAD_EQUAL=390,
  WXK_NUMPAD_MULTIPLY=391,
  WXK_NUMPAD_ADD=392,
  WXK_NUMPAD_SEPARATOR=393,
  WXK_NUMPAD_SUBTRACT=394,
  WXK_NUMPAD_DECIMAL=395,
  WXK_NUMPAD_DIVIDE=396,

	wxOPEN  = 1,
	wxSAVE = 2,
	wxOVERWRITE_PROMPT = 4,
	wxHIDE_READONLY = 8,
	wxFILE_MUST_EXIST = 16,
	wxMULTIPLE = 32

-- Key Codes
----------------

--/topic Key Codes
--/parent Key Events
--/info
--
--<ul>
--/li  WXK_BACK    =    8,
--/li  WXK_TAB     =    9,
--/li  WXK_RETURN  =    13,
--/li  WXK_ESCAPE  =    27,
--/li  WXK_SPACE   =    32,
--/li  WXK_DELETE  =    127,
--/li  WXK_START   = 300,
--/li  WXK_LBUTTON = 301,
--/li  WXK_RBUTTON = 302,
--/li  WXK_CANCEL = 303,
--/li  WXK_MBUTTON = 304,
--/li  WXK_CLEAR = 305,
--/li  WXK_SHIFT = 306 ,
--/li  WXK_ALT =307,
--/li  WXK_CONTROL =308,
--/li  WXK_MENU = 309,
--/li  WXK_PAUSE =310 ,
--/li  WXK_CAPITAL= 311,
--/li  WXK_PRIOR = 312,--  /* Page up */
--/li  WXK_NEXT = 313,--   /* Page down */
--/li  WXK_END = 314,
--/li  WXK_HOME = 315,
--/li  WXK_LEFT = 316,
--/li  WXK_UP = 317,
--/li  WXK_RIGHT = 318,
--/li  WXK_DOWN = 319,
--/li  WXK_SELECT = 320,
--/li  WXK_PRINT = 321,
--/li  WXK_EXECUTE = 322,
--/li  WXK_SNAPSHOT = 323,
--/li  WXK_INSERT = 324 ,
--/li  WXK_HELP = 325,
--/li  WXK_NUMPAD0 = 326,
--/li  WXK_NUMPAD1 = 327 , 
--/li  WXK_NUMPAD2 =328,
--/li  WXK_NUMPAD3 = 329,
--/li  WXK_NUMPAD4 = 330,
--/li  WXK_NUMPAD5 = 331,
--/li  WXK_NUMPAD6 = 332,
--/li  WXK_NUMPAD7 = 333,
--/li  WXK_NUMPAD8 =334,
--/li  WXK_NUMPAD9=335,
--/li  WXK_MULTIPLY=336,
--/li  WXK_ADD=337,
--/li  WXK_SEPARATOR=338,
--/li  WXK_SUBTRACT=339,
--/li  WXK_DECIMAL=340,
--/li  WXK_DIVIDE=341,
--/li  WXK_F1=342,
--/li  WXK_F2=343,
--/li  WXK_F3=344,
--/li  WXK_F4=345,
--/li  WXK_F5=346,
--/li  WXK_F6=347,
--/li  WXK_F7=348,
--/li  WXK_F8=349,
--/li  WXK_F9=350,
--/li  WXK_F10=351,
--/li  WXK_F11=352,
--/li  WXK_F12=353,
--/li  WXK_F13=354,
--/li  WXK_F14=355,
--/li  WXK_F15=356,
--/li  WXK_F16=357,
--/li  WXK_F17=358,
--/li  WXK_F18=359,
--/li  WXK_F19=360,
--/li  WXK_F20=361,
--/li  WXK_F21=362,
--/li  WXK_F22=363,
--/li  WXK_F23=364,
--/li  WXK_F24=365,
--/li  WXK_NUMLOCK=366,
--/li  WXK_SCROLL=367,
--/li  WXK_PAGEUP=368,
--/li  WXK_PAGEDOWN=369,
--/li  WXK_NUMPAD_SPACE=370,
--/li  WXK_NUMPAD_TAB=371,
--/li  WXK_NUMPAD_ENTER=372,
--/li  WXK_NUMPAD_F1=373,
--/li  WXK_NUMPAD_F2=374,
--/li  WXK_NUMPAD_F3=375,
--/li  WXK_NUMPAD_F4=376,
--/li  WXK_NUMPAD_HOME=377,
--/li  WXK_NUMPAD_LEFT=378,
--/li  WXK_NUMPAD_UP=379,
--/li  WXK_NUMPAD_RIGHT=380,
--/li  WXK_NUMPAD_DOWN=381,
--/li  WXK_NUMPAD_PRIOR=382,
--/li  WXK_NUMPAD_PAGEUP=383,
--/li  WXK_NUMPAD_NEXT=384,
--/li  WXK_NUMPAD_PAGEDOWN=385,
--/li  WXK_NUMPAD_END=386,
--/li  WXK_NUMPAD_BEGIN=387,
--/li  WXK_NUMPAD_INSERT=388,
--/li  WXK_NUMPAD_DELETE=389,
--/li  WXK_NUMPAD_EQUAL=390,
--/li  WXK_NUMPAD_MULTIPLY=391,
--/li  WXK_NUMPAD_ADD=392,
--/li  WXK_NUMPAD_SEPARATOR=393,
--/li  WXK_NUMPAD_SUBTRACT=394,
--/li  WXK_NUMPAD_DECIMAL=395,
--/li  WXK_NUMPAD_DIVIDE=396
--</ul>

--/topic wxEuphoria Developers
--/func new_control( integer class, atom this, sequence params, sequence default )
--
--This is a generic create function that can be used by other create routines that use
--default arguments.  It assumes that the arguments passed are:
--<ul>
--/li parent
--/li id
--/li caption
--/li x (optional)
--/li y (optional)
--/li cx (optional)
--/li cy (optional)
--/li style (optional)
--</ul>
--Additionally, there can be an arbitrary number of other params.  /b new_control() will
--create the wxPoint and wxPosition objects for (x,y) and (cx,cy), and will create the
--wxString for caption.  Most controls use this format in their constructors, and this
--function should make it easier to write the Euphoria wrapper for the constructors.
global function new_control( integer class_, atom this, sequence params, sequence default )
	atom string, point, size
	sequence control
	integer len
	size = 0
	control = default
	len = length(params)
	if len then
		control[1] = params[1]		
		
		if len > 1 then
			

			control[2] = params[2]
			if len > 2 then
				
				if sequence(params[3]) then
					string = create(wxString, {params[3]})
					control[3] = string
				end if
			
				if length(params) > 3 then
					point = create( wxPoint, params[4..5])
					control[4] = point
					if length(params) > 5 then
						if compare(params[6..7],{-1,-1}) then
							size = create(wxSize, params[6..7])
							control[5] = size
						end if
						if length(params) = 8 then
							control[6] = params[8]
						end if
					end if
				end if
			end if
		end if
	end if
	this = cpp:new_instance( class_, this, control )
	return this
end function

global constant
--wxSTAY_ON_TOP          = #8000,
--wxICONIZE              = #4000,
--wxMINIMIZE             = wxICONIZE,
--wxMAXIMIZE             = #2000,
--                                        // free flag value: 0x1000
--wxSYSTEM_MENU          = #0800,
--wxMINIMIZE_BOX         = #0400,
--wxMAXIMIZE_BOX         = #0200,
--wxTINY_CAPTION_HORIZ   = #0100,
--wxTINY_CAPTION_VERT    = #0080,
--wxRESIZE_BORDER        = #0040,

--wxDIALOG_NO_PARENT     = #0001,  --// Don't make owned by apps top window
wxFRAME_NO_TASKBAR     = #0002,  --// No taskbar button (MSW only)
wxFRAME_TOOL_WINDOW    = #0004,  --// No taskbar button, no system menu
--wxFRAME_FLOAT_ON_PARENT= #0008,  --// Always above its parent
wxFRAME_SHAPED         = #0010   --// Create a window that is able to be shaped



constant 
default_frame = { 0, -1, create( wxString, ""), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, 
--#LINUX
--create(wxString, {"frame"})}
--#ENDLINUX
--#WIN32
  wxFrameNameStr }
--#ENDWIN32
function new_wxFrame( sequence params )
	atom this

	this = new_control(wxFrame, 0, params, default_frame )

	set_event_handler( this, get_id(this)*0-1, wxEVT_CLOSE_WINDOW, routine_id("OnCloseWindow"))
	return this
end function
create_func( wxFrame, routine_id( "new_wxFrame" ))



constant 
default_window = { 0, -1, wxDefaultPosition, wxDefaultSize, 0, wxPanelNameStr }

-- 1248 wxWindow::wxWindow(class wxWindow *,int,class wxPoint const &,class wxSize const &,
--                                                long,class wxString const &)
function new_wxWindow( sequence params )
	sequence window
	integer len

	window = default_window

	len = length( params )
	if len then
	window[1] = params[1]
	if len > 1 then
	    window[2] = params[2]
	    if len > 2 then
		window[3] = create(wxPoint, params[3..4] )
		if len > 4 then
		    window[4] = create(wxSize, params[5..6] )
		    if len > 6 then
			window[5] = params[7]
			if len > 7 then
			    window[6] = create(wxString, { params[8] })
			end if
		    end if
		end if
	    end if
	end if
	end if

	return cpp:new_instance( wxWindow, 0, window )
end function
create_func( wxWindow, routine_id( "new_wxWindow" ))

constant 
default_scrollwindow = { 0, -1, wxDefaultPosition, wxDefaultSize, wxHSCROLL + wxVSCROLL, 
	create(wxString,{"scrolledWindow"}) }

-- 1248 wxWindow::wxWindow(class wxWindow *,int,class wxPoint const &,class wxSize const &,
--                                                long,class wxString const &)
function new_wxScrolledWindow( sequence params )
	sequence panel
	panel = default_scrollwindow
	panel[1] = params[1]
	if length(params) > 1 then
		panel[2] = params[2]
		if length(params) > 3 then
			if compare(params[3..4],{-1,-1}) then
				panel[3] = create( wxPoint, params[3..4])
			end if
			if length(params) > 5 then
				if compare(params[5..6],{-1,-1}) then
					panel[4] = create(wxSize, params[5..6])
				end if
				if length(params) > 6 then
					panel[5] = params[7]
				end if
			end if
		end if
	end if
	return cpp:new_instance( wxScrolledWindow, 0, panel )
end function

create_func( wxScrolledWindow, routine_id( "new_wxScrolledWindow" ))



--wxPanel(
--1     1  wxWindow* parent, 
--2     2  wxWindowID id, 
--34    3  const wxPoint& pos = wxDefaultPosition, 
--56    4  const wxSize& size = wxDefaultSize, 
--7     5  long style = wxTAB_TRAVERSAL, 
--8     6  const wxString& name = "panel")

-- wxPanel::wxPanel[in-charge](wxWindow*, int, int, int, int, long, wxString const&)
constant default_panel = {0,-1,wxDefaultPosition,wxDefaultSize, wxTAB_TRAVERSAL, create(wxString,{"panel"})}
function new_wxPanel( sequence params )
	sequence panel
	panel = default_panel
	panel[1] = params[1]
	if length(params) > 1 then
	panel[2] = params[2]
	if length(params) > 3 then
	    if compare(params[3..4],{-1,-1}) then
		panel[3] = create( wxPoint, params[3..4])
	    end if
	    if length(params) > 5 then
		if compare(params[5..6],{-1,-1}) then
		    panel[4] = create(wxSize, params[5..6])
		end if
		if length(params) > 6 then
		    panel[5] = params[7]
		end if
	    end if
	end if
	end if
	return cpp:new_instance( wxPanel, 0, panel )
end function
create_func(wxPanel, routine_id("new_wxPanel"))

--/topic Controls
--/func get_handle( atom this )
--
--Returns the platform specific handle for objects derived from class wxWindow.
global function get_handle( atom this )
	return call_member( wxWindow_GetHandle, this, {})
end function

--/topic Controls
--/proc set_tip( atom this, sequence tip )
--
--Sets the tooltip for an object derived from class wxWindow.
global procedure set_tip( atom this, sequence tip )
	atom str
	str = create(wxString, {tip})
	void = call_member( wxWindowBase_SetToolTip_1, this, {str})
	cpp:delete_instance( str )
end procedure

--/topic wxWindow
--/proc set_title( atom window, sequence title )
--
global procedure set_title( atom window, sequence title )
	atom str
	str = create(wxString, {title})
--#WIN32
  void = call_member( wxWindow_SetTitle, window, {str})
--#ENDWIN32
--#LINUX
--      void = call_member( wxTopLevelWindowGTK_SetTitle, window, {str})
--#ENDLINUX
	cpp:delete_instance(str)
end procedure

--/topic Controls
--/func get_label( atom control )
--
--Returns the default label associated with the control.  This would be the caption for a
--/wxFrame or the label on a /wxButton or the text of a /wxStaticText.
constant default_label = create( wxString, "" )
global function get_label( atom control )
	void = cpp:call_member( wxWindowBase_GetDefaultText, control, {default_label})
	return wx_peek_string( default_label )
end function

--/topic wxWindow
--/proc refresh_window( object params )
--
--Forces a wxWindow to repaint itself.  params can take one of several forms: 
--<ul>
--/li /b atom: /i this pointer to wxWindow to be refreshed.  /i erase_background is set to 1
--/li /b sequence:
--<ul>
--/li { /i this, /i erase_background}
--/li { /i this, /i erase_background, /i x1, /i y1, /i x2, /i y2}
--/li If /i erase_background is 0, then the background is not erased before repainting.
--/li /i "{ x1, y1, x2, y2}" defines a rectangle to repaint.  If no rectangle is specified, 
--then the entire wxWindow will be refreshed.
--</ul></ul>

--virtual void Refresh(bool eraseBackground = TRUE, const wxRect* rect = NULL)

constant refresh_rect = allocate( 16 )
global procedure refresh_window( object params )
	atom this
	
	if atom(params) then
	this = params
	params = {1,0}
	else
	this = params[1]
	if length(params) = 6 then
	    poke4( refresh_rect, params[3..6] )
	    params = params[2] & refresh_rect
	else
	    params = params[2] & 0
	end if
	end if

	void = call_member( wxWindow_Refresh, this, params      )
end procedure

--/topic wxFrame
--/proc set_icon( atom frame, atom icon )
--
global procedure set_icon( atom frame, atom icon )
--#WIN32
		void = call_member( wxTopLevelWindowMSW_SetIcon, frame, {icon})
--#ENDWIN32
--#LINUX
--    void = call_member( wxTopLevelWindowGTK_SetIcon, frame, {icon})
--#ENDLINUX
end procedure

--/topic wxPanel
--/proc set_default_item( atom panel, atom button )
--
global procedure set_default_item( atom panel, atom button )
	void = call_member( wxPanel_SetDefaultItem, panel, {button})
end procedure

--/topic wxWindow
--/func get_client_size( atom this )
--
constant client_size_x = allocate(8), client_size_y = client_size_x + 4
global function get_client_size( atom this )
	void = call_member( wxWindowBase_GetClientSize, this, {client_size_x,client_size_y})
	return peek4s({client_size_x,2})
end function

--virtual void GetTextExtent(
--const wxString& string, 
--int* x, 
--int* y,
--int* descent = NULL, 
--int* externalLeading = NULL, 
--const wxFont* font = NULL, 
--bool use16 = FALSE) const


--/topic Controls
--/proc set_size( atom win, integer cx, integer cy )
--
global procedure set_size( atom win, integer cx, integer cy )
	void = call_member( wxWindowBase_SetSize, win, {cx, cy })
end procedure


--/topic Controls
--/proc set_focus( atom window )
--

global procedure set_focus( atom window )

	void = call_member( wxWindowBase_AcceptsFocus, window, {} )

	if void then

		void = call_member( wxWindow_SetFocus, window, {})
	else

	end if

end procedure

--/topic Graphics
--/func get_text_extent( atom win, sequence text, atom font )
--

-- void wxWindow::GetTextExtent(class wxString const &,int *,
-- int *,int *,int *,class wxFont const *)"

--virtual void GetTextExtent(
--const wxString& string, 
--int* x, 
--int* y, 
--int* descent = NULL, 
--int* externalLeading = NULL, 
--const wxFont* font = NULL, 
--bool use16 = FALSE) const

constant extent_x = allocate(16), extent_y = extent_x + 4
global function get_text_extent( atom win, sequence text, atom font )
	atom string

	string = create(wxString,{text})
	void = call_member( wxWindow_GetTextExtent, win, 
	{string, extent_x, extent_y, extent_x + 8, extent_x+12, font})
	
	delete_string( string )

	return peek4s( {extent_x,4})
end function

--Key Events
------------------------

--/topic Key Events
--/parent Events
--/info
--
--Key Event Types:
--<ul>
--/li wxEVT_CHAR
--/li wxEVT_CHAR_HOOK
--/li wxEVT_NAVIGATION_KEY
--/li wxEVT_KEY_DOWN
--/li wxEVT_KEY_UP
--</ul>

--/topic Key Events
--/func get_key_code( atom event )
--
--Returns the virtual key code. ASCII events return normal ASCII values, while non-ASCII events 
--return values such as WXK_LEFT for the left cursor key.

global function get_key_code( atom event )
	return call_member( wxKeyEvent_GetKeyCode, event, {})
end function

--/topic Key Events
--/func key_event_shiftdown( atom event )
--
global function key_event_shiftdown( atom event )
--      return peek(event+45)
	  return remainder(call_member( wxKeyEvent_ShiftDown, event, {}), 2 )
end function

--/topic Key Events 
--/func key_event_controldown( atom event )
--
global function key_event_controldown( atom event )
--      return peek(event+44)
	  return remainder(call_member( wxKeyEvent_ControlDown, event, {}), 2 )
end function

--/topic Key Events 
--/func key_event_altdown( atom event )
--
global function key_event_altdown( atom event )
--      return peek(event+46)
	return remainder( call_member( wxKeyEvent_AltDown, event, {} ), 2 )
end function

--/topic Miscellaneous Routines
--/func get_key_state( integer keycode )
--
--Returns 1 if specified key (see /"Key Codes" for a list of codes to use) is currently
--pressed down.

--#LINUX
--constant
--so = open_dll(""),
--
--XKeysymToKeycode = define_c_func( so, "XKeysymToKeycode", {C_POINTER,C_INT}, C_INT ),
--XQueryKeymap = define_c_proc( so, "XQueryKeymap", {C_POINTER, C_POINTER}),
--XGetKeyboardMapping = define_c_func( so, "XGetKeyboardMapping", repeat( C_POINTER, 4 ), C_POINTER )
--
--
--atom Xkeymap, Xdisplay, Xkeysyms_per_keycode_returned
--Xdisplay = 0
--Xkeymap = allocate(32)
--Xkeysyms_per_keycode_returned = allocate(4*256)
--#ENDLINUX


global function get_key_state( integer keycode )
--#WIN32
	return and_bits( 1, cpp:call_cdecl( wxGetKeyState, keycode ) )
--#ENDWIN32
	-- The wxWidgets 2.5.5 implementation of this doesn't work for keys other 
	-- than 'modifiers', because it uses XQueryPointer instead of
	-- XQueryKeymap.  So I wrote it here in Euphoria:
--#LINUX
--	integer bit, byte, fn, xkey, xmapped
--	sequence bits
--	if not Xdisplay then 	
--		Xdisplay = cpp:call_cdecl( wxGetDisplay, {Xdisplay, Xkeymap})
--	end if
--	c_proc( XQueryKeymap, {Xdisplay, Xkeymap})
--	
--	-- need to convert key to an X key and check to see if the bit is set
--	xkey = c_func( XKeysymToKeycode, {Xdisplay,cpp:call_cdecl( wxCharCodeWXToX, keycode )})
--	byte = floor( xkey / 8 )
--	bit = power(2, remainder( xkey, 8 ) )
--	return (and_bits( peek( Xkeymap + byte ), bit ) != 0)
--
--#ENDLINUX
end function

--/topic Controls
--/func get_rect( atom win )
--
--Returns the size and position of the control.
constant rect_ptr = allocate(8), x_rect = rect_ptr, y_rect = x_rect + 4
global function get_rect( atom win )
	sequence rect
	rect = repeat(0,4)

	void = call_member(wxWindowBase_GetPosition, win, {x_rect, y_rect})
	rect[1..2] = peek4s( {rect_ptr,2})

	void = call_member(wxWindowBase_GetSize, win, {x_rect,y_rect})
	rect[3..4] = peek4s( {rect_ptr,2})
	
	return rect
end function


global constant
    wxCURSOR_NONE = 0,
    wxCURSOR_ARROW = 1,
    wxCURSOR_RIGHT_ARROW = 2,
    wxCURSOR_BULLSEYE = 3,
    wxCURSOR_CHAR = 4,
    wxCURSOR_CROSS = 5,
    wxCURSOR_HAND = 6,
    wxCURSOR_IBEAM = 7,
    wxCURSOR_LEFT_BUTTON = 8,
    wxCURSOR_MAGNIFIER = 9,
    wxCURSOR_MIDDLE_BUTTON = 10,
    wxCURSOR_NO_ENTRY = 11,
    wxCURSOR_PAINT_BRUSH = 12,
    wxCURSOR_PENCIL = 13,
    wxCURSOR_POINT_LEFT = 14,
    wxCURSOR_POINT_RIGHT = 15,
    wxCURSOR_QUESTION_ARROW = 16,
    wxCURSOR_RIGHT_BUTTON = 17,
    wxCURSOR_SIZENESW = 18,
    wxCURSOR_SIZENS = 19,
    wxCURSOR_SIZENWSE = 20,
    wxCURSOR_SIZEWE = 21,
    wxCURSOR_SIZING = 22,
    wxCURSOR_SPRAYCAN = 23,
    wxCURSOR_WAIT = 24,
    wxCURSOR_WATCH = 25,
    wxCURSOR_BLANK = 26
--wxCursor
---------------------------------

--/topic wxCursor
--/parent Classes
--/parent wxWindow
--/parent Controls
--/parent wxFrame
--/info
--include file: wxEuphoria.e
--Creation parameters:
--
--There are two methods:
--<ul>
--/li From a wxImage (create a /wxBitmap and use /convert_to_image)
--/li Cursor id
--<ul>
--/li    wxCURSOR_NONE = 0,
--/li    wxCURSOR_ARROW = 1,
--/li    wxCURSOR_RIGHT_ARROW = 2,
--/li    wxCURSOR_BULLSEYE = 3,
--/li    wxCURSOR_CHAR = 4,
--/li    wxCURSOR_CROSS = 5,
--/li    wxCURSOR_HAND = 6,
--/li    wxCURSOR_IBEAM = 7,
--/li    wxCURSOR_LEFT_BUTTON = 8,
--/li    wxCURSOR_MAGNIFIER = 9,
--/li    wxCURSOR_MIDDLE_BUTTON = 10,
--/li    wxCURSOR_NO_ENTRY = 11,
--/li    wxCURSOR_PAINT_BRUSH = 12,
--/li    wxCURSOR_PENCIL = 13,
--/li    wxCURSOR_POINT_LEFT = 14,
--/li    wxCURSOR_POINT_RIGHT = 15,
--/li    wxCURSOR_QUESTION_ARROW = 16,
--/li    wxCURSOR_RIGHT_BUTTON = 17,
--/li    wxCURSOR_SIZENESW = 18,
--/li    wxCURSOR_SIZENS = 19,
--/li    wxCURSOR_SIZENWSE = 20,
--/li    wxCURSOR_SIZEWE = 21,
--/li    wxCURSOR_SIZING = 22,
--/li    wxCURSOR_SPRAYCAN = 23,
--/li    wxCURSOR_WAIT = 24,
--/li    wxCURSOR_WATCH = 25,
--/li    wxCURSOR_BLANK = 26
--</ul>
--</ul>

--/topic Controls
--/proc set_cursor( atom window, atom cursor )
--
--Changes the mouse cursor for the specified window to be the specified cursor.
--See /wxCursor for the available cursor shapes.
global procedure set_cursor( atom window, atom cursor )
	void = cpp:call_member( wxWindow_SetCursor, window, cursor )
end procedure


function new_wxCursor( sequence params )
	atom curs
	atom this
	curs = params[1]
	if curs <= 26 then
		return new_instance( wxCursor, 0, params )
	end if
	
	this = wx_alloc( sizeof_wxCursor )
--#LINUX
--	curs = cpp:call_member( wxCursor_wxCursor_2, this, params )
--#ENDLINUX
--#WIN32
	curs = cpp:call_member( wxCursor_op_ctr_1, this, params )
--#ENDWIN32
	return this
end function
create_func( wxCursor, routine_id("new_wxCursor") )


-- Files
----------------------

--/topic Files
--/info
--Working with files and directories
--See also /file_selector()

--/topic Files
--/func copy_file( sequence file1, sequence file2 )
--
global function copy_file( sequence file1, sequence file2 )
	atom ret
	sequence str
	str = { create(wxString,{file1}), create(wxString,{file2})}
	ret = call_cdecl( wxCopyFile, str)
	cpp:delete_instance( str )
	return ret
end function

--/topic Files
--/func remove_file( sequence file )
--Removes (deletes) the specified file, returns true if successful.
global function remove_file( sequence file )
	atom str, ret
	str = create(wxString, {file})
	ret = call_cdecl( wxRemoveFile, {str})
	cpp:delete_instance( str )
	return ret
end function


--wxFileSelector(
--      wxString&,
--      const char*,
--      const char*,
--      const char*,
--      const char*,
--      const char*,
--      int,
--      wxWindow*,
--      int,
--      int)


--/topic Dialogs
--/func file_selector( atom parent, sequence message, sequence info, atom flag )
--Pops up a file selector box. In Windows, this is the common file selector dialog. In X, 
--this is a file selector box with the same functionality.  This function is used for 
--both open and save dialogs.
--<ul>
--/i info is a sequence containing:
--<ul>
--/li path
--/li file
--/li extension
--/li wildcard
--</ul></ul>
--You may supply none or any number of these, but /b file_selector() will assume they are
--in this order, so in order to specify a wildcard selection, you must specify the others, even
--if they are empty sequences.
--<br><br>
--The path and filename are distinct 
--elements of a full file pathname. If path is empty, the current directory will be used. 
--If filename is empty, no default filename will be supplied. The wildcard determines what 
--files are displayed in the file selector, and file extension supplies a type extension for 
--the required filename. 
--
--Flags may be a combination of /b "wxOPEN, wxSAVE, wxOVERWRITE_PROMPT", 
--/b "wxHIDE_READONLY, wxFILE_MUST_EXIST, wxMULTIPLE" or 0.
--
--Both the Unix and Windows versions implement a wildcard filter. Typing a filename 
--containing wildcards (*, ?) in the filename text item, and clicking on Ok, will result 
--in only those files matching the pattern being displayed.
--
--The wildcard may be a specification for multiple types of file with a description for each, such as:
--/code
--    "BMP files (*.bmp)|*.bmp|GIF files (*.gif)|*.gif"
--/endcode
constant dlg_ptr = create( wxString, {"file dialog"})

global function file_selector( atom parent, sequence message, sequence info, atom flag )
	atom path, ext, wild, empty, file, msg, result
	sequence strings

	empty = allocate_string("")

	path = empty
	ext = empty
	wild = empty
	msg = empty
	file = empty

	if length(message) then
		msg = allocate_string(message)
	end if

	if length(info) then
		path = allocate_string(info[1])
		if length(info) > 1 then
			file = allocate_string(info[2])
			if length(info) > 2 then
				ext = allocate_string(info[3])
				if length(info) > 3 then
					wild = allocate_string( info[4] )
				end if
			end if
		end if
	end if

	  result = call_cdecl( wxFileSelector2, {dlg_ptr, msg, path, file, ext, wild, flag, parent, -1, -1})


	free(empty)
	strings = {path,ext, wild, msg}
	for i = 1 to length(strings) do
		if strings[i] != empty then
			wx_free(strings[i])
		end if
	end for
	return wx_peek_string(dlg_ptr)
end function

--/topic Miscellaneous Routines
--/proc cleanup()
--
--This cleans up internal wxWidgets memory.  /wxMain() automatically calls this before
--it exits.  If you do not use /wxMain(), then you should manually call cleanup() before
--your app exits.
global procedure cleanup()
	void = cpp:call_member( wxApp_CleanUp, myApp_this, {})
end procedure

--/topic Miscellaneous Routines
--/proc wxMain( atom topWindow )
--/info
--
--This starts the event loop and your main application.
global procedure wxMain( atom topWindow )

	mainWindow = topWindow

	show_window( topWindow, 1 )

	void = call_member( wxAppBase_OnRun, myApp_this, {})
	
	disable_events()

	topWindow = call_member( wxAppBase_GetTopWindow, myApp_this, {} )
	if topWindow then

	if call_member( wxObject_IsKindOf, topWindow, { wxFrame_sm_classwxFrame }) or
	   call_member( wxObject_IsKindOf, topWindow, { wxWindow_sm_classwxWindow }) then
	
	   
		void = call_member( wxWindowBase_Close, topWindow, {1} )
		void = call_member( wxApp_DeletePendingObjects, myApp_this, {} )
	
	else
		wx_free( topWindow )
		void = call_member( wxAppBase_SetTopWindow, myApp_this, {0})
	end if
	end if
	if platform() = WIN32 then
		cleanup()
	end if
	
end procedure

-- Classes
-----------------

--/topic Classes
--/desc List of Classes and routines that apply to them
--/info
--List of Classes and routines that apply to them
--
--Each class should have at least two things defined, a constant identifying the class
--and a sizeof_ constant.  In order to refer to class /wxWindow, simply use its name, "wxWindow".  To
--refer to the size in bytes of an object of type wxWindow, use sizeof_wxWindow.




-- Utilities
--------------------------

--/topic Utilities
--/desc Helper routines
--/info
--Helper routines
--

-- Events
--------------------

--/topic Events
--/desc Using events with wxEuphoria
--/info
--Using events with wxEuphoria
--
--<a href="#wxEVT_PAINT">On Paint</a><br>
--<a href="#keyevents">Key Events</a>
--
--Event procedures take 4 arguments:
--<ul>
--/li atom this
--/li atom event_type
--/li atom id
--/li atom event
--</ul>
--<a name="wxEVT_PAINT"><h3>wxEVT_PAINT</h3></a>
--During a paint event, you need to create a /wxPaintDC.  This must be destroyed
--(/delete_instance) before you return from the paint handler.  Also, any drawing
--that is done should be within calls to /begin_drawing() and /end_drawing():
--/code
--  procedure onPaint( atom this, atom event_type, atom id, atom event )
--      atom dc
--
--      dc = create( wxPaintDC, {this} )
--      begin_drawing(dc)
--      --  ... do drawing here...
--      end_drawing(dc)
--      delete_instance(dc)
--  end procedure
--/endcode
--
--<a name="keyevents"><h3>Key Events</h3></a>
--Key events under Linux should be set with an id of -1.  Also, no events will be passed until
--the window has been clicked by the user.
--
--Full listing of events as defined in wxEuphoria.e:
--<ul>
--/li wxEVT_ACTIVATE
--/li wxEVT_ACTIVATE_APP
--/li wxEVT_CALCULATE_LAYOUT
--/li wxEVT_CALENDAR_DAY_CHANGED
--/li wxEVT_CALENDAR_DOUBLECLICKED
--/li wxEVT_CALENDAR_MONTH_CHANGED
--/li wxEVT_CALENDAR_SEL_CHANGED
--/li wxEVT_CALENDAR_WEEKDAY_CLICKED
--/li wxEVT_CALENDAR_YEAR_CHANGED
--/li wxEVT_CHAR
--/li wxEVT_CHAR_HOOK
--/li wxEVT_CHILD_FOCUS
--/li wxEVT_CLOSE_WINDOW
--/li wxEVT_COMMAND_BUTTON_CLICKED
--/li wxEVT_COMMAND_CHECKBOX_CLICKED
--/li wxEVT_COMMAND_CHECKLISTBOX_TOGGLED
--/li wxEVT_COMMAND_CHOICE_SELECTED
--/li wxEVT_COMMAND_COMBOBOX_SELECTED
--/li wxEVT_COMMAND_ENTER
--/li wxEVT_COMMAND_FIND
--/li wxEVT_COMMAND_FIND_CLOSE
--/li wxEVT_COMMAND_FIND_NEXT
--/li wxEVT_COMMAND_FIND_REPLACE
--/li wxEVT_COMMAND_FIND_REPLACE_ALL
--/li wxEVT_COMMAND_KILL_FOCUS
--/li wxEVT_COMMAND_LEFT_CLICK
--/li wxEVT_COMMAND_LEFT_DCLICK
--/li wxEVT_COMMAND_LISTBOX_DOUBLECLICKED
--/li wxEVT_COMMAND_LISTBOX_SELECTED
--/li wxEVT_COMMAND_LIST_BEGIN_DRAG
--/li wxEVT_COMMAND_LIST_BEGIN_LABEL_EDIT
--/li wxEVT_COMMAND_LIST_BEGIN_RDRAG
--/li wxEVT_COMMAND_LIST_CACHE_HINT
--/li wxEVT_COMMAND_LIST_COL_BEGIN_DRAG
--/li wxEVT_COMMAND_LIST_COL_CLICK
--/li wxEVT_COMMAND_LIST_COL_DRAGGING
--/li wxEVT_COMMAND_LIST_COL_END_DRAG
--/li wxEVT_COMMAND_LIST_COL_RIGHT_CLICK
--/li wxEVT_COMMAND_LIST_DELETE_ALL_ITEMS
--/li wxEVT_COMMAND_LIST_DELETE_ITEM
--/li wxEVT_COMMAND_LIST_END_LABEL_EDIT
--/li wxEVT_COMMAND_LIST_GET_INFO
--/li wxEVT_COMMAND_LIST_INSERT_ITEM
--/li wxEVT_COMMAND_LIST_ITEM_ACTIVATED
--/li wxEVT_COMMAND_LIST_ITEM_DESELECTED
--/li wxEVT_COMMAND_LIST_ITEM_FOCUSED
--/li wxEVT_COMMAND_LIST_ITEM_MIDDLE_CLICK
--/li wxEVT_COMMAND_LIST_ITEM_RIGHT_CLICK
--/li wxEVT_COMMAND_LIST_ITEM_SELECTED
--/li wxEVT_COMMAND_LIST_KEY_DOWN
--/li wxEVT_COMMAND_LIST_SET_INFO
--/li wxEVT_COMMAND_MENU_SELECTED
--/li wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGED
--/li wxEVT_COMMAND_NOTEBOOK_PAGE_CHANGING
--/li wxEVT_COMMAND_RADIOBOX_SELECTED
--/li wxEVT_COMMAND_RADIOBUTTON_SELECTED
--/li wxEVT_COMMAND_RIGHT_CLICK
--/li wxEVT_COMMAND_RIGHT_DCLICK
--/li wxEVT_COMMAND_SCROLLBAR_UPDATED
--/li wxEVT_COMMAND_SET_FOCUS
--/li wxEVT_COMMAND_SLIDER_UPDATED
--/li wxEVT_COMMAND_SPINCTRL_UPDATED
--/li wxEVT_COMMAND_SPLITTER_DOUBLECLICKED
--/li wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGED
--/li wxEVT_COMMAND_SPLITTER_SASH_POS_CHANGING
--/li wxEVT_COMMAND_SPLITTER_UNSPLIT
--/li wxEVT_COMMAND_TAB_SEL_CHANGED
--/li wxEVT_COMMAND_TAB_SEL_CHANGING
--/li wxEVT_COMMAND_TEXT_ENTER
--/li wxEVT_COMMAND_TEXT_MAXLEN
--/li wxEVT_COMMAND_TEXT_UPDATED
--/li wxEVT_COMMAND_TEXT_URL
--/li wxEVT_COMMAND_TOGGLEBUTTON_CLICKED
--/li wxEVT_COMMAND_TOOL_ENTER
--/li wxEVT_COMMAND_TOOL_RCLICKED
--/li wxEVT_COMMAND_TREE_BEGIN_DRAG
--/li wxEVT_COMMAND_TREE_BEGIN_LABEL_EDIT
--/li wxEVT_COMMAND_TREE_BEGIN_RDRAG
--/li wxEVT_COMMAND_TREE_DELETE_ITEM
--/li wxEVT_COMMAND_TREE_END_DRAG
--/li wxEVT_COMMAND_TREE_END_LABEL_EDIT
--/li wxEVT_COMMAND_TREE_GET_INFO
--/li wxEVT_COMMAND_TREE_ITEM_ACTIVATED
--/li wxEVT_COMMAND_TREE_ITEM_COLLAPSED
--/li wxEVT_COMMAND_TREE_ITEM_COLLAPSING
--/li wxEVT_COMMAND_TREE_ITEM_EXPANDED
--/li wxEVT_COMMAND_TREE_ITEM_EXPANDING
--/li wxEVT_COMMAND_TREE_ITEM_MIDDLE_CLICK
--/li wxEVT_COMMAND_TREE_ITEM_RIGHT_CLICK
--/li wxEVT_COMMAND_TREE_KEY_DOWN
--/li wxEVT_COMMAND_TREE_SEL_CHANGED
--/li wxEVT_COMMAND_TREE_SEL_CHANGING
--/li wxEVT_COMMAND_TREE_SET_INFO
--/li wxEVT_COMMAND_VLBOX_SELECTED
--/li wxEVT_COMPARE_ITEM
--/li wxEVT_CONTEXT_MENU
--/li wxEVT_CREATE
--/li wxEVT_DESTROY
--/li wxEVT_DETAILED_HELP
--/li wxEVT_DIALUP_CONNECTED
--/li wxEVT_DIALUP_DISCONNECTED
--/li wxEVT_DISPLAY_CHANGED
--/li wxEVT_DRAW_ITEM
--/li wxEVT_DROP_FILES
--/li wxEVT_END_PROCESS
--/li wxEVT_END_SESSION
--/li wxEVT_ENTER_WINDOW
--/li wxEVT_ERASE_BACKGROUND
--/li wxEVT_GRID_CELL_CHANGE
--/li wxEVT_GRID_CELL_LEFT_CLICK
--/li wxEVT_GRID_CELL_LEFT_DCLICK
--/li wxEVT_GRID_CELL_RIGHT_CLICK
--/li wxEVT_GRID_CELL_RIGHT_DCLICK
--/li wxEVT_GRID_COL_SIZE
--/li wxEVT_GRID_EDITOR_CREATED
--/li wxEVT_GRID_EDITOR_HIDDEN
--/li wxEVT_GRID_EDITOR_SHOWN
--/li wxEVT_GRID_LABEL_LEFT_CLICK
--/li wxEVT_GRID_LABEL_LEFT_DCLICK
--/li wxEVT_GRID_LABEL_RIGHT_CLICK
--/li wxEVT_GRID_LABEL_RIGHT_DCLICK
--/li wxEVT_GRID_RANGE_SELECT
--/li wxEVT_GRID_ROW_SIZE
--/li wxEVT_GRID_SELECT_CELL
--/li wxEVT_HELP
--/li wxEVT_ICONIZE
--/li wxEVT_IDLE
--/li wxEVT_INIT_DIALOG
--/li wxEVT_JOY_BUTTON_DOWN
--/li wxEVT_JOY_BUTTON_UP
--/li wxEVT_JOY_MOVE
--/li wxEVT_JOY_ZMOVE
--/li wxEVT_KEY_DOWN
--/li wxEVT_KEY_UP
--/li wxEVT_KILL_FOCUS
--/li wxEVT_LEAVE_WINDOW
--/li wxEVT_LEFT_DCLICK
--/li wxEVT_LEFT_DOWN
--/li wxEVT_LEFT_UP
--/li wxEVT_MAXIMIZE
--/li wxEVT_MEASURE_ITEM
--/li wxEVT_MENU_CLOSE
--/li wxEVT_MENU_HIGHLIGHT
--/li wxEVT_MENU_OPEN
--/li wxEVT_MIDDLE_DCLICK
--/li wxEVT_MIDDLE_DOWN
--/li wxEVT_MIDDLE_UP
--/li wxEVT_MOTION
--/li wxEVT_MOUSEWHEEL
--/li wxEVT_MOUSE_CAPTURE_CHANGED
--/li wxEVT_MOVE
--/li wxEVT_NAVIGATION_KEY
--/li wxEVT_NC_ENTER_WINDOW
--/li wxEVT_NC_LEAVE_WINDOW
--/li wxEVT_NC_LEFT_DCLICK
--/li wxEVT_NC_LEFT_DOWN
--/li wxEVT_NC_LEFT_UP
--/li wxEVT_NC_MIDDLE_DCLICK
--/li wxEVT_NC_MIDDLE_DOWN
--/li wxEVT_NC_MIDDLE_UP
--/li wxEVT_NC_MOTION
--/li wxEVT_NC_PAINT
--/li wxEVT_NC_RIGHT_DCLICK
--/li wxEVT_NC_RIGHT_DOWN
--/li wxEVT_NC_RIGHT_UP
--/li wxEVT_NULL
--/li wxEVT_PAINT
--/li wxEVT_PAINT_ICON
--/li wxEVT_PALETTE_CHANGED
--/li wxEVT_POWER
--/li wxEVT_QUERY_END_SESSION
--/li wxEVT_QUERY_LAYOUT_INFO
--/li wxEVT_QUERY_NEW_PALETTE
--/li wxEVT_RIGHT_DCLICK
--/li wxEVT_RIGHT_DOWN
--/li wxEVT_RIGHT_UP
--/li wxEVT_SASH_DRAGGED
--/li wxEVT_SCROLLWIN_BOTTOM
--/li wxEVT_SCROLLWIN_LINEDOWN
--/li wxEVT_SCROLLWIN_LINEUP
--/li wxEVT_SCROLLWIN_PAGEDOWN
--/li wxEVT_SCROLLWIN_PAGEUP
--/li wxEVT_SCROLLWIN_THUMBRELEASE
--/li wxEVT_SCROLLWIN_THUMBTRACK
--/li wxEVT_SCROLLWIN_TOP
--/li wxEVT_SCROLL_BOTTOM
--/li wxEVT_SCROLL_ENDSCROLL
--/li wxEVT_SCROLL_LINEDOWN
--/li wxEVT_SCROLL_LINEUP
--/li wxEVT_SCROLL_PAGEDOWN
--/li wxEVT_SCROLL_PAGEUP
--/li wxEVT_SCROLL_THUMBRELEASE
--/li wxEVT_SCROLL_THUMBTRACK
--/li wxEVT_SCROLL_TOP
--/li wxEVT_SETTING_CHANGED
--/li wxEVT_SET_CURSOR
--/li wxEVT_SET_FOCUS
--/li wxEVT_SHOW
--/li wxEVT_SIZE
--/li wxEVT_SOCKET
--/li wxEVT_SYS_COLOUR_CHANGED
--/li wxEVT_TASKBAR_LEFT_DCLICK
--/li wxEVT_TASKBAR_LEFT_DOWN
--/li wxEVT_TASKBAR_LEFT_UP
--/li wxEVT_TASKBAR_MOVE
--/li wxEVT_TASKBAR_RIGHT_DCLICK
--/li wxEVT_TASKBAR_RIGHT_DOWN
--/li wxEVT_TASKBAR_RIGHT_UP
--/li wxEVT_TIMER
--/li wxEVT_UPDATE_UI
--/li wxEVT_WIZARD_CANCEL
--/li wxEVT_WIZARD_FINISHED
--/li wxEVT_WIZARD_HELP
--/li wxEVT_WIZARD_PAGE_CHANGED
--/li wxEVT_WIZARD_PAGE_CHANGING
--</ul>


-- wxWindow
------------------------

--/topic wxWindow
--/parent Controls
--/parent Classes
--/info 
--include file: wxEuphoria
--/b wxWindow is a very well used class.  Most controls are derived from /b wxWindow, so you should
--remember that anything that can be done to a window can be done to an object derived from wxWindow.
--The parameters for creating a /b wxWindow are:
--<ul>
--/li atom parent
--/li atom id
--/li integer x [ = -1]
--/li integer y [ = -1]
--/li integer cx [ = -1]
--/li integer cy [ = -1]
--/li atom style [ = 0]
--</ul>
--An object of class /b wxWindow /b must have a parent.  Therefore,
--you cannot create an object of class /b wxWindow to be your top level window.  Your top level window
--should be either of type /wxFrame or /wxDialog.  In fact, you should probably rarely
--create an object using wxWindow.  See /wxPanel.

-- wxFrame
----------------------

--/topic wxFrame
--/parent Classes
--/parent Controls
--/parent wxWindow
--/info
--include file: wxEuphoria
--/b wxFrame is a class derived from /wxWindow.  You must use a /b wxFrame as your top level window.
--The parameters for creating a /b wxFrame are:
--<ul>
--/li atom parent
--/li atom id
--/li sequence title
--/li integer x [ = -1]
--/li integer y [ = -1]
--/li integer cx [ = -1]
--/li integer cy [ = -1]
--/li atom style [ = wxDEFAULT_FRAME_STYLE]
--<ul>
--/li wxSTAY_ON_TOP
--/li wxICONIZE          
--/li wxMINIMIZE             
--/li wxMAXIMIZE             
--/li wxSYSTEM_MENU          
--/li wxMINIMIZE_BOX         
--/li wxMAXIMIZE_BOX         
--/li wxTINY_CAPTION_HORIZ   
--/li wxTINY_CAPTION_VERT    
--/li wxRESIZE_BORDER        
--/li wxDIALOG_NO_PARENT     Don't make owned by apps top window
--/li wxFRAME_NO_TASKBAR     No taskbar button (MSW only)
--/li wxFRAME_TOOL_WINDOW    No taskbar button, no system menu
--/li wxFRAME_FLOAT_ON_PARENT Always above its parent
--/li wxFRAME_SHAPED         Create a window that is able to be shaped
--</ul>
--</ul>
--All items with a default value are optional, although you must supply both x and y, or both
--cx and cy if you supply either one.
--/code
--ex:
--  constant myFrame = create( wxFrame, {0,         -- has no parent
--                                      -1,         -- wxWidgets will create an id
--                                      "myFrame",  -- will be dispayed as the caption
--                                      -1,         -- start at default x position
--                                      -1,         -- start at default y position
--                                      300,        -- 300 wide
--                                      200})       -- 200 tall
--                                                  -- no style supplied means will be default style
--/endcode
--If there is only one child of a frame, that child will be automatically resized
--(by wxWidgets) to the client rect of the frame.
--


-- wxString
--------------------

--/topic wxString
--/parent Classes
--/info
--include file: wxEuphoria
--The format for strings that wxWidgets uses.  The parameter to create should be a string.
--/code
--ex:
--  atom myString
--  myString = create( wxString, {"Hello World"})
--/endcode
--I wrote my own destructor for wxString objects, which you may call directly to save
--some time: /delete_string().

-- wxPoint
---------------------

--/topic wxPoint
--/parent Classes
--/info
--include file: wxEuphoria
--A /b wxPoint is actually just an 8-byte location in memory with two 4-byte integers stored there,
--corresponding to the x,y coordinates of the point.  It is possible to specify the place in memory
--where you want to have the point created.  A call to /create() will simply poke the values for you,
--so it may be easier to do this yourself.  To specify the place in memory, the pointer should be the
--third parameter passed.
--/code
--ex:
--  atom point1, point_array, void
--
--  --creates a point with x=3, y=4
--  point = create( wxPoint, {3,4})             
--
--  -- allocates space for an array of 2 wxPoints
--  point_array = allocate(8 * 2)               
--
--  -- create the points in place
--  void = create( wxPoint, {3,4,point_array})
--  void = create( wxPoint, {5,6,point_array + sizeof_wxPoint})
--/endcode
--

-- wxSize
---------------------

--/topic wxSize
--/parent Classes
--/info
--include file: wxEuphoria
--

-- Developer's Notes
--------------------------

--/topic Developer's Notes
--/desc Changes, Bugs and TODO List
--/info
--Changes, Bugs and TODO List
--
--The windows DLL was built using the free Borland C++ compiler v5.5.  The runtime 
--library is statically linked, so it should run fine on any system (although for 
--Win95, you may need to update your COMCTL32.DLL to version 5).  It only increased
--the file size by about 200K (before UPX) to link statically, whereas the runtime
--as a DLL is about 1MB.  I altered several source and header files (see patch.zip), 
--and used a slightly different makefile (static link, compile & link resources).  
--UPX'd, the DLL shrinks to under 2MB (from ~ 4.3MB), which I think is pretty good, 
--and it zips to just over 1MB.
--
--/b File /b Formats:<br>
--Similar classes are grouped together in their own include files.  Each group of classes has
--one file, which can be converted from one platform to the other using tools from
--the developer's download.  The format of each file is as follows:
--/code
----start of file.e
--
--global constant
--
---- begin autogenerated
--
---- begin class wxClass
--
--  -- (lots of wxClass_MemberName = "@@&&ZAXFGF" garbage)
--
---- end class wxClass
--
---- end autogenerated
--
--
---- end of file.eu or file.ew
--/endcode
--I use some automated tools to insert the import strings into the files, and this is the
--format that the tools recognize, making it easy to add or remove classes from any given
--set of files.  The "--begin autogenerated" and "-- end autogenerated" lines should never be touched.
--Anything between them will be deleted the next time the file is updated.
--
--I've tried to use namespaces to refer to all wxEuphoria symbols between files to
--prevent possible namespace clashes if wxEuphoria is combined with another library.
--All files include at least wxEuphoria.e (as wxeu) and cplusplus.e (as cpp).
--
--Functions that return an object by value may not work.  I believe that Borland and
--gcc both return the value on the stack, which I can't easily handle.  To get around this,
--I've created some new functions that work with references or pointers.  The Developers
--download has a patch for Windows and Linux to update your source tree if you want to 
--build the library yourself.
--
--If you look at the *.e files, you'll see at the top where there are constants defined 
--that hold the size of the various objects (sizeof_wx*).  Some objects in wxWidgets 
--contain that information in their wxClassInfo member.  However, those objects which
--are not derived from wxObject don't have this.  The sizes for these objects are based
--on my combing through source and header files, and when that didn't work, trial and
--error.  That's why you'll see things like:
--/code
--   sizeof_wxGridBoolCellEditor = 36,
--/endcode
--If you're able to figure out the exact size of some of these things, please let me know.
--Also, if you ever experience a strange crash that is somewhat repeatable, one of these
--objects may be the culprit.  Try commenting out the lines that lead to the creation of
--these objects in order to track down the offender.  Then you can increase the size of
--the object until you don't get the crash again.  Please let me know if you find 
--something!
--
--You can change the name or location of the wxeu library by creating a global function 
--named "wxEu_Lib" before wxEuphoria.e is created.  The function should take no parameters,
--and should return a sequence that contains the text that will be passed to open_dll().

-- Change History
-----------------------------

--/topic Change History
--/info
--Enhancements and bug fixes
--/code
-- v0.9.0 - Made class_table local in cplusplus.e to avoid conflicts with 
--          embedded ooeu
--       - Documented /set_cursor()
--       - Added /convert_to_image()
--        - Requires library build #9
--
--v0.8.1 - Fixed bug in /wxWizardPage -- vtable offset was changed
--       - Added /wxSplashScreen
--       - Added /get_days_in_month() and /get_cal_days_in_month()
--        - Fixed bug that could prevent wxEVT_CLOSE_WINDOW events from being handled
--          correctly
--        - Fixed bug that would prevent translation to a dll, when wxEuphoria 
--          looks at the command_line()
--
--v0.8.0 - Fixed bug in /wxTreeCtrl creation for detecting optional parameters
--       - New classes: /wxFileName, /wxHtmlWindow
--       - New wrappers: /select_tree_item(), /delete_tree_children(), /is_visible()
--        - Both versions use build #8.
--       - Added /call_member_str() and /call_cdecl_str() too allow easy wrapping of 
--          functions that return a wxString by value.
--       - Added /init_image_handlers() and fixed constructor for wxGIFHandler for Win32
--       - /set_column_label() didn't work properly under Windows.
--       - Added /set_bmpbutton() to change the displayed bitmap of a /wxBitmapButton
--       - wxeu.so now belongs in "/usr/lib"
--       - Added new accessor functions for /wxFont.
--       - Added /choice_count(), /combobox_count()
--        - Global sequence PATH contains the path of the startup directory, if possible
--
--v0.7.2 - Documentation was wrong for /set_editor_choices()
--       - Fixed bug in /ftp_rename() (Thanks to Mario Steele)
--       - /set_ip_host() was using the wrong wxWidgets call under Linux
--          (Thanks to Mario Steele)
--
--v0.7.1 - Fixed /get_list_string() to work for /wxListCtrl on Linux
--        - Fixed constructor for wxURL on Linux
--        - Linux uses library build #7.
--
--v0.7.0 - Fixed /set_brush() and /set_back_brush() to work with /wxMemoryDC
--          under GTK
--       - New classes: /wxMDIParentFrame, /wxMDIClientWindow, /wxMDIChildFrame,
--         /wxFontEnumerator, /wxCursor
--       - Added /set_choice() for /wxChoice
--       - Can now insert a /wxMenu at specified location in the /wxMenuBar upon creation
--       - Added /get_label(), which should work for all controls.
--       - Fixed /get_list_string() under GTK.
--        - Uses library build #6.
--       - Several bugfixes for /wxTreeCtrl under GTK.
--       - Added /"Resource Management" routines (thanks to Mario Steele)
--
-- v0.6.0 - Docs now in multiple file format
--        - CK Lester helped updating demos
--       - Added /set_bitmap_size() and made /get_bitmap_size() work under Linux
--       - /set_checked() didn't work for /wxToggleButton (CK Lester)
--       - Added /get_text_number()
--       - New classes: /wxMask, /wxFlexGridSizer, /wxStaticBoxSizer
--       - Added /set_mask() to use a /wxMask with a /wxBitmap
--        - Added global constant wxTrue
--        - Uses build 5
--       - Added several new /wxSizer functions.
--       - Added /get_key_state() (from wxMSW 2.5.5, and implemented in Euphoria for wxGTK,
--          since the wxGTK implementation only works for shift, ctrl, alt keys)
--        - Fixed bug in Linux where wxWidgets frees image handlers and that memory
--          is reused, cplusplus.e still thought the object was of the old class' type
--          (thanks to Eumario)
--       - Added /font_ok() to check for a valid /wxFont
--
--v0.5.0  - New classes: /wxTextAttr, /wxStaticLine, /wxStaticBox, /wxCalendarCtrl
--        - Fixed constructor for /wxTextCtrl so that default parameters can be used for
--           id, text, size and position.
--         - wxEuphoria will display an error message and abort if open_dll( wxWin_name ) fails
--         - Cleaned up warnings
--         - Size of wxColour was wrong under Windows
--        - Can now /destroy() controls 
--         - Added version constant wxEuphoria_Version = {0,5,0}
--        - Can set the column labels in a /wxListCtrl: /set_column_label()
--        - Fixed bug in constructor for /wxToggleButton
--         - Uses library build 4.  The file is now named wxeu.[dll|so]
--         - Allows you to change the location or name of the wxEuphoria library by
--          declaring a global function /wxEu_Lib that returns the path to the 
--           wxEuphoria library.
--        - /set_text_back_color() works correctly in Linux
--         - Change instance memory handling to cooperate with wxWidgets under Win32 
--           so that memory is freed in the correct place
--        - /cleanup() added.  This should be manually called before your app exits
--          if you don't use /wxMain() ( /wxMain() calls /cleanup() automatically before exit)
--        - /set_status_text() now checks to make sure that you don't set a status field that doesn't exist
--           (thanks to CK Lester)
--         - Global constant wxFalse is now 0 (was a pointer to the actual value) (thanks to CK Lester)
--        - Added /set_button_label()
--
-- v0.4.0  - New classes:
--          /wxDir, /wxDirTraverser, /wxWizard, /wxWizardPage, /wxSocketClient,
--          /wxSocketServer, /wxURL, /wxInputStream, /wxIPV4Address, /wxHTTP, /wxFTP
--        - Fixed destructor for /wxArrayString
--
-- v0.3.0  - New classes:
--          + /Controls: /wxTreeCtrl, /wxSplitterWindow, /wxSpinCtrl, 
--                      /wxSlider, /wxListCtrl
--          + /Dialogs: /wxDirDialog, /wxFontDialog (see also /font_selector),
--                     /wxPrintDialog, /wxProgressDialog, /wxColourDialog
--                     (see also /color_selector)
--          + /Printing: /wxPreviewFrame, /wxPrintout, /wxPrintPreview
--          + /wxGrid: /wxGridCellAttr, /wxGridCellEditor
--          + /wxImageList
--        - /wxDialog has been moved from wxEuphoria.e to the new file wxDialog.e
--        - Support for popup- and sub- menus (See /Menus)
--        - /create(), /call_member(), /call_member_s(), /call_cdecl(), /call_cdecl_s() 
--           will now take an atom if only one parameter is passed
--          + A /wxString can be created without wrapping the string in 
--             an extra set of braces:
--                 str = create( wxString, "A String" )
--         - Uses Libarary build 3
--         - Checks for Library build >= Required build (used to be =)
--         - platform.pl ported to Euphoria (platform.exw)
--        - /blit() parameters were incorrect (src and dst coords were swapped)
--        - /wx_execute() is now a function, and takes flags
--
-- v0.2.0  - New classes:
--          + /Sizers: /wxBoxSizer, /wxGridSizer, /wxNotebookSizer
--          + /wxNotebook
--          + /wxGrid
--          + /wxToolBar
--          + /wxBitmapButton
--          + Clipboard, Drag'n'Drop: /wxClipboard, /wxDataObject, /wxTextDataObject,
--            /wxFileDataObject, /wxDropTarget, /wxFileDropTarget
--         -  New functions:
--          + /file_selector()
--          + /get_sys_metric()
--          + /get_sys_color()
--         - Uses Library build 2
--           + Both
--            * Added string access routines ( /wxChoice, /wxComboBox, /wxGrid, /wxClipboard)
--             * Moved implementation of some routines from grid.h to grid.cpp to 
--               allow them to be exported
--           + Win32:
--             * Added call to IDataObject::AddRef when adding data to the clipboard
--            * GetColour added for use in /get_sys_colour
--         - Dumped fptr.e and added some code in src\common\utilscmn.cpp for calling
--           functions.  Random crashes have disapeared.  Still seem to need string
--           accessors, though.
--
-- v0.1.0  - Using wxWidgets 2.4.2 
--           + Win32: Borland C++ v5.5 (free version)
--           + Linux gcc v3.2
--           + Library build 1 for both platforms (WX_DLL_BUILD)
--         - Overhauled and reengineered library development
--           + All files are *.e with platform specific code wrapped with
--             'preprocessor' directives (see platform.pl)
--           + Library exports managed through EuSQL databases
--           + generate.exw, wxeu.exw, EDB forms included to assist db and
--             file maintenance
--
--7/3/2003
-- * Got rid of cross-platform + platform-specific includes.  Combined
--   into platform-specific format.
--/endcode

-- Miscellaneous Routines
-------------------------

--/topic Miscellaneous Routines
--/info
--Random stuff
--
--

-- Known Bugs
----------------------

--/topic Known Bugs
--/info
--Stuff that needs fixing
--<table>
--<tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Win32 </td>
--<td bgcolor="#D4D4D4" ><ul>
--/li /wxStaticLine will only work as wxHORIZONTAL
--/li Sometimes, controls in a /wxPanel won't size themselves properly at 
--program startup if the /wxPanel is created before menus are added.  The controls
--will properly position themselves after their parent is resized, or if the creation
--of the /wxPanel is moved after the menus are created.
--</ul></td></tr>
--<tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Linux </td>
--<td bgcolor="#D4D4D4"><ul>
--/li /wxToolBar 's don't seem to play nicely with sizers.  First, panels
--don't seem to automatically take them into account, and if they're put
--into sizers, the sizers seem to allocate the space for the toolbar
--at the end.  The proposed workaround for now is:
--<ul>
--/li Create a sizer for the frame
--/li Create the toolbar with correct dimensions
--/li Add space ( /space_sizer ) to the sizer of equal dimensions to the toolbar
--/li Add the panel to the sizer with a wxBOTTOM border of negative the height of the
--toolbar
--</ul>
--/li Drag and Drop does not result in any files being transmitted to wxEuphoria.
--/li The clipboard isn't very robust.  Multiple copy & pastes from a wxEuphoria app
--can lock up.  In between these, if you use the clipboard in another app, it seems
--to be fine.  An alternative workaround is to use a hidden /wxTextCtrl, and use 
--/copy_text(), /cut_text() and /paste_text() to manage putting text onto the clipboard.
--/li Be careful if using characters above 127.  Specifically, 146 (apostrophe)
--will cause problems, and no text may show up in the wxTextCtrl.  Also, you should
--make sure the /wxTextCtrl has the wxTE_MULTILINE style, or you will be limited to
--2047 characters.
--</ul></td></tr>
--<tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Both </td>
--<td bgcolor="#D4D4D4"></td></tr>
--</table>

-- TODO
---------------------

--/topic TODO
--/info
--What's next?
--This is a list of the classes I plan to wrap, although I'm not promising any
--particular class will make any particular version, or even the order in which
--these get implemented.  If you want or need something on this list (or even
--something not on this list), let me know, and I'll probably move it up on my
--priority list.  Better yet, write the wrappers yourself and send them to me!
--
--I plan to upgrade wxWidgets to v2.6.2 after it is released.  See the <a href=
--"http://www.wxwidgets.org">wxWidgets Home Page</a> for details on how this might
--change wxEuphoria (one big change will be using GTK2).
--<ul><table width="90%">
--<tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Controls </td>
--<td bgcolor="#D4D4D4"><ul>
--/li There are many functions not yet wrapped.  Please let me know if there is something you need.
--</ul></td></tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Database </td>
--<td bgcolor="#D4D4D4">Low priority now that 
--<a href="http://www.rapideuphoria.com/cgi-bin/asearch.exu?gen=on&keywords=odbc">
--odbc.e</a> is cross platform<ul>
--/li wxDB
--/li wxDBConnectInf
--/li wxDBTable
--</ul></td></tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Networking </td>
--<td bgcolor="#D4D4D4"><ul>
--/li wxFTP (it's in the code, but haven't gotten it to work yet)
--/li wxHTTP (it's in the code, but haven't gotten it to work yet)
--</ul></td></tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Printing </td>
--<td bgcolor="#D4D4D4">These don't work well yet:<ul>
--/li wxPrinter
--/li wxPrinterDC
--/li wxPrintPreview
--</ul></td></tr>
--<td valign="top" bgcolor="#E0E0E0"> /b Documentation </td>
--<td bgcolor="#D4D4D4">(Please contribute!)<ul>
--/li Filled in and improved just about everywhere
--/li More and better demos 
--</ul></td></tr>
--<td valign="top" bgcolor="#E0E0E0"> /b General </td>
--<td bgcolor="#D4D4D4"><ul>
--/li FreeBSD port
--</ul>
--</table></ul>

-- wxPanel
-----------------------

--/topic wxPanel
--/parent Classes
--/parent Controls
--/parent wxWindow
--/info
--include file: wxEuphoria
--If you create a /wxFrame, you should create a 
--wxPanel to be the child of the main frame, and place
--all controls into the panel (except for menus and /wxStatusBar 's). The only creation
--parameter required is a parent.  The panel will automatically grow or shrink whenever
--its parent does, and automatically handles tabbing between controls.



-- wxEuphoria Developers
-----------------------------

--/topic wxEuphoria Developers
--/info
--Information about extending or debugging the library
--
--All of the tools and scripts mentioned below can be found in the developer's
--download from the download section of the wxEuphoria home page.
--
--If you look at the files, you'll see that I'm trying to maintain only one
--set of files, with platform specific code bracketed and commented out as 
--appropriate:
--/code
--     ...platform independent code goes here...
--
--  --#WIN32
--       ...win32 specific stuff goes here...
--  --#ENDWIN32
--
--     ...platform independent code goes here...
--
--  --#LINUX
--   ...linux specific stuff goes here...
--  --#ENDLINUX
--
--     ...platform independent code goes here...
--/endcode
--I have a Perl script (yeah, yeah, I'll probably rewrite it into Euphoria some day)
--called platform.pl, which comments and uncomments based on the target platform.
--
--Of course, you'll also have to regenerate the imports when switching platforms.
--This is done using generate.exw (which will run under Linux).  It looks at the 
--appropriate database for the platform you're interested in, and allows a choice 
--of files to generate.  If the file doesn't exist, it will create the file, but 
--you won't have anything other than a file of imports (and a couple of standard 
--include statements).
--
--<h3>Contributing to the library</h3>
--I welcome and encourage others to extend the library, improving the wrappers that
--I've already written and wrapping new classes.  If you take a look at the wxWidgets
--documentation, you'll see that there are a LOT of classes, and pretty much all of them
--are available to wxEuphoria, once the proper wrapper is generated.  Please refer to 
--the documentation in the developer's package for details on using the wxEuphoria 
--developer tools.
--
--If you do want to contribute something, please send the source to me, with your 
--additions or modifications clearly marked with your initials:
--/code
--   -- begin mwl 1/23/04
--
--       -- new code....
--
--   -- end mwl 1/23/04
--/endcode
--...will be perfect.  The same goes for modifications to wxWidgets source (which might be
--required in some cases).  Also, please document your wrappers using the same format 
--as the rest of the library, so that it can be easily included in the wxEuphoria documentation,
--which is automatically generated from the source files.

--Getting Started
-----------------------

--/topic Getting Started
--/info
--How do I use wxEuphoria?
--
--wxEuphoria is designed to be very similar to other Euphoria GUI libraries (i.e., 
--Win32Lib).  Although I recommend downloading the wxWidgets documentation, a
--program written in wxEuphoria will take a different form than a C++ program
--written using wxWidgets.  In wxEuphoria, you don't have to worry about 
--creating a class derived from wxApp, or overloading an OnInit() function.
--All you need to do is to create your controls, define and connect your event
--handlers, and start the wxEuphoria event loop.  Below is a basic outline 
--of what a wxEuphoria program might look like:
--/code
--   [include statements]
--
--   [create the controls]
--
--   [event handlers and other code]
--
--   wxMain()
--/endcode
--
--Here is the classic 'Hello World!' program written in wxEuphoria (see hello_world.exw):
--/code
--      include wxEuphoria.e
--      include wxGraphics.e
--      
--      constant 
--      HelloFrame = create( wxFrame, {0, -1, "My First Message", -1, -1, 200, 100} ),
--      HelloWin   = create( wxPanel, {HelloFrame})
--              
--      procedure onPaint_HelloWin( atom this, atom event, atom it, atom event_type )
--              wx_puts( this, "Hello, World!")
--      end procedure
--      set_event_handler( HelloWin, get_id(HelloWin), wxEVT_PAINT, routine_id( "onPaint_HelloWin" ))
--      
--      wxMain( HelloFrame )
--/endcode
--
--One thing to remember is that similar classes are grouped together in 
--their own include files.  If you want to use a particular class, you need
--to include the correct file.  The documentation for each class should
--indicate the name of its file.  In this case, we used /wx_puts(), which
--is found in the documentation under /Graphics (Drawing, Text, Fonts), for
--which the include file is wxGraphics.e.
--
--Notice the syntax of the calls to /create().  This is the standard function
--that should be called to create an object of almost any wxEuphoria class that 
--is wrapped.  The class documentation should indicate what the second parameter
--(always a sequence) should be.  Many classes have /i optional parameters.  You
--can omit these parameters if the default values are acceptable.  Note that if
--the third and fourth parameters are optional, you can't specify the fourth and 
--not the third--i.e., you can't skip parameters in the middle of the list.
--
--Unfortunately, all functions and classes haven't been documented as consistently
--or as thourough as they should be.  If something in particular doesn't make sense,
--please ask (best is the <a href="http://www.rapideuphoria.com/listserv.htm" target="_blank">Euphoria 
--forum</a>), and I'll try to correct the situation.  Contributions, in the
--form of code and/or documentation is also welcomed and encouraged (please see the
--<a href="http://wxeuphoria.sourceforge.net" target = "_blank">developer's download</a>
--for guidelines).

procedure initialize()
	myApp_this = peek4u( wxTheApp )
	if myApp_this then
		-- to prevent multiple initializations (causes crash in Linux)
		return	
	end if
	if wxNEED_BUILD > WX_DLL_BUILD then
		printf(2,"You have an old dynamic/shared library (build %d--build %d is required)\n",
		{WX_DLL_BUILD, wxNEED_BUILD})
		puts(2,"Press any key to exit\n")
		if wait_key() then end if
		abort(1)
	end if
--#WIN32
	-- need to pass the dll's instance, so it knows
	-- where to find it's resources
	poke4( wxhInstance, wxWin ) 
	poke4( define_c_var( wxWin, "@wxObject@EuDelete"), call_back( '+' & routine_id("eu_delete") ) )
--#ENDWIN32

	void = call_cdecl( wxEntryStart, {0,0})
	myApp_this = create( wxApp, {})
	
	
	poke4( wxTheApp, myApp_this )

--#LINUX
--    call( wxEntryInitGui )
--#ENDLINUX
end procedure
initialize()


--Demos
--------------

--/topic Demos
--/parent Getting Started
--/info
--Some examples to get you started
--
--There are a number of demos included with wxEuphoria.  They should be located in the
--demos subdirectory of your wxEuphoria directory if you preserved the directory structure
--when you decompressed wxEuphoria.  First, make sure that you properly installed wxEuphoria.
--This means that the dynamic or shared libary is located in the correct directory.  Under 
--Windows, it can be in either your euphoria/bin directory, or your %WINDIR%\system32 directory.
--Under Linux, it should be in your /usr/lib/ directory.  Also, ensure that
--the wxEuphoria source files are either in a directory that's included in your EUINC variable
--(see the Euphoria docs for information about changing this), or that any program that uses 
--wxEuphoria is in the same directory as the wxEuphoria library.  Then, to run the window_basic.exw 
--demo from the command line, you can type:
--/code
--Windows:
--  > exw window_basic.exw
--
--Linux:
--  $ exu window_basic.exw
--/endcode
--In Windows, if you have the ".exw" extension associated with the Euphoria interpreter, you may 
--simply type:
--/code
--  > window_basic.exw
--/endcode
--In Linux, there is a similar feature available to you, but you will need to change the first 
--line of the file, which is sometimes called the shebang.  This line tells your shell that
--it should use the interpreter listed on the first line to execute the file.  You may also 
--need to change the permissions on the file using /b chmod to allow the file to execute.
--To see what the shebang should be, you could type:
--/code
--  > which exu
--/endcode
--This will give the path to your copy of the Euphoria interpreter.  It will probably look similar
--to the current shebang in the demos.  The path must be preceded by "#!" to tell the shell that
--the line is actually the interpreter to be used:
--/code
--  Current shebang (based on my system):
--       #!/home/matt/euphoria/bin/exu
--
--  Yours might look like:
--       #!/home/myuserid/euphoria/bin/exu
--/endcode
--You also need to make sure that the file does not have DOS style new lines
--(carriage returns + new line).  Once you have done this, you can run the demo from the command line:
--/code
--  > ./window_basic.exw
--/endcode
--Note that this assumes your current directory is the same directory where the file is located.
--Linux doesn't include the current directory in your executable PATH environment variable (like
--Windows does), so you need to tell Linux to look there using "./".

--Cross Platform Tips
---------------------

--/topic Cross Platform Tips
--/info
--Helpful hints for coding for multiple platforms
--
--<ul>
--/li Use portable graphics.  This means no windows icons (*.ico).  
--Try to use bmp, jpg, png or xpm graphics.

--/li Be mindful of path names and operating system conventions.  Use the proper slash type.
--/li Try to avoid calls to system(), or at least wrap these calls in 
--tests for the current platform.  Try to use wxEuphoria wrappers for 
--common system commands (copy, move, delete).
--/li Always pass both the /wxEvtHandler and /wxMenu parent for /wxMenuItem
--event handling.
--/li Check the /"Known Bugs" section to see if there are any platform specific 
--issues that need to be addressed.  These can usually be resolved by putting any
--workaround code inside of a platform test, or by using the platform.pl script
--provided in the developer package.
--/li Linux and Windows sometimes pass different information on the command line.
--wxEuphoria will parse the command line to see where your application has started
--from, and stores this in the sequence \b PATH (see frecell.exw for an example of
--using this).  If a Linux user double clicks on an executable file from a file
--manager (e.g., Nautilus or Konqueror), the current directory may not be changed to
--the location of your application.  The PATH variable should have that information
--for you.  This is useful if you assume that some important data is located in the
--same directory as your application.
--</UL>
